-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript dient den Tests fr die Aufgabe OKTOBERFEST an. Es wird durch     ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Vortrag_Kopfnuss]
GO

-- #####################################################################################
-- ## berschaubares Beispiel zur Verifizierung                                       ##     
-- #####################################################################################
-- ## SOllBETRAG = 6.90 Euro, der Zielpreis ist genau zu treffen                      ##
-- ## 6 verschiedene Ergebnisse, auf diesem Rechner Laufzeit < 1 Sekunde              ##
-- #####################################################################################
DECLARE @RC						INTEGER
DECLARE @ZielPreis				MONEY
DECLARE @ProzentualeAbweichung	INTEGER

SET @ZielPreis				= 6.90
SET @ProzentualeAbweichung	= 0

EXECUTE @RC = [Oktoberfest].[SpassgeldAusgeben] 
   @ZielPreis, @ProzentualeAbweichung
GO



-- #####################################################################################
-- ## berschaubares Beispiel zur Verifizierung                                       ##     
-- #####################################################################################
-- ## SOllBETRAG = 8.05 Euro, der Zielpreis ist genau zu treffen                      ##
-- ## 10 verschiedene Ergebnisse, auf diesem Rechner Laufzeit < 1 Sekunde             ##
-- ## Blick auf die Abfragestatistik                                                  ##
-- #####################################################################################
SET STATISTICS XML ON

DECLARE @RC						INTEGER
DECLARE @ZielPreis				MONEY
DECLARE @ProzentualeAbweichung	INTEGER

SET @ZielPreis				= 8.05
SET @ProzentualeAbweichung	= 0

EXECUTE @RC = [Oktoberfest].[SpassgeldAusgeben] 
   @ZielPreis, @ProzentualeAbweichung
GO

SET STATISTICS XML OFF
GO


-- #####################################################################################
-- ## berschaubares Beispiel zur Verifizierung                                       ##     
-- #####################################################################################
-- ## SOllBETRAG = 7.28 Euro, der Zielpreis darf 5% nach unten abweichen              ##
-- ## 34 verschiedene Ergebnisse, auf diesem Rechner Laufzeit < 1 Sekunde             ##
-- #####################################################################################
DECLARE @RC						INTEGER
DECLARE @ZielPreis				MONEY
DECLARE @ProzentualeAbweichung	INTEGER

SET @ZielPreis				= 7.28
SET @ProzentualeAbweichung	= 5

EXECUTE @RC = [Oktoberfest].[SpassgeldAusgeben] 
   @ZielPreis, @ProzentualeAbweichung
GO


-- #####################################################################################
-- ## Beispiel aus der Prsentation (Colin)                                           ##     
-- #####################################################################################
-- ## SOllBETRAG = 21.80 Euro, der Zielpreis darf 2% nach unten abweichen             ##
-- ## 16030 verschiedene Ergebnisse, auf diesem Rechner Laufzeit < 4 Sekunden         ##
-- #####################################################################################
DECLARE @RC						INTEGER
DECLARE @ZielPreis				MONEY
DECLARE @ProzentualeAbweichung	INTEGER

SET @ZielPreis				= 21.80
SET @ProzentualeAbweichung	= 2

EXECUTE @RC = [Oktoberfest].[SpassgeldAusgeben] 
   @ZielPreis, @ProzentualeAbweichung
GO



-- #####################################################################################
-- ## Beispiel aus der Prsentation (Zoe)                                             ##     
-- #####################################################################################
-- ## SOllBETRAG = 38.10 Euro, der Zielpreis darf 1% nach unten abweichen             ##
-- ## 785.579 verschiedene Ergebnisse, auf diesem Rechner Laufzeit < 4:36 Minuten     ##
-- #####################################################################################
DECLARE @RC						INTEGER
DECLARE @ZielPreis				MONEY
DECLARE @ProzentualeAbweichung	INTEGER

SET @ZielPreis				= 38.10
SET @ProzentualeAbweichung	= 1

EXECUTE @RC = [Oktoberfest].[SpassgeldAusgeben] 
   @ZielPreis, @ProzentualeAbweichung
GO



/*
Bei greren Geldbetrgen oder noch mehr Auswahl der Attraktionen wird die Zahl der Kombinationen 
schnell extrem riesig. Mathematisch handelt es sich bei diesem Beispiel um ein "Urnenmodell mit 
Zurcklegen", bei dem dem Zahl der Kugeln (=Attraktionen) "n" und die Anzahl der Ziehungen (Fahrten/Einkufe) 
"k" genannt werden. Die Reihenfolge, in der die Kugeln gezogen werden, ist irrelevant. 
Es gilt die mathematische Formel aus der Kombinatorik:

							n + k - 1 
Anzahl Mglichkeiten =  (				) 
							  n - 1

_________________________________________________________________________________________________________________

Bei einem Durchschnittspreis von bspw. 3 Euro pro Attraktion und eine Budget von 21 Euro kann man 7 Einkufe
ttigen. Werden, wie im Beispiel, 12 Attraktionen angeboten ergibt dies:

							12 + 7 - 1            18               18!              18!  
Anzahl Mglichkeiten =  (				)   =   (    )   =   --------------   =  --------  
							  12 - 1              11         (18-11)! * 11!      7! * 11!        



					    6.402.373.705.728.000      6.402.373.705.728.000
					 =  ----------------------  =  ---------------------  ~  31.835
					     5.040 * 39.916.800            201.180.672.000
_________________________________________________________________________________________________________________

Erhht man bei unverndertem Durchschnittspreis die Zahl der Attraktionen um 3 und gibt nur 6 Euro mehr Budget, 
klettert die Anzahl der Mglichkeiten schon auf 

							15 + 9 - 1            23               23!              23!  
Anzahl Mglichkeiten =  (				)   =   (    )   =   --------------   =  --------  
							  15 - 1              14         (23-14)! * 14!      9! * 14!        


					    ?  2,585201673888498e+22?      2,585201673888498e+22
					 =  ------------------------  =  ------------------------  ~  817.190
					    362.880 * 87.178.291.200         3,1635258310656e+16

_________________________________________________________________________________________________________________

Bei einem Durchschnittspreis 2,50 Euro, einer Auswahl aus 20 Attraktionen und einem Budget von 30 Euro erreicht  
die Anzahl der Kombinationen schon Hhen, die die TempDB vor ersthafte Probleme stellen kann:

							20 + 12 - 1           31               31!              31!  
Anzahl Mglichkeiten =  (				)   =   (    )   =   --------------   =  --------  
							  20 - 1              19         (31-19)! * 19!      12! * 19!        


					             8.22283865418E+33                  8.22283865418E+33
					 =  -------------------------------------  =  ---------------------  ~  141.120.525
					    479.001.600 * 121.645.100.408.832.000     5,826819772799118e+23

*/
