-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe SPORTFEST an. Es wird durch     ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Vortrag_Kopfnuss]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


-----------------------------
-- Aufrumarbeiten ----------
-----------------------------
-- bestehende Tabelle VORLAUF im Schema SPORTFEST lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [Sportfest].[Vorlauf]
GO

-- bestehende Tabelle ENDLAUF im Schema SPORTFEST lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [Sportfest].[Endlauf]
GO

-- bestehendes Schema SPORTFEST lschen, um sauber wieder aufzusetzen
DROP SCHEMA  IF EXISTS [Sportfest]
GO


-----------------------------
-- Aufbauarbeiten ----------
-----------------------------
-- Schema SPORTFEST anlegen, um Aufgaben sauber trennen zu knnen
CREATE SCHEMA [Sportfest]
GO

-- Tabelle VORLAUF im Schema SPORTFEST anlegen
CREATE TABLE [Sportfest].[Vorlauf](
	  [ID]			[INT] PRIMARY KEY IDENTITY(1,1)
	, [Sportler]	[NVARCHAR](50)							NULL
	, [Laufnummer]	[SMALLINT]								NULL
	, [Zeit]		[TIME](4)								NULL
) ON [PRIMARY]
GO


-- Tabelle ENDLAUF im Schema SPORTFEST anlegen
CREATE TABLE [Sportfest].[Endlauf](
	  [ID]			[INT] PRIMARY KEY IDENTITY(1,1)
	, [Sportler]	[NVARCHAR](50)							NULL
	, [Zeit]		[TIME](4)								NULL
) ON [PRIMARY]
GO


-- Tabelle VORLAUF im Schema SPORTFEST mit Beispielwerten aus der Prsentation fllen
INSERT INTO [Sportfest].[Vorlauf] VALUES 
    ('Dack, Donalt',		1, '00:00:14.8300')
  , ('Musterfrau, Elke',	1, '00:00:13.8100')
  , ('Dack, Disie',	    1, '00:00:14.3000')
  , ('Pahn, Petr',			1, '00:00:14.2100')
  , ('Thalr, Tymm',			1, '00:00:12.9900')
  , ('Blhmchn, Ben',		1, '00:00:14.5500')
  , ('Musstermann, Max',	1, '00:00:14.2100')
  , ('Rosenroth, Rose',		1, '00:00:13.8100')

  , ('Graph, Stephi',		2, '00:00:14.2200')
  , ('Langa, Bernhart',		2, '00:00:13.8100')
  , ('Mathuhs, Lodda',		2, '00:00:15.2100')
  , ('Hynkys, Martinah',	2, '00:00:13.7100')
  , ('Bcker, Bobbele',	    2, '00:00:14.3300')
  , ('Henkl, Hayke',		2, '00:00:14.2200')
  , ('Lndl, Ywan',			2, '00:00:14.7000')
  , ('Huhba, Ank',			2, '00:00:13.7100')





-- Tabelle ENDLAUF im Schema SPORTFEST mit Beispielwerten aus der Prsentation fllen
INSERT INTO [Sportfest].[Endlauf] VALUES 
    ('Langa, Bernhart',		'00:00:12.4500')
  , ('Huhba, Ank',			'00:00:13.0100')
  , ('Thalr, Tymm',		    '00:00:13.0900')
  , ('Hynkys, Martinah',	'00:00:12.8600')
  , ('Rosenroth, Rose',		'00:00:12.4500')
  , ('Musterfrau, Elke',	'00:00:14.0800')
  , ('Pahn, Petr',			'00:00:13.9000')
  , ('Mustermann, Max',		'00:00:13.0100')
