-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript zeigt eine mgliche Lsung fr die Aufgabe SPORTFEST. Es wird     ##
-- ## durch weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu- ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Vortrag_Kopfnuss]
GO

--------------------------------------------------------------
-- Einfache Sortierung ohne Ordnungsnummer
--------------------------------------------------------------
SELECT 
	  [ID]										AS [ID]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 1
ORDER BY [ZEIT] ASC
GO

SELECT 
	  [ID]										AS [ID]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 2
ORDER BY [ZEIT] ASC
GO

--------------------------------------------------------------
-- Einfache Sortierung mit Ordnungsnummer
--------------------------------------------------------------
SELECT 
	  ROW_NUMBER() OVER(ORDER BY [Zeit] ASC)	AS [Ordnung]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 1
ORDER BY [ZEIT] ASC
GO

SELECT 
	  ROW_NUMBER() OVER(ORDER BY [Zeit] ASC)	AS [Ordnung]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 2
ORDER BY [ZEIT] ASC
GO


--------------------------------------------------------------
-- Einfache Ordung mit Ordungsnummer und Platzierungsnummer
--------------------------------------------------------------
SELECT 
	  ROW_NUMBER() OVER(ORDER BY [Zeit] ASC)	AS [Ordnung]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
	, RANK() OVER(ORDER BY [Zeit] ASC)			AS [Platzierung]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 1
ORDER BY [ZEIT] ASC
GO

SELECT 
	  ROW_NUMBER() OVER(ORDER BY [Zeit] ASC)	AS [Ordnung]
	, [Sportler]								AS [Sportler]
	, [Zeit]									AS [Zeit]
	, RANK() OVER(ORDER BY [Zeit] ASC)			AS [Platzierung]
FROM [Sportfest].[Vorlauf]
WHERE 1=1
	AND [Laufnummer] = 2
ORDER BY [ZEIT] ASC
GO
