-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe KALENDER an. Es wird durch      ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Vortrag_Kopfnuss]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------
-- Aufrumarbeiten ----------
-----------------------------
-- bestehende Tabelle JAHRESTAGE im Schema KALENDER lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [Kalender].[Jahrestage]
GO

-- bestehendes Schema KALENDER lschen, um sauber wieder aufzusetzen
DROP SCHEMA  IF EXISTS [Kalender]
GO

-----------------------------
-- Aufbauarbeiten ----------
-----------------------------
-- neues Schema KALENDER anlegen, um Aufgaben sauber trennen zuknnen
CREATE SCHEMA [Kalender]
GO

-- Schnellste Methode, eine Kalendernachschlagetabelle zu generieren
WITH Jahrestage(n, [Tag]) 
AS (
    SELECT 
        0, 
        CONVERT(DATE, DATEADD(day, 0, '20180101'),104)
    UNION ALL
    SELECT    
        n + 1, 
        CONVERT(DATE, DATEADD(day, n+1, '20180101'),104)
    FROM    
        Jahrestage
    WHERE n < 364
)
SELECT 
    [Tag]
INTO [Kalender].[Jahrestage]
FROM 
    Jahrestage
OPTION (MAXRECURSION 365);

