-- #####################################################################################
-- ## Skript zum Vortrag R Services / Machine Learning Services mit SQL Server        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Markus Delhofen, arelium GmbH        markus.delhofen@arelium.de                 ##
-- #####################################################################################

-- allgemeine Datenbank als Startpunkt whlen, die es IMMER gibt
USE [master]
GO

DROP DATABASE IF EXISTS [R_Services_Demo]
GO

CREATE DATABASE [R_Services_Demo]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'R_Services_Demo', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL15.SQL2019\MSSQL\DATA\R_Services_Demo.mdf' , SIZE = 10240KB , MAXSIZE = 102400KB , FILEGROWTH = 10240KB )
 LOG ON 
( NAME = N'R_Services_Demo_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL15.SQL2019\MSSQL\DATA\R_Services_Demo_log.ldf' , SIZE = 10240KB , MAXSIZE = 102400KB , FILEGROWTH = 10240KB )
GO
ALTER DATABASE [R_Services_Demo] SET COMPATIBILITY_LEVEL = 150
GO
ALTER DATABASE [R_Services_Demo] SET ANSI_NULL_DEFAULT OFF 
GO
ALTER DATABASE [R_Services_Demo] SET ANSI_NULLS OFF 
GO
ALTER DATABASE [R_Services_Demo] SET ANSI_PADDING OFF 
GO
ALTER DATABASE [R_Services_Demo] SET ANSI_WARNINGS OFF 
GO
ALTER DATABASE [R_Services_Demo] SET ARITHABORT OFF 
GO
ALTER DATABASE [R_Services_Demo] SET AUTO_CLOSE OFF 
GO
ALTER DATABASE [R_Services_Demo] SET AUTO_SHRINK OFF 
GO
ALTER DATABASE [R_Services_Demo] SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF)
GO
ALTER DATABASE [R_Services_Demo] SET AUTO_UPDATE_STATISTICS ON 
GO
ALTER DATABASE [R_Services_Demo] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO
ALTER DATABASE [R_Services_Demo] SET CURSOR_DEFAULT  GLOBAL 
GO
ALTER DATABASE [R_Services_Demo] SET CONCAT_NULL_YIELDS_NULL OFF 
GO
ALTER DATABASE [R_Services_Demo] SET NUMERIC_ROUNDABORT OFF 
GO
ALTER DATABASE [R_Services_Demo] SET QUOTED_IDENTIFIER OFF 
GO
ALTER DATABASE [R_Services_Demo] SET RECURSIVE_TRIGGERS OFF 
GO
ALTER DATABASE [R_Services_Demo] SET  DISABLE_BROKER 
GO
ALTER DATABASE [R_Services_Demo] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO
ALTER DATABASE [R_Services_Demo] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO
ALTER DATABASE [R_Services_Demo] SET PARAMETERIZATION SIMPLE 
GO
ALTER DATABASE [R_Services_Demo] SET READ_COMMITTED_SNAPSHOT OFF 
GO
ALTER DATABASE [R_Services_Demo] SET  READ_WRITE 
GO
ALTER DATABASE [R_Services_Demo] SET RECOVERY FULL 
GO
ALTER DATABASE [R_Services_Demo] SET  MULTI_USER 
GO
ALTER DATABASE [R_Services_Demo] SET PAGE_VERIFY CHECKSUM  
GO
ALTER DATABASE [R_Services_Demo] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO
ALTER DATABASE [R_Services_Demo] SET DELAYED_DURABILITY = DISABLED 
GO

USE [R_Services_Demo]
GO
ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
GO
ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = On;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = Primary;
GO
USE [R_Services_Demo]
GO
IF NOT EXISTS (SELECT name FROM sys.filegroups WHERE is_default=1 AND name = N'PRIMARY') ALTER DATABASE [R_Services_Demo] MODIFY FILEGROUP [PRIMARY] DEFAULT
GO

