
-- #####################################################################################
-- ## Skript zum Vortrag R Services / Machine Learning Services mit SQL Server        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Markus Delhofen, arelium GmbH        markus.delhofen@arelium.de                 ##
-- #####################################################################################


-- Projekt- / Demodatenbank auswhlen
USE [R_Services_Demo]
GO

DROP TABLE IF EXISTS [dbo].[MaxPopulation]
GO

CREATE TABLE [dbo].[MaxPopulation] (
		[Country Name] nvarchar(200),
		[Year]         bigint,
		[MaxPopulation] bigint
)
GO

DECLARE @rscript nvarchar(max)
DECLARE @InputStmt nvarchar(max)

SET @InputStmt = N'
SELECT [Country Name]
      ,[Year] = convert(bigint, [Year])
	  ,[Value]
  FROM [dbo].[WorldGenderStatisticsDataByYear]
  where  [Indicator Code] = ''SP.POP.TOTL''
'

SET @rscript = N'
	splitByName<-split(population,population$''Country Name'')
	maxPopulationSplitted<-lapply(splitByName,function(chunk) chunk[which.max(chunk$Value),])
	maxPopulation<-do.call(rbind,maxPopulationSplitted);
' 



INSERT INTO [dbo].[MaxPopulation]
EXEC sp_execute_external_script  
      @language = N'R'  
     ,@script = @rscript
     ,@input_data_1 = @InputStmt
     ,@input_data_1_name = N'population'  
     ,@output_data_1_name = N'maxPopulation'  
GO

-- Ergebnis anzeigen 
SELECT [Country Name]
      ,[Year]
      ,[MaxPopulation]
  FROM [R_Services_Demo].[dbo].[MaxPopulation]
 ORDER BY 
       [Year]
      ,[MaxPopulation] DESC
 