
-- #####################################################################################
-- ## Skript zum Vortrag R Services / Machine Learning Services mit SQL Server        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Markus Delhofen, arelium GmbH        markus.delhofen@arelium.de                 ##
-- #####################################################################################


-- Projekt- / Demodatenbank auswhlen
USE [R_Services_Demo]
GO

DROP PROCEDURE IF EXISTS [dbo].[ChinaPlot] 
GO

CREATE PROCEDURE [dbo].[ChinaPlot] AS 
BEGIN

	DECLARE @rscript nvarchar(max)
	DECLARE @InputStmt nvarchar(max)

	SET @InputStmt = N'
				SELECT [Country Name]
					  ,[Year]
					  ,[Value]
				  FROM [dbo].[WorldGenderStatisticsDataByYear]
				 WHERE [Indicator Code] = ''SP.POP.TOTL''
			'

	SET @rscript = N'
		IndiaInput<-subset(InputDataSet,InputDataSet$''Country Name''==''India'');
		Indien<-reshape(IndiaInput, direction = "wide", idvar = "Country Name", timevar = "Year");
		Indien<-t(Indien[,2:57])

		ChinaInput<-subset(InputDataSet,InputDataSet$''Country Name''==''China'');
		China<-reshape(ChinaInput, direction = "wide", idvar = "Country Name", timevar = "Year");
		China<-t(China[,2:57])
	
		data <- (data.frame(Indien, China))
		colnames(data) <- c(''Indien'', ''China'')

	# Bild in Datei plotten	

		# temporre Datei erzeugen
		image_file = tempfile(); #create a temporary file
		jpeg(filename=image_file, width = 800, height = 800, units = "px", pointsize = 15, quality = 100); 

		# Boxplot erstellen
		boxplot(data, main="Boxplot Frauenpopulation 65 (in %) in Indien/China", yaxt="n", ylab = "Population in Mio.")

		# Y-Achse formatieren
		ticks  <- seq(from=600000000, to=1400000000, by=100000000)
		labels <- seq(from=600, to=1400, by=100)
		axis(2, las=1, at=ticks, labels = labels, )

		dev.off();  

	# Bild im Binrformat auslesen 
		result <- data.frame(data=readBin(file(image_file,"rb"),what=raw(),n=1e6))
	'

	EXEC sp_execute_external_script  @language =N'R',
		@script=@rscript
	   ,@input_data_1 = @InputStmt
	   ,@output_data_1_name = N'result'  
	WITH RESULT SETS ((
		[plot] varbinary(max)
	));
END
GO


EXEC [dbo].[ChinaPlot]

