-- #####################################################################################
-- ## Skript zum Vortrag R Services / Machine Learning Services mit SQL Server        ##     
-- #####################################################################################
-- ## Dieses Skript legt die Projektdatenbank an. Es wird durch weitere Skripte       ##
-- ## ergnzt, die in ihrer durchnummerierten Reihenfolge abzuarbeiten sind. Die      ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Markus Delhofen, arelium GmbH        markus.delhofen@arelium.de                 ##
-- #####################################################################################

-- Projekt- / Demodatenbank auswhlen
USE [R_Services_Demo]
GO

-- Tabelle [dbo].[WorldGenderStatisticsDataByYear] mit den Demodaten anlegen.
-- Quelle: https://www.kaggle.com/theworldbank/world-gender-statistics
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- Tabelle neu anlegen ...
DROP TABLE IF EXISTS [dbo].[WorldGenderStatisticsDataByYear]
GO

CREATE TABLE [dbo].[WorldGenderStatisticsDataByYear](
	[Year] [nvarchar](255) NOT NULL,
	[Country Name] [varchar](100) NULL,
	[Country Code] [varchar](50) NOT NULL,
	[Indicator Name] [varchar](500) NULL,
	[Indicator Code] [varchar](22) NOT NULL,
	[Value] [numeric](28, 5) NULL,
 CONSTRAINT [PK_WorldGenderStatisticsDataByYear] PRIMARY KEY CLUSTERED 
(
	[Country Code] ASC,
	[Indicator Code] ASC,
	[Year] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

-- ... und mit Daten befllen
TRUNCATE TABLE [dbo].[WorldGenderStatisticsDataByYear]
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1960', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29092.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29966.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30578.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31018.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31431.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31910.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32364.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32915.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33522.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34113.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34656.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35393.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36058.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36680.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37310.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37951.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38218.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38544.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38964.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39471.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40045.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40692.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41459.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42175.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42695.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42956.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42445.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41784.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41299.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41350.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42134.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44277.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47097.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50241.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53289.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55963.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57781.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59237.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60468.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61646.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62912.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64400.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65946.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67478.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68855.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69960.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70441.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70547.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70397.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70169.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69991.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70304.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70759.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71297.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71799.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72169.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Aruba', N'ABW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(54208.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(55435.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(56226.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(56697.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(57029.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(57360.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(57712.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(58049.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(58385.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(58724.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(59065.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(59438.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(59849.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60239.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60525.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60655.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60589.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60366.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60106.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(59978.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60096.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(60567.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(61344.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(62204.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(62831.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(63028.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(62644.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(61835.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(61077.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(61032.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(62148.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(64623.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(68235.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(72498.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(76700.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(80326.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(83195.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(85447.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(87276.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(89004.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(90858.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(92894.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(94995.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(97015.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(98742.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(100031.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(100830.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(101218.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(101342.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(101416.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(101597.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(101936.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(102393.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(102921.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(103441.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(103889.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Aruba', N'ABW', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Andorra', N'ADO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(13414.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(14376.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(15376.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(16410.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(17470.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(18551.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(19646.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(20755.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(21888.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(23061.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(24279.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(25560.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(26892.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(28231.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(29514.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(30706.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(31781.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(32769.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(33746.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(34819.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(36063.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(37502.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(39112.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(40862.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(42704.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(44597.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(46515.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(48458.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(50431.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(52449.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(54511.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(56674.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(58904.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(61003.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(62707.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(63854.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(64291.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(64147.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(63888.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(64161.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(65399.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(67770.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(71046.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(74783.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(78337.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(81223.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(83373.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(84878.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(85616.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(85474.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(84419.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(82326.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(79316.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(75902.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(72786.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(70473.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Andorra', N'ADO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4949871.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5014856.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5097403.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5192872.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5294949.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5400762.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5482918.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5571410.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5669225.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5781775.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5911489.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6028088.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6160120.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6300670.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6441791.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6578141.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6673672.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6761818.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6826238.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6848670.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6821720.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6673460.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6474619.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6253922.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6045705.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5873299.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5753911.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5693046.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5705719.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5807793.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6000932.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6362620.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6842687.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7379658.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7901489.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8366338.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8687389.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8928815.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9139671.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9381972.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9693251.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10117209.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10625752.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11181554.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11735399.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12256449.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12618668.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12938748.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13250068.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13599533.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14018966.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14574529.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15220107.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15930455.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16665899.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17398120.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Afghanistan', N'AFG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(8994793.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(9164945.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(9343772.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(9531555.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(9728645.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(9935358.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(10148841.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(10368600.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(10599790.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(10849510.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11121097.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11412821.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11716896.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12022514.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12315553.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12582954.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12831361.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(13056499.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(13222547.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(13283279.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(13211412.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12996923.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12667001.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12279095.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11912510.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11630498.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11438949.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11337932.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11375768.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(11608351.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12067570.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(12789374.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(13745630.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(14824371.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(15869967.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(16772522.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(17481800.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(18034130.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(18511480.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(19038420.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(19701940.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(20531160.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(21487079.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(22507368.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(23499850.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(24399948.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(25183615.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(25877544.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(26528741.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(27207291.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(27962207.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(28809167.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(29726803.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(30682500.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(31627506.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(32526562.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Afghanistan', N'AFG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2796681.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2823388.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2850995.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2881829.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2920467.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2968953.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3000735.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3044802.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3099904.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3163301.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3233351.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3291240.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3360812.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3440274.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3528050.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3622987.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3703860.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3794759.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3896687.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4011329.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4139187.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4261351.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4402334.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4554690.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4709858.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4863446.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4982579.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5100691.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5225125.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5365037.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5525403.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5681507.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5864848.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6067240.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6278305.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6492097.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6667217.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6849000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7043239.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7257175.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7494452.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7723481.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7983165.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8266674.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8566254.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8877435.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9165668.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9470550.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9793362.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10136949.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10503072.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10856785.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11239586.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11647505.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12075262.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12520017.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Angola', N'AGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5270844.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5367287.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5465905.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5565808.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5665701.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5765025.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5863568.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(5962831.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6066094.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6177703.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6300969.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6437645.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6587647.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6750215.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(6923749.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(7107334.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(7299508.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(7501320.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(7717139.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(7952882.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(8211950.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(8497950.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(8807511.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(9128655.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(9444918.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(9745209.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(10023700.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(10285712.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(10544904.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(10820992.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(11127870.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(11472173.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(11848971.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(12246786.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(12648483.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(13042666.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(13424813.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(13801868.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(14187710.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(14601983.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(15058638.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(15562791.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(16109696.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(16691395.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(17295500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(17912942.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(18541467.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(19183907.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(19842251.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(20520103.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(21219954.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(21942296.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(22685632.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(23448202.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(24227524.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(25021974.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Angola', N'AGO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(875745.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(897420.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(918887.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(940412.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(963516.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(988530.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1013854.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1043014.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1077738.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1115427.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1150953.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1187523.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1225727.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1263881.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1303920.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1347150.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1388744.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1434008.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1479687.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1524556.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1569795.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1614071.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1659680.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1705366.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1751314.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1797025.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1840091.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1884320.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1926718.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1986217.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2031133.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2010085.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1990705.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1973449.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1957413.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1941358.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1941756.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1940503.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1938134.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1936079.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1935652.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1928652.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1935897.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1943925.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1952845.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1961282.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1966814.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1968685.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1969290.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1969576.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1969787.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1979808.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1988708.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1994288.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1996833.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1995185.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Albania', N'ALB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1608800.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1659800.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1711319.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1762621.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1814135.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1864791.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1914573.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(1965598.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2022272.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2081695.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2135479.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2187853.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2243126.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2296752.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2350124.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2404831.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2458526.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2513546.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2566266.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2617832.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2671997.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2726056.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2784278.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2843960.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2904429.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2964762.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3022635.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3083605.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3142336.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3227943.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3286542.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3266790.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3247039.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3227287.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3207536.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3187784.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3168033.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3148281.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3128530.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3108778.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3089027.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3060173.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3051010.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3039616.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3026939.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(3011487.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2992547.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2970017.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2947314.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2927519.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2913021.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2904780.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2900247.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2896652.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2893654.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(2889167.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Albania', N'ALB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49312982.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50289021.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51345658.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52495415.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53765005.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55169962.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56494411.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57999470.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59641520.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61367115.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63154369.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64796556.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66546598.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68434048.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70495400.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72747613.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75126633.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77698793.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80425935.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83268612.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86200513.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89055533.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92022799.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95088149.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98209925.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101446884.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104542468.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107710609.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110959238.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114290051.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118813609.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122551264.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125247667.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129415005.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133801347.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139365415.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143825261.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148341565.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152905968.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157603825.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162463080.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167427087.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172593642.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177965937.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183555556.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189357584.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195460004.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(201779252.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208166092.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214414496.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220375066.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225649042.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230610353.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235355026.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240035955.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244775884.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Arab World', N'ARB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(92540534.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(95077992.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(97711191.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(100439395.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(103263656.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(106184090.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(109210743.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(112342573.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(115557094.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(118823872.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(122128175.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(125439089.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(128801209.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(132298955.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(136044481.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(140114424.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(144542039.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(149296257.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(154303887.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(159455867.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(164670713.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(169926632.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(175237742.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(180606318.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(186005735.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(191564251.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(197202142.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(202851923.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(208546282.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(214250542.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(222117305.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(228171034.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(232417246.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(238628852.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(244893420.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(252591048.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(258423164.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(264153948.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(269795252.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(275503565.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(281326250.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(287291826.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(293402563.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(299731956.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(306387415.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(313430911.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(320906736.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(328766559.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(336886468.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(345054176.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(353112237.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(361031820.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(368802611.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(376504253.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(384222592.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(392022276.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Arab World', N'ARB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48060.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53792.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61502.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70562.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79944.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88983.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97348.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105521.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115300.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129339.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149584.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181145.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219831.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265189.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(316537.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372849.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(442632.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(517915.00000 AS Numeric(28, 5)))
   ,(N'1978', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(592172.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(659529.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(717391.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(764976.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(803067.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(835428.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(868321.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(906743.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(957618.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1017755.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1085269.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1158024.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1234931.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1319296.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1408881.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1503019.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1600363.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1699740.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1793055.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1894973.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2001859.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2114519.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2239844.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2418400.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2608537.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2843716.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3173063.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3627182.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4257323.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5024587.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5837565.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6576931.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7160249.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7490324.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7658870.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7714722.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7734750.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7776519.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United Arab Emirates', N'ARE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(92612.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(100985.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(112240.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(125216.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(138220.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(150318.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(161077.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(171781.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(185312.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(205570.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(235434.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(275160.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(324069.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(382823.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(451948.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(531265.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(622051.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(722849.00000 AS Numeric(28, 5)))
   ,(N'1978', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(827394.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(927303.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1016789.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1093108.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1158477.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1218223.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1280278.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1350433.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1430548.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1518991.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1613904.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1712117.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1811458.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(1913190.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2019014.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2127863.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2238281.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2350192.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2467726.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2595220.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2733770.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(2884188.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(3050128.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(3217865.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(3394060.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(3625798.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(3975945.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(4481976.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(5171255.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(6010100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(6900142.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(7705423.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(8329453.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(8734722.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(8952542.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(9039978.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(9086139.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(9156963.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United Arab Emirates', N'ARE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13133401.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13330160.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13533207.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13742203.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13956341.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14174764.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14378394.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14588237.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14805878.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15032271.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15267480.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15503985.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15750590.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16000508.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16243486.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16471551.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16649544.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16803984.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16946929.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17099114.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17274519.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17435886.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17650995.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17899648.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18152334.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18395234.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18673469.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18921626.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19163430.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19433772.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19746935.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20039222.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20378063.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20745198.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21110387.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21458407.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21777651.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22088271.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22392770.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22699696.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23014006.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23342175.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23664450.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23986164.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24314158.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24650251.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24960752.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25288827.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25624830.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25953718.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26268473.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26576728.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26869998.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27154082.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27440421.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27734297.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Argentina', N'ARG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(20619075.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(20953079.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(21287682.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(21621845.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(21953926.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(22283389.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(22608747.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(22932201.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(23261273.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(23605992.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(23973062.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(24366442.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(24782950.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(25213388.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(25644505.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(26066975.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(26477153.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(26878567.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(27277742.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(27684530.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(28105889.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(28543366.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(28993989.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(29454739.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(29920907.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(30388781.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(30857242.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(31326473.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(31795515.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(32263559.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(32729740.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(33193920.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(33655149.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(34110912.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(34558114.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(34994818.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(35419683.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(35833965.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(36241578.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(36648054.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(37057453.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(37471535.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(37889443.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(38309475.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(38728778.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(39145491.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(39558750.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(39969903.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(40381860.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(40798641.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(41222875.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(41655616.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(42095224.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(42538304.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(42980026.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(43416755.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Argentina', N'ARG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1030712.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1051370.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1074919.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1101637.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1131630.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1165231.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1201253.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1242864.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1289455.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1339380.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1391441.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1452277.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1511350.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1569670.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1629365.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1691080.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1747244.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1805839.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1864426.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1919642.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1970087.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2014037.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2051502.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2084756.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2117637.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2151893.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2188892.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2226911.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2258281.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2273693.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2268881.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2233342.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2178464.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2113901.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2052526.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2003030.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1977950.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1966873.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1966432.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1970213.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1973165.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1979482.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1984013.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1988406.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1995099.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2004811.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2010260.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2017829.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2026274.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2034515.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2042954.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2065955.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2089616.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2110876.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2127056.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2136242.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Armenia', N'ARM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(1867396.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(1934239.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2002170.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2070427.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2138133.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2204650.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2269475.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2332624.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2394635.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2456370.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2518408.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2580894.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2643464.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2705584.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2766495.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2825650.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2882831.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2938181.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2991954.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3044564.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3096298.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3145885.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3192877.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3239212.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3287588.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3339147.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3396511.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3457054.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1988', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3510439.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3542720.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3544695.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3511912.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3449497.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3369673.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3289943.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3223173.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3173425.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3137652.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3112958.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3093820.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3076098.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3060036.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3047249.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3036420.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3025982.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3014917.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3002161.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2988117.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2975029.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2966108.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2963496.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2967984.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2978339.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(2992192.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3006154.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(3017712.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Armenia', N'ARM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'American Samoa', N'ASM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(20012.00000 AS Numeric(28, 5)))
   ,(N'1961', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(20478.00000 AS Numeric(28, 5)))
   ,(N'1962', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(21118.00000 AS Numeric(28, 5)))
   ,(N'1963', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(21883.00000 AS Numeric(28, 5)))
   ,(N'1964', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(22701.00000 AS Numeric(28, 5)))
   ,(N'1965', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(23518.00000 AS Numeric(28, 5)))
   ,(N'1966', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(24320.00000 AS Numeric(28, 5)))
   ,(N'1967', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(25116.00000 AS Numeric(28, 5)))
   ,(N'1968', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(25886.00000 AS Numeric(28, 5)))
   ,(N'1969', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(26615.00000 AS Numeric(28, 5)))
   ,(N'1970', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(27292.00000 AS Numeric(28, 5)))
   ,(N'1971', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(27916.00000 AS Numeric(28, 5)))
   ,(N'1972', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(28490.00000 AS Numeric(28, 5)))
   ,(N'1973', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(29014.00000 AS Numeric(28, 5)))
   ,(N'1974', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(29491.00000 AS Numeric(28, 5)))
   ,(N'1975', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(29932.00000 AS Numeric(28, 5)))
   ,(N'1976', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(30325.00000 AS Numeric(28, 5)))
   ,(N'1977', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(30690.00000 AS Numeric(28, 5)))
   ,(N'1978', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(31105.00000 AS Numeric(28, 5)))
   ,(N'1979', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(31670.00000 AS Numeric(28, 5)))
   ,(N'1980', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(32456.00000 AS Numeric(28, 5)))
   ,(N'1981', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(33488.00000 AS Numeric(28, 5)))
   ,(N'1982', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(34740.00000 AS Numeric(28, 5)))
   ,(N'1983', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(36165.00000 AS Numeric(28, 5)))
   ,(N'1984', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(37687.00000 AS Numeric(28, 5)))
   ,(N'1985', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(39247.00000 AS Numeric(28, 5)))
   ,(N'1986', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(40835.00000 AS Numeric(28, 5)))
   ,(N'1987', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(42448.00000 AS Numeric(28, 5)))
   ,(N'1988', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(44049.00000 AS Numeric(28, 5)))
   ,(N'1989', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(45591.00000 AS Numeric(28, 5)))
   ,(N'1990', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(47044.00000 AS Numeric(28, 5)))
   ,(N'1991', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(48379.00000 AS Numeric(28, 5)))
   ,(N'1992', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(49597.00000 AS Numeric(28, 5)))
   ,(N'1993', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(50725.00000 AS Numeric(28, 5)))
   ,(N'1994', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(51807.00000 AS Numeric(28, 5)))
   ,(N'1995', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(52874.00000 AS Numeric(28, 5)))
   ,(N'1996', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(53926.00000 AS Numeric(28, 5)))
   ,(N'1997', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(54942.00000 AS Numeric(28, 5)))
   ,(N'1998', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55899.00000 AS Numeric(28, 5)))
   ,(N'1999', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(56768.00000 AS Numeric(28, 5)))
   ,(N'2000', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(57522.00000 AS Numeric(28, 5)))
   ,(N'2001', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(58176.00000 AS Numeric(28, 5)))
   ,(N'2002', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(58729.00000 AS Numeric(28, 5)))
   ,(N'2003', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(59117.00000 AS Numeric(28, 5)))
   ,(N'2004', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(59262.00000 AS Numeric(28, 5)))
   ,(N'2005', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(59117.00000 AS Numeric(28, 5)))
   ,(N'2006', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(58648.00000 AS Numeric(28, 5)))
   ,(N'2007', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(57904.00000 AS Numeric(28, 5)))
   ,(N'2008', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(57031.00000 AS Numeric(28, 5)))
   ,(N'2009', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(56226.00000 AS Numeric(28, 5)))
   ,(N'2010', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55636.00000 AS Numeric(28, 5)))
   ,(N'2011', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55316.00000 AS Numeric(28, 5)))
   ,(N'2012', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55227.00000 AS Numeric(28, 5)))
   ,(N'2013', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55302.00000 AS Numeric(28, 5)))
   ,(N'2014', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55434.00000 AS Numeric(28, 5)))
   ,(N'2015', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(55538.00000 AS Numeric(28, 5)))
   ,(N'2016', N'American Samoa', N'ASM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29049.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29545.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30110.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30744.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31444.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32194.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33025.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33866.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34721.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35582.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36451.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37177.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37912.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38637.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39330.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39994.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40706.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41416.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42075.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42611.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42967.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43224.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43151.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42850.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42471.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42070.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41428.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40781.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40078.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39304.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38543.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38943.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39513.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40295.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41309.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42507.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44067.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45621.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47072.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48347.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49463.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50474.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51349.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52060.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52642.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53176.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54036.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54959.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55945.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56977.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58039.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59053.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60090.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61122.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62112.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63040.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Antigua and Barbuda', N'ATG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(54681.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(55403.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(56311.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(57368.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(58500.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(59653.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(60818.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(62002.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(63176.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(64307.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(65369.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(66338.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(67205.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(67972.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(68655.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(69253.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(69782.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(70223.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(70508.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(70553.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(70301.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(69750.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(68950.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(67958.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(66863.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(65744.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(64605.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(63484.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(62538.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(61967.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(61906.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(62412.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(63434.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(64868.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(66550.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(68349.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(70245.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(72232.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(74206.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(76041.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(77648.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(78972.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(80030.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(80904.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(81718.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(82565.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(83467.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(84397.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(85350.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(86300.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(87233.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(88152.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(89069.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(89985.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(90900.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(91818.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Antigua and Barbuda', N'ATG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6290827.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6407822.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6575159.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6723653.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6880257.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7036236.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7224696.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7340000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7490057.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7667954.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7845995.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8137332.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8311222.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8464615.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8712762.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8859424.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8968011.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9110144.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9267817.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9415876.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9568208.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9775183.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9972088.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10117547.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10255039.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10426700.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10611757.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10803891.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11018322.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11233402.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11412069.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11559785.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11686497.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11779718.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11890082.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12032558.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12188702.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12333810.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12477812.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12634882.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12795192.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12994813.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13177257.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13360342.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13532824.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13724965.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13960904.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14071702.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14366061.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14659595.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14870683.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15031411.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15244637.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15451303.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15618659.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15756698.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Australia', N'AUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(10276477.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(10483000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(10742000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(10950000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(11167000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(11388000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(11651000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(11799000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(12009000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(12263000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(12507000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(12937000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(13177000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(13380000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(13723000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(13893000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14033000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14192000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14358000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14514000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14692000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(14927000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(15178000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(15369000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(15544000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(15758000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(16018400.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(16263900.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(16532200.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(16814400.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(17065100.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(17284000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(17495000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(17667000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(17855000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(18072000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(18311000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(18517000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(18711000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(18926000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(19153000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(19413000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(19651400.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(19895400.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(20127400.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(20394800.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(20697900.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(20827600.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(21249200.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(21691700.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(22031750.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(22340024.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(22728254.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(23117353.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(23464086.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(23781169.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Australia', N'AUS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4625942.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4621973.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4622717.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4623992.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4623365.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4618921.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4614844.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4612363.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4601623.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4590055.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4588856.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4597963.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4624803.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4660920.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4687004.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4698712.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4714721.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4743374.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4771831.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4805212.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4856676.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4920096.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4982528.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5034574.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5086789.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5129244.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5150180.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5164898.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5177637.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5201386.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5237320.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5275784.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5313182.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5333500.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5335890.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5336970.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5341846.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5358137.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5382267.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5410256.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5434728.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5463723.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5492752.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5517145.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5548609.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5585361.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5606570.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5618656.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5630856.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5640078.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5647222.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5657232.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5674887.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5699859.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5733415.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5772290.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Austria', N'AUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7047539.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7086299.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7129864.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7175811.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7223801.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7270889.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7322066.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7376998.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7415403.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7441055.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7467086.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7500482.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7544201.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7586115.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7599038.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7578903.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7565525.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7568430.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7562305.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7549425.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7549433.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7568710.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7574140.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7561910.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7561434.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7564985.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7569794.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7574586.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7585317.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7619567.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7677850.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7754891.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7840709.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7905633.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7936118.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7948278.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7959017.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7968041.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7976789.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(7992324.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8011566.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8042293.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8081957.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8121423.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8171966.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8227829.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8268641.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8295487.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8321496.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8343323.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8363404.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8391643.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8429991.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8479375.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8541575.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(8611088.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Austria', N'AUT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2143244.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2159066.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2183636.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2215353.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2251870.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2292928.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2337590.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2389795.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2450462.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2520327.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2599430.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2690317.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2784939.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2883422.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2986923.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3096474.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3212506.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3333888.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3458892.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3584092.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3706604.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3809275.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3908363.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4002188.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4089033.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4167727.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4226257.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4281882.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4336519.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4391789.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4413145.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4472625.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4530864.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4592526.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4653851.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4716416.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4775831.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4844050.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4922739.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5007528.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5097188.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5199336.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5303218.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5412303.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5534150.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5670206.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5806759.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5949477.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6148935.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6338883.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6459545.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6589773.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6704091.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6806548.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6903516.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6992920.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Azerbaijan', N'AZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(3897889.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4030130.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4167558.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4307315.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4445653.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4579759.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4708485.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4832098.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(4950977.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5066080.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5178160.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5287272.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5393176.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5496061.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5596160.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5693796.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5789050.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5882395.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(5975045.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6068531.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6163990.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6261942.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6362289.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6464775.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6568857.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6674107.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6779970.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6886428.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(6994139.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7104058.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7159000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7271000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7382000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7495000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7597000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7685000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7763000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7838250.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7913000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(7982750.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8048600.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8111200.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8171950.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8234100.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8306500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8391850.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8484550.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8581300.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8763400.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(8947243.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9054332.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9173082.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9295784.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9416801.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9535079.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(9651349.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Azerbaijan', N'AZE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1491223.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1510506.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1527642.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1545715.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1569556.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1601385.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1628096.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1664490.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1706370.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1747970.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1786391.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1804024.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1820061.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1837730.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1860903.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1891846.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1933455.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1982996.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2038784.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2098819.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2161236.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2207157.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2258863.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2314807.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2373717.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2435283.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2493862.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2557073.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2623265.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2691614.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2761542.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2798711.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2840281.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2885995.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2934771.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2986651.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3026410.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3068439.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3118389.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3183374.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3267957.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3406685.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3566628.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3743126.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3928708.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4117322.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4300688.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4487437.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4675937.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4865404.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5055045.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5216337.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5381847.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5550335.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5720931.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5894355.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Burundi', N'BDI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(2786740.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(2840375.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(2894510.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(2950903.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3011957.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3079034.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3153879.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3235125.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3317315.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3392949.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3457113.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3507593.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3547335.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3582952.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3623853.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3676991.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3744696.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3825484.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(3917866.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4018927.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4126544.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4239673.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4359122.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4486613.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4624617.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4774258.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(4936429.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5108581.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5284173.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5454475.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5613141.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5759429.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(5895131.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6019901.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6134041.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6239030.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6333415.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6420397.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6511920.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6623707.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6767073.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(6946720.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(7159918.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(7401215.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(7661613.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(7934213.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(8218070.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(8514578.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(8821795.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(9137786.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(9461117.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(9790151.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(10124572.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(10465959.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(10816860.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(11178921.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Burundi', N'BDI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5870478.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5853688.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5857414.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5892922.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5942357.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5987817.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6016519.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6040897.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6058149.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6073576.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6084546.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6099395.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6132579.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6167851.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6210453.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6258074.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6290997.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6325684.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6364049.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6408791.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6461655.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6505491.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6554058.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6603225.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6642887.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6669209.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6672111.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6665289.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6665426.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6667065.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6667338.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6671478.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6679672.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6688095.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6692094.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6691022.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6688405.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6692843.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6698335.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6706444.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6716577.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743872.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6777474.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6809636.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6846136.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6895166.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6944904.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7005635.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7072124.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7134686.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7195658.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7278550.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7307511.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7313303.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7312279.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7316617.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belgium', N'BEL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9153489.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9183948.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9220578.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9289770.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9378113.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9463667.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9527807.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9580991.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9618756.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9646032.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9655549.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9673162.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9711115.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9741720.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9772419.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9800700.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9818227.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9830358.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9839534.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9848382.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9859242.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9858982.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9856303.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9855520.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9855372.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9858308.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9861823.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9870234.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9901664.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9937697.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(9967379.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10004486.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10045158.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10084475.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10115603.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10136811.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10156637.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10181245.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10203008.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10226419.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10251250.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10286570.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10332785.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10376133.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10421137.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10478617.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10547958.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10625700.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10709973.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10796493.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(10895586.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(11047744.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(11128246.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(11182817.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(11231213.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(11285721.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belgium', N'BEL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1372571.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1381994.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1393162.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1406293.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1422242.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1441469.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1454884.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1472505.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1493832.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1518211.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1545316.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1567312.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1593179.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1622765.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1656020.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1692919.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1726332.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1764282.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1806440.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1852469.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1902188.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1948204.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1999356.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2055072.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2114740.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2178131.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2237241.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2301087.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2370858.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2448268.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2534354.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2630948.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2737927.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2851749.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2968089.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3084139.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3177921.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3272583.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3370632.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3475628.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3590157.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3716547.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3853730.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3999842.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4152532.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4309994.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4457443.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4611489.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4771379.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4936501.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5106666.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5268782.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5436637.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5610562.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5791094.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5978513.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Benin', N'BEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2431620.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2466002.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2503232.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2543335.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2586362.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2632360.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2681382.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2733450.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2788551.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2846652.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2907769.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(2971941.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3039300.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3110074.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3184547.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3262959.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3345501.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3432262.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3523270.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3618509.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3718024.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3822206.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(3931355.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4045352.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4163968.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4287263.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4414450.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4546136.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4685375.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(4836240.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5001271.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5182525.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5378226.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5582420.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5786794.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(5985658.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(6176318.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(6361301.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(6546493.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(6740491.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(6949366.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(7174911.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(7414744.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(7665681.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(7922796.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(8182362.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(8443717.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(8707637.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(8973525.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(9240982.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(9509798.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(9779391.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(10049792.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(10322232.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(10598482.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(10879829.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Benin', N'BEN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2721252.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2740146.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2763817.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2791772.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2823546.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2859013.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2884127.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2914177.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2948969.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2988750.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3033577.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3064108.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3102560.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3147488.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3196629.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3248837.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3287024.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3329082.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3376570.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3431875.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3496158.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3550581.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3617386.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3693925.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3776984.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3865226.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3946554.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4036275.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4134367.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4241493.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4358276.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4471213.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4594752.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4728878.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4873451.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5028184.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5171799.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5328309.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5496002.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5672843.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5857981.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6029999.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6213959.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6409855.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6617644.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6836893.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7044976.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7267203.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7501899.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7748419.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8006905.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8259186.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8528083.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8812423.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9110384.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9421166.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Burkina Faso', N'BFA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1960', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(4829291.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(4894578.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(4960325.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5027818.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5098892.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5174869.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5256363.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5343020.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5434040.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5528172.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5624597.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5723379.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5825171.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(5930487.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6040044.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6154548.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6274037.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6398937.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6530820.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6671659.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6822840.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(6985158.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(7158256.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(7340907.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(7531244.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(7727912.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(7930690.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(8140076.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(8356306.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(8579825.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(8811033.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(9050090.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(9297116.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(9552473.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(9816586.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(10089876.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(10372809.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(10665781.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(10969093.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(11283016.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(11607944.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(11943740.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(12290984.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(12651596.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(13028039.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(13421929.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(13834195.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(14264002.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(14709011.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(15165856.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(15632066.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(16106851.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(16590813.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(17084554.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(17589198.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(18105570.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Burkina Faso', N'BFA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26734111.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27301771.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27952249.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28666918.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29418435.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30194126.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30931673.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31706294.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32490387.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33272082.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34051412.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34612045.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35129354.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35659818.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36255683.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36955432.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37752426.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38724210.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39839582.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41070550.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42391763.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43585443.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44924394.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46374829.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47891926.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49456857.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51000406.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52597968.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54253426.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55988034.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57808923.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59533061.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61330037.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63199786.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65138500.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67145326.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69135650.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71190383.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73295071.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75434301.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77590779.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79596906.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81633114.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83665413.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85653890.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87578449.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89246500.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90867473.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92473005.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94105419.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95800712.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97672878.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99568352.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101505150.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103508200.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105580087.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bangladesh', N'BGD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(48200702.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(49593610.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(51030604.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(52532595.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(54129390.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(55835020.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(57675529.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(59625294.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(61585520.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(63422570.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(65048701.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(66417450.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(67578486.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(68658472.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(69837960.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(71247153.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(72930206.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(74848466.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(76948378.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(79141947.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(81364176.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(83599582.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(85868228.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(88181211.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(90559540.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(93015182.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(95550798.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(98149262.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(100779551.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(103400571.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(105983136.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(108509679.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(110987459.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(113442354.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(115913710.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(118427768.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(120987124.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(123574107.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(126169583.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(128746273.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(131280739.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(133776064.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(136228456.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(138600174.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(140843786.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(142929979.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(144839238.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(146592687.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(148252473.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(149905836.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(151616777.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(153405612.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(155257387.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(157157394.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(159077513.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(160995642.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bangladesh', N'BGD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5227031.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5286714.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5349193.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5412484.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5475088.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5529209.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5573154.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5613463.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5655872.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5699238.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5733715.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5756162.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5772807.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5791118.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5816032.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5828491.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5830592.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5837308.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5823731.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5820971.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5846155.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5873289.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5912916.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5956467.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5993677.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6004733.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6003810.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5999158.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5986759.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5904716.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5799477.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5732834.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5677099.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5647348.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5644498.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5631625.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5614669.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5588245.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5558181.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5540257.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5534864.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5449664.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5368451.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5361269.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5351529.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5334954.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5308837.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5198169.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5149885.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5098731.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5042150.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4974974.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4911920.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4850560.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4788905.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4725164.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bulgaria', N'BGR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7867374.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7943118.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8012946.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8078145.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8144340.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8204168.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8258057.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8310226.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8369603.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8434172.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8489574.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8536395.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8576200.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8620967.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8678745.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8720742.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8758599.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8804183.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8814032.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8825940.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8861535.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8891117.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8917457.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8939738.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8960679.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8960547.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8958171.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8971359.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8981446.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8876972.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8718289.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8632367.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8540164.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8472313.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8443591.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8406067.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8362826.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8312068.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8256786.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8210624.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8170172.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(8020282.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7868468.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7823557.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7781161.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7739900.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7699020.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7545338.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7492561.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7444443.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7395599.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7348328.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7305888.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7265115.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7223938.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(7177991.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bulgaria', N'BGR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90499.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91725.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93072.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94228.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95135.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96135.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99172.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102088.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104999.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108221.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112037.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118018.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125422.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134119.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143944.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154797.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168781.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183972.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199523.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214457.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(228059.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238208.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246262.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(253068.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(259879.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267649.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276996.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288006.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299771.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311491.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322979.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332873.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343426.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(354707.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366822.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379644.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(390790.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403589.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(417021.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(430855.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445820.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(472641.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500482.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531303.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(568668.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(615032.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(686616.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(767125.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(849908.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(925557.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(986982.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1015775.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1031149.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1037061.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1040769.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1048273.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bahrain', N'BHR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(162501.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(167924.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(173107.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(178048.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(182774.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(187348.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(191782.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(196203.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(200953.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(206469.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(213102.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(220808.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(229588.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(239860.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(252139.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(266686.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(283843.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(303236.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(323511.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(342829.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(359902.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(374125.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(385950.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(396447.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(407223.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(419425.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(433487.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(448994.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(465235.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(481126.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(495944.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(509654.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(522748.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(535692.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(549151.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(563730.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(579855.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(597834.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(618054.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(640904.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(666855.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(694893.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(725365.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(761595.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(807989.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(867014.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(940808.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1026568.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1115777.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1196774.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1261319.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1306014.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1333577.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1349427.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1361930.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(1377237.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bahrain', N'BHR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58959.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62024.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65175.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68328.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71459.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74603.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78351.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82196.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85930.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89305.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92232.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95814.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98524.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100722.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102996.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105698.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108587.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112239.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116351.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120382.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124060.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128432.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132127.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(135447.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138899.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142721.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146036.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149992.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154299.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158428.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162132.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166212.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169648.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172685.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175813.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179250.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181704.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184576.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187799.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191166.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194650.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200019.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205676.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211679.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218008.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(224490.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229943.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235531.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(241521.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247913.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254436.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258986.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(263627.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267967.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271682.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274711.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bahamas, The', N'BHS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(109526.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(115108.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(121083.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(127331.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(133697.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(140049.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(146364.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(152607.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(158629.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(164250.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(169356.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(173867.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(177844.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(181489.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(185097.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(188882.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(192905.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(197118.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(201511.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(206038.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(210660.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(215404.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(220275.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(225185.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(230016.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(234684.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(239132.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(243391.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(247576.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(251855.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(256338.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(261117.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(266133.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(271165.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(275903.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(280151.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(283792.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(286968.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(290054.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(293572.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(297891.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(303138.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(309170.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(315757.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(322539.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(329243.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(335801.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(342259.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(348587.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(354780.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(360830.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(366711.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(372388.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(377841.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(383054.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(388019.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bahamas, The', N'BHS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1889172.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1923408.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1961443.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2002940.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2046242.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2090050.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2123152.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2160389.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2199879.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2238701.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2275756.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2318304.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2356580.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2393285.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2433090.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2478060.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2518629.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2565812.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2617741.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2670370.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2721548.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2779154.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2830245.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2878060.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2928430.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2983307.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3031888.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3087899.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3136582.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3157938.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3141556.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3084193.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2988572.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2875039.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2770362.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2691445.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2647070.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2627941.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2628127.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2637851.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2649602.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2655012.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2668250.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2685434.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2701955.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2715454.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2735261.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2746164.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2750573.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2753054.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2755405.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2747278.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2741664.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2735809.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2725076.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2707604.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bosnia and Herzegovina', N'BIH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3214520.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3277096.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3341809.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3406466.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3468083.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3524596.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3574972.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3619997.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3661642.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3702834.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3745637.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3790948.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3838002.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3885229.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3930283.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3971608.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4008411.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4041623.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4073480.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4107135.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4144726.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4185074.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4226663.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4270598.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4318301.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4369527.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4428460.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4491745.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4542757.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4559256.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4526996.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4437898.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4301169.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(4141167.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3992256.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3879278.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3810649.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3779354.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3775898.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3784389.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3792878.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3799747.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3808347.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3817313.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3825872.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3833377.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3838504.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3840418.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3839749.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3837732.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3835258.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3832310.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3828419.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3823533.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3817554.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(3810416.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bosnia and Herzegovina', N'BIH', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5146671.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5141263.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5156156.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5186289.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5223755.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5264451.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5317944.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5378530.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5446739.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5522864.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5604864.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5703164.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5796380.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5883469.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5964614.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6039264.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6099453.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6172278.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6255038.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6332547.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6402966.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6475986.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6541681.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6601109.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6655544.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6704258.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6734372.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6764929.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6770116.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6774729.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6770217.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6750252.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743703.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743911.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6732439.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6721251.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6729536.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6739450.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6752912.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6779385.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6808471.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6786665.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6771878.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6753877.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6740536.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6732840.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6721386.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6728095.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743169.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6756137.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6756546.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6734296.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6706273.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6679305.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6661944.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6654426.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belarus', N'BLR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8198000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8271216.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8351928.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8437232.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8524224.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8610000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8696496.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8785648.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8874552.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(8960304.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9040000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9115576.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9188968.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9257272.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9317584.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9367000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9411000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9463000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9525000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9584000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9643000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9710000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9776000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9843000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9910000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9975000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10043000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10111000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10140000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10170000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10189000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10194000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10216000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10239000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10227000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10194000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10160000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10117000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10069000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10035000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(10005000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9928000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9865000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9797000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9730000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9663000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9604000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9560000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9528000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9507000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9490000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9473000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9464000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9466000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9483000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(9513000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belarus', N'BLR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46563.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47272.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48177.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49215.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50363.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51630.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53085.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54611.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56188.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57787.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59367.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60274.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61117.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61942.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62787.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63691.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64667.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65787.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67152.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68761.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70571.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73117.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75700.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78349.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81163.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84172.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86809.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89744.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92785.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95667.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98295.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100406.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102157.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103938.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106240.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109312.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114096.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119713.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125684.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131484.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136890.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142197.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147309.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152401.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157723.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163412.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169391.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175586.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181918.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188266.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194539.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(201525.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208366.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215186.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222112.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229165.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belize', N'BLZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(92068.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(94701.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(97389.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(100166.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(103070.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(106121.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(109344.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(112699.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(116061.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(119260.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(122179.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(124792.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(127148.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(129294.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(131306.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(133261.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(135145.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(136991.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(138972.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(141308.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(144151.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(147566.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(151498.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(155820.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(160342.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(164916.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(169570.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(174326.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(179025.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(183470.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(187552.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(191127.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(194321.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(197615.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(201678.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(206962.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(213674.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(221608.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(230289.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(239024.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(247312.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(254989.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(262202.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(269132.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(276085.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(283279.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(290751.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(298403.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(306165.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(313925.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(321609.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(329193.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(336707.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(344193.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(351706.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(359287.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Belize', N'BLZ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bermuda', N'BMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(44400.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(45500.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(46600.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(47700.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(48900.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(50100.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(51000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(52000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(54000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(55000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(54600.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(54200.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53800.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53400.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53200.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53400.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53600.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(53800.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(54670.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(55050.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(55449.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(55930.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(56423.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(56898.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(57382.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(57849.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(58347.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(58841.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(59326.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(59021.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(58595.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(58910.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(59320.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(59746.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(60129.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(60497.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(60943.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(61285.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(61833.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(62504.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(62912.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(63325.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(63740.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(64154.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(64523.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(64888.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65273.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65636.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65124.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(64564.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(64798.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65001.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65139.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(65235.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bermuda', N'BMU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1960657.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1995208.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2029591.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2065491.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2106381.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2153989.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2195748.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2244987.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2299940.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2357814.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2417139.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2468571.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2523128.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2580319.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2640152.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2702730.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2758537.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2817217.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2878648.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2943101.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3010838.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3071710.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3136911.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3205396.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3276061.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3348625.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3417772.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1987', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3489530.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3564058.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3641829.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3723277.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3807243.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3895437.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3987823.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4084337.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4184814.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4284809.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4389473.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4497778.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4608740.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4721818.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4831107.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4943810.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5058716.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5174608.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5291041.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5407026.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5523411.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5641262.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5762406.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5887750.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6015168.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6147573.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6283038.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6418397.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6551650.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bolivia', N'BOL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(3693451.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(3764815.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(3838096.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(3913397.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(3990855.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4070590.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4152665.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4237126.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4324066.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4413584.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4505774.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4600596.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4698090.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4798510.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(4902173.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5009259.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5119833.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5233677.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5350320.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5469123.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5589572.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5711598.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5835186.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(5959962.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6085499.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6211549.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6337893.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6464736.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6592787.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6723046.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6856246.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(6992521.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7131699.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7273824.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7418864.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7566716.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7717445.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(7870860.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8026257.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8182710.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8339512.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8496378.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8653343.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8810420.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(8967740.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9125405.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9283345.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9441482.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9599916.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9758799.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(9918245.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(10078238.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(10238762.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(10399931.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(10561887.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(10724705.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bolivia', N'BOL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38789709.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39790423.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40839951.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41955351.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43166253.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44487746.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45730245.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47148142.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48692473.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50290455.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51908306.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53573288.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55230223.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56921114.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58711112.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60624216.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62498476.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64483988.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66553161.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68657461.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70766146.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72735644.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74748324.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76779923.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78822452.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80879521.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82839820.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84857764.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86921325.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89019354.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91152976.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93332166.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95510988.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97733693.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100045320.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102456442.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104875565.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107331400.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109810337.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112286048.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114732589.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116931967.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119165914.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121378234.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123517926.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125572297.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127530111.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129443357.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131314147.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133146439.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134943102.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136868092.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138633217.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140308722.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141982773.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143680172.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Brazil', N'BRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(72493585.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(74706888.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(77007549.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(79368453.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(81751802.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(84130061.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(86494987.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(88853679.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(91213009.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(93585746.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(95982453.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(98402200.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(100844391.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(103320787.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(105846274.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(108431284.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(111076063.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(113776467.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(116532153.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(119341444.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(122199721.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(125107382.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(128054757.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(131014337.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(133950551.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(136836428.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(139664639.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(142437479.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(145150468.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(147801816.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(150393143.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(152916852.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(155379009.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(157812220.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(160260508.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(162755054.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(165303155.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(167893835.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(170516482.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(173153066.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(175786441.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(178419396.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(181045592.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(183627339.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(186116363.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(188479240.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(190698241.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(192784521.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(194769696.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(196701298.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(198614208.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(200517584.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(202401584.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(204259377.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(206077898.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(207847528.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Brazil', N'BRA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127264.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126637.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126405.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126427.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126501.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126531.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126917.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127472.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128220.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129200.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130463.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133498.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136234.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138781.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141378.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144106.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145665.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147593.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149289.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150257.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150558.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153089.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155014.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156686.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158572.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160833.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162643.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164918.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167382.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169615.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171423.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172881.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173881.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174599.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175300.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176120.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176847.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177655.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178453.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179094.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179528.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180908.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182037.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183017.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184013.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185104.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186032.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187032.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187970.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188659.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189028.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189573.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189742.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189607.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189305.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188918.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Barbados', N'BRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(230934.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(231674.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(232584.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(233587.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(234547.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(235373.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(236043.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(236620.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(237199.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(237911.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(238847.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(240038.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(241441.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(242980.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(244539.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(246033.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(247444.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(248785.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(250035.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(251176.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(252197.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(253080.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(253836.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(254515.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(255195.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(255929.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(256738.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(257609.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(258524.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(259454.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(260374.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(261281.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(262184.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(263091.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(264015.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(264962.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(265940.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(266944.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(267949.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(268920.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(269838.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(270686.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(271479.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(272261.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(273091.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(274013.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(275040.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(276154.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(277315.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(278466.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(279566.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(280602.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(281580.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(282503.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(283380.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(284215.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Barbados', N'BRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42990.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44515.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45885.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47279.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48997.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51192.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54100.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57507.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61296.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65270.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69296.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73432.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77605.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81825.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86150.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90601.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94701.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99127.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103710.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108349.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113035.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116877.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120751.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124660.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128631.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132700.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138533.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144319.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150006.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155692.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161459.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166633.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172188.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177978.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183882.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189877.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195851.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202085.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208484.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215020.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221673.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227451.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233379.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239221.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245004.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250871.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256289.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262195.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268293.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274287.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280070.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286206.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291723.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(296809.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301764.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306694.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Brunei Darussalam', N'BRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(81825.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(85687.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(89603.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(93650.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(97933.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(102525.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(107450.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(112680.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(118176.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(123875.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(129729.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(135716.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(141836.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(148067.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(154395.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(160799.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(167283.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(173826.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(180357.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(186786.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(193057.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(199136.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(205061.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(210933.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(216893.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(223049.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(229418.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(235980.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(242750.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(249738.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(256939.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(264365.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(271989.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(279717.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(287423.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(295010.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(302449.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(309746.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(316873.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(323812.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(330554.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(337074.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(343383.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(349557.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(355700.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(361889.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(368150.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(374459.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(380786.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(387080.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(393302.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(399443.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(405512.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(411499.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(417394.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(423188.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Brunei Darussalam', N'BRN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126124.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128466.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131516.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(135017.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138582.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142046.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145256.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148527.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152031.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156087.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160867.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166218.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172371.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179131.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186238.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193497.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199681.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(206155.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212761.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219398.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226014.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230476.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234960.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239756.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245225.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251547.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258923.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267117.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275118.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281737.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286254.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284188.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279843.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274655.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(270384.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268309.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272648.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279761.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(289281.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(300705.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313546.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329936.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(347847.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366485.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384934.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(402614.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(417817.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(432003.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445311.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458221.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(471074.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(482607.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494402.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506116.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(517213.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(527442.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bhutan', N'BTN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(224108.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(229297.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(234703.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(240364.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(246324.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(252629.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(259270.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(266293.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(273868.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(282210.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(291457.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(301653.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(312712.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(324465.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(336677.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(349146.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(361862.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(374801.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(387731.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(400378.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(412561.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(423887.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(434385.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(444789.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(456135.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(469010.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(484151.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(500952.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(517068.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(529284.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(535505.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(534678.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(528085.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(518847.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(511382.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(508897.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(512377.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(520917.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(533506.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(548387.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(564187.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(580784.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(598421.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(616474.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(634235.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(651163.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(666920.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(681471.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(694990.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(707830.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(720246.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(732246.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(743711.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(754637.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(765008.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(774830.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Bhutan', N'BTN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264236.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268091.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271641.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275446.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280382.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286890.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294660.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304035.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(314805.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(326504.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338848.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351645.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(365315.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379862.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(395370.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(411866.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(429634.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448388.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467889.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487890.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508218.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(526481.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(545333.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(564782.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(584924.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(605935.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(627337.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(649922.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(673807.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(699203.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(726231.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(754713.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(784661.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(815757.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(847537.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(879568.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(908347.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(937342.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(966280.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(994836.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1022808.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1046268.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1069479.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1092876.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1117090.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1142653.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1172301.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1202996.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1234603.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1266871.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1299411.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1331503.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1363664.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1395491.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1426690.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1457127.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Botswana', N'BWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(524029.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(536576.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(549990.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(564316.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(579560.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(595741.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(612950.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(631276.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(650730.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(671305.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(693021.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(715811.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(739754.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(765177.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(792513.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(822029.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(853860.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(887793.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(923305.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(959666.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(996331.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1033073.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1069962.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1107103.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1144716.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1182942.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1221668.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1260720.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1300097.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1339813.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1379814.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1420098.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1460453.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1500356.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1539135.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1576291.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1611827.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1645846.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1678111.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1708368.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1736579.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1762531.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1786672.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1810438.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1835750.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1864003.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1895671.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1930431.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(1967866.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2007212.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2047831.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2089706.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2132822.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2176510.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2219937.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(2262485.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Botswana', N'BWA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(863909.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(872690.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(883434.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(896010.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910481.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(926859.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(939806.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(955310.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(972767.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(991498.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1011093.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1023852.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1038205.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1054312.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1072465.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1092914.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1112123.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1134264.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1159438.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1187816.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1219396.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1253042.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1290554.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1330259.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1370204.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1409155.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1435430.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1461188.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1487876.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1517522.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1551563.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1589760.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1633553.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1681571.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1731888.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1783100.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1827010.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1871477.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1916566.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1962690.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2009957.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2043425.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2079488.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2118099.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2159128.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2202946.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2248481.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2298274.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2352018.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2409438.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2470123.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2530147.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2592652.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2657810.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2726119.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2797661.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Central African Republic', N'CAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1503501.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1529229.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1556656.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1585765.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1616515.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1648830.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1682874.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1718558.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1755260.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1792150.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1828710.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1864757.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1900702.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1937383.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(1975968.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2017379.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2061552.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2108417.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2158844.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2213888.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2274095.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2340259.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2411693.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2485666.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2558432.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2627424.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2691312.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2751163.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2809720.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2871005.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(2937832.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3010950.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3089141.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3170848.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3253698.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3335840.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3417163.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3497910.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3577028.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3653310.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3726048.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3794677.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3859784.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3923294.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(3987896.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4055608.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4127112.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4202104.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4280405.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4361492.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4444973.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4530903.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4619500.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4710678.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4804316.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(4900274.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Central African Republic', N'CAF', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10493841.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10683010.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10882678.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11106352.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11353205.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11611865.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11913968.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12240379.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12568141.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12876917.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13196752.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13561247.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13931143.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14315016.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14726203.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15169568.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15487600.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15802493.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16096679.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16377214.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16684797.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16962707.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17217129.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17418428.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17599365.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17764398.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17932935.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18152004.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18364307.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18666625.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18916926.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19140975.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19341122.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19523969.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19697555.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19864938.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20080400.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20321135.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20545152.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20771051.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21010831.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21293249.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21546545.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21818897.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22094476.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22365880.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22586835.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22839576.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23104419.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23363245.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23591101.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23748102.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23944812.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24120992.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24266420.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24340545.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Canada', N'CAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(17909009.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(18271000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(18614000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(18964000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(19325000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(19678000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(20048000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(20412000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(20744000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(21028000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(21324000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(21645535.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(21993631.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(22369408.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(22774087.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(23209000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(23518000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(23796000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(24036000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(24277000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(24593000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(24900000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(25202000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(25456000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(25702000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(25942000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(26204000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(26550000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(26895000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(27379000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(27791000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(28171682.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(28519597.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(28833410.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(29111906.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(29354000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(29671900.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(29987200.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(30247900.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(30499200.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(30769700.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(31081900.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(31362000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(31676000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(31995000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(32312000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(32570505.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(32887928.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(33245773.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(33628571.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(34005274.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(34342780.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(34751476.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(35155499.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(35543658.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(35851774.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Canada', N'CAN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58103440.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58588564.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59157865.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59860703.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60641004.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61335632.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62097015.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62925367.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63692501.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64402830.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65016601.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65410192.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66034600.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66696141.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67313686.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67853569.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68257575.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68467783.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68559952.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68696767.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69038218.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69448962.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70047159.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70743071.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71376573.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71870286.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72243075.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72464313.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72608387.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72655001.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72739132.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72461937.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72460659.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72813633.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73106981.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73365429.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73426339.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73643253.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73767335.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74022539.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73933356.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73841059.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73700762.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73809715.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73932579.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74027001.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74014635.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73784517.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73571326.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73403504.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73025424.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72474978.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71996649.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71491108.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70920445.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70307356.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Central Europe and the Baltics', N'CEB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(91401583.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(92237118.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(93014890.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(93845749.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(94722599.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(95447065.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(96148635.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(97043587.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(97882394.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(98602140.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(99133296.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(99638983.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(100363597.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(101120519.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(101946256.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(102862489.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(103770134.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(104589313.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(105304312.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(105924838.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(106564905.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(107187982.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(107770794.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(108326895.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(108853181.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109360296.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109847148.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110296680.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110688533.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110801380.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110745760.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110290445.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110005636.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110081461.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(110019570.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109913216.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109563097.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109459093.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109207205.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(109092730.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(108405522.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(107811539.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(107128884.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(106808998.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(106530417.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(106254694.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(105999320.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(105504531.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(105126686.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(104924372.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(104543801.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(104174038.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(103935318.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(103713726.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2014', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(103496179.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(103318638.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Central Europe and the Baltics', N'CEB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3498743.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3556031.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3642034.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3720808.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3785653.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3833760.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3866451.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3908288.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3952214.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3992641.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4019441.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4031579.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4057212.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4085888.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4111022.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4117441.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4101240.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4097637.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4112991.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4141581.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4182329.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4232396.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4286988.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4334696.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4375566.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4414427.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4444607.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4477908.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4513860.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4550321.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4593558.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4644242.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4684636.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4714468.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4740849.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4765435.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4772890.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4775037.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4784143.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4804947.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4832211.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4870252.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4916430.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4963361.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5008091.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5049844.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5089983.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5141244.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5209372.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5273755.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5323917.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5374764.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5421044.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5469202.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5519088.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5567422.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Switzerland', N'CHE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5327827.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5434294.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5573815.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5694247.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5789228.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5856472.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5918002.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(5991785.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6067714.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6136387.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6180877.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6213399.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6260956.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6307347.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6341405.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6338632.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6302504.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6281174.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6281738.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6294365.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6319408.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6354074.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6391309.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6418773.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6441865.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6470365.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6504124.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6545106.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6593386.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6646912.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6715519.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6799978.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6875364.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6938265.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(6993795.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7040687.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7071850.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7088906.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7110001.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7143991.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7184250.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7229854.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7284753.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7339001.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7389625.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7437115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7483934.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7551117.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7647675.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7743831.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7824909.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7912398.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(7996861.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(8089346.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(8188649.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(8286976.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Switzerland', N'CHE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71467.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71949.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72686.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73419.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74038.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74585.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75353.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76244.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77002.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77575.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78069.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78829.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79757.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80765.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81771.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82716.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83179.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83601.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84066.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84690.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85533.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86546.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87789.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89157.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90540.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91875.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93085.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94322.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95484.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96531.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97455.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97810.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98098.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98326.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98532.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98800.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99241.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99753.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100352.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101055.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101872.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102640.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103498.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104423.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105364.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106254.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106875.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107575.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108352.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109162.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109920.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110359.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110720.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110991.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111195.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111348.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Channel Islands', N'CHI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(109419.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(110399.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(111463.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(112595.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(113778.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(114992.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(116226.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(117475.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(118726.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(119971.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(121196.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(122413.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(123611.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(124728.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(125680.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(126417.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(126906.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(127190.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(127394.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(127694.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(128213.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(128988.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(129983.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(131158.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(132451.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(133804.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(135227.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(136716.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(138186.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(139528.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(140669.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(141568.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(142258.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(142822.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(143388.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(144050.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(144832.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(145709.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(146669.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(147682.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(148725.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(149797.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(150905.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(152034.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(153170.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(154298.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(155415.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(156516.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(157587.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(158613.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(159583.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(160489.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(161336.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(162138.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(162917.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(163692.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Channel Islands', N'CHI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4326025.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4410586.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4497186.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4587494.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4684777.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4790591.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4894862.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5007679.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5127598.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5252803.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5382310.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5504688.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5635211.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5772097.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5913084.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6057235.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6206856.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6356168.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6507479.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6663994.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6826552.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6986721.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7151828.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7320285.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7488730.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7654902.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7814342.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7972339.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8128211.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8283079.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8437894.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8581963.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8731723.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8884210.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9035789.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9185397.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9341309.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9491956.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9642055.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9798303.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9963483.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10131854.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10308316.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10489790.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10670317.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10845935.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11012360.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11175867.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11336111.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11493932.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11649596.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11798302.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11945644.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12089504.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12227342.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12357305.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Chile', N'CHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(7695692.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(7873504.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8054166.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8237555.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8423614.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8612074.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8802926.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(8995410.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(9187592.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(9377005.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(9561868.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(9741579.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(9916558.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10087377.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10255074.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10420590.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10584237.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10746328.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(10907901.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11070198.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11234340.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11400489.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11569135.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11742057.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(11921407.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(12108576.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(12304203.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(12507488.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(12716508.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(12928491.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(13141202.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(13354054.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(13566942.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(13778676.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(13987999.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(14193986.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(14396020.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(14594070.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(14788609.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(14980484.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(15170387.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(15358418.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(15544554.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(15729268.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(15913119.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(16096571.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(16279728.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(16462701.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(16645940.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(16829957.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17015048.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17201305.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17388437.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17575833.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17762647.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(17948141.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Chile', N'CHL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(376191182.00000 AS Numeric(28, 5)))
   ,(N'1961', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(371876762.00000 AS Numeric(28, 5)))
   ,(N'1962', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372577169.00000 AS Numeric(28, 5)))
   ,(N'1963', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(378935477.00000 AS Numeric(28, 5)))
   ,(N'1964', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(386207827.00000 AS Numeric(28, 5)))
   ,(N'1965', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(395826827.00000 AS Numeric(28, 5)))
   ,(N'1966', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405033095.00000 AS Numeric(28, 5)))
   ,(N'1967', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(415980846.00000 AS Numeric(28, 5)))
   ,(N'1968', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428753234.00000 AS Numeric(28, 5)))
   ,(N'1969', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(442284968.00000 AS Numeric(28, 5)))
   ,(N'1970', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455509445.00000 AS Numeric(28, 5)))
   ,(N'1971', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467286977.00000 AS Numeric(28, 5)))
   ,(N'1972', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478405331.00000 AS Numeric(28, 5)))
   ,(N'1973', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(489399099.00000 AS Numeric(28, 5)))
   ,(N'1974', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500571356.00000 AS Numeric(28, 5)))
   ,(N'1975', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(511939976.00000 AS Numeric(28, 5)))
   ,(N'1976', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(524219056.00000 AS Numeric(28, 5)))
   ,(N'1977', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(536877875.00000 AS Numeric(28, 5)))
   ,(N'1978', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(550837868.00000 AS Numeric(28, 5)))
   ,(N'1979', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(566106080.00000 AS Numeric(28, 5)))
   ,(N'1980', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(581978459.00000 AS Numeric(28, 5)))
   ,(N'1981', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(599692697.00000 AS Numeric(28, 5)))
   ,(N'1982', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(618551548.00000 AS Numeric(28, 5)))
   ,(N'1983', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(637348811.00000 AS Numeric(28, 5)))
   ,(N'1984', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(655193510.00000 AS Numeric(28, 5)))
   ,(N'1985', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(672774877.00000 AS Numeric(28, 5)))
   ,(N'1986', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(688531651.00000 AS Numeric(28, 5)))
   ,(N'1987', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(704361638.00000 AS Numeric(28, 5)))
   ,(N'1988', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(719455474.00000 AS Numeric(28, 5)))
   ,(N'1989', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(733546019.00000 AS Numeric(28, 5)))
   ,(N'1990', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(747133655.00000 AS Numeric(28, 5)))
   ,(N'1991', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(756317502.00000 AS Numeric(28, 5)))
   ,(N'1992', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(766978313.00000 AS Numeric(28, 5)))
   ,(N'1993', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(778336904.00000 AS Numeric(28, 5)))
   ,(N'1994', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(789327269.00000 AS Numeric(28, 5)))
   ,(N'1995', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(799336864.00000 AS Numeric(28, 5)))
   ,(N'1996', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(813177707.00000 AS Numeric(28, 5)))
   ,(N'1997', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(824753011.00000 AS Numeric(28, 5)))
   ,(N'1998', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(835509226.00000 AS Numeric(28, 5)))
   ,(N'1999', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(847642966.00000 AS Numeric(28, 5)))
   ,(N'2000', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(862186290.00000 AS Numeric(28, 5)))
   ,(N'2001', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(877146502.00000 AS Numeric(28, 5)))
   ,(N'2002', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893686481.00000 AS Numeric(28, 5)))
   ,(N'2003', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(911193206.00000 AS Numeric(28, 5)))
   ,(N'2004', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(928281651.00000 AS Numeric(28, 5)))
   ,(N'2005', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(944135441.00000 AS Numeric(28, 5)))
   ,(N'2006', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(956600332.00000 AS Numeric(28, 5)))
   ,(N'2007', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(968464915.00000 AS Numeric(28, 5)))
   ,(N'2008', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979152784.00000 AS Numeric(28, 5)))
   ,(N'2009', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(987901106.00000 AS Numeric(28, 5)))
   ,(N'2010', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(994437514.00000 AS Numeric(28, 5)))
   ,(N'2011', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(999402858.00000 AS Numeric(28, 5)))
   ,(N'2012', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1002465639.00000 AS Numeric(28, 5)))
   ,(N'2013', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1003869526.00000 AS Numeric(28, 5)))
   ,(N'2014', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1004273165.00000 AS Numeric(28, 5)))
   ,(N'2015', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1003968793.00000 AS Numeric(28, 5)))
   ,(N'2016', N'China', N'CHN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(667070000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(660330000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(665770000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(682335000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(698355000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(715185000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(735400000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(754550000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(774510000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(796025000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(818315000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(841105000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(862030000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(881940000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(900350000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(916395000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(930685000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(943455000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(956165000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(969005000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(981235000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(993885000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1008630000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1023310000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1036825000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1051040000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1066790000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1084035000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1101630000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1118650000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1135185000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1150780000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1164970000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1178440000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1191835000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1204855000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1217550000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1230075000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1241935000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1252735000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1262645000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1271850000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1280400000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1288400000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1296075000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1303720000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1311020000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1317885000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1324655000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1331260000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1337705000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1344130000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1350695000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1357380000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1364270000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(1371220000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'China', N'CHN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1943801.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2004171.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2073697.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2150294.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2231482.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2315947.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2397677.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2486361.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2582311.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2686668.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2799839.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2913394.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3039118.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3175634.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3321199.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3474283.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3619183.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3774283.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3939235.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4114396.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4299645.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4475675.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4666431.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4869077.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5080106.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5297300.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5497883.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5704710.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5920506.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6149269.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6392622.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6633451.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6889982.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7158170.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7431819.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7705848.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7944044.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8183251.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8420059.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8650880.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8873248.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9020978.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9162255.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9304017.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9454323.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9619652.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9805336.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10008996.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10232979.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10478349.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10743976.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11033478.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11344300.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11673946.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12018052.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12372068.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cote d''Ivoire', N'CIV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(3474724.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(3602075.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(3740503.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(3889859.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(4049675.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(4219739.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(4400054.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(4591238.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(4794399.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(5010962.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(5241914.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(5487594.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(5747633.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(6021405.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(6307936.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(6606395.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(6916302.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(7237451.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(7569558.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(7912390.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(8265549.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(8629121.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(9002400.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(9383289.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(9769105.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(10158033.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(10548148.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(10939987.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(11337122.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(11744698.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(12165909.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(12600967.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(13046907.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(13499696.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(13953779.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(14404340.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(14852193.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(15296390.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(15728482.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(16137824.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(16517948.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(16865376.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(17185421.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(17491539.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(17802516.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(18132702.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(18486392.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(18862172.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(19261647.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(19684909.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(20131707.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(20604172.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(21102641.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(21622490.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(22157107.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(22701556.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cote d''Ivoire', N'CIV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3023135.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3073081.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3128221.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3188101.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3252541.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3321393.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3377892.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3441880.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3512084.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3587128.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3666457.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3735661.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3811696.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3894426.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3984235.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4081377.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4170468.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4269344.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4376962.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4491822.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4613051.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4726939.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4847899.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4976496.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5114024.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5261129.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5397429.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5547723.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5709622.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5880250.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6058453.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6227813.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6407650.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6598236.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6800794.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7015999.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7221943.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7442198.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7675868.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7921049.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8176262.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8417928.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8670077.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8932997.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9207489.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9493718.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9763461.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10050211.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10351148.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10662761.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10983477.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11293227.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11615773.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11951460.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12302255.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12669290.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cameroon', N'CMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5361367.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5474509.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5593768.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5719135.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5850454.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(5987671.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6130990.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6280743.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6437157.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6600479.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6770967.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(6948847.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(7134374.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(7327874.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(7529704.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(7740196.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(7959500.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(8187840.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(8425707.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(8673666.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(8932121.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(9201146.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(9480638.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(9770555.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(10070779.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(10381098.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(10701458.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(11031515.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(11370394.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(11716975.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(12070359.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(12430311.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(12796739.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(13169100.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(13546823.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(13929575.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(14317191.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(14709961.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(15108630.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(15514249.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(15927713.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(16349364.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(16779434.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(17218591.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(17667576.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(18126999.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(18597109.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(19078100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(19570418.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(20074522.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(20590666.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(21119065.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(21659488.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(22211166.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(22773014.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(23344179.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cameroon', N'CMR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(557193.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(568437.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(580573.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(593571.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607470.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(622303.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(636001.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(650985.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(667209.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684620.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(703198.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721709.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(741681.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(762904.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(785152.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(808272.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(828891.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850661.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(873725.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(898333.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(924687.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(951027.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979746.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1010471.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1042742.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1076313.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1108920.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1142930.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1178501.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1215923.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1255304.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1293677.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1334216.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1376752.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1420939.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1466510.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1511499.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1558117.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1605620.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1653217.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1700397.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1738226.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1776292.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1815879.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1858606.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1905580.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1959902.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2019148.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2081509.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2144892.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2207870.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2259912.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2311859.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2364955.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2421022.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2481507.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Congo, Rep.', N'COG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1013581.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1039966.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1067611.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1096502.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1126602.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1157905.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1190361.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1224041.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1259190.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1296137.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1335090.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1376189.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1419305.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1464052.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1509880.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1556406.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1603446.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1651134.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1699781.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1749859.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1801688.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1855391.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1910800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(1967596.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2025320.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2083648.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2142529.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2202106.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2262496.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2323890.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2386467.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2450125.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2514907.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2581306.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2649964.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2721277.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2795903.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2873638.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(2953011.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3031969.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3109269.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3183883.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3256867.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3331564.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3412592.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3503086.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3604595.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3715665.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3832771.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(3950786.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4066078.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4177435.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4286188.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4394334.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4504962.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(4620330.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Congo, Rep.', N'COG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8303752.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8521242.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8750462.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8995411.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9261094.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9549257.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9833572.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10144819.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10476610.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10822359.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11179899.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11525732.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11897020.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12289849.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12696776.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13114132.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13571371.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14013771.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14458315.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14929942.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15437745.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15915102.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16441820.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16993501.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17533523.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18044253.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18531732.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18997553.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19450368.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19909172.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20385155.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20877843.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21375449.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21882952.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22404954.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22943127.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23476075.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24033893.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24607769.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25182007.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25747709.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26323788.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26878322.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27419813.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27964082.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28517254.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29037636.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29574754.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30112836.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30627691.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31107082.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31567464.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31989391.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32380546.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32755382.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33120687.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Colombia', N'COL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(16480384.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(16982313.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(17500166.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(18033548.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(18581972.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(19144220.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(19721464.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(20311369.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(20905061.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(21490948.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(22061214.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(22611988.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(23146803.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(23674505.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(24208022.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(24756969.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(25323412.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(25905124.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(26502172.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(27113510.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(27737905.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(28375995.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(29027158.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(29687096.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(30350082.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(31011686.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(31669780.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(32324326.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(32975533.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(33624442.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(34271563.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(34916770.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(35558683.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(36195170.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(36823539.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(37441980.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(38049040.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(38645409.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(39234059.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(39819279.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(40403959.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(40988909.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(41572493.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(42152147.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(42724157.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(43285636.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(43835744.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(44374647.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(44901660.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(45416276.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(45918101.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(46406446.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(46881018.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(47342363.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(47791393.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(48228704.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Colombia', N'COL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103926.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104515.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105064.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105701.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106644.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109391.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111276.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113532.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115985.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118543.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120708.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123062.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125757.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128980.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132816.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137173.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142242.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147733.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153299.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158738.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163260.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167636.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172003.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176564.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181460.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186187.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191378.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(196981.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202961.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209319.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215753.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222663.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230023.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(237801.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245977.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254245.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262833.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271736.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280953.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(290467.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299596.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309071.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(318840.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328827.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338989.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(348887.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(359010.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(369388.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(380094.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(391159.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(402035.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413333.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(424967.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(436837.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448900.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Comoros', N'COM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(188732.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(191828.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(194960.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(198205.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(201665.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(205412.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(209536.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(214038.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(218794.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(223629.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(228443.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(233125.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(237797.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(242875.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(248921.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(256309.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(265234.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(275496.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(286583.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(297765.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(308518.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(318659.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(328355.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(337853.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1984', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(347548.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(357729.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(368443.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(379589.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(391133.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(403003.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(415144.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(427556.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(440252.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(453188.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(466309.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(479574.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(492979.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(506525.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(520180.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(533909.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(547696.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(561525.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(575428.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(589500.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(603869.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(618632.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(633814.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(649404.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(665414.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(681845.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(698695.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(715972.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(733661.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(751697.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(769991.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(788474.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Comoros', N'COM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106853.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107190.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107146.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107271.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108462.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111033.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113418.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117304.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121797.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125644.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128271.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129597.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129312.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128224.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127435.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127565.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127641.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128837.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131003.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133696.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136594.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141062.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145593.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150005.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154139.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157875.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160334.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162482.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164578.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166889.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169579.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173451.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177907.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182912.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188395.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194283.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199976.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205922.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212114.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218619.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225519.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233678.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(242211.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250972.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(259618.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267890.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276292.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283890.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291082.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298400.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306073.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(312823.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320348.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328158.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(335593.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342327.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cabo Verde', N'CPV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(202316.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(205958.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(210866.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(216913.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(223854.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(231427.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(239765.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(248733.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(257478.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(264885.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(270197.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(273053.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(273788.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(273211.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(272509.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(272575.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(273625.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(275479.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(278152.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(281555.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(285599.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(290428.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(296071.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(302174.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(308251.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(313976.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(319161.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(323972.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(328861.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(334473.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(341256.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(349326.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(358473.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(368423.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(378763.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(389156.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(399508.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(409805.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(419884.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(429576.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(438737.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(447357.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(455396.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(462675.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(468985.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(474224.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(478265.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(481278.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(483824.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(486673.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(490379.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(495159.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(500870.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(507258.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(513906.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(520502.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cabo Verde', N'CPV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(696604.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(718822.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(745132.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(774042.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(803362.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(832086.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(859614.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887470.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(916003.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(946275.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979016.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1013780.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1050869.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1090380.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1131904.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1174995.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1220747.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1266489.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1312829.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1360640.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1410030.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455605.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1504271.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1554101.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1602498.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1648308.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1691765.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1733254.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1774106.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1816773.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1862821.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1913712.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1968252.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2026363.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2087517.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2151182.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2216802.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2284897.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2354629.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2424958.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2494969.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2559089.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2622908.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2686132.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2748238.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2808952.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2869904.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2927643.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2982807.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3036540.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3089114.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3134995.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3181110.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3226228.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3268536.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3307334.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Costa Rica', N'CRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1333042.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1381920.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1432583.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1484512.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1537035.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1589625.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1642189.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1694711.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1746870.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1798315.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1848873.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1898366.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1947048.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(1995744.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2045580.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2097410.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2151492.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2207727.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2266153.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2326708.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2389309.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2454127.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2521163.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2589932.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2659772.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2730231.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2800986.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2872214.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(2944560.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3018953.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3095994.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3175654.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3257463.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3341005.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3425692.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3510925.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3596733.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3682725.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3767369.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3848725.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3925450.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(3996800.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4063208.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4125970.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4187039.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4247843.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4308790.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4369465.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4429506.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4488261.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4545273.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4600487.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4654148.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4706433.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4757606.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(4807850.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Costa Rica', N'CRI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2145321.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2169568.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2195019.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2221589.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2248463.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2274635.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2293045.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2310738.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2329024.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2349109.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2372358.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2421202.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2468641.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2516728.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2568354.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2624631.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2691940.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2761542.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2830639.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2895596.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2955709.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3019639.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3080864.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3139518.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3198489.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3256984.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3299972.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3342691.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3381961.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3425055.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3461388.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3502097.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3540434.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3578065.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3619020.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3664911.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3722335.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3777822.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3831591.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3878979.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3921687.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3976124.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4024736.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4071756.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4118376.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4165415.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4218945.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4272455.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4326516.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4381088.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4435330.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4488170.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4540489.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4591034.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4637511.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4678295.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Caribbean small states', N'CSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4190810.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4270928.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4353408.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4435830.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4514432.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4586896.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4653340.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4713767.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4770152.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4825706.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4882583.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4940523.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(4999973.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5060335.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5120227.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5178940.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5237098.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5293790.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5350330.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5409054.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5471020.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5531599.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5599100.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5667553.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5732089.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5786277.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5831154.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5863744.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5886592.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5923643.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(5960368.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6001738.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6047269.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6096016.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6146503.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6197620.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6258158.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6312682.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6365223.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6411686.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6454716.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6497461.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6532561.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6567210.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6603018.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6640916.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6681231.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6723587.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6767278.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6811213.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6854569.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6896697.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6937108.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(6975754.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(7012857.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(7048966.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Caribbean small states', N'CSS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4305221.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4391962.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4449478.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4491646.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4540785.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4606763.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4639347.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4707203.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4793127.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4870813.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4929366.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5012019.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5068231.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5113928.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5176854.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5270508.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5370042.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5505277.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5663360.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5818550.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5956075.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6104386.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6220970.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6320439.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6426863.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6551044.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6669152.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6809548.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6956958.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7088903.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7193915.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7269262.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7329349.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7374598.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7410051.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7440601.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7484392.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7512228.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7533716.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7560318.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7596666.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7635537.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7686440.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7742741.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7792805.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7830478.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7859836.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7877135.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7885690.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7892070.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7899855.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7914106.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7928636.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7940710.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7945835.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7941010.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cuba', N'CUB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7141129.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7289828.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7450404.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7618359.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7787149.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(7951928.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8110428.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8263547.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8413329.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8563191.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8715123.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(8869961.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9025299.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9176051.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9315371.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9438445.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9544268.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9634677.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9711393.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9777287.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9835177.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9884219.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9925618.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(9966733.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10017061.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10082990.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10167998.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10269276.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10379080.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10486110.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10582082.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10664577.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10735775.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10797556.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10853435.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10906048.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(10955372.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11000431.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11041893.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11080506.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11116787.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11151472.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11184540.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11214837.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11240680.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11261052.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11275199.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11284043.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11290239.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11297442.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11308133.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11323570.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11342631.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11362505.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11379111.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(11389562.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cuba', N'CUB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67290.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67884.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69257.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70832.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72311.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73659.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74720.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75572.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76721.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78099.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79714.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81554.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82516.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83119.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85016.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86455.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88302.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89912.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90713.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91802.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93182.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94705.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96549.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98010.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99243.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100415.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100525.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99665.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98017.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96210.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94863.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94031.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93500.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93553.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93588.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93763.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94570.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95022.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93498.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90334.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86775.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84474.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85135.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87342.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89271.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91934.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94434.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96509.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97910.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98549.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99569.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101247.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101960.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102729.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103647.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104595.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Curacao', N'CUW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(124826.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(126125.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(128414.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(130860.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(133148.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(135266.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(136682.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(138140.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(140298.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(142581.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144739.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(147389.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(147710.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(146912.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(148351.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(149129.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(149399.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(149459.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(148341.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(147851.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(148041.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(148629.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(150101.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(151159.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(151940.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(152711.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(152662.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(151456.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(149254.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(146937.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(145400.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144403.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(143912.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144299.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144630.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(145139.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(146306.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(146956.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144472.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(139428.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(133860.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(129047.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(129205.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(131897.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(134192.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(137658.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(141239.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(144056.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(145880.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(146833.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(148703.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(150831.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(152088.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(153822.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(155909.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(158040.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Curacao', N'CUW', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cayman Islands', N'CYM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(7867.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8026.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8142.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8228.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8299.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8371.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8442.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8518.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8632.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(8831.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(9144.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(9583.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(10137.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(10785.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(11494.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(12238.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(13020.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(13840.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(14663.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(15447.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(16164.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(16795.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(17357.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(17911.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(18543.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(19315.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(20254.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(21343.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(22539.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(23776.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(25009.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(26211.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(27402.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(28652.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(30055.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(31672.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(33535.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(35596.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(37742.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(39810.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(41685.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(43317.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(44742.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(46032.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(47299.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(48623.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(50028.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(51480.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(52925.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(54285.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(55509.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(56580.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(57522.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(58369.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(59172.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(59967.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cayman Islands', N'CYM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328799.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330318.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332168.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334933.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338820.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343805.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346277.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(349618.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(353583.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(357780.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361822.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(371575.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381288.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(390307.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(398583.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(406519.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(415413.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(424686.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(433832.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(442375.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450028.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451654.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(452799.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(453872.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455681.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458979.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(463605.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(470339.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478210.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(486532.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(495254.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506856.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(519329.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(532385.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(546017.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(560201.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(573469.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(588065.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(603474.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(619319.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(635505.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(652058.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(668677.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684871.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(700555.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715822.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(729457.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(742790.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(755691.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(768086.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(779903.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(789537.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(798876.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(807612.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(815563.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(822743.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cyprus', N'CYP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(572929.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(576395.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(577691.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(577912.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(578629.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(580971.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(585311.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(591304.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(598491.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(606117.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(613619.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(620860.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(628000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(635109.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(642335.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(649755.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(657526.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(665528.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(673252.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(680013.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(685406.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(689173.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(691711.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(694074.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(697717.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(703693.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(712340.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(723380.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(736477.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(751047.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(766611.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(783138.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(800660.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(818814.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(837166.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(855389.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(873246.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(890733.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(908040.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(925491.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(943287.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(961482.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(979883.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(998150.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1015827.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1032586.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1048293.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1063040.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1077010.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1090486.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1103685.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1116644.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1129303.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1141652.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1153658.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(1165300.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cyprus', N'CYP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6236691.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6247933.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6296802.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6353677.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6420071.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6483797.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6518908.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6553806.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6583571.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6602753.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6569082.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6534513.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6532257.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6528015.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6528615.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6533797.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6514197.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6497606.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6488268.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6492876.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6495702.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6502640.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6548973.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6607362.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6660415.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6699368.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6736155.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6749496.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6757302.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6777550.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6798683.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6803656.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6858173.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6927910.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6991723.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7040001.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7069039.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7094867.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7118987.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7144288.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7160347.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7175634.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7196433.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7223196.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7249522.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7277525.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7291208.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7325920.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7372545.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7388272.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7370062.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7319634.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7259240.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7186293.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7116063.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7056879.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Czech Republic', N'CZE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9602006.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9586651.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9624660.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9670685.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9727804.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9779358.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9821040.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9852899.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9876346.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9896580.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9858071.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9826815.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9867632.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9922266.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(9988459.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10058620.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10125939.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10186755.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10242098.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10292341.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10304193.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10300591.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10314826.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10323856.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10330213.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10337118.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10342227.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10347318.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10355276.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10361068.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10333355.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10308578.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10319123.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10329855.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10333587.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10327253.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10315241.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10304131.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10294373.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10283860.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10255063.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10216605.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10196916.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10193998.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10197101.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10211216.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10238905.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10298828.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10384603.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10443936.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10474410.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10496088.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10510785.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10514272.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10525347.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(10551219.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Czech Republic', N'CZE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48823062.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48898783.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48955703.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48999252.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49004759.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49085088.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49111336.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49026742.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49004474.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49214427.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49264770.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49232653.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49467804.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49719505.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49892031.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49895791.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49965940.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50092485.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50320341.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50751567.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51440470.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52023354.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52664265.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53280439.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53731589.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54027253.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54231939.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54319028.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54399555.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54647995.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54968168.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55182076.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55445819.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55692581.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55808634.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55940966.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56081399.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56162708.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56180635.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56211261.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56244446.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56083151.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55917014.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55683672.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55413497.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55146838.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54878177.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54600310.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54313951.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54040067.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53869452.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2011', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53875306.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53005176.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54170112.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53409966.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53629708.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Germany', N'DEU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(72814900.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(73377632.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(74025784.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(74714353.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(75318337.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(75963695.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(76600311.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(76951336.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77294314.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77909682.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78169289.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78312842.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78688452.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78936666.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78967433.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78673554.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78336950.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78159814.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78091820.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78126350.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78288576.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78407907.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78333366.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78128282.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77858685.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77684873.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77720436.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(77839920.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78144619.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(78751283.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(79433029.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(80013896.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(80624598.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81156363.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81438348.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81678051.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81914831.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82034771.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82047195.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82100243.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82211508.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82349925.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82488495.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82534176.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82516260.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82469422.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82376451.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82266372.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82110097.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81902307.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81776930.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81797673.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(80425823.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(82132753.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(80982500.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(81413145.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Germany', N'DEU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45437.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47954.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51144.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54797.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58629.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62470.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66229.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70222.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74401.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78758.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83325.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87672.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92220.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97598.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104559.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113473.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124927.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139017.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154479.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169731.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183719.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192104.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198738.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205067.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212789.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222984.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238547.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256062.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274374.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292411.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309378.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320219.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330295.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(339752.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(348487.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(356759.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(365636.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373861.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381982.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(390936.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(401121.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(411522.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(422905.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435059.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(447462.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(459765.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(470852.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(482261.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493727.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(504942.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(515722.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(525034.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(533838.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(542345.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(550992.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(560045.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Djibouti', N'DJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(83636.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(88499.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(94200.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(100622.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(107584.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(114963.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(122868.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(131403.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(140461.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(149891.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(159667.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(169370.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(179212.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(190536.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(205157.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(224182.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(248619.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(277622.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(308213.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(336254.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(358960.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(374683.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(384743.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(392908.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(404589.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(423470.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(451068.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(485565.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(523266.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(558810.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(588356.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(610679.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(627063.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(639215.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(649878.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(661076.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(673202.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(685644.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(698256.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(710652.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(722562.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(734088.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(745459.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(756656.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(767644.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(778406.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(788941.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(799309.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(809639.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(820097.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(830802.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(841802.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(853069.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(864554.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(876174.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(887861.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Djibouti', N'DJI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Dominica', N'DMA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(60016.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(61035.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(61984.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(62920.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(63921.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(65038.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(66305.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(67682.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(69042.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70212.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71076.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71566.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71737.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71745.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71811.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72091.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72648.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(73411.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(74239.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(74923.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(75313.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(75376.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(75168.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(74750.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(74215.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(73640.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(73025.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72368.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71743.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71242.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70928.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70849.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70978.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71205.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71372.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71367.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71146.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70756.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70295.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(69902.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(69679.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(69660.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(69806.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70058.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70325.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70542.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70690.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70795.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70881.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(70995.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71167.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71402.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(71685.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72005.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72341.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(72680.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Dominica', N'DMA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2939426.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2963799.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2994046.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3025997.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3056764.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3084011.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3106400.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3127976.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3143110.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3155945.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3175003.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3191017.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3202781.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3216541.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3228582.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3238548.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3247126.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3261689.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3279920.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3299049.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3316695.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3330772.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3346262.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3363573.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3380998.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3399458.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3418132.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3432580.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3441613.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3450284.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3462474.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3471805.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3484934.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3497966.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3509406.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3525279.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3537392.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3544349.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3549447.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3553900.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3559587.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3566477.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3571749.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3575484.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3579035.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3583220.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3587520.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3595702.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3608677.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3619456.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3626817.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3629692.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3631791.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3633424.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3636271.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3641697.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Denmark', N'DNK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4579603.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4611687.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4647727.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4684483.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4722072.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4759012.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4797381.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4835354.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4864883.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4891860.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4928757.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4963126.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(4991596.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5021861.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5045297.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5059862.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5072596.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5088419.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5104248.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5116801.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5123027.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5121572.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5117810.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5114297.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5111619.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5113691.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5120534.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5127024.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5129516.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5132594.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5140939.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5154298.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5171370.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5188628.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5206180.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5233373.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5263074.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5284991.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5304219.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5321799.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5339616.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5358783.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5375931.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5390574.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5404523.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5419432.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5437272.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5461438.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5493621.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5523095.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5547683.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5570572.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5591572.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5614932.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5643475.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(5676002.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Denmark', N'DNK', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1621415.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1666083.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1713506.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1764078.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1818683.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1877964.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1940051.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2007013.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2078393.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2153581.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2232317.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2313207.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2397511.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2484811.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2574795.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2667268.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2760482.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2856105.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2953421.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3051437.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3149591.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3247791.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3344778.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3441033.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3537612.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3635170.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3731045.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3828713.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3927276.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4025225.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4121985.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4221493.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4318676.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4414646.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4511485.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4610346.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4709293.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4811581.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4915988.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5019910.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5122071.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5229497.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5332365.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5433241.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5536127.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5642723.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5748684.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5859192.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5971479.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6081033.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6185611.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6290920.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6390654.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6486167.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6580099.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6673789.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Dominican Republic', N'DOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3294039.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3406299.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3521276.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3638628.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3757962.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(3878952.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4001377.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4125107.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4250026.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4376056.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4503114.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4631114.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4759935.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(4889437.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5019471.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5149934.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5280727.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5411867.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5543520.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5675930.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5809271.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(5943591.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6078816.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6214857.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6351572.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6488857.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6626544.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6764623.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(6903314.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7042940.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7183646.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7325622.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7468551.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7611463.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7753052.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(7892420.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8029114.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8163474.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8296375.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8429116.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8562623.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8697127.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8832286.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(8967759.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9102997.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9237565.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9371333.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9504336.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9636491.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9767737.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(9897983.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(10027140.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(10155036.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(10281408.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(10405943.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(10528391.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Dominican Republic', N'DOM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5811614.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5891156.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5952988.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6014606.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6102025.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6228412.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6367093.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6551767.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6768713.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6995722.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7220492.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7422068.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7623375.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7830321.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8053885.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8300028.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8540484.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8806299.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9094795.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9401452.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9723875.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10047887.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10395855.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10765260.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11155024.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11564450.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11975708.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12407711.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12858024.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13324820.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13806989.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14291285.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14790625.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15304174.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15832213.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16374753.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16906994.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17456849.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18019181.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18583980.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19144448.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19730888.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20296666.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20849148.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21395828.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21934975.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22439619.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22919566.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23377247.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23816330.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24237093.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24603801.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24984984.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25355882.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25693018.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25990793.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Algeria', N'DZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(11124892.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(11404859.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(11690152.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(11985130.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(12295973.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(12626953.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(12980269.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(13354197.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(13744383.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(14144437.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(14550033.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(14960111.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(15377095.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(15804428.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(16247113.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(16709098.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(17190236.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(17690184.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(18212331.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(18760761.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(19337723.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(19943667.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(20575701.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(21228288.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(21893857.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(22565908.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(23241276.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(23917889.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(24591493.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(25257671.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(25912364.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(26554277.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(27180921.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(27785977.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(28362015.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(28904300.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(29411839.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(29887717.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(30336880.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(30766551.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(31183658.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(31590320.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(31990387.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(32394886.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(32817225.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(33267887.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(33749328.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(34261971.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(34811059.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(35401790.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(36036159.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(36717132.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(37439427.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(38186135.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(38934334.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(39666519.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Algeria', N'DZA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(502329612.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500159886.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(503200247.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(512100879.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(522136349.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(534757533.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(547048753.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(561268773.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(577579158.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(595012918.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(612531302.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(628566147.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(644424757.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(660520851.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676990725.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(693764586.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(711170940.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(729091552.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(748498976.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(769472745.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(791336619.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(815245813.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(840446710.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(865771947.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(890396751.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(915045664.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(937667885.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(960793664.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(983395779.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1004957420.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1025697940.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1041724185.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1058979751.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1076848126.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1094538409.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1111596671.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1132442533.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1151435788.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1169924751.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1189843339.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1211758777.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1233614805.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1256809695.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1280837360.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1304459379.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1326919561.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1346344404.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1365057857.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1382523966.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1397909314.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1410888724.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1422327216.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1431646156.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1439197316.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1445619031.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1451280390.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(896492991.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(895784704.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(907395358.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(930292410.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(952838633.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(976409639.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1003576772.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1029875983.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1057180652.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1086235891.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1116250866.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1146964227.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1175990054.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1204100118.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1230702590.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1254860626.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1277136144.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1297790313.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1318387202.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1339265399.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1359783541.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1380911399.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1404321928.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1427842273.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1450329263.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1473632648.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1498637395.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1525225958.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1552111436.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1578320124.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1603652723.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1627881291.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1650544592.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1672375813.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1694082971.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1715417437.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1736435473.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1757273497.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1777437867.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1796509002.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1814543356.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1831803900.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1848308223.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1864184472.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1879602648.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1894744514.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1909251689.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1923095029.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1936736134.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1950280764.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1963842316.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1977658253.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(1991783241.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(2006123447.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(2020656037.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(2035129646.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific (excluding high income)', N'EAP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(544729917.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(554167259.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(563862096.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(574151596.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(585694202.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(598805296.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(611332555.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(625692970.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(641539061.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(658430329.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676100104.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(692853673.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(710582666.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(729284542.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(748941050.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(769559540.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(788963725.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(809610210.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(831433527.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(854371369.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(878363836.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(901892326.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(926644521.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(952516792.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979460960.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007434521.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1033792038.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1061575250.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1090470999.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1120133261.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1151431121.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1180599307.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1210529911.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1241406272.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1273454401.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1306804528.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1339965708.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1374266990.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1409506082.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1445487113.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1482119806.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1516759585.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1551952456.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1587776415.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1623951297.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1660306607.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1696043866.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1731794661.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1767624221.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1803679061.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1840161443.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1875769977.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1911482666.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1947346009.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1983095068.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2018545827.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Early-demographic dividend', N'EAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(980067595.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1003380277.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1027454562.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1052236205.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1077759547.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1104010610.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1130979984.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1158749092.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1187224115.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1216495817.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1246583735.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1277520490.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1309264805.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1341833433.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1375075563.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1408970396.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1443466317.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1478619136.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1514688000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1552055886.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1590931253.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1631355333.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1673182374.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1716152739.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1759875499.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1804081410.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1848663355.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1893586588.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1938610747.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(1983464632.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2029981092.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2074306790.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2118156196.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2161775525.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2205478532.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2249548153.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2294124499.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2339055962.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2384027372.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2428750673.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2473204321.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2516977040.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2559959392.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2602699761.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2645383620.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2688160483.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2731071075.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2774122008.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2817324737.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2860676106.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2904408228.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2948205642.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(2991724468.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(3035325824.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(3079001949.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(3122703317.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Early-demographic dividend', N'EAR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(586056627.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(586788633.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591847200.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(602788726.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(614796849.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(629310225.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(643337589.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(659166844.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676600108.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(696305992.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715399669.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(733318741.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(750907179.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(768253412.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(786907447.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(805685572.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(824204410.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(843696208.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(864794195.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887505230.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910928602.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(936825053.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(963725852.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(990559965.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1016697942.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1042990374.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1067193880.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1092125705.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1116612962.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1139952449.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1162121162.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1179578447.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1197830804.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1216474493.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1235035263.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1253058132.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1274659601.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1294267691.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1313340664.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1333626904.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1355854318.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1378177709.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1401667572.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1425851120.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1449571660.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1472101453.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1491653628.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1510394228.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1528124970.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1543528660.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1556401408.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1567565618.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1576542333.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1583641523.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1589567294.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1594724904.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific', N'EAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1042479827.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1045793993.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1059977365.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1085452978.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1110564125.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1136733610.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1166341432.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1195012928.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1224109922.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1256740076.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1289404691.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1323056644.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1354930027.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1385247264.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1415351115.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1442569738.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1466838266.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1489758534.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1512554064.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1535753338.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1558472173.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1581903755.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1607549234.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1633141623.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1657498383.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1682528269.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1709258866.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1737476308.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1765937284.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1793758539.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1820616892.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1846419035.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1870516977.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1893718374.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1916928717.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1939958969.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1962650225.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(1984871945.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2006354328.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2026515698.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2045729346.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2064266243.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2081848420.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2098602000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2114743503.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2130541816.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2146013429.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2160761464.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2175670361.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2190185797.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2204613382.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2219109404.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2233936812.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2248920288.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2264064351.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(2279186469.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific', N'EAS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170600028.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172118535.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174000320.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176247511.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178754331.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181444419.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183930825.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186729776.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189694126.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192724385.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195683700.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198883444.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202031950.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204950107.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207825039.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(210692692.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213067271.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215563614.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218135821.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220718777.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223360056.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1981', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226102050.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(228677304.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231171176.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233796614.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236408655.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238575698.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240802023.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(243005305.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245114057.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246644181.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247388665.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248137340.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248944092.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(249714198.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250747626.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252373809.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254165206.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256131962.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258080348.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(260022906.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261006905.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261973807.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(263327327.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264940603.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266736965.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268289922.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269927350.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271757542.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(273766125.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276744373.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276952404.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(278100080.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279139448.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279944382.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281636408.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(275220745.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(279488927.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(283776336.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(288075008.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(292347310.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(296539327.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(300049053.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(303610743.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(307087575.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(310521319.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(313854674.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(317386564.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(321109635.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(324679698.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(328258842.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(331828536.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(335514466.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(339110577.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(342651168.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(346176299.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(349819167.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(353551640.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(357124622.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(360691781.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(364507586.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(368335062.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(372130677.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(375910215.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(379564871.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(383041377.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(385568047.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(387534203.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(389132701.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(390363718.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(390990562.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(391431995.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(391816812.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392207147.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392487603.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392502054.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392648544.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392415533.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392122448.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392288707.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(392654477.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(393077520.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(393637104.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(394217145.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(395265896.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(397037901.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(399121746.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(401448188.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(403830537.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(406424758.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(408984246.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(411338238.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia (excluding high income)', N'ECA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423407723.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426368462.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(430181457.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434608893.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(439252790.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443865452.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(447730311.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451780083.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455939232.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(460237671.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(464269415.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(468588427.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(473391188.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478073535.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(482753566.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487473570.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(491429371.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(495512733.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499958360.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(504767239.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(510133390.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(515579598.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(521041450.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(526454738.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531703272.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(536500692.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540130985.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(543488071.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(546687019.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(549902438.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(552718939.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(554209506.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(556077093.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(558051175.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(559701570.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(561621866.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(563869238.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(566520750.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569302930.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(572308430.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(575105953.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(577317842.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(579611791.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(582321428.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(585368816.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(588637301.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591359233.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(594383431.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(597569337.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(600405151.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(603656391.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(603544611.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(603223855.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(604856713.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(604378140.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(605449923.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia', N'ECS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(667516938.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(675214286.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(683152930.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(691146253.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(699046950.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(706691764.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(713344146.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(719786852.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(725974310.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(732060925.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(737511115.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(743158081.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(749515255.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(755582491.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(761444994.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(767114225.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(772656242.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(777946308.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(783260461.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(788456015.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(793795423.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(799120587.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(803884347.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(808473556.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(813273557.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(818181288.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(823227203.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(828312655.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(833439109.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(838607561.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(842972172.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(846287676.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(849687540.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(852686641.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(854538617.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(856060572.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(857263836.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(858641127.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(859721023.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(860892312.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(861989674.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(863492336.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(865189443.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(867472980.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(870067822.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(872720228.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(875415605.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(878428497.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(881925905.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(885580688.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(889077523.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(892816142.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(895050287.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(900863153.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(903987814.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(907944124.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia', N'ECS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2359114.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2416345.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2471950.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2529318.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2594222.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2669448.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2745055.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2831093.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2925760.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3025723.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3129081.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3227686.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3332252.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3441822.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3555916.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3674462.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3790266.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3911314.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4037734.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4170020.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4308384.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4446354.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4590127.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4739548.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4894258.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5053739.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5210535.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5372255.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5538079.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5707310.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5879525.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6046989.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6218942.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6393912.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6570234.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6747079.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6918783.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7089928.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7261380.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7434768.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7610813.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7779753.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7952344.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8128213.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8305747.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8484201.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8674635.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8862686.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9050181.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9240198.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9433502.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9621808.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9815192.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10009265.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10197589.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10377037.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ecuador', N'ECU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(4545548.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(4676858.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(4812892.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(4953735.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5099470.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5250120.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5405692.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5566057.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5730908.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(5899842.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6072520.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6248831.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6428707.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6611916.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6798205.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(6987393.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(7179399.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(7374235.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(7571953.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(7772652.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(7976449.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(8183194.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(8392935.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(8606214.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(8823746.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(9045977.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(9272905.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(9504132.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(9739179.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(9977380.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(10218085.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(10460988.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(10705670.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(10951200.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(11196476.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(11440576.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(11683480.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(11924991.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(12163887.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(12398691.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(12628596.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(12852753.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(13072056.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(13289600.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(13509645.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(13735232.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(13967490.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(14205479.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(14447600.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(14691310.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(14934692.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(15177280.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(15419493.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(15661312.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(15902916.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(16144363.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ecuador', N'ECU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14701671.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14985603.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15374950.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15836025.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16313137.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16777621.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17181622.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17585473.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17994385.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18429037.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18901526.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19310941.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19762295.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20252093.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20765875.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21294727.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21806944.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22323834.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22855839.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23418338.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24016671.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24576552.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25186621.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25832747.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26493123.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27157657.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27826520.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28501063.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29183219.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29890232.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30635547.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31312791.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32073019.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32902211.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33772751.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34673396.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35688854.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36699499.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37737564.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38846465.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40038298.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41242585.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42510719.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43814803.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45112760.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46378045.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47493347.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48623115.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49741846.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50808879.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51805103.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52830655.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53715025.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54531220.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55402095.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56386786.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Egypt, Arab Rep.', N'EGY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(27072397.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(27810001.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(28560741.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(29322709.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(30094082.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(30872982.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(31660914.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(32456565.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(33252275.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(34038147.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(34808599.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(35561087.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(36302154.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(37046807.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(37815578.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(38624410.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(39478585.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(40377668.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(41324806.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(42321740.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(43369552.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(44465918.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(45610430.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(46807221.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(48061546.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(49373806.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(50748187.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(52173840.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(53617678.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(55035937.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(56397273.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(57689828.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(58922018.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(60108373.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(61272847.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(62434527.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(63595629.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(64754566.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(65922626.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(67112877.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(68334905.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(69599945.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(70908710.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(72247626.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(73596068.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(74942115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(76274285.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(77605327.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(78976122.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(80442443.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(82040994.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(83787634.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(85660902.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(87613909.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(89579670.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(91508084.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Egypt, Arab Rep.', N'EGY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171602450.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172573316.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173756427.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175076688.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176355640.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177555263.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178391409.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179077114.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179746933.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180518574.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181184789.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182010100.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183210501.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184508202.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185852890.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187269973.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188550226.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189845907.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191401538.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193205605.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195383967.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197581408.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199866297.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202132044.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204125924.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205780516.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(206947069.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207873939.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208712666.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209687696.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(210752981.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211428134.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212277205.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213017803.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213531770.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214010412.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214444398.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214874992.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215283396.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215801196.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216491140.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217166688.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217932642.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218718993.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219542652.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220356143.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220946853.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221705551.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222409028.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222683847.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222641251.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222365477.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220965489.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221694522.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220564430.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220077575.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Euro area', N'EMU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(265396501.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(267825309.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(270324828.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(272876446.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(275382199.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(277856708.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(280147497.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(282114541.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(283966951.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(285855062.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(287416203.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(288999688.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(290938923.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(292789890.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(294470414.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(296017540.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(297374619.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(298597020.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(299916557.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(301109767.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(302311356.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(303480588.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(304270836.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(304870908.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(305380451.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(305968030.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(306748199.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(307614327.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(308674767.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(310043791.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(311522808.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(312674707.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(314065808.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(315270699.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(316105840.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(316837436.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(317583952.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(318278768.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(318923150.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(319779891.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(320997414.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(322454670.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(324128255.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(325890549.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(327687926.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(329385346.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(330925570.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(332644496.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(334270178.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(335353297.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(336142557.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(336940330.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(336161537.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(338755304.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(338617134.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(339425073.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Euro area', N'EMU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(739591.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(757374.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(779144.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(803517.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(828302.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(852395.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(872901.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893139.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(913705.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(935844.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(960245.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(982601.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007484.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1034549.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1063205.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1093146.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1120275.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1149209.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1180024.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1212844.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1247731.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1280155.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1314206.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1350418.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1389451.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1431414.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1469599.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1510979.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1551719.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1587201.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1614831.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1603905.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1584325.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1562296.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1545416.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1539452.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1576671.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1625497.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1685716.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1756004.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1834334.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1930609.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2034899.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2142441.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2246910.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2343572.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2405736.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2459729.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2507150.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2551197.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2595230.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2640346.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Eritrea', N'ERI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1407631.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1441297.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1476321.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1512671.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1550297.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1589187.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1629333.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1670821.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1713846.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1758668.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1805480.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1854395.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1905406.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(1958444.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2013382.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2070145.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2128597.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2188806.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2251129.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2316054.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2383858.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2453689.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2525005.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2598626.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2675717.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2756493.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2843141.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(2933871.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3020278.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3091083.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3139083.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3160644.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3160617.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3150811.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3147871.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3164095.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3202598.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3260612.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3337227.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3429656.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3535156.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3655006.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3788532.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(3928408.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4064958.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4191273.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4304440.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4406299.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4500638.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4593549.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4689664.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(4789568.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Eritrea', N'ERI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19631624.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19739813.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19877064.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20017943.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20169866.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20319046.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20450090.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20608271.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20778647.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20895700.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21061293.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21276184.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21459770.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21659050.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21887057.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22153476.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22412321.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22708524.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23073248.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23353649.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23602413.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23890198.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24148767.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24412979.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24664040.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24896934.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25137365.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25337921.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25520981.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25705864.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25892273.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26083234.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26313506.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26537487.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26727790.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26875783.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26999748.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27111628.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27228877.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27381316.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27617167.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28023600.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28542977.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29102915.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29632543.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30143791.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30605359.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31116023.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31541938.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31733802.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31782878.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31706124.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31542397.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31261300.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30996029.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30788706.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Spain', N'ESP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(30455000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(30739250.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(31023366.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(31296651.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(31609195.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(31954292.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(32283194.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(32682947.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(33113134.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(33441054.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(33814531.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(34191678.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(34502705.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(34817071.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(35154338.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(35530725.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(35939437.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(36370050.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(36872506.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(37201123.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(37439035.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(37740556.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(37942805.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38122429.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38278575.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38418817.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38535617.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38630820.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38715849.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38791473.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38850435.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(38939049.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39067745.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39189400.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39294967.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39387017.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39478186.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39582413.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39721108.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(39926268.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(40263216.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(40756001.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(41431558.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(42187645.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(42921895.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(43653155.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(44397319.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(45226803.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(45954106.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46362946.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46576897.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46742697.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46773055.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46620045.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46480882.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(46418269.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Spain', N'ESP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(803893.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(810891.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(820929.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(832450.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(845176.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(857519.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(866493.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(873333.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(881546.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(890795.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(900318.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910719.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(920114.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(928158.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(935854.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(943458.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(948234.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(954221.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(960532.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(966195.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(972896.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(981558.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(990661.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(999510.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007896.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1016078.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1022944.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1029788.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1034763.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1037644.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1038029.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028983.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1008206.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(981906.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(961370.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(945014.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(936193.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(930172.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(925519.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(926087.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(941532.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(937685.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(933704.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(929792.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(926100.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(922428.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(915843.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910569.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(906554.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(902300.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(896655.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(888421.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(879821.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(871178.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(862970.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(854799.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Estonia', N'EST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1211537.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1225077.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1241623.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1258857.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1277086.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1294566.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1308597.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1318946.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1331214.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1345249.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1360076.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1376955.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1392518.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1405951.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1418169.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1429352.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1439576.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1450211.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1460188.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1468333.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1477219.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1487666.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1498414.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1508745.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1518617.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1528781.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1540190.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1552221.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1561900.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1568131.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1569174.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1561314.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1533091.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1494128.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1462514.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1436634.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1415594.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1399535.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1386156.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1380620.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1396985.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1388115.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1379350.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1370720.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1362550.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1354775.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1346810.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1340680.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1337090.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1334515.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1331475.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1327439.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1322696.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1317997.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1314545.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(1311998.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Estonia', N'EST', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11939512.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12200873.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12498210.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12821819.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13160724.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13509420.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13786982.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14088883.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14415581.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14769021.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15149824.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15510693.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15902820.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16303778.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16689898.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17048665.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17305979.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17522161.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17723413.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17948026.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18226691.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18548401.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18979237.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19502616.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20096040.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20740550.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21333524.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21988645.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22699762.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23467290.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24295930.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25082420.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25943451.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26861220.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27813542.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28787383.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29662162.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30559860.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31487609.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32462026.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33494639.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34434112.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35458174.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36546888.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37681236.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38860943.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40079443.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41365221.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42733836.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44198048.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45756583.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47417742.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49150513.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50952784.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52818925.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54740332.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ethiopia', N'ETH', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(22151218.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(22671131.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(23221331.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(23798378.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(24396965.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(25013551.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(25641176.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(26280771.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(26945459.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(27653622.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(28414999.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(29246170.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(30135007.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(31028728.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(31855294.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(32568539.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(33144537.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(33614153.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(34053431.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(34569428.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(35239974.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(36093319.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(37109517.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(38259376.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(39493503.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(40775997.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(42097111.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(43470219.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(44908705.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(46433604.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(48057094.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(49784987.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(51602776.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(53477944.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(55366517.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(57237226.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(59076414.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(60893264.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(62707547.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(64550161.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(66443603.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(68393128.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(70391170.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(72432290.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(74506974.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(76608431.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(78735675.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(80891968.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2008', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(83079608.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(85302099.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(87561814.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(89858696.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(92191211.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(94558374.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(96958732.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(99390750.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ethiopia', N'ETH', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264114253.00000 AS Numeric(28, 5)))
   ,(N'1961', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265628562.00000 AS Numeric(28, 5)))
   ,(N'1962', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267619270.00000 AS Numeric(28, 5)))
   ,(N'1963', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269891979.00000 AS Numeric(28, 5)))
   ,(N'1964', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272136876.00000 AS Numeric(28, 5)))
   ,(N'1965', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274153776.00000 AS Numeric(28, 5)))
   ,(N'1966', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275715550.00000 AS Numeric(28, 5)))
   ,(N'1967', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277170244.00000 AS Numeric(28, 5)))
   ,(N'1968', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(278505641.00000 AS Numeric(28, 5)))
   ,(N'1969', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279894513.00000 AS Numeric(28, 5)))
   ,(N'1970', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281145500.00000 AS Numeric(28, 5)))
   ,(N'1971', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(282328526.00000 AS Numeric(28, 5)))
   ,(N'1972', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284094330.00000 AS Numeric(28, 5)))
   ,(N'1973', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(285989213.00000 AS Numeric(28, 5)))
   ,(N'1974', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(287908334.00000 AS Numeric(28, 5)))
   ,(N'1975', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(289860565.00000 AS Numeric(28, 5)))
   ,(N'1976', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291566592.00000 AS Numeric(28, 5)))
   ,(N'1977', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293145778.00000 AS Numeric(28, 5)))
   ,(N'1978', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294931716.00000 AS Numeric(28, 5)))
   ,(N'1979', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(297084406.00000 AS Numeric(28, 5)))
   ,(N'1980', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299856113.00000 AS Numeric(28, 5)))
   ,(N'1981', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(302630173.00000 AS Numeric(28, 5)))
   ,(N'1982', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(305652939.00000 AS Numeric(28, 5)))
   ,(N'1983', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308762325.00000 AS Numeric(28, 5)))
   ,(N'1984', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311556616.00000 AS Numeric(28, 5)))
   ,(N'1985', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313858602.00000 AS Numeric(28, 5)))
   ,(N'1986', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(315422417.00000 AS Numeric(28, 5)))
   ,(N'1987', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(316568610.00000 AS Numeric(28, 5)))
   ,(N'1988', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317545469.00000 AS Numeric(28, 5)))
   ,(N'1989', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(318584709.00000 AS Numeric(28, 5)))
   ,(N'1990', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(319783059.00000 AS Numeric(28, 5)))
   ,(N'1991', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320259013.00000 AS Numeric(28, 5)))
   ,(N'1992', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321189680.00000 AS Numeric(28, 5)))
   ,(N'1993', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322361348.00000 AS Numeric(28, 5)))
   ,(N'1994', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323268228.00000 AS Numeric(28, 5)))
   ,(N'1995', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324133449.00000 AS Numeric(28, 5)))
   ,(N'1996', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324751013.00000 AS Numeric(28, 5)))
   ,(N'1997', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(325546699.00000 AS Numeric(28, 5)))
   ,(N'1998', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(326268544.00000 AS Numeric(28, 5)))
   ,(N'1999', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327251331.00000 AS Numeric(28, 5)))
   ,(N'2000', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328075747.00000 AS Numeric(28, 5)))
   ,(N'2001', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328957583.00000 AS Numeric(28, 5)))
   ,(N'2002', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329903224.00000 AS Numeric(28, 5)))
   ,(N'2003', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331139065.00000 AS Numeric(28, 5)))
   ,(N'2004', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332471166.00000 AS Numeric(28, 5)))
   ,(N'2005', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333809881.00000 AS Numeric(28, 5)))
   ,(N'2006', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334802967.00000 AS Numeric(28, 5)))
   ,(N'2007', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(335757799.00000 AS Numeric(28, 5)))
   ,(N'2008', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336680210.00000 AS Numeric(28, 5)))
   ,(N'2009', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(337190817.00000 AS Numeric(28, 5)))
   ,(N'2010', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(337187961.00000 AS Numeric(28, 5)))
   ,(N'2011', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336597794.00000 AS Numeric(28, 5)))
   ,(N'2012', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334878976.00000 AS Numeric(28, 5)))
   ,(N'2013', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(335237956.00000 AS Numeric(28, 5)))
   ,(N'2014', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333712608.00000 AS Numeric(28, 5)))
   ,(N'2015', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332834600.00000 AS Numeric(28, 5)))
   ,(N'2016', N'European Union', N'EUU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(409498462.00000 AS Numeric(28, 5)))
   ,(N'1961', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(413007006.00000 AS Numeric(28, 5)))
   ,(N'1962', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(416670637.00000 AS Numeric(28, 5)))
   ,(N'1963', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(420393292.00000 AS Numeric(28, 5)))
   ,(N'1964', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(424075860.00000 AS Numeric(28, 5)))
   ,(N'1965', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(427592610.00000 AS Numeric(28, 5)))
   ,(N'1966', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(430868375.00000 AS Numeric(28, 5)))
   ,(N'1967', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(434001552.00000 AS Numeric(28, 5)))
   ,(N'1968', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(436916057.00000 AS Numeric(28, 5)))
   ,(N'1969', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(439730660.00000 AS Numeric(28, 5)))
   ,(N'1970', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(442062264.00000 AS Numeric(28, 5)))
   ,(N'1971', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(444368185.00000 AS Numeric(28, 5)))
   ,(N'1972', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(447151812.00000 AS Numeric(28, 5)))
   ,(N'1973', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(449788759.00000 AS Numeric(28, 5)))
   ,(N'1974', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(452256892.00000 AS Numeric(28, 5)))
   ,(N'1975', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(454638308.00000 AS Numeric(28, 5)))
   ,(N'1976', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(456802618.00000 AS Numeric(28, 5)))
   ,(N'1977', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(458746586.00000 AS Numeric(28, 5)))
   ,(N'1978', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(460706924.00000 AS Numeric(28, 5)))
   ,(N'1979', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(462498335.00000 AS Numeric(28, 5)))
   ,(N'1980', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(464340783.00000 AS Numeric(28, 5)))
   ,(N'1981', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(466081804.00000 AS Numeric(28, 5)))
   ,(N'1982', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(467346238.00000 AS Numeric(28, 5)))
   ,(N'1983', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(468419741.00000 AS Numeric(28, 5)))
   ,(N'1984', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(469449808.00000 AS Numeric(28, 5)))
   ,(N'1985', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(470587065.00000 AS Numeric(28, 5)))
   ,(N'1986', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(471888308.00000 AS Numeric(28, 5)))
   ,(N'1987', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(473230098.00000 AS Numeric(28, 5)))
   ,(N'1988', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(474741457.00000 AS Numeric(28, 5)))
   ,(N'1989', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(476355806.00000 AS Numeric(28, 5)))
   ,(N'1990', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(477988417.00000 AS Numeric(28, 5)))
   ,(N'1991', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(478942970.00000 AS Numeric(28, 5)))
   ,(N'1992', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(480342226.00000 AS Numeric(28, 5)))
   ,(N'1993', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(481920881.00000 AS Numeric(28, 5)))
   ,(N'1994', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(483001906.00000 AS Numeric(28, 5)))
   ,(N'1995', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(483927331.00000 AS Numeric(28, 5)))
   ,(N'1996', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(484581653.00000 AS Numeric(28, 5)))
   ,(N'1997', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(485409098.00000 AS Numeric(28, 5)))
   ,(N'1998', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(486055038.00000 AS Numeric(28, 5)))
   ,(N'1999', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(487060355.00000 AS Numeric(28, 5)))
   ,(N'2000', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(487865459.00000 AS Numeric(28, 5)))
   ,(N'2001', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(489073595.00000 AS Numeric(28, 5)))
   ,(N'2002', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(490424475.00000 AS Numeric(28, 5)))
   ,(N'2003', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(492252932.00000 AS Numeric(28, 5)))
   ,(N'2004', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(494232263.00000 AS Numeric(28, 5)))
   ,(N'2005', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(496200867.00000 AS Numeric(28, 5)))
   ,(N'2006', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(498074489.00000 AS Numeric(28, 5)))
   ,(N'2007', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(499915977.00000 AS Numeric(28, 5)))
   ,(N'2008', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(501803925.00000 AS Numeric(28, 5)))
   ,(N'2009', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(503310374.00000 AS Numeric(28, 5)))
   ,(N'2010', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(504412209.00000 AS Numeric(28, 5)))
   ,(N'2011', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(505526581.00000 AS Numeric(28, 5)))
   ,(N'2012', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(505098575.00000 AS Numeric(28, 5)))
   ,(N'2013', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(508050888.00000 AS Numeric(28, 5)))
   ,(N'2014', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(508344735.00000 AS Numeric(28, 5)))
   ,(N'2015', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(509668361.00000 AS Numeric(28, 5)))
   ,(N'2016', N'European Union', N'EUU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64324224.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65424396.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66564410.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67794596.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69198053.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70810910.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72253475.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73941700.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75823112.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77822270.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79898745.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81689560.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83621288.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85698992.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87941795.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90360301.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92699731.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95238772.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97924496.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100703056.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103543274.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106011798.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108570961.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111241906.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114050055.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117018278.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119771335.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122752417.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125985853.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129504213.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134295151.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138267655.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142600758.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147204048.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151964496.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156809687.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161280409.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165837571.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170509852.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175392322.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180522837.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185461925.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190716662.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(196228530.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(201927670.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207775683.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213411630.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219232398.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225244457.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231453187.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239031300.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244030700.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250464439.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(257174412.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264160267.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272638974.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Fragile and conflict affected situations', N'FCS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(118691130.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(121429326.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(124278225.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(127248584.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(130366333.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(133649618.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(137111509.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(140748226.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(144536592.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(148446120.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(152456401.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(156545910.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(160728970.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(165052113.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(169587903.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(174377166.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(179453773.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(184779096.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(190245713.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(195704807.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(201051077.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(206257422.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(211368464.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(216454794.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(221617588.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(226941758.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(232422187.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(238061473.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(243953809.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(250210140.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(258881635.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(266166456.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(273909354.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(281946172.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(290043848.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(298040428.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(305868679.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(313590684.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(321130376.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(328783990.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(336909548.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(345461879.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(354332474.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(363479314.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(372832172.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(382338023.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(392013911.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(401863906.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(411873180.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(421999099.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(432225198.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(442535318.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(452946224.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(463535772.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(474395380.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(485609230.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Fragile and conflict affected situations', N'FCS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2759044.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2788586.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2829009.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2878088.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2923085.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2957522.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2984751.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3015240.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3041215.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3050953.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3050427.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3065891.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3095743.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3124527.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3151166.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3174239.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3189979.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3200782.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3210377.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3220962.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3236470.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3250536.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3275201.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3303210.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3325769.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3338656.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3346937.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3348887.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3348062.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3349683.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3355644.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3366682.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3377618.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3386856.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3397161.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3409628.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3416035.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3428085.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3442751.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3455502.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3464376.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3474891.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3480602.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3483298.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3488930.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3499096.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3509019.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3524218.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3542024.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3555543.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3559150.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3552728.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3537482.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3514482.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3488191.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3463782.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Finland', N'FIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4429634.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4461005.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4491443.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4523309.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4548543.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4563732.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4580869.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4605744.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4626469.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4623785.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4606307.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4612124.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4639657.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4666081.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4690574.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4711440.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4725664.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4738902.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4752528.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4764690.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4779535.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4799964.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4826933.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4855787.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4881803.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4902206.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4918154.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4932123.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4946481.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4964371.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(4986431.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5013740.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5041992.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5066447.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5088333.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5107790.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5124573.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5139835.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5153498.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5165474.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5176209.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5188008.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5200598.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5213014.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5228172.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5246096.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5266268.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5288720.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5313399.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5338871.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5363352.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5388272.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5413971.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5438972.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5461512.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(5482013.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Finland', N'FIN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194865.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(201870.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209859.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218489.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227352.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236277.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244748.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(253240.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261935.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271125.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280966.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(290002.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299664.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309835.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320273.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330774.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(337892.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(345018.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352479.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360614.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(369551.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379221.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(389683.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(399615.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407827.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(414004.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(418104.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(420345.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(421771.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423752.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(427187.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(433185.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(440577.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(449236.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458739.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(468486.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(474809.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(481743.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(488552.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494426.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499218.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508655.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(516089.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(522574.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(529407.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(537119.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540993.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(546820.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(554039.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(561700.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569038.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(572445.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(575679.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(578595.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(581214.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(583680.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Fiji', N'FJI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(393383.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(407152.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(421576.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(436208.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(450452.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(463884.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(476329.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(487911.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(498887.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(509659.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(520529.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(531601.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(542811.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(554109.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(565386.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(576592.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(587523.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(598258.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(609348.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(621541.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(635256.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(650957.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(668196.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(685389.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(700366.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(711663.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(718548.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(721725.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(722918.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(724624.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(728626.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(735469.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(744534.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(755024.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(765666.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(775498.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(784479.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(792859.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(800314.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(806494.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(811223.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(814215.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(815691.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(816626.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(818355.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(821820.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(827390.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(834729.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(843206.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(851854.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(859952.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(867327.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(874158.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(880487.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(886450.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(892145.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Fiji', N'FJI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29093480.00000 AS Numeric(28, 5)))
   ,(N'1961', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29394475.00000 AS Numeric(28, 5)))
   ,(N'1962', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29828274.00000 AS Numeric(28, 5)))
   ,(N'1963', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30339686.00000 AS Numeric(28, 5)))
   ,(N'1964', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30833611.00000 AS Numeric(28, 5)))
   ,(N'1965', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31255627.00000 AS Numeric(28, 5)))
   ,(N'1966', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31545034.00000 AS Numeric(28, 5)))
   ,(N'1967', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31789681.00000 AS Numeric(28, 5)))
   ,(N'1968', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32005951.00000 AS Numeric(28, 5)))
   ,(N'1969', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32227784.00000 AS Numeric(28, 5)))
   ,(N'1970', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32478508.00000 AS Numeric(28, 5)))
   ,(N'1971', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32774531.00000 AS Numeric(28, 5)))
   ,(N'1972', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33089173.00000 AS Numeric(28, 5)))
   ,(N'1973', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33413719.00000 AS Numeric(28, 5)))
   ,(N'1974', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33740460.00000 AS Numeric(28, 5)))
   ,(N'1975', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34062940.00000 AS Numeric(28, 5)))
   ,(N'1976', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34279824.00000 AS Numeric(28, 5)))
   ,(N'1977', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34501965.00000 AS Numeric(28, 5)))
   ,(N'1978', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34749653.00000 AS Numeric(28, 5)))
   ,(N'1979', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35046252.00000 AS Numeric(28, 5)))
   ,(N'1980', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35406333.00000 AS Numeric(28, 5)))
   ,(N'1981', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35847342.00000 AS Numeric(28, 5)))
   ,(N'1982', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36323069.00000 AS Numeric(28, 5)))
   ,(N'1983', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36809469.00000 AS Numeric(28, 5)))
   ,(N'1984', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37271781.00000 AS Numeric(28, 5)))
   ,(N'1985', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37681430.00000 AS Numeric(28, 5)))
   ,(N'1986', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37922506.00000 AS Numeric(28, 5)))
   ,(N'1987', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38146351.00000 AS Numeric(28, 5)))
   ,(N'1988', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38348825.00000 AS Numeric(28, 5)))
   ,(N'1989', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38527132.00000 AS Numeric(28, 5)))
   ,(N'1990', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38687634.00000 AS Numeric(28, 5)))
   ,(N'1991', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38644146.00000 AS Numeric(28, 5)))
   ,(N'1992', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38749625.00000 AS Numeric(28, 5)))
   ,(N'1993', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38825479.00000 AS Numeric(28, 5)))
   ,(N'1994', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38887103.00000 AS Numeric(28, 5)))
   ,(N'1995', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38960444.00000 AS Numeric(28, 5)))
   ,(N'1996', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39043131.00000 AS Numeric(28, 5)))
   ,(N'1997', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39128625.00000 AS Numeric(28, 5)))
   ,(N'1998', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39230594.00000 AS Numeric(28, 5)))
   ,(N'1999', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39403948.00000 AS Numeric(28, 5)))
   ,(N'2000', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39658272.00000 AS Numeric(28, 5)))
   ,(N'2001', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39900308.00000 AS Numeric(28, 5)))
   ,(N'2002', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40159954.00000 AS Numeric(28, 5)))
   ,(N'2003', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40424905.00000 AS Numeric(28, 5)))
   ,(N'2004', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40711694.00000 AS Numeric(28, 5)))
   ,(N'2005', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41015912.00000 AS Numeric(28, 5)))
   ,(N'2006', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41284947.00000 AS Numeric(28, 5)))
   ,(N'2007', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41529505.00000 AS Numeric(28, 5)))
   ,(N'2008', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41738860.00000 AS Numeric(28, 5)))
   ,(N'2009', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41885606.00000 AS Numeric(28, 5)))
   ,(N'2010', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41955446.00000 AS Numeric(28, 5)))
   ,(N'2011', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41950507.00000 AS Numeric(28, 5)))
   ,(N'2012', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41881273.00000 AS Numeric(28, 5)))
   ,(N'2013', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41764517.00000 AS Numeric(28, 5)))
   ,(N'2014', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41775700.00000 AS Numeric(28, 5)))
   ,(N'2015', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41685730.00000 AS Numeric(28, 5)))
   ,(N'2016', N'France', N'FRA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(46814237.00000 AS Numeric(28, 5)))
   ,(N'1961', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(47444751.00000 AS Numeric(28, 5)))
   ,(N'1962', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(48119649.00000 AS Numeric(28, 5)))
   ,(N'1963', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(48803680.00000 AS Numeric(28, 5)))
   ,(N'1964', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(49449403.00000 AS Numeric(28, 5)))
   ,(N'1965', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(50023774.00000 AS Numeric(28, 5)))
   ,(N'1966', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(50508717.00000 AS Numeric(28, 5)))
   ,(N'1967', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(50915456.00000 AS Numeric(28, 5)))
   ,(N'1968', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(51276054.00000 AS Numeric(28, 5)))
   ,(N'1969', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(51638260.00000 AS Numeric(28, 5)))
   ,(N'1970', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(52035095.00000 AS Numeric(28, 5)))
   ,(N'1971', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(52480421.00000 AS Numeric(28, 5)))
   ,(N'1972', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(52959228.00000 AS Numeric(28, 5)))
   ,(N'1973', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(53441264.00000 AS Numeric(28, 5)))
   ,(N'1974', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(53882416.00000 AS Numeric(28, 5)))
   ,(N'1975', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(54252574.00000 AS Numeric(28, 5)))
   ,(N'1976', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(54541493.00000 AS Numeric(28, 5)))
   ,(N'1977', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(54764462.00000 AS Numeric(28, 5)))
   ,(N'1978', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(54947975.00000 AS Numeric(28, 5)))
   ,(N'1979', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(55130594.00000 AS Numeric(28, 5)))
   ,(N'1980', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(55340782.00000 AS Numeric(28, 5)))
   ,(N'1981', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(55585824.00000 AS Numeric(28, 5)))
   ,(N'1982', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(55858727.00000 AS Numeric(28, 5)))
   ,(N'1983', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(56156284.00000 AS Numeric(28, 5)))
   ,(N'1984', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(56470769.00000 AS Numeric(28, 5)))
   ,(N'1985', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(56795686.00000 AS Numeric(28, 5)))
   ,(N'1986', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(57132691.00000 AS Numeric(28, 5)))
   ,(N'1987', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(57482591.00000 AS Numeric(28, 5)))
   ,(N'1988', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(57836486.00000 AS Numeric(28, 5)))
   ,(N'1989', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(58182702.00000 AS Numeric(28, 5)))
   ,(N'1990', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(58512808.00000 AS Numeric(28, 5)))
   ,(N'1991', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(58559312.00000 AS Numeric(28, 5)))
   ,(N'1992', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(58851216.00000 AS Numeric(28, 5)))
   ,(N'1993', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(59106766.00000 AS Numeric(28, 5)))
   ,(N'1994', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(59327194.00000 AS Numeric(28, 5)))
   ,(N'1995', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(59541900.00000 AS Numeric(28, 5)))
   ,(N'1996', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(59753098.00000 AS Numeric(28, 5)))
   ,(N'1997', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(59964845.00000 AS Numeric(28, 5)))
   ,(N'1998', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(60186291.00000 AS Numeric(28, 5)))
   ,(N'1999', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(60496715.00000 AS Numeric(28, 5)))
   ,(N'2000', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(60912498.00000 AS Numeric(28, 5)))
   ,(N'2001', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(61357431.00000 AS Numeric(28, 5)))
   ,(N'2002', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(61805267.00000 AS Numeric(28, 5)))
   ,(N'2003', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(62244884.00000 AS Numeric(28, 5)))
   ,(N'2004', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(62704897.00000 AS Numeric(28, 5)))
   ,(N'2005', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(63179356.00000 AS Numeric(28, 5)))
   ,(N'2006', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(63621376.00000 AS Numeric(28, 5)))
   ,(N'2007', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(64016229.00000 AS Numeric(28, 5)))
   ,(N'2008', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(64374990.00000 AS Numeric(28, 5)))
   ,(N'2009', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(64707044.00000 AS Numeric(28, 5)))
   ,(N'2010', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(65027512.00000 AS Numeric(28, 5)))
   ,(N'2011', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(65342776.00000 AS Numeric(28, 5)))
   ,(N'2012', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(65659790.00000 AS Numeric(28, 5)))
   ,(N'2013', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(65972097.00000 AS Numeric(28, 5)))
   ,(N'2014', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(66495940.00000 AS Numeric(28, 5)))
   ,(N'2015', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(66808385.00000 AS Numeric(28, 5)))
   ,(N'2016', N'France', N'FRA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Faroe Islands', N'FRO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(34266.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(34730.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(35153.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(35550.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(35946.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(36363.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(36804.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(37258.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(37718.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(38164.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(38587.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(38983.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(39360.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(39731.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(40116.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(40529.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(40974.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(41447.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(41946.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(42468.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(43010.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(43559.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44105.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44661.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(45239.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(45840.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(46501.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47194.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47789.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48105.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48031.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47494.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(46574.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(45501.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44600.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44099.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44081.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(44467.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(45126.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(45852.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(46491.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47012.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47452.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(47812.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48103.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48337.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48505.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48599.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48629.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48613.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48567.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48492.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48393.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48292.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48221.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(48199.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Faroe Islands', N'FRO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22747.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23360.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23862.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24354.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24987.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25827.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26790.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27953.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29185.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30294.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31160.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31254.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31085.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30796.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30572.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30522.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31274.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32238.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33360.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34574.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35838.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37307.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40331.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41930.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43587.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44888.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46238.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47625.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49010.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50395.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51742.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53096.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54453.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55761.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56932.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57835.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58454.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58955.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59491.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60120.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60090.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60212.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60408.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60600.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60742.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60881.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60973.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61057.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61188.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61399.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61891.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62456.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63079.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63715.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64321.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Micronesia, Fed. Sts.', N'FSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(44539.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(45956.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(47387.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(48875.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(50483.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(52238.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(54201.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(56324.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(58404.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(60167.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(61433.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(62107.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(62298.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(62289.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(62477.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(63146.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(64386.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(66110.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(68221.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(70550.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(72967.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(75462.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(78057.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(80678.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(83242.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(85689.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(87948.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(90024.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(92020.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(94091.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(96331.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(98800.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(101412.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103937.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(106057.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(107556.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(108342.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(108506.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(108236.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(107808.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(107430.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(107170.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(106983.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(106816.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(106575.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(106198.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(105680.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(105080.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(104472.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103961.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103619.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103476.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103516.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(103718.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(104044.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(104460.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Micronesia, Fed. Sts.', N'FSM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308953.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(310375.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(312574.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(315526.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(319210.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323599.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327572.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332462.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(337943.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343651.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(349328.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352144.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355291.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(358820.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362870.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(367578.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372118.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(377436.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(383522.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(390386.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(397999.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405124.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413156.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(422030.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(431674.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(442019.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451949.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(462809.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(474421.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(486629.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499363.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(511720.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(524782.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(538600.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(553278.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(568886.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(585016.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(602088.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(620027.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(638745.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(658181.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676871.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(696468.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(716900.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(738041.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(759822.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(781719.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(804100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(827028.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850625.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(874871.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(897909.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(921806.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(946336.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(971309.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(996669.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gabon', N'GAB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(499189.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(504174.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(509806.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(516270.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(523793.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(532512.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(542562.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(553829.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(565878.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(578114.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(590119.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(601734.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(613129.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(624625.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(636702.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(649719.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(663774.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(678786.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(694734.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(711544.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(729165.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(747593.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(766867.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(787017.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(808088.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(830091.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(853039.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(876877.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(901473.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(926648.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(952269.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(978252.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1004598.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1031358.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1058625.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1086449.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1114879.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1143838.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1173114.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1202412.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1231548.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1260435.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1289192.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1318093.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1347524.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1377777.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1408920.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1440902.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1473741.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1507428.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1541936.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1577298.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1613489.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1650351.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1687673.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(1725292.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gabon', N'GAB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34112423.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34248297.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34493284.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34743662.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34935408.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35070979.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35054944.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35036641.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35003366.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34966552.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34960940.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34978040.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34999452.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35015197.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35045109.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35113873.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35191710.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35316412.00000 AS Numeric(28, 5)))
   ,(N'1978', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35504279.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35762694.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36057921.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36277729.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36485567.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36709978.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36945745.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37157821.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37235836.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37284035.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37313420.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37342339.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37380970.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37411488.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37422045.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37424918.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37455504.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37524195.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37621153.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37751826.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37922208.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38126501.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38352808.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38592342.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38868660.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39170642.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39507484.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39874667.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40219120.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40564765.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40899833.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41208579.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41507080.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41620068.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41703282.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41771962.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41868720.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41991628.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United Kingdom', N'GBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(52400000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(52800000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(53250000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(53650000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(54000000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(54348050.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(54648500.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(54943600.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(55211700.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(55441750.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(55663250.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(55896223.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56086065.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56194527.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56229974.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56225800.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56211968.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56193492.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1978', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56196504.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56246951.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56314216.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56333829.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56313641.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56332848.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56422072.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56550268.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56681396.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56802050.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(56928327.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57076711.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57247586.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57424897.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57580402.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57718614.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(57865745.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58019030.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58166950.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58316954.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58487141.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58682466.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(58892514.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(59119673.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(59370479.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(59647577.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(59987905.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(60401206.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(60846820.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(61322463.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(61806995.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(62276270.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(62766365.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(63258918.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(63700300.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(64128226.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(64613160.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(65138232.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United Kingdom', N'GBR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2271430.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2288962.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2305882.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2324061.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2345383.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2370164.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2392602.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2417921.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2447752.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2482111.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2426078.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2471718.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2608407.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2644590.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2682258.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2720822.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2753528.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2790121.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2827514.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2868687.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2909829.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2948639.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2985437.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3020332.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3052769.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3084767.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3113725.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3140196.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3171077.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3176926.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3171083.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3178711.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3186756.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3194464.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3148789.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3058741.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2983361.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2935214.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2917409.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2907357.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2897523.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2885893.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2873957.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2845945.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2823726.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2809387.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2785037.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2766245.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2749348.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2727572.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2699279.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2662420.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2626847.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2592886.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2559387.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2525519.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Georgia', N'GEO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3645600.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3703600.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3760300.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3816100.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3870300.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3921600.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3966700.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4005800.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4042300.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4080300.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3967800.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4009400.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4205300.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4242500.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4279500.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4311200.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4342400.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4372100.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4397700.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4430200.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4467700.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4504500.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4542800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4582900.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4622200.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4662900.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4704500.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4743500.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4790700.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4803300.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4802000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4835900.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4873500.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4911100.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4861600.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4734000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4616100.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4531600.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4487300.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4452500.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4418300.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4386400.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4357000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4301000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4245000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4190000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4136000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4082000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(4030000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3978000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3926000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3875000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3825000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3776000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3727000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(3679000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Georgia', N'GEO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3544332.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3646749.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3762117.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3882568.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3996883.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4099966.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4174794.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4239201.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4301533.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4373667.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4462195.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4558256.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4674935.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4803080.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4931062.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5052858.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5144840.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5231677.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5325136.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5439539.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5582766.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5754132.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5961075.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6191920.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6432204.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6672772.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6891008.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7110465.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7334511.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7568064.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7814071.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8052540.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8304474.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8566027.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8833149.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9103687.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9354143.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9612065.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9880313.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10161497.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10457417.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10752625.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11059042.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11378168.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11713151.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12065074.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12409458.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12779308.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13167662.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13561165.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13950807.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14331546.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14701790.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15068251.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15444838.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15839827.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ghana', N'GHA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(6652285.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(6866545.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(7085463.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(7303432.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(7513286.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(7710547.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(7890992.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(8057442.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(8221021.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(8397346.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(8596977.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(8827273.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(9083575.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(9350111.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(9604280.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(9831409.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(10023471.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(10189889.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(10354490.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(10550770.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(10802025.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(11117608.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(11488112.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(11895130.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(12311166.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(12716238.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(13103975.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(13480381.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(13852597.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(14232493.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(14628260.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(15042736.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(15471527.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(15907244.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(16339344.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(16760991.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(17169214.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(17568583.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(17969006.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(18384426.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(18824994.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(19293804.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(19788181.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(20305396.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(20840493.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(21389514.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(21951891.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(22528041.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(23115919.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(23713164.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(24317734.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(24928503.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(25544565.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(26164432.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(26786598.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(27409893.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ghana', N'GHA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gibraltar', N'GIB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(21529.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(21797.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(22133.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(22510.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(22894.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(23256.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(23590.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(23901.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(24185.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(24438.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(24661.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(24844.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(24991.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(25121.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(25266.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(25443.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(25666.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(25922.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26185.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26409.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26568.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26651.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26671.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26650.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26621.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26611.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26623.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26653.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26700.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26760.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26833.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(26924.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27035.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27146.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27235.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27285.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27284.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27246.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27211.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27233.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27351.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27580.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(27903.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(28290.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(28694.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(29080.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(29437.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(29770.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(30089.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(30407.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(30732.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(31067.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(31402.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(31720.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(31997.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(32217.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gibraltar', N'GIB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2008838.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2030375.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2051256.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2074268.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2104139.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2142940.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2174689.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2215979.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2262613.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2308500.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2350116.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2370770.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2387876.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2402416.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2416246.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2430860.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2429596.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2431688.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439177.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2454402.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2478785.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2505628.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2547800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2601654.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2663173.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2730266.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2791031.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2859750.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2943108.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3049451.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3182246.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3343615.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3534523.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3737872.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3933967.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4111573.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4236728.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4338947.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4427437.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4513830.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4606213.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4686153.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4773269.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4870081.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4979251.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5102278.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5229733.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5377057.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5540479.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5715050.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5897153.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6073810.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6259460.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6452757.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6652949.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6859651.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guinea', N'GIN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3577413.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3633778.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3690960.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3749920.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3812004.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3877804.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(3948206.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4021880.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4094528.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4160375.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4215442.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4259102.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4293208.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4319502.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4340748.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4359735.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4376768.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4393551.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4416074.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4451872.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4506559.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4584305.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4684992.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4804740.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(4937230.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(5078689.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(5223553.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(5375058.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(5548270.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(5763843.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(6034082.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(6367110.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(6751394.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(7155564.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(7536389.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(7863033.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8124799.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8331366.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8497582.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8647336.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8799165.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(8955756.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(9114287.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(9281572.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(9464771.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(9669023.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(9898301.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(10152521.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(10427356.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(10715770.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(11012406.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(11316351.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(11628767.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(11948726.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(12275527.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(12608590.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guinea', N'GIN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216545.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218459.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220810.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223957.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227834.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232171.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235961.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239962.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244068.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248609.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(253810.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256253.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261019.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267587.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275067.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(282768.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288237.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293407.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298793.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(305437.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313944.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320518.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330015.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342019.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355887.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(371200.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(388823.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(408154.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428314.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448671.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(468894.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(482224.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(495445.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(509179.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523962.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540064.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(555228.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(572117.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(590627.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(610560.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(631651.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(650293.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(670743.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(692614.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715523.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(739268.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(761556.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(785088.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(810092.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(836859.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(865465.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893829.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(924136.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(956257.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(990045.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1025363.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gambia, The', N'GMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(367929.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(376736.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(383525.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(389070.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(394552.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(400865.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(408182.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(416342.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(425509.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(435800.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(447283.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(460193.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(474538.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(489860.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(505512.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(521070.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(536409.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(551823.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(567828.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(585155.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(604371.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(625413.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(648202.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(673230.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(701097.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(732092.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(766598.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(804134.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(843060.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(881146.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(916811.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(949490.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(979701.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1008296.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1036627.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1065746.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1095839.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1126786.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1159001.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1192920.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1228863.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1267103.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1307674.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1350345.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1394727.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1440542.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1487731.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1536424.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1586749.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1638899.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1693002.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1749099.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1807108.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1866878.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1928201.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(1990924.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Gambia, The', N'GMB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(349548.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352738.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355279.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(357912.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361776.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(367395.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372427.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379400.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(387646.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(396159.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(404351.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410430.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(416527.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(422617.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428825.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435243.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(439635.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(444465.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(449781.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455596.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(461933.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467250.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(473231.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(479926.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487517.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(496093.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(502991.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(511667.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(521721.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(532629.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(544160.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(555076.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(566674.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(579195.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(593124.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(608681.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(623070.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(639447.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(657388.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676265.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(695715.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(713755.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(732617.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(752276.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(772829.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(794307.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(813986.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(834906.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(857048.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(880369.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(904819.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(928153.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(953048.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979121.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1006017.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1033535.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guinea-Bissau', N'GNB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(616407.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(623413.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(629973.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(636593.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(643962.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(652566.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(662597.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(673893.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(686155.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(698917.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(711828.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(724863.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(738117.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(751512.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(764974.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(778482.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(791959.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(805481.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(819371.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(834068.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(849886.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(866947.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(885166.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(904391.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(924378.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(944941.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(966039.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(987718.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1009967.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1032797.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1056208.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1080191.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1104708.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1129706.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1155111.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1180877.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1207006.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1233520.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1260424.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1287727.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1315455.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1343646.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1372367.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1401716.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1431816.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1462784.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1494603.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1527342.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1561293.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1596832.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1634196.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1673509.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1714620.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1757138.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1800513.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(1844325.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guinea-Bissau', N'GNB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146078.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146979.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147825.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148903.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150641.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153204.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155874.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159356.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162735.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164855.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164996.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157302.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147871.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137633.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127643.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118682.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113645.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109755.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107628.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107925.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110923.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123898.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139701.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157085.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174150.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189361.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197431.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203718.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208637.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212948.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217343.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221070.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225301.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230023.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235291.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(241203.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247833.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(255138.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(263328.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272659.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283214.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294051.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306276.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(319548.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333345.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(347340.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360283.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373440.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(386865.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(400754.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(415199.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(429036.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443594.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458608.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(473765.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(488894.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Equatorial Guinea', N'GNQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(252115.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(255100.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(257940.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(260990.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(264743.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(269427.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(275470.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(282445.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(288701.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(292014.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(290905.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(284915.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(274906.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(262399.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(249587.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(238240.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(228491.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(220352.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(215284.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(215014.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(220605.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(232934.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(251301.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(273199.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(295090.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(314407.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(330247.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(343290.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(354488.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(365451.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(377363.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(390381.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(404081.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(418409.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(433197.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(448332.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(463844.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(479836.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(496330.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(513347.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(530896.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(549007.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(567664.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(586772.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(606201.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(625866.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(645718.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(665798.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(686223.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(707155.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(728710.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(750918.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(773729.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(797082.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(820885.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(845060.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Equatorial Guinea', N'GNQ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5449697.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5482745.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5523631.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5563089.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5598021.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5626615.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5660959.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5677503.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5670961.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5648387.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5625154.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5627173.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5661724.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5697630.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5726917.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5779787.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5880662.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5954466.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6024269.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6101660.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6179774.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6255312.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6323874.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6393384.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6453932.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6504457.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6552064.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6608339.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6670399.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6741656.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6843356.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6947373.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7017709.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7073460.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7124168.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7174917.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7204672.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7243235.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7287363.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7315589.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7340630.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7355021.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7353544.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7341101.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7333404.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7336115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7346701.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7360176.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7376205.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7387324.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7380676.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7333659.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7244710.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7132743.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7024827.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6927309.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Greece', N'GRC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8331725.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8398050.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8448233.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8479625.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8510429.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8550333.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8613651.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8684088.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8740765.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8772764.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8792806.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8831036.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8888628.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8929086.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(8962022.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9046541.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9188150.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9308479.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9429959.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9548258.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9642505.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9729350.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9789513.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9846627.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9895801.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9934300.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(9967213.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10000595.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10036983.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10089498.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10196792.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10319927.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10399061.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10460415.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10512922.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10562153.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10608800.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10661259.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10720509.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10761698.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10805808.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10862132.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10902022.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10928070.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10955141.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10987314.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11020362.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11048473.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11077841.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11107017.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11121341.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11104899.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(11045011.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10965211.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10892413.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(10823732.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Greece', N'GRC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41349.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41635.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42018.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42426.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42737.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42914.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43014.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43008.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42951.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42913.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42947.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44301.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45379.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46183.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46813.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47348.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47176.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47051.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46999.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47003.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47090.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48720.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50618.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52546.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54276.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55618.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55388.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54607.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53500.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52307.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51214.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51128.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51461.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52161.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53091.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54101.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55016.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55748.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56412.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57179.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58127.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59145.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60362.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61699.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62994.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2005', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64143.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65224.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66111.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66861.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67569.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68295.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68830.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69407.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69980.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70482.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70886.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Grenada', N'GRD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(89861.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(91260.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(92424.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(93354.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94066.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94579.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94878.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94962.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94875.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94682.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94430.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(94180.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(93937.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(93629.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(93151.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(92453.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(91435.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(90187.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(89070.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(88571.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(89004.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(90575.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(93091.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(95981.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(98440.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(99907.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(100146.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(99381.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(98063.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(96871.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(96286.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(96455.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(97201.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(98302.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(99403.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(100253.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(100796.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(101125.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(101302.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(101441.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(101620.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(101849.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(102100.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(102371.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(102657.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(102951.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(103259.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(103587.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(103934.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(104298.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(104677.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(105070.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(105476.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(105902.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(106349.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(106825.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Grenada', N'GRD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Greenland', N'GRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(32500.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(33700.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(35000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(36400.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(37600.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(39200.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(40500.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(41900.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(43400.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(44900.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(46400.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(47200.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(48300.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49500.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49600.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49700.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49400.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49200.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(49600.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(50200.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(51000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(51500.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(52100.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(52700.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(53200.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(53500.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(54100.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(54800.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55300.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55600.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55500.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55300.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55200.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55500.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55800.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(55900.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56100.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56100.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56200.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56350.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56609.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56765.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56911.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56935.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56774.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56555.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56328.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56323.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56905.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56890.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56810.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56483.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56295.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(56114.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Greenland', N'GRL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2127356.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2183689.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2245126.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2311652.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2383101.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2459066.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2526195.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2600025.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2679163.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2761632.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2846309.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2924472.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3005215.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3088235.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3173662.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3261414.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3337834.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3416663.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3498684.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3584236.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3673424.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3758249.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3847117.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3940237.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4038038.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4140773.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4238565.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4344593.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4458107.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4576672.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4698878.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4830179.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4960630.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5094072.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5235575.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5386879.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5534101.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5693014.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5860982.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6032904.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6206362.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6388369.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6572783.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6761195.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6957033.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7162047.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7377981.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7603017.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7835989.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8073731.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8314007.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8561201.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8807492.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9055202.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9307561.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9565603.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guatemala', N'GTM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4127555.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4240084.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4356579.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4476923.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4600846.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4728203.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4858880.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(4993104.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5131461.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5274726.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5423384.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5577824.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5737720.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(5901980.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6069077.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6237963.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6408029.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6579710.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6754258.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(6933492.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(7118628.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(7310397.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(7508161.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(7710142.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(7913814.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(8117499.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(8320498.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(8523785.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(8729406.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(8940285.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(9158547.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(9385000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(9619113.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(9860063.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(10106463.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(10357354.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(10612300.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(10871786.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(11136814.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(11408815.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(11688660.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(11976725.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(12272208.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(12573346.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(12877711.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(13183505.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(13490041.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(13797629.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(14106687.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(14418033.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(14732261.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(15049280.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(15368759.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(15690793.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(16015494.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(16342897.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guatemala', N'GTM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38936.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39715.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40779.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41922.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43033.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44126.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45259.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46480.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47610.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48646.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49690.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51258.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52836.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54303.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55642.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56928.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58555.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60249.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61960.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63655.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65325.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67335.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69326.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71281.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73216.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75150.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77327.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79549.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81805.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84082.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86326.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87944.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89505.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90986.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92401.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93781.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94998.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96238.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97472.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98632.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99658.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100208.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100616.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100916.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101192.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101506.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101771.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102103.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102555.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103178.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104006.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105285.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106796.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108454.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110145.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111782.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guam', N'GUM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(66741.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(68073.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(69607.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(71289.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(73048.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(74827.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(76611.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(78409.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(80219.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(82042.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(83880.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(85728.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(87585.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(89463.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(91381.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(93354.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(95386.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(97476.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(99628.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(101846.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(104131.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(106486.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(108911.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(111405.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(113961.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(116576.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(119232.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(121924.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(124677.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(127525.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(130482.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(133553.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(136696.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(139820.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(142806.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(145562.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(148060.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(150306.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(152275.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(153951.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(155328.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(156417.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(157241.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(157823.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158194.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158401.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158429.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158332.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158310.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(158621.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(159440.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(160858.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(162807.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(165121.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(167543.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(169885.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guam', N'GUM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284739.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292582.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299690.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306050.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311995.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317859.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323505.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329071.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334653.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(339977.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(344949.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(354526.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362325.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(368830.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(375213.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(382263.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(389070.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(396967.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405201.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(412600.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(418747.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423579.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426648.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428460.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(429905.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(431694.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(432691.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(433520.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434171.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435199.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(437391.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434262.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434225.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435736.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(437174.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(437706.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(442846.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(446716.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448286.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(447487.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445055.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445180.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443248.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(440231.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(437626.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(436503.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(441008.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(447158.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(454012.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(460397.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(465957.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(475246.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(483363.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(491012.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499075.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(507707.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guyana', N'GUY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(564222.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(582034.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(600559.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(618887.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(635778.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(650379.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(662332.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(671986.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(680068.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(687658.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(695561.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(703811.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(712188.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(720919.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(730227.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(740167.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(751008.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(762445.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(773227.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(781677.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(786614.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(787728.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(785466.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(780367.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(773302.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(765043.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(755598.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(745149.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(734872.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(726237.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(720282.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(717502.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(717621.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(719910.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(723230.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(726695.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(730193.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(733854.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(737316.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(740189.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(742218.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(743163.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(743107.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(742537.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(742162.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(742495.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(743705.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(745638.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(748096.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(750749.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(753362.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(755883.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(758410.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(761033.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(763893.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(767085.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Guyana', N'GUY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467725436.00000 AS Numeric(28, 5)))
   ,(N'1961', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(474016045.00000 AS Numeric(28, 5)))
   ,(N'1962', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480164452.00000 AS Numeric(28, 5)))
   ,(N'1963', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(486768626.00000 AS Numeric(28, 5)))
   ,(N'1964', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493425997.00000 AS Numeric(28, 5)))
   ,(N'1965', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499785833.00000 AS Numeric(28, 5)))
   ,(N'1966', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(505407645.00000 AS Numeric(28, 5)))
   ,(N'1967', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(510898385.00000 AS Numeric(28, 5)))
   ,(N'1968', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(515825267.00000 AS Numeric(28, 5)))
   ,(N'1969', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(522037892.00000 AS Numeric(28, 5)))
   ,(N'1970', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(527714862.00000 AS Numeric(28, 5)))
   ,(N'1971', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(534216828.00000 AS Numeric(28, 5)))
   ,(N'1972', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540857736.00000 AS Numeric(28, 5)))
   ,(N'1973', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(547067110.00000 AS Numeric(28, 5)))
   ,(N'1974', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(554298429.00000 AS Numeric(28, 5)))
   ,(N'1975', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(561622893.00000 AS Numeric(28, 5)))
   ,(N'1976', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(567233106.00000 AS Numeric(28, 5)))
   ,(N'1977', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(573521440.00000 AS Numeric(28, 5)))
   ,(N'1978', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(580333803.00000 AS Numeric(28, 5)))
   ,(N'1979', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(587566190.00000 AS Numeric(28, 5)))
   ,(N'1980', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(594845016.00000 AS Numeric(28, 5)))
   ,(N'1981', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(602519169.00000 AS Numeric(28, 5)))
   ,(N'1982', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(609966376.00000 AS Numeric(28, 5)))
   ,(N'1983', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(617054596.00000 AS Numeric(28, 5)))
   ,(N'1984', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(623668506.00000 AS Numeric(28, 5)))
   ,(N'1985', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(629946715.00000 AS Numeric(28, 5)))
   ,(N'1986', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(635174589.00000 AS Numeric(28, 5)))
   ,(N'1987', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(640311866.00000 AS Numeric(28, 5)))
   ,(N'1988', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(645404626.00000 AS Numeric(28, 5)))
   ,(N'1989', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(650645912.00000 AS Numeric(28, 5)))
   ,(N'1990', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(656028463.00000 AS Numeric(28, 5)))
   ,(N'1991', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(661120736.00000 AS Numeric(28, 5)))
   ,(N'1992', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(664949159.00000 AS Numeric(28, 5)))
   ,(N'1993', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(669934170.00000 AS Numeric(28, 5)))
   ,(N'1994', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(674789109.00000 AS Numeric(28, 5)))
   ,(N'1995', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(681034073.00000 AS Numeric(28, 5)))
   ,(N'1996', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(685767001.00000 AS Numeric(28, 5)))
   ,(N'1997', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(690970397.00000 AS Numeric(28, 5)))
   ,(N'1998', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(696174060.00000 AS Numeric(28, 5)))
   ,(N'1999', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(701447087.00000 AS Numeric(28, 5)))
   ,(N'2000', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(706450686.00000 AS Numeric(28, 5)))
   ,(N'2001', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(711983723.00000 AS Numeric(28, 5)))
   ,(N'2002', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(717271521.00000 AS Numeric(28, 5)))
   ,(N'2003', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(722414954.00000 AS Numeric(28, 5)))
   ,(N'2004', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(727933892.00000 AS Numeric(28, 5)))
   ,(N'2005', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(733718591.00000 AS Numeric(28, 5)))
   ,(N'2006', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(739096956.00000 AS Numeric(28, 5)))
   ,(N'2007', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(744881738.00000 AS Numeric(28, 5)))
   ,(N'2008', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(750961514.00000 AS Numeric(28, 5)))
   ,(N'2009', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(755970628.00000 AS Numeric(28, 5)))
   ,(N'2010', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(759837948.00000 AS Numeric(28, 5)))
   ,(N'2011', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(762416475.00000 AS Numeric(28, 5)))
   ,(N'2012', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(763508275.00000 AS Numeric(28, 5)))
   ,(N'2013', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(766113882.00000 AS Numeric(28, 5)))
   ,(N'2014', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(766534789.00000 AS Numeric(28, 5)))
   ,(N'2015', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(767339673.00000 AS Numeric(28, 5)))
   ,(N'2016', N'High income', N'HIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(758716470.00000 AS Numeric(28, 5)))
   ,(N'1961', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(770099673.00000 AS Numeric(28, 5)))
   ,(N'1962', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(780133572.00000 AS Numeric(28, 5)))
   ,(N'1963', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(790080922.00000 AS Numeric(28, 5)))
   ,(N'1964', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(799918623.00000 AS Numeric(28, 5)))
   ,(N'1965', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(809360466.00000 AS Numeric(28, 5)))
   ,(N'1966', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(818167431.00000 AS Numeric(28, 5)))
   ,(N'1967', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(826583007.00000 AS Numeric(28, 5)))
   ,(N'1968', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(834012315.00000 AS Numeric(28, 5)))
   ,(N'1969', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(843140725.00000 AS Numeric(28, 5)))
   ,(N'1970', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(851290758.00000 AS Numeric(28, 5)))
   ,(N'1971', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(860031660.00000 AS Numeric(28, 5)))
   ,(N'1972', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(868875520.00000 AS Numeric(28, 5)))
   ,(N'1973', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(876847559.00000 AS Numeric(28, 5)))
   ,(N'1974', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(885878283.00000 AS Numeric(28, 5)))
   ,(N'1975', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(894516873.00000 AS Numeric(28, 5)))
   ,(N'1976', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(901709691.00000 AS Numeric(28, 5)))
   ,(N'1977', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(909169527.00000 AS Numeric(28, 5)))
   ,(N'1978', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(916799313.00000 AS Numeric(28, 5)))
   ,(N'1979', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(924641692.00000 AS Numeric(28, 5)))
   ,(N'1980', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(932213838.00000 AS Numeric(28, 5)))
   ,(N'1981', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(939880497.00000 AS Numeric(28, 5)))
   ,(N'1982', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(947075507.00000 AS Numeric(28, 5)))
   ,(N'1983', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(953842472.00000 AS Numeric(28, 5)))
   ,(N'1984', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(960250975.00000 AS Numeric(28, 5)))
   ,(N'1985', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(966684594.00000 AS Numeric(28, 5)))
   ,(N'1986', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(973400217.00000 AS Numeric(28, 5)))
   ,(N'1987', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(980091126.00000 AS Numeric(28, 5)))
   ,(N'1988', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(986918025.00000 AS Numeric(28, 5)))
   ,(N'1989', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(994203460.00000 AS Numeric(28, 5)))
   ,(N'1990', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1001966223.00000 AS Numeric(28, 5)))
   ,(N'1991', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1009883314.00000 AS Numeric(28, 5)))
   ,(N'1992', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1016171233.00000 AS Numeric(28, 5)))
   ,(N'1993', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1024162143.00000 AS Numeric(28, 5)))
   ,(N'1994', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1031489890.00000 AS Numeric(28, 5)))
   ,(N'1995', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1040394770.00000 AS Numeric(28, 5)))
   ,(N'1996', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1047405818.00000 AS Numeric(28, 5)))
   ,(N'1997', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1054469107.00000 AS Numeric(28, 5)))
   ,(N'1998', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1061211341.00000 AS Numeric(28, 5)))
   ,(N'1999', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1068095946.00000 AS Numeric(28, 5)))
   ,(N'2000', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1074878739.00000 AS Numeric(28, 5)))
   ,(N'2001', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1082312299.00000 AS Numeric(28, 5)))
   ,(N'2002', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1089656214.00000 AS Numeric(28, 5)))
   ,(N'2003', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1096885903.00000 AS Numeric(28, 5)))
   ,(N'2004', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1104476123.00000 AS Numeric(28, 5)))
   ,(N'2005', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1112235304.00000 AS Numeric(28, 5)))
   ,(N'2006', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1120543449.00000 AS Numeric(28, 5)))
   ,(N'2007', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1129339051.00000 AS Numeric(28, 5)))
   ,(N'2008', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1138677189.00000 AS Numeric(28, 5)))
   ,(N'2009', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1147005992.00000 AS Numeric(28, 5)))
   ,(N'2010', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1154477199.00000 AS Numeric(28, 5)))
   ,(N'2011', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1161326328.00000 AS Numeric(28, 5)))
   ,(N'2012', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1166574800.00000 AS Numeric(28, 5)))
   ,(N'2013', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1174927882.00000 AS Numeric(28, 5)))
   ,(N'2014', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1180597445.00000 AS Numeric(28, 5)))
   ,(N'2015', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(1187189841.00000 AS Numeric(28, 5)))
   ,(N'2016', N'High income', N'HIC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1731334.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1775195.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1854348.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1928741.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1988946.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2058688.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2078651.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2142338.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2204928.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2259825.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2336242.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2425743.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2507270.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2612056.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2704740.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2824278.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2905066.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3002785.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3116033.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3345147.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3479763.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3584093.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3647258.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3700769.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3734131.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3774937.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3824714.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3879538.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3916913.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3966240.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3982688.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4037344.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4084460.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4163452.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4267933.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4367582.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4564390.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4610858.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4663999.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4725105.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4784711.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4842082.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4886333.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4900771.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4966871.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5020337.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5090582.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5169252.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5224341.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5242395.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5270003.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5299912.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5339413.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5329125.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5328615.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5331613.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Hong Kong SAR, China', N'HKG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3075605.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3168100.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3305200.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3420900.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3504600.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3597900.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3629900.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3722800.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3802700.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3863900.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(3959000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4045300.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4123600.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4241600.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4334200.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4461600.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4518000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4583700.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4667500.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(4929700.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5063100.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5183400.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5264500.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5345100.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5397900.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5456200.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5524600.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5590500.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5627600.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5686200.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5704500.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5752000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5800500.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(5901000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6035400.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6156100.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6435500.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6489300.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6543700.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6606500.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6665000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6714300.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6744100.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6730800.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6783500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6813200.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6857100.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6916300.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6957800.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(6972800.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7024200.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7071600.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7154600.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7187500.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7241700.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(7305700.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Hong Kong SAR, China', N'HKG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1016289.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1043061.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1072082.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1103131.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1136184.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1171063.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1197815.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1226086.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1256134.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1288345.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1323207.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1357888.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1396924.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1439663.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1485202.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1533096.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1583292.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1635474.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1690258.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1748756.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1811326.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1871148.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1935818.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2003998.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2073795.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2144347.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2213706.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2284262.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2356286.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2430570.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2507592.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2585477.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2664843.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2745838.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2828633.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2913283.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2996006.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3080936.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3167939.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3256892.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3348117.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3445366.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3545453.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3648641.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3755389.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3865919.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3984426.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4105646.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4229329.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4355090.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4482298.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4609472.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4738390.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4867617.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4994750.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5118291.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Honduras', N'HND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2002333.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2069085.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2139208.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2211144.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2282764.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2352637.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2420234.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2486288.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2552200.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2620014.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2691309.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2766444.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2845260.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(2928190.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3015606.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3107735.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3204883.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3306988.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3413426.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3523283.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3635862.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3750843.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3868296.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(3988371.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4111369.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4237436.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4366401.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4497875.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4631491.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4766802.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(4903363.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5041050.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5179557.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5318042.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5455481.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5591136.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5724587.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5855946.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(5985675.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6114534.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6243080.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6371304.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6499001.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6626304.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6753352.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(6880181.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7007029.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7133737.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7259470.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7383098.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7503875.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7621414.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7736131.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7849059.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(7961680.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(8075060.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Honduras', N'HND', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87623007.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89287021.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91144406.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93175901.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95369724.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97720820.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99727912.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101966048.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104408462.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107029037.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109813236.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112243667.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114895197.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117744784.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120773997.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123971552.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126840132.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129914247.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133155444.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136535576.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140051144.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143070651.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146352608.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149902791.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153729297.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157840755.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161659188.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165850793.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170424715.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175410504.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180821426.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186180392.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192079773.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198383986.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204930405.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211629236.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217618247.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223796609.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230218300.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236980491.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244152500.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251166238.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258691503.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266650968.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274957453.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283572435.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291918709.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(300691187.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309897108.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(319555222.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329675593.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(339943942.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(350737097.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362029000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373792726.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(386006719.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(162491185.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(166337526.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(170332701.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(174484508.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(178802599.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(183294395.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(187962262.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(192806249.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(197828276.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(203029611.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(208410359.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(213971961.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(219712407.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(225623793.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(231695364.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(237918910.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(244306047.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(250860495.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(257558535.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(264368402.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(271276022.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(278278454.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(285410524.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(292744009.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(300374211.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(308377129.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(316760151.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(325525015.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(334731596.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(344448856.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(354714206.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(365581300.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(377011630.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(388837016.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(400825087.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(412815898.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(424741843.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(436671177.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(448746908.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(461180538.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(474127024.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(487633972.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(501659710.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(516163015.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(531070213.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(546329345.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(561934621.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(577914150.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(594288511.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(611087950.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(628333588.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(646028823.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(664163813.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(682730030.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(701714118.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(721104105.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Heavily indebted poor countries (HIPC)', N'HPC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2714156.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2735079.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2759107.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2786224.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2814876.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2844066.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2867871.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2895341.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2923866.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2949793.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2973182.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2992154.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3004957.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3014263.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3022886.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1975', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3032660.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3039050.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3040028.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3058674.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3072864.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3089562.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3113989.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3144087.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3172206.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3197618.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3221753.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3237188.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3250491.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3263069.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3270751.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3280757.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3088636.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3054511.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3163941.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3163825.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3168939.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3045570.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3090743.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3033706.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3061460.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2970395.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2970636.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2968123.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2970034.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2972446.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2977102.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2981554.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2979859.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2976471.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2969666.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2958945.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2858734.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2845097.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2833386.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2815373.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2795384.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Croatia', N'HRV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4140000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4171672.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4202104.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4231408.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4259680.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4287000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4313000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4339000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4364000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4387000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4411000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4435000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4457000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4478000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4497000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4514000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4530000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4532000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4556000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4571000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4588000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4608000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4635000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4659000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4680000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4701000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4722000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4740000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4757000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4767000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4780000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4510000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4470000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4640000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4650000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4669000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4494000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4572000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4501000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4554000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4426000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4440000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4440000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4440000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4439000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4442000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4440000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4436000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4434508.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4429078.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4417781.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4280622.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4267558.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4255689.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4238389.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(4224404.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Croatia', N'HRV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2184429.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2215589.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2244079.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2272210.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2304334.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2342743.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2376399.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2417733.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2464645.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2513977.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2564281.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2609210.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2656311.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2706157.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2759586.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2816966.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2872742.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2930631.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2991192.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3054590.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3120359.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3178207.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3238844.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3301216.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3364817.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3429833.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3484658.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3546278.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3612682.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3681643.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3752891.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3830287.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3907528.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3988269.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4077548.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4177388.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4278871.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4390248.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4509032.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4630713.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4752607.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4868780.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4987196.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5107174.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5228339.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5350597.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5471908.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5592386.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5713417.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5837506.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5965738.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6088958.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6217478.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6348342.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6476987.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6600992.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Haiti', N'HTI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(3866160.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(3943363.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4022596.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4103732.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4186636.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4271133.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4357482.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4445531.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4534233.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4622209.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4708639.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4793157.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4876558.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(4960655.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5047948.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5140357.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5238242.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5341418.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5450550.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5566265.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5688832.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5818673.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(5955265.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6096690.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6240330.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6384196.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6527545.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6670566.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6813344.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(6956301.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7099733.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7243391.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7386974.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7530703.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7674911.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7819806.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(7965548.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8111954.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8258484.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8404396.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8549202.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8692564.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8834739.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(8976555.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9119182.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9263409.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9409479.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9556958.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9705130.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9852953.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(9999617.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(10144890.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(10288828.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(10431249.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(10572029.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(10711067.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Haiti', N'HTI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6557745.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6603141.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6631448.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6653393.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6685855.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6725236.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6772479.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6823556.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6875865.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6931211.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6983130.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6996318.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7022838.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7051258.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7071405.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7076993.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7069230.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7025792.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6964209.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6914852.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6899524.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6889282.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6926600.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6986376.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7033063.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7050854.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7066186.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7041218.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6999956.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6910513.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6857144.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6856022.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6885486.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6927996.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6964206.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6985213.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6987034.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6979634.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6966021.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6952317.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6946990.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6947999.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6943528.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6938551.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6938102.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6938623.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6925227.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6913047.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6899427.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6885294.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6863511.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6827929.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6778032.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6742529.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6701671.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6657311.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Hungary', N'HUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9983967.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10029321.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10061734.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10087947.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10119835.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10147935.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10178653.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10216604.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10255815.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10298723.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10337910.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10367537.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10398489.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10432055.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10478720.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10540525.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10598677.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10648031.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10684822.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10704152.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10711122.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10711848.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10705535.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10689463.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10668095.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10648713.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10630564.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10612741.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10596487.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10481719.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10373988.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10373400.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10369341.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10357523.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10343355.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10328965.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10311238.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10290486.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10266570.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10237530.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10210971.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10187576.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10158608.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10129552.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10107146.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10087065.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10071370.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10055780.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10038188.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10022650.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(10000023.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9971727.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9920362.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9893082.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9866468.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(9844686.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Hungary', N'HUN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1064599733.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1071083285.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1083181639.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1101963488.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1123197471.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1148444554.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1172443651.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1200314931.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1231642538.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1264699560.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1297943963.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1329292633.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1360945486.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1393147295.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1426424036.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1460814144.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1494557381.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1529804338.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1567351179.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1607072157.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1648272556.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1690693742.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1734983213.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1779929104.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1824812811.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1870213516.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1912058610.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1955163282.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1998407382.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2041123673.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2083295246.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2119350302.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2157502197.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2197207930.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2237489541.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2278107843.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2322653794.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2366223973.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2409872700.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2455551841.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2503231597.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2548978368.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2596506093.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2645713126.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2694906687.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2743113944.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2787102733.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2830439176.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2872664306.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2912992417.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2950438473.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2984918448.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3017355576.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3047827099.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3076670677.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3104086924.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IBRD only', N'IBD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(1875777633.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(1895482796.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(1928072258.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(1972479321.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2016899211.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2062448481.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2111123127.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2159380423.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2208964734.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2260714085.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2313790246.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2368392016.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2422248641.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2475684938.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2528266914.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2579052214.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2628706415.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2677257515.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2726308949.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2776306428.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2826799187.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2878740929.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2933470381.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(2988787474.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3043554498.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3099289034.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3156647533.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3215507297.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3274479533.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3332402053.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3388684816.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3442817616.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3495038083.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3546164932.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3596717140.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3646880415.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3696674262.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3746789759.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3796268516.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3844686211.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3891341487.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3936976322.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(3981261150.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4025255455.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4068932937.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4112488698.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4155627832.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4198115070.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4240795662.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4283880652.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4326536938.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4369332638.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4412598770.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4456007248.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4499429071.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(4542580688.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IBRD only', N'IBD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1298497147.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1308907708.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1325369805.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1348849943.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1375284569.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1406120409.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1435254725.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1468820850.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1506367116.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1546083685.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1586411226.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1624137655.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1662635967.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1702197747.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1743315836.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1786074989.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1827721060.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1871571069.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1918328454.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1967764723.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2019094220.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2070727094.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2124909794.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2180330383.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2236287279.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2293391331.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2346325530.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2401341132.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2457204321.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2513230534.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2569230211.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2618548720.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2670839550.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2725415509.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2781190958.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2837932222.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2897794921.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2957379273.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3017738278.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3080770124.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3146471007.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3209590192.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3275148520.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3343001069.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3411360962.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3479136490.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3541844024.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3604460122.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3666550988.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3727372972.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3787342437.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3842014204.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3896440907.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3949650345.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4001890123.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4054465271.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA & IBRD total', N'IBT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2302766065.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2332645361.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2375791917.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2431027642.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2486895322.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2544283874.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2605302965.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2666366898.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2729171137.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2794384186.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2861116444.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2929455006.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(2997265511.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3065048540.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3132441576.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3198666331.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3264427284.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3329713128.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3396110153.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3464008965.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3532863897.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3603364405.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3677247133.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3752252711.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3827354654.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3904169497.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(3983418913.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4064872946.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4147006714.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4228633617.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4308835687.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4387370401.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4464494101.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4540828915.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4616731819.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4692385329.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4767797399.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4843628455.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4918857078.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(4993168528.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5066287495.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5138888813.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5210552441.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5282417436.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5354468454.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5426821987.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5499192098.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5571443480.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5644543404.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5718852388.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5793949021.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5870148581.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(5947367231.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(6025553530.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(6104461024.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(6183634830.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA & IBRD total', N'IBT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233897414.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(237824423.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(242188166.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246886455.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252087098.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(257675855.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262811074.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268505919.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274724578.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281384125.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288467263.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294845022.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301690481.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309050452.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(316891800.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(325260845.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333163679.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341766731.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(350977275.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360692566.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(370821664.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(380033352.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(389926581.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(400401279.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(411474468.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423177815.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434266920.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(446177850.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458796939.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(472106861.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(485934965.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499198418.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(513337353.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(528207579.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(543701417.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(559824379.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(575141127.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591155300.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607865578.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(625218283.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(643239410.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(660611824.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(678642427.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(697287943.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(716454275.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(736022546.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(754741291.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(774020946.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(793886682.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(814380555.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(836903964.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(857095756.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(879085331.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(901823246.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(925219446.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(950378347.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA total', N'IDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(426988432.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(437162565.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(447719659.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(458548321.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(469996111.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(481835393.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(494179838.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(506986475.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(520206403.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(533670101.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(547326198.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(561062990.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(575016870.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(589363602.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(604174662.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(619614117.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(635720869.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(652455613.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(669801204.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(687702537.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(706064710.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(724623476.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(743776752.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(763465237.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(783800156.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(804880463.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(826771380.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(849365649.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(872527181.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(896231564.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(920150871.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(944552785.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(969456018.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(994663983.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1020014679.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1045504914.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1071123137.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1096838696.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1122588562.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1148482317.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1174946008.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1201912491.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1229291291.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1257161981.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1285535517.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1314333289.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1343564266.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1373328410.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1403747742.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1434971736.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1467412083.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1500815943.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1534768461.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1569546282.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1605031953.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(1641054142.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA total', N'IDA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91366355.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92661151.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94113900.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95625625.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97357110.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99192598.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101000452.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102989740.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105196369.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107611334.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110254438.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112819611.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115614677.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118675028.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121943473.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125445321.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128812085.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132465543.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136362243.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140432614.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144603505.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148424611.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152434434.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156572532.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160900423.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165469655.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169901262.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174615175.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179522881.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184589410.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189649217.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194284648.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199176555.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204297378.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209633261.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215229102.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220805423.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226707404.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232905046.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239311161.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245945441.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252393616.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258988274.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265783150.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272788962.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279932543.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286755080.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293733404.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(300848052.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308071005.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(315571826.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322591993.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329585246.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336722410.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343981496.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351306579.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA blend', N'IDB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(163861743.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(167557049.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(171402542.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(175257487.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(179430842.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(183677726.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(188077709.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(192616898.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(197338633.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(202203700.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(207250858.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(212393671.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(217715341.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(223308793.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(229107516.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(235184715.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(241541333.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(248153270.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(255015624.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(262098756.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(269328534.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(276430081.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(283773443.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(291267007.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(298992872.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(307023847.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(315428654.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(324102452.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(332878430.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(341671811.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(350159965.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(358569565.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(366983131.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(375374923.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(383737278.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(392141218.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(400674821.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(409285530.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(417928840.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(426492623.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(435073133.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(443627954.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(452157850.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(460797947.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(469662036.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(478749307.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(488079322.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(497712924.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(507660939.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(517916391.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(528772010.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(539941221.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(551030216.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(562377856.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(573991143.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(585760189.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA blend', N'IDB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49643718.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50507238.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51440663.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52437731.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53504456.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54652845.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55790207.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57008127.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58330154.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59787632.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61393078.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62941250.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64670162.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66550629.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68535335.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70597669.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72602031.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74694407.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76883064.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79186875.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81611774.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84014975.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86531839.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89144148.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91835043.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94592184.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97225390.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99964647.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102778319.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105620337.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108465721.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111267372.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114027846.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116782353.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119590471.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122479929.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125224179.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128074084.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130988010.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133876293.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136664789.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138907935.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141100062.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143274460.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145476713.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147729475.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150381892.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152913569.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155333281.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157646201.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159901187.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162594749.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165155722.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167673073.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170252166.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172912592.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Indonesia', N'IDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(87792512.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(90138235.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(92558006.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(95055669.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(97638027.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(100308896.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(103067352.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(105907403.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(108821565.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(111800090.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(114834781.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(117921994.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(121059511.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(124242299.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(127465232.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(130724118.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(134010695.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(137322122.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(140665859.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(144053516.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(147490366.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(150978841.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(154506266.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(158044343.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(161555584.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(165012195.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(168402027.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(171728916.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(175000919.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(178233231.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(181436821.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(184614740.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(187762097.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(190873248.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(193939912.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(196957845.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(199926615.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(202853850.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(205753493.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(208644079.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(211540428.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(214448301.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(217369087.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(220307809.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(223268606.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(226254703.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(229263980.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(232296830.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(235360765.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(238465165.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(241613126.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(244808254.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(248037853.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(251268276.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(254454778.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(257563815.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Indonesia', N'IDN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142531059.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145163272.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148074266.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151260830.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154729988.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158483257.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161810622.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165516179.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169528209.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173772791.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178212825.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182025411.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186075804.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190375424.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194948327.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199815524.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204351594.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209301188.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214615032.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220259952.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226218159.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231608741.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(237492147.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(243828747.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250574045.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(257708160.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264365658.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271562675.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279274058.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(287517451.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(296285748.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304913770.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(314160798.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323910201.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334068156.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(344595277.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(354335704.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(364447896.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(374960532.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(385907122.00000 AS Numeric(28, 5)))
   ,(N'2000', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(397293969.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(408218208.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(419654153.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(431504793.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443665313.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(456090003.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467986211.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480287542.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493038630.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506309550.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(521332138.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(534503763.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(549500085.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(565100836.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(581237950.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(599071768.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA only', N'IDX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(263126689.00000 AS Numeric(28, 5)))
   ,(N'1961', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(269605516.00000 AS Numeric(28, 5)))
   ,(N'1962', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(276317117.00000 AS Numeric(28, 5)))
   ,(N'1963', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(283290834.00000 AS Numeric(28, 5)))
   ,(N'1964', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(290565269.00000 AS Numeric(28, 5)))
   ,(N'1965', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(298157667.00000 AS Numeric(28, 5)))
   ,(N'1966', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(306102129.00000 AS Numeric(28, 5)))
   ,(N'1967', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(314369577.00000 AS Numeric(28, 5)))
   ,(N'1968', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(322867770.00000 AS Numeric(28, 5)))
   ,(N'1969', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(331466401.00000 AS Numeric(28, 5)))
   ,(N'1970', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(340075340.00000 AS Numeric(28, 5)))
   ,(N'1971', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(348669319.00000 AS Numeric(28, 5)))
   ,(N'1972', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(357301529.00000 AS Numeric(28, 5)))
   ,(N'1973', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(366054809.00000 AS Numeric(28, 5)))
   ,(N'1974', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(375067146.00000 AS Numeric(28, 5)))
   ,(N'1975', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(384429402.00000 AS Numeric(28, 5)))
   ,(N'1976', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(394179536.00000 AS Numeric(28, 5)))
   ,(N'1977', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(404302343.00000 AS Numeric(28, 5)))
   ,(N'1978', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(414785580.00000 AS Numeric(28, 5)))
   ,(N'1979', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(425603781.00000 AS Numeric(28, 5)))
   ,(N'1980', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(436736176.00000 AS Numeric(28, 5)))
   ,(N'1981', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(448193395.00000 AS Numeric(28, 5)))
   ,(N'1982', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(460003309.00000 AS Numeric(28, 5)))
   ,(N'1983', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(472198230.00000 AS Numeric(28, 5)))
   ,(N'1984', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(484807284.00000 AS Numeric(28, 5)))
   ,(N'1985', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(497856616.00000 AS Numeric(28, 5)))
   ,(N'1986', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(511342726.00000 AS Numeric(28, 5)))
   ,(N'1987', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(525263197.00000 AS Numeric(28, 5)))
   ,(N'1988', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(539648751.00000 AS Numeric(28, 5)))
   ,(N'1989', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(554559753.00000 AS Numeric(28, 5)))
   ,(N'1990', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(569990906.00000 AS Numeric(28, 5)))
   ,(N'1991', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(585983220.00000 AS Numeric(28, 5)))
   ,(N'1992', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(602472887.00000 AS Numeric(28, 5)))
   ,(N'1993', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(619289060.00000 AS Numeric(28, 5)))
   ,(N'1994', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(636277401.00000 AS Numeric(28, 5)))
   ,(N'1995', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(653363696.00000 AS Numeric(28, 5)))
   ,(N'1996', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(670448316.00000 AS Numeric(28, 5)))
   ,(N'1997', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(687553166.00000 AS Numeric(28, 5)))
   ,(N'1998', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(704659722.00000 AS Numeric(28, 5)))
   ,(N'1999', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(721989694.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2000', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(739872875.00000 AS Numeric(28, 5)))
   ,(N'2001', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(758284537.00000 AS Numeric(28, 5)))
   ,(N'2002', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(777133441.00000 AS Numeric(28, 5)))
   ,(N'2003', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(796364034.00000 AS Numeric(28, 5)))
   ,(N'2004', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(815873481.00000 AS Numeric(28, 5)))
   ,(N'2005', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(835583982.00000 AS Numeric(28, 5)))
   ,(N'2006', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(855484944.00000 AS Numeric(28, 5)))
   ,(N'2007', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(875615486.00000 AS Numeric(28, 5)))
   ,(N'2008', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(896086803.00000 AS Numeric(28, 5)))
   ,(N'2009', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(917055345.00000 AS Numeric(28, 5)))
   ,(N'2010', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(938640073.00000 AS Numeric(28, 5)))
   ,(N'2011', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(960874722.00000 AS Numeric(28, 5)))
   ,(N'2012', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(983738245.00000 AS Numeric(28, 5)))
   ,(N'2013', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(1007168426.00000 AS Numeric(28, 5)))
   ,(N'2014', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(1031040810.00000 AS Numeric(28, 5)))
   ,(N'2015', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(1055293953.00000 AS Numeric(28, 5)))
   ,(N'2016', N'IDA only', N'IDX', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Isle of Man', N'IMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(48441.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(48353.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(48580.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(49089.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(49818.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(50713.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(51776.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(52995.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(54289.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(55554.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(56712.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(57711.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(58563.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(59326.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(60098.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(60941.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(61900.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(62934.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(63918.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(64680.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(65108.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(65128.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(64817.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(64404.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(64207.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(64446.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(65225.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(66449.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(67902.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(69265.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(70312.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(70963.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(71306.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(71486.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(71726.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(72181.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(72899.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(73817.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(74853.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(75879.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(76806.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(77608.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(78318.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(78975.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(79636.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(80345.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(81110.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(81914.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(82737.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(83548.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(84327.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(85069.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(85779.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(86462.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(87127.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(87780.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Isle of Man', N'IMY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254680024.00000 AS Numeric(28, 5)))
   ,(N'1961', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258312604.00000 AS Numeric(28, 5)))
   ,(N'1962', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261871268.00000 AS Numeric(28, 5)))
   ,(N'1963', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265660661.00000 AS Numeric(28, 5)))
   ,(N'1964', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(270166092.00000 AS Numeric(28, 5)))
   ,(N'1965', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275611610.00000 AS Numeric(28, 5)))
   ,(N'1966', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280737512.00000 AS Numeric(28, 5)))
   ,(N'1967', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286916771.00000 AS Numeric(28, 5)))
   ,(N'1968', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293947414.00000 AS Numeric(28, 5)))
   ,(N'1969', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301468223.00000 AS Numeric(28, 5)))
   ,(N'1970', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309279667.00000 AS Numeric(28, 5)))
   ,(N'1971', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(316673646.00000 AS Numeric(28, 5)))
   ,(N'1972', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324526657.00000 AS Numeric(28, 5)))
   ,(N'1973', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332818158.00000 AS Numeric(28, 5)))
   ,(N'1974', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341598243.00000 AS Numeric(28, 5)))
   ,(N'1975', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(350869664.00000 AS Numeric(28, 5)))
   ,(N'1976', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(359348656.00000 AS Numeric(28, 5)))
   ,(N'1977', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(368444390.00000 AS Numeric(28, 5)))
   ,(N'1978', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(378054712.00000 AS Numeric(28, 5)))
   ,(N'1979', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(388030520.00000 AS Numeric(28, 5)))
   ,(N'1980', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(398283917.00000 AS Numeric(28, 5)))
   ,(N'1981', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407909694.00000 AS Numeric(28, 5)))
   ,(N'1982', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(417835343.00000 AS Numeric(28, 5)))
   ,(N'1983', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428097482.00000 AS Numeric(28, 5)))
   ,(N'1984', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(438809189.00000 AS Numeric(28, 5)))
   ,(N'1985', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450014221.00000 AS Numeric(28, 5)))
   ,(N'1986', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(460218045.00000 AS Numeric(28, 5)))
   ,(N'1987', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(471211026.00000 AS Numeric(28, 5)))
   ,(N'1988', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(482812757.00000 AS Numeric(28, 5)))
   ,(N'1989', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494781883.00000 AS Numeric(28, 5)))
   ,(N'1990', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(507014954.00000 AS Numeric(28, 5)))
   ,(N'1991', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(518710882.00000 AS Numeric(28, 5)))
   ,(N'1992', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(530730478.00000 AS Numeric(28, 5)))
   ,(N'1993', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(543168702.00000 AS Numeric(28, 5)))
   ,(N'1994', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(556185519.00000 AS Numeric(28, 5)))
   ,(N'1995', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569835370.00000 AS Numeric(28, 5)))
   ,(N'1996', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(583132035.00000 AS Numeric(28, 5)))
   ,(N'1997', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(597013889.00000 AS Numeric(28, 5)))
   ,(N'1998', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(611403130.00000 AS Numeric(28, 5)))
   ,(N'1999', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(626157855.00000 AS Numeric(28, 5)))
   ,(N'2000', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(641156499.00000 AS Numeric(28, 5)))
   ,(N'2001', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(655287457.00000 AS Numeric(28, 5)))
   ,(N'2002', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(669766460.00000 AS Numeric(28, 5)))
   ,(N'2003', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684508740.00000 AS Numeric(28, 5)))
   ,(N'2004', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(699432404.00000 AS Numeric(28, 5)))
   ,(N'2005', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(714483076.00000 AS Numeric(28, 5)))
   ,(N'2006', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(728843389.00000 AS Numeric(28, 5)))
   ,(N'2007', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(743364718.00000 AS Numeric(28, 5)))
   ,(N'2008', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(758009790.00000 AS Numeric(28, 5)))
   ,(N'2009', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(772799276.00000 AS Numeric(28, 5)))
   ,(N'2010', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(787736653.00000 AS Numeric(28, 5)))
   ,(N'2011', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(802047581.00000 AS Numeric(28, 5)))
   ,(N'2012', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(816620150.00000 AS Numeric(28, 5)))
   ,(N'2013', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(831296401.00000 AS Numeric(28, 5)))
   ,(N'2014', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(845811113.00000 AS Numeric(28, 5)))
   ,(N'2015', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(859993590.00000 AS Numeric(28, 5)))
   ,(N'2016', N'India', N'IND', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(449661874.00000 AS Numeric(28, 5)))
   ,(N'1961', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(458691457.00000 AS Numeric(28, 5)))
   ,(N'1962', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(468054145.00000 AS Numeric(28, 5)))
   ,(N'1963', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(477729958.00000 AS Numeric(28, 5)))
   ,(N'1964', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(487690114.00000 AS Numeric(28, 5)))
   ,(N'1965', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(497920270.00000 AS Numeric(28, 5)))
   ,(N'1966', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(508402908.00000 AS Numeric(28, 5)))
   ,(N'1967', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(519162069.00000 AS Numeric(28, 5)))
   ,(N'1968', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(530274729.00000 AS Numeric(28, 5)))
   ,(N'1969', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(541844848.00000 AS Numeric(28, 5)))
   ,(N'1970', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(553943226.00000 AS Numeric(28, 5)))
   ,(N'1971', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(566605402.00000 AS Numeric(28, 5)))
   ,(N'1972', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(579800632.00000 AS Numeric(28, 5)))
   ,(N'1973', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(593451889.00000 AS Numeric(28, 5)))
   ,(N'1974', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(607446519.00000 AS Numeric(28, 5)))
   ,(N'1975', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(621703641.00000 AS Numeric(28, 5)))
   ,(N'1976', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(636182810.00000 AS Numeric(28, 5)))
   ,(N'1977', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(650907559.00000 AS Numeric(28, 5)))
   ,(N'1978', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(665936435.00000 AS Numeric(28, 5)))
   ,(N'1979', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(681358553.00000 AS Numeric(28, 5)))
   ,(N'1980', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(697229745.00000 AS Numeric(28, 5)))
   ,(N'1981', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(713561406.00000 AS Numeric(28, 5)))
   ,(N'1982', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(730303461.00000 AS Numeric(28, 5)))
   ,(N'1983', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(747374856.00000 AS Numeric(28, 5)))
   ,(N'1984', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(764664278.00000 AS Numeric(28, 5)))
   ,(N'1985', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(782085127.00000 AS Numeric(28, 5)))
   ,(N'1986', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(799607235.00000 AS Numeric(28, 5)))
   ,(N'1987', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(817232241.00000 AS Numeric(28, 5)))
   ,(N'1988', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(834944397.00000 AS Numeric(28, 5)))
   ,(N'1989', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(852736160.00000 AS Numeric(28, 5)))
   ,(N'1990', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(870601776.00000 AS Numeric(28, 5)))
   ,(N'1991', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(888513869.00000 AS Numeric(28, 5)))
   ,(N'1992', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(906461358.00000 AS Numeric(28, 5)))
   ,(N'1993', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(924475633.00000 AS Numeric(28, 5)))
   ,(N'1994', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(942604211.00000 AS Numeric(28, 5)))
   ,(N'1995', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(960874982.00000 AS Numeric(28, 5)))
   ,(N'1996', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(979290432.00000 AS Numeric(28, 5)))
   ,(N'1997', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(997817250.00000 AS Numeric(28, 5)))
   ,(N'1998', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1016402907.00000 AS Numeric(28, 5)))
   ,(N'1999', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1034976626.00000 AS Numeric(28, 5)))
   ,(N'2000', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1053481072.00000 AS Numeric(28, 5)))
   ,(N'2001', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1071888190.00000 AS Numeric(28, 5)))
   ,(N'2002', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1090189358.00000 AS Numeric(28, 5)))
   ,(N'2003', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1108369577.00000 AS Numeric(28, 5)))
   ,(N'2004', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1126419321.00000 AS Numeric(28, 5)))
   ,(N'2005', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1144326293.00000 AS Numeric(28, 5)))
   ,(N'2006', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1162088305.00000 AS Numeric(28, 5)))
   ,(N'2007', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1179685631.00000 AS Numeric(28, 5)))
   ,(N'2008', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1197070109.00000 AS Numeric(28, 5)))
   ,(N'2009', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1214182182.00000 AS Numeric(28, 5)))
   ,(N'2010', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1230984504.00000 AS Numeric(28, 5)))
   ,(N'2011', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1247446011.00000 AS Numeric(28, 5)))
   ,(N'2012', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1263589639.00000 AS Numeric(28, 5)))
   ,(N'2013', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1279498874.00000 AS Numeric(28, 5)))
   ,(N'2014', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1295291543.00000 AS Numeric(28, 5)))
   ,(N'2015', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(1311050527.00000 AS Numeric(28, 5)))
   ,(N'2016', N'India', N'IND', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1639391.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1636582.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1642732.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1652282.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1661227.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1669292.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1675751.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1686381.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1697664.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1709318.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1722046.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1748199.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1774330.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1800133.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1829027.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1862011.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1886115.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1914899.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1949889.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1983845.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2012940.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2040216.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2060001.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2074339.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2090207.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2101854.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2109708.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2121616.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2128550.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2138198.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2158619.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2197381.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2237411.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2272954.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2306445.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2342911.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2389258.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439559.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2489377.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2538786.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2590289.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2647821.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2706128.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2760471.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2817245.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2880806.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2955710.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3034937.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3086299.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3104389.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3107279.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3089590.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3067194.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3046247.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3031168.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3020167.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ireland', N'IRL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2828600.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2824400.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2836050.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2852650.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2866550.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2877300.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2888800.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2902450.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2915550.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2932650.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2957250.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(2992050.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3036850.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3085950.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3137500.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3189550.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3238050.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3282200.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3329100.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3373750.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3412800.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3453000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3485800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3510600.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3532423.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3538082.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3539690.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3540057.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3524949.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3511009.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3513974.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3534235.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3558430.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3576261.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3590386.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3608841.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3637510.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3674171.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3712696.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3754786.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3805174.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3866243.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3931947.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(3996521.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4070262.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4159914.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4273591.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4398942.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4489544.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4535375.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4560155.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4576794.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4586897.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4598294.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4617225.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(4640703.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ireland', N'IRL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11666370.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11869170.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12076182.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12304311.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12578732.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12910782.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13231582.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13617713.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14054844.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14518971.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14996902.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15444338.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15916886.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16415683.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16944668.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17505934.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18070542.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18664282.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19295630.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19970668.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20686341.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21356527.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22066801.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22812571.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23596168.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24421817.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25191559.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26050016.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26965197.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27890745.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28800635.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29540041.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30217525.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30898921.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31671921.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32596723.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33900326.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35342791.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36882498.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38467401.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40064952.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41713095.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43394710.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45104495.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46798962.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48413034.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49567571.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50619451.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51554471.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52394538.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53171827.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53905416.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54612265.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55276110.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55881795.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56428180.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iran, Islamic Rep.', N'IRN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(21906905.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(22480420.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(23071426.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(23680433.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(24308080.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(24955116.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(25624650.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(26318116.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(27032944.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(27765239.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(28514011.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(29281130.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(30073845.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(30903565.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(31784896.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(32730555.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(33739231.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(34814231.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(35977589.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(37256771.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(38668222.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(40209077.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(41862373.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(43610506.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(45429019.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(47290793.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(49205577.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(51152122.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(53035939.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(54735239.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(56169196.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(57288039.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(58130099.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(58811858.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(59501292.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(60318632.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(61306632.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(62426086.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(63616065.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(64780362.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(65850062.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(66812736.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(67696677.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(68522074.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(69321953.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(70122115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(70923164.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(71720859.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(72530693.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(73370982.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(74253373.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(75184322.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(76156975.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(77152445.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(78143644.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(79109272.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iran, Islamic Rep.', N'IRN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4041016.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4127529.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4181943.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4225815.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4291678.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4393287.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4492219.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4626922.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4784772.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4944617.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5095637.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5223162.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5356090.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5492886.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5635733.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5787610.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5953899.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6121536.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6296875.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6488543.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6699618.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6886840.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7093830.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7314652.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7537915.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7757846.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7951023.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8139762.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8334319.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8548629.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8791020.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9090923.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9422377.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9779707.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10153015.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10535591.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10939403.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11349785.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11766598.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12192580.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12628386.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13035374.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13460766.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13896721.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14330006.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14755223.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15169809.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15564773.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15968186.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16418306.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16934963.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17537783.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18220884.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18950914.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19680574.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20382898.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iraq', N'IRQ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(7289759.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(7475354.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(7674220.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(7888914.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(8122200.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(8375791.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(8651167.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(8947399.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(9260685.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(9585576.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(9917982.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(10255904.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(10599846.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(10951169.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(11312304.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(11684585.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(12068195.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(12460997.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(12859226.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(13257910.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(13653358.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(14046273.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(14437661.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(14824876.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(15204746.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(15576396.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(15937864.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(16293719.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(16657708.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(17048167.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(17478455.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(17952909.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(18468521.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(19021967.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(19606895.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(20217759.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(20855408.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(21519356.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(22200835.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(22888600.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(23574751.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(24258794.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(24943793.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(25630426.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(26320530.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(27017712.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(27716983.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(28423538.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(29163327.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(29970634.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(30868156.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(31867758.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(32957622.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(34107366.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(35273293.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(36423395.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iraq', N'IRQ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100193.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101744.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103500.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105438.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107538.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109728.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111967.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114296.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116514.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118346.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119765.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121677.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124339.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127092.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129766.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132495.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134533.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136418.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138447.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140693.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142888.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145230.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147707.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150069.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152043.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153658.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155145.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157272.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160199.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162581.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164122.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166103.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168121.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169690.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171087.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172083.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173139.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174944.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177376.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180120.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183175.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186366.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188661.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190543.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192797.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(196438.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(201768.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207543.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211931.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212994.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212879.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213073.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213770.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215239.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216885.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218232.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iceland', N'ISL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(175574.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(179029.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(182378.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(185653.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(188983.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(192286.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(195570.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(198751.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(201488.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(203369.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(204438.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(206098.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(209137.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(212317.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(215209.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(217979.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(220154.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(221799.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(223537.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(225735.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(228138.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(230755.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(233860.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(236977.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(239511.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(241405.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(243180.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(245859.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(249740.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(252852.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(254826.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(257797.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(261057.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(263725.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(266021.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(267468.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(268916.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(271128.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(274047.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(277381.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(281205.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(284968.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(287523.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(289521.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(292074.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(296734.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(303782.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(311566.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(317414.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(318499.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(318041.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(319014.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(320716.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(323764.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(327386.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(330823.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Iceland', N'ISL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1244652.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1285291.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1347156.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1397379.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1456854.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1515768.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1561690.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1641544.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1688567.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1742609.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1805222.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1862824.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1905235.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1974548.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2024442.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2063048.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2094882.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2130414.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2166232.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2214367.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2261356.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2305394.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2348987.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2393701.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2428953.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2478045.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2526555.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2578170.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2632823.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2690842.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2789681.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2976750.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3097630.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3197863.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3296581.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3397188.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3499429.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3596541.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3685477.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3785516.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3892283.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3987163.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4072322.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4151152.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4228500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4304891.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4392374.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4478169.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4561811.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4671407.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4751559.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4821970.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4889427.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4956464.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5027580.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5105971.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Israel', N'ISR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2114020.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2185000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2293000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2379000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2475000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2563000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2629000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2745000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2803000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2877000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(2974000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3069000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3148000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3278000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3377000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3455000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3533000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3613000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3690000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3786000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3878000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(3956000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4031000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4105000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4159000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4233000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4299000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4369000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4442000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4518000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4660000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(4949000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5123000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5261000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5399000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5545000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5692000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5836000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(5971000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6125000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6289000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6439000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6570000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6689700.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6809000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(6930100.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7053700.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7180100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7308800.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7485600.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7623600.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7765800.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(7910500.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(8059500.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(8215700.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(8380400.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Israel', N'ISR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32854164.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33036185.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33256455.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33510754.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33777769.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34018076.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34183138.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34331522.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34443522.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34524722.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34586662.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34665137.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34774156.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34931967.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35114484.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35323500.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35491902.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35689282.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35925956.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36208494.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36531064.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36880904.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37271619.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37671916.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38044344.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38365601.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38544187.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38676610.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38786531.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38886682.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38979766.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39006712.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39022091.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39020664.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38988697.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38935672.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38864356.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38799257.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38715164.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38606855.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38484127.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38393570.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38310238.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38326233.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38431572.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38504491.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38497766.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38596136.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38770009.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38852697.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38848394.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38731486.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38638801.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38878925.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39026709.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38840215.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Italy', N'ITA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(50199700.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(50536350.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(50879450.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(51252000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(51675350.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(52112350.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(52519000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(52900500.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(53235750.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(53537950.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(53821850.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(54073490.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(54381345.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(54751406.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(55110868.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(55441001.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(55718260.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(55955411.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56155143.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56317749.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56433883.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56501675.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56543548.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56564074.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56576718.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56593071.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56596155.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56601931.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56629288.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56671781.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56719240.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56758521.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56797087.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56831821.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56843400.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56844303.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56860281.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56890372.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56906744.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56916317.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56942108.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(56974100.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(57059007.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(57313203.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(57685327.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(57969484.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(58143979.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(58438310.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(58826731.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(59095365.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(59277417.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(59379449.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(59539717.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(60233948.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(60789140.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(60802085.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Italy', N'ITA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(878586.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(879565.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(882867.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(888453.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(894659.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(899452.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(897644.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(892984.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887678.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(884623.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(885730.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(898345.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(915464.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(936574.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(960196.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(985069.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1019055.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1049894.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1077715.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1103891.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1130085.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1157442.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1188800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1222039.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1255770.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1286883.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1309742.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1328552.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1342146.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1360525.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1373582.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1391288.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1407009.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1421676.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1437464.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455290.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1478039.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1497269.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1515428.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1530149.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1543492.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1561546.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1577278.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1593836.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1610480.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1626848.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1647874.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1667981.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1688536.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1710886.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1734952.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1755850.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1778290.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1800608.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1819800.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1834088.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Jamaica', N'JAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1629003.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1651915.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1678467.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1707019.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1734763.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1760000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1783125.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1803891.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1823706.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1844936.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1970', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1869000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1895629.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1925162.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1956080.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(1985852.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2013000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2037716.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2059399.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2080307.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2104141.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2133000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2162300.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2200100.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2240800.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2279900.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2311100.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2335800.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2350600.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2356400.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2374900.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2390000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2406042.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2423044.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2441024.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2460002.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2480000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2509923.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2534069.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2556780.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2574289.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2589389.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2605556.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2615253.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2624695.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2634145.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2643601.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2653042.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2662481.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2671934.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2681386.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2690824.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2699838.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2707805.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2714669.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2720554.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(2725941.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Jamaica', N'JAM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(464799.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(483069.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(499692.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(517936.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(542025.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(574463.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(617081.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(670508.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(729588.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(787914.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(841552.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(877865.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(907884.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(933938.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(959534.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(987060.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(995693.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1010122.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1030834.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1057575.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1090219.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1138710.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1191408.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1248345.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1309183.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1372480.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1425028.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1481373.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1543335.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1613759.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1695751.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1835552.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1985694.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2140779.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2292528.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2432799.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2509311.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2574158.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2631086.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2685236.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2741890.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2803469.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2869605.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2944904.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3034562.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3140648.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3266276.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3410127.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3565683.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3725260.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3883633.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4040189.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4192317.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4338475.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4477565.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4609030.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Jordan', N'JOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(888632.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(927850.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(962783.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1000506.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1050725.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1119798.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1210948.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1320414.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1438986.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1553585.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1654769.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1739903.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1811870.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1873548.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1929939.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(1985121.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2039114.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2091716.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2146662.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2208562.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2280670.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2365665.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2462968.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2568582.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2676515.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2782885.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2884065.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(2982349.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3086664.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3209466.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3358453.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3538663.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3743944.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(3957221.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4154813.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4320158.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4448113.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4545248.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4621329.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4691402.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4767476.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4850227.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(4938935.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(5042538.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(5171633.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(5332982.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(5530218.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(5759424.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(6010035.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(6266865.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(6517912.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(6760371.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(6994451.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(7214832.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(7416083.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(7594547.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Jordan', N'JOR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59306599.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61586712.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62958460.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64428081.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65859263.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67196356.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68163659.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69101891.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69539522.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71075980.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71837539.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72681727.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73459140.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73738087.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74862251.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75876454.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76097909.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76707936.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77416662.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78098201.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78702311.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79534236.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80185220.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80805023.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81495936.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82327783.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83105168.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83952671.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84825064.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85602678.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86151381.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86614216.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86863223.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86980566.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87116521.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87260349.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87217357.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87108848.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86991732.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86767198.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86500952.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86282269.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86048306.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85774644.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85307538.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84777018.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84289230.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83792813.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83179179.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82445730.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81667563.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80771779.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79830694.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78895857.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78002180.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77193913.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Japan', N'JPN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(92500572.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(94943000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(95832000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(96812000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(97826000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(98883000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(99790000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(100725000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(101061000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(103172000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(104345000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(105697000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(107188000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(108079000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(110162000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(111940000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(112771000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(113863000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(114898000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(115870000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(116782000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(117648000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(118449000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(119259000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(120018000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(120754000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(121492000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(122091000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(122613000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(123116000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(123537000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(123921000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(124229000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(124536000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(124961000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(125439000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(125757000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(126057000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(126400000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(126631000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(126843000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127149000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127445000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127718000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127761000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127773000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127854000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(128001000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(128063000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(128047000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(128070000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127817277.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127561489.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127338621.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(127131800.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(126958472.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Japan', N'JPN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5640383.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5807731.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5974587.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6141333.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6307562.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6475040.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6621777.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6775611.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6937705.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7105421.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7277380.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7477097.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7663890.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7843000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8024813.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8212766.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8357585.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8509499.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8660947.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8801331.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8929678.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9076710.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9211087.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9335997.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9461616.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9593362.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9733241.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9873434.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9998186.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10174178.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10246657.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10289961.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10280474.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10226835.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10108574.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9975822.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9896116.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9819682.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9732875.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9717304.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9754158.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9813783.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9874926.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9964173.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10095271.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10255159.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10411157.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10585888.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10769978.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11096684.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11265307.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11369682.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11457281.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11534720.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11607487.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11675065.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kazakhstan', N'KAZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(9714260.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(10129861.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(10532062.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(10913552.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(11267329.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(11588870.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(11872939.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(12120504.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(12341412.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(12550121.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(12757245.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(12966920.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(13176584.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(13382211.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(13577049.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(13756789.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(13920105.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14070681.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14215111.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14362417.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14518924.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14683789.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14853993.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15030495.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15214051.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15403006.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15600928.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15801753.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15982510.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16249500.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16348000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16450500.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16439095.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16330419.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16095199.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15815626.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15577894.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15333703.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15071300.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14928426.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14883626.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14858335.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14858948.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(14909018.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15012985.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15147029.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15308084.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15484192.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(15674000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16092701.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16321581.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16556600.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(16791425.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(17035275.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(17289224.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(17544126.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kazakhstan', N'KAZ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4043333.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4121183.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4211150.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4314197.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4431294.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4562713.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4688028.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4831709.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4991251.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5162764.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5344097.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5520078.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5708041.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5908383.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6122740.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6352043.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6575494.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6818425.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7079195.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7355386.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7645902.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7936984.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8244619.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8569529.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8913832.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9278764.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9640839.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10026628.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10435928.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10869988.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11330402.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11798531.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12303776.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12835777.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13378925.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13923398.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14417729.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14900081.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15385225.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15892948.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16431726.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16943787.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17489464.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18058165.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18633807.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19207898.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19758056.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20318835.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20888793.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21471495.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22071756.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22699515.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23350089.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24025199.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24728019.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25460518.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kenya', N'KEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(8105440.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(8361442.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(8628973.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(8908425.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(9200158.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(9504702.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(9822505.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(10154489.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(10502250.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(10867717.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(11252466.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(11657479.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(12083165.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(12529810.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(12997447.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(13486241.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(13995974.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(14527187.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(15081598.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(15661414.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(16267906.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(16901181.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(17559778.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(18241331.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(18942599.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(19660713.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(20393724.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(21140344.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(21899004.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(22668238.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(23446229.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(24234087.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(25029754.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(25824736.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(26608089.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(27373035.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(28116027.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(28842245.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(29564614.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(30301240.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(31065820.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(31863280.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(32691980.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(33551079.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(34437460.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(35349040.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(36286015.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(37250540.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(38244442.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(39269988.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(40328313.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(41419954.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(42542978.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(43692881.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(44863583.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(46050302.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kenya', N'KEN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1228673.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1249501.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1267530.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1288743.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1313836.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1341583.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1373324.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1411205.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455255.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1500472.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1542342.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1588309.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1634003.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1679177.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1729762.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1784377.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1836109.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1893481.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1953034.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2011653.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2065808.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2118889.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2168583.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2216221.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2261826.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2305932.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2343939.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2385946.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2427124.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2476526.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2521753.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2552518.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2573831.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2569605.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2568374.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2599129.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2654412.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2714018.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2780280.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2850132.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2917039.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2973104.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3033390.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3104463.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3186622.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3269069.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3335931.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3398932.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3457771.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3518447.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3570669.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3612944.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3663572.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3720663.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3776631.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3834611.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kyrgyz Republic', N'KGZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2172300.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2255900.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2333400.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2413700.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2495300.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2573300.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2655300.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2736500.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2818300.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2894800.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(2959900.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3022300.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3088200.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3153800.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3223900.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3292400.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3358700.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3423900.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3487100.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3552000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3617400.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3685800.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3759300.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3838300.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3916400.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(3990300.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4066500.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4144600.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4218400.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4307500.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4391200.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4463600.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4515400.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4516700.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4515100.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4560400.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4628400.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4696400.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4769000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4840400.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4898400.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4945100.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(4990700.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5043300.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5104700.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5162600.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5218400.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5268400.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5318700.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5383300.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5447900.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5514600.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5607200.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5719600.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5835500.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(5957000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kyrgyz Republic', N'KGZ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2960317.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3023734.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3083014.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3141566.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3205762.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3278453.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3339120.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3405985.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3479888.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3559363.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3643010.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3736216.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3833276.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3920418.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3985201.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4021995.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3987855.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3927655.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3860469.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3805462.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3776121.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3839936.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3916945.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4007202.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4116128.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4240612.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4301098.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4408439.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4539393.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4660341.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4758526.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4888855.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4994494.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5094675.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5224049.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5399903.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5586155.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5827838.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6119633.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6434541.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6748222.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7033689.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7284837.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7506289.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7716538.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7931519.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8155627.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8380262.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8606767.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8828711.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9040526.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9235182.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9440548.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9645278.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9837738.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10013439.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cambodia', N'KHM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(5722370.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(5872247.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6026696.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6181137.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6329411.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6467196.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6588993.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6695460.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6795514.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6902025.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7022185.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7167716.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7331162.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7478147.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7561583.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7551988.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7431505.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7222050.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6982522.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6795102.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6718241.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6774509.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(6945053.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7196139.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7475011.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7743065.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(7990133.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(8228268.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(8467109.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(8723550.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(9008856.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(9323607.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(9659238.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(10007092.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(10355253.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(10694459.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(11022162.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(11338733.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(11641509.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(11928306.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(12197905.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(12448881.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(12681984.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(12901217.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(13112334.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(13320058.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(13525360.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(13728700.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(13933660.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(14144337.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(14363586.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(14593099.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(14832255.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(15078564.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(15328136.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(15577899.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Cambodia', N'KHM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21044.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21360.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21764.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22241.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22764.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23320.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23850.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24431.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25061.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25739.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26460.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27208.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27973.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28755.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29553.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30359.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31160.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31903.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32602.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33281.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33959.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34303.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34765.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35336.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35956.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36586.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37511.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38382.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39198.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39992.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40761.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41153.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41541.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41976.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42483.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43075.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43818.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44627.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45548.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46633.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47872.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48952.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50354.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51964.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53550.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54968.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56778.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58110.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59219.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60469.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61995.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63097.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64580.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66248.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67761.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68971.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kiribati', N'KIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(41234.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(42261.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(43312.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(44372.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(45424.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(46455.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(47461.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(48440.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(49389.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(50303.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(51181.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(52020.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(52823.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(53605.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(54382.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(55169.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(55980.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(56815.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(57664.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(58509.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(59340.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(60137.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(60918.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(61760.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(62768.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(64006.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(65519.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(67262.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(69104.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(70863.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(72411.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(73698.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(74773.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(75722.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(76674.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(77727.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(78907.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(80190.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(81556.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(82969.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(84406.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(85858.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(87343.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(88892.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(90545.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(92329.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(94257.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(96310.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(98437.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(100566.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(102648.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(104662.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(106620.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(108544.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(110470.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(112423.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kiribati', N'KIR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Kitts and Nevis', N'KNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(51197.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(51195.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(50966.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(50533.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(49934.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(49211.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(48355.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(47383.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(46399.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(45534.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44882.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44490.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44328.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44314.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44327.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44278.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44142.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43946.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43704.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43450.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43205.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42978.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42761.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42539.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42294.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42017.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41697.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41353.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41045.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(40854.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(40833.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41009.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41360.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(41836.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42363.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(42888.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43391.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(43885.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44391.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(44938.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(45544.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(46216.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(46935.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(47681.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(48424.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(49139.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(49818.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(50465.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(51093.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(51717.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(52352.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(52998.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(53650.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(54301.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(54944.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(55572.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Kitts and Nevis', N'KNA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13844588.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14257871.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14594441.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14878204.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15128552.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15386155.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15865837.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16275417.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16680957.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17113521.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17588355.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18152339.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18751374.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19362645.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19975539.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20591781.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21221242.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21868874.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22507094.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23121169.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23720057.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24422026.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25068630.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25669233.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26228070.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26768616.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27300249.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27918165.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28574812.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29197769.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29746456.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30324611.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30799230.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31198677.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31609786.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32070104.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32371444.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1997', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32768237.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33132614.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33441536.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33706413.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33993847.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34179153.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34361966.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34572117.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34785939.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34930868.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35067958.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35349178.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35610536.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35907029.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36226972.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36460964.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36668508.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36815038.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36889895.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Korea, Rep.', N'KOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(25012374.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(25765673.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(26513030.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(27261747.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(27984155.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(28704674.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(29435571.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(30130983.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(30838302.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(31544266.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(32240827.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(32882704.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(33505406.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(34103149.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(34692266.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(35280725.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(35848523.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(36411795.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(36969185.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(37534236.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(38123775.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(38723248.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(39326352.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(39910403.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(40405956.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(40805744.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(41213674.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(41621690.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(42031247.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(42449038.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(42869283.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(43295704.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(43747962.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(44194628.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(44641540.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(45092991.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(45524681.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(45953580.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(46286503.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(46616677.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(47008111.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(47357362.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(47622179.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(47859311.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(48039415.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(48138077.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(48371946.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(48597652.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(48948698.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(49182038.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(49410366.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(49779440.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(50004441.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(50219669.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(50423955.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(50617045.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Korea, Rep.', N'KOR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1169789.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1214796.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kosovo', N'KSV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(947000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(966000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(994000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1022000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1050000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1078000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1106000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1135000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1163000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1191000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1219000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1247000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1278000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1308000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1339000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1369000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1400000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1430000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1460000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1491000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1521000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1552000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1582000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1614000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1647000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1682000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1717000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1753000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1791000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1827000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1862000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1898000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1932000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1965000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1997000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(2029000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(2059000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(2086000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1966000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1762000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1700000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1701154.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1702310.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1703466.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1704622.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1705780.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1719536.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1733404.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1747383.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1761474.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1775680.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1790957.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1805200.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1818117.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1812771.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(1797151.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kosovo', N'KSV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163193.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183303.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208694.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236872.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265567.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293557.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317140.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(340305.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362718.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384861.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407717.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435113.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(462602.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(491220.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(522599.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(557793.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(600663.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(647796.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(698117.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(749897.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(802190.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(855368.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(907713.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(960077.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1015701.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1076244.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1127419.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1189780.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1251279.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1295072.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1310744.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1307412.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1116550.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1127429.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1168216.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1229376.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1296060.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1357550.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1404273.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1449108.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1495351.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1549525.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1617735.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1727185.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1851146.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1986756.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2131376.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2281430.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2419527.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2564481.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2707108.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2836376.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2946556.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kuwait', N'KWT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(261962.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(294639.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(335161.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(381665.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(431366.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(482173.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(533521.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(585831.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(639170.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(693876.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(750184.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(807900.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(866747.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(926817.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(988267.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1051187.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1115463.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1180939.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1247597.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1315428.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1384342.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1452383.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1518855.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1586205.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1657920.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1735320.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1823201.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1917950.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2002645.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2054443.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2058832.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2007110.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1637031.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1637906.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1686256.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1766247.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1853152.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1929470.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(1990022.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2042215.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2095993.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2166344.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2263604.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2389498.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2538591.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2705290.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(2881243.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3059473.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3239181.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3419581.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3593689.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3753121.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(3892115.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Kuwait', N'KWT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110726173.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113391706.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116110685.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118950523.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122025895.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125391465.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128588154.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132177342.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136067291.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140111162.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144239834.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148439076.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152695644.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157063848.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161643654.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166473527.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171192100.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176153186.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181313707.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186600914.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191975999.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197246591.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202649386.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208156830.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213763156.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219468612.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225150107.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230941383.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236836616.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(242840558.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248940892.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(255026479.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261208939.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267494263.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(273879385.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280349407.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286727601.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293127987.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299544619.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(305960189.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(312353942.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(318478411.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324599043.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330705177.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336795733.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342888667.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(349061077.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355290937.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361543742.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(367763404.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373902550.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(380099832.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(386075469.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(391882546.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(397595328.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403227110.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(206448158.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(212366790.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(218494458.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(224787697.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(231185110.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(237642446.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(244142240.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(250694578.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(257320695.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(264055390.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(270922368.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(277924408.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(285048696.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(292280590.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(299598590.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(306986513.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(314436200.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(321947113.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(329524820.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(337179879.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(344916769.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(352728537.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(360611980.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(368544043.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(376497966.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(384449375.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(392391406.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(400317367.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(408221307.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(416119293.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(423990572.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(431829627.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(439632368.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(447406941.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(455166402.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(462917430.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(470674560.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(478410615.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(486099120.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(493694997.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(501172602.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(508521178.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(515744299.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(522876279.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(529958993.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(537022336.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(544072618.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(551099144.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(558093934.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(565043167.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(571935098.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(578766919.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(585536615.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(592233875.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(598846559.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(605364992.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean (excluding high income)', N'LAC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1171714.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1194960.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1219673.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1246118.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1274760.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1305789.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1333641.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1364105.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1397169.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1432734.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1470661.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1507073.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1546523.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1586374.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1623573.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1656356.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1664706.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1669136.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1673098.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1680787.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1695148.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1726062.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1764600.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1809806.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1860099.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1914042.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1968629.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2027102.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2088894.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2153325.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2219810.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2278302.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2339418.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2402310.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2466697.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2532709.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2586918.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2645511.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2707583.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2771855.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2838097.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2906132.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2973712.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3044238.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3121630.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3207310.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3301325.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3401301.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3505475.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3610850.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3715051.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3806954.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3901556.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3996453.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4088825.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4177789.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lao PDR', N'LAO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2119944.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2169287.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2219964.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2272078.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2325742.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2381063.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2437527.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2495093.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2554843.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2618246.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2686025.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2759634.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2837967.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2916148.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(2987544.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3047864.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3094940.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3131492.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3164146.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3202270.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3252701.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3317570.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3395113.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3483492.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3579370.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3680145.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3785230.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(3895066.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4009121.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4126935.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4247839.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4371549.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4496971.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4621685.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4742685.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4857774.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(4966303.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5068658.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5165072.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5256207.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5342879.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5424701.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5502340.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5579003.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5658894.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5745012.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5838837.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(5939634.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6045439.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6153153.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6260544.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6366909.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6473050.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6579985.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6689300.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(6802023.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lao PDR', N'LAO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(946480.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(970845.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(993810.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1016591.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1041331.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1069024.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1093878.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1120797.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1150512.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1183158.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1218891.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1259314.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1303541.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1348164.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1389116.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1423599.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1438038.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1443540.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1443852.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1443917.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1447289.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1467372.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1490777.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1515005.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1536771.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1554294.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1564407.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1571982.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1581077.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1596464.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1620739.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1663573.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1718226.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1778209.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1835747.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1886354.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1918904.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1944568.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1972673.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2015114.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2078861.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2153377.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2255961.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2371645.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2482055.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2576634.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2644311.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2691814.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2740748.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2819376.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2944165.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3124786.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3351040.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3590812.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3805590.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3970975.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lebanon', N'LBN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(1804927.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(1864605.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(1925276.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(1984982.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2041212.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2092354.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2136640.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2174850.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2210965.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2250609.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2297403.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2353569.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2416743.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2480426.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2535503.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2575693.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2598362.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2606224.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2604875.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2602573.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2605294.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2615753.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2632281.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2651295.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2667229.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2676593.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2677290.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2672182.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2668593.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2676615.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2703019.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2752473.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2821868.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2900862.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(2974647.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3033406.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3070974.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3092684.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3113960.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3156661.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3235380.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3359875.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3522842.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3701464.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3863271.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(3986865.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4057041.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4085426.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4109389.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4181742.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4337156.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4591698.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(4924257.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(5286990.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(5612096.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(5850743.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lebanon', N'LBN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(629353.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(639982.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(650622.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(661721.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(674146.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(688349.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(700669.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715074.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(731325.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(748981.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(767780.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(784373.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(802593.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(822431.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(843939.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(867134.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887806.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910093.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(934601.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(962031.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(992492.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1023996.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1058402.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1091658.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1119285.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1139048.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1140059.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1132980.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1120691.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1106555.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1093354.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1076166.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1061504.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1056149.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1068160.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1101233.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1167456.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1259833.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1364696.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1465500.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1552150.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1606625.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1644462.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1674725.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1708997.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1754596.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1813586.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1884929.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1963534.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2043338.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2120722.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2190060.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2256400.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2322176.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2390311.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2462608.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Liberia', N'LBR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1120314.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1144896.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1170267.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1196588.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1224094.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1252968.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1283304.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1315119.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1348448.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1383305.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1419728.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1457714.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1497356.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1538882.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1582584.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1628656.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1676016.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1724313.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1775200.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1830963.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1892529.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(1961795.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2036325.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2107523.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2163835.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2197442.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2206867.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2196204.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2170426.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2137018.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2102877.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2066060.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2028672.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2006349.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2019148.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2079921.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2197801.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2365290.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2558085.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2741755.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2891968.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(2998770.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3070673.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3124222.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3184643.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3269786.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3384804.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3522337.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3672782.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3821498.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(3957990.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(4079574.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(4190155.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(4293692.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(4396554.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(4503438.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Liberia', N'LBR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(780071.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(802940.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(826393.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850984.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(877800.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(907320.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(935314.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(966154.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(999550.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1035153.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1072822.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1110026.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1150941.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1194845.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1241130.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1289691.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1338831.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1390754.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1446451.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1507638.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1575428.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1653117.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1738036.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1828114.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1920299.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2012382.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2094528.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2175094.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2255542.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2338647.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2426131.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2511067.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2603239.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2700015.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2797002.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2891927.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2993394.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3089114.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3182088.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3277413.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3377155.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3472250.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3571201.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3671549.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3769095.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3861455.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3945746.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4025861.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4096684.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4153522.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4193849.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4188898.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4168060.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4141785.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4122770.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4120317.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Libya', N'LBY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1434576.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1483856.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1536196.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1592111.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1652294.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1717255.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1787080.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1861661.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(1941056.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2025282.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2114264.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2208125.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2306668.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2409101.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2514373.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2621730.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2730373.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2840378.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(2952877.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3069540.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3191304.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3318560.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3450078.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3583183.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3714264.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3840635.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(3961363.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4076888.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4187631.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4294547.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4398419.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4499210.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4596811.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4691934.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4785488.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4878202.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(4970391.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5062160.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5153764.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5245414.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5337264.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5428303.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5518341.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5609166.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5703224.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5801543.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(5907149.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6017794.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6123022.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6208680.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6265697.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6288652.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6283403.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6265987.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6258984.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(6278438.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Libya', N'LBY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45927.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45856.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45914.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46094.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46326.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46526.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46897.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47181.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47305.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47279.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47184.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48380.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49508.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50647.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51870.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53166.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54441.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55812.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57264.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58765.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60264.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62057.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63711.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65251.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66694.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68077.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70351.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72446.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74341.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75991.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77366.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79047.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80458.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81719.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82971.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84318.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86003.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87938.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90052.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92248.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94453.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96721.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98967.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101267.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103713.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106342.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108725.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111148.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113538.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115719.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117564.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119497.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121157.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122647.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124100.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125572.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Lucia', N'LCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(89901.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(90913.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(92086.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(93397.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(94813.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(96303.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(97877.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(99526.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(101181.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(102747.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(104162.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(105389.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(106458.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(107461.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(108534.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(109770.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(111211.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(112826.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(114551.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(116292.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(117984.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(119593.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(121150.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(122738.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(124468.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(126416.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(128620.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(131032.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(133532.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(135954.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(138180.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(140159.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(141934.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(143592.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(145262.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(147040.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(148962.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(150994.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(153066.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(155073.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(156949.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(158650.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(160218.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(161767.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(163462.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(165407.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(167656.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(170146.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(172729.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(175196.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(177397.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(179278.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(180890.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(182305.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(183645.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(184999.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Lucia', N'LCA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118690263.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121515769.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124399699.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127406310.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130649897.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134186815.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137533339.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1967', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141283013.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145341884.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149561197.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153871847.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158268998.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162728062.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167306195.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172101572.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177150757.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182078632.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187250082.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192628221.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198135339.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203733055.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209224951.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214851336.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220581702.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226413065.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232341055.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238234844.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244237548.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250342559.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256555857.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262867573.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269154739.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275543432.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(282042611.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288643609.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295328927.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301926610.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308539506.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(315159076.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321778394.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(328375131.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334702600.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341031136.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(347348173.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(353648504.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(359945429.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366303707.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372714293.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379146183.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(385542997.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(391856187.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(398196306.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(404309809.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410251705.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(416081080.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(421818661.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean', N'LCN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(220572260.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(226772499.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(233191504.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(239779637.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(246466984.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(253204080.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(259974227.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(266785628.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(273664052.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(280650669.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(287773317.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(295036273.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(302419008.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(309912432.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(317489876.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(325130543.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(332828460.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(340579992.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(348401844.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(356299231.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(364281964.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(372341418.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(380478713.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(388666253.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(396882210.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(405096423.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(413306622.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(421504828.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(429683476.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(437859510.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(446014681.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(454134571.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(462218401.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(470281397.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(478328837.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(486362102.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(494403039.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(502409290.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(510376571.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(518208411.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(525907201.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(533470758.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(540906214.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(548247528.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(555537969.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(562806404.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(570053899.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(577273042.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(584461446.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(591604073.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(598690163.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(605694637.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(612638376.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(619513507.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(626285603.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(632959079.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean', N'LCN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131482786.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133813617.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136392435.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139219222.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142312479.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145680034.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148645262.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151967464.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155567790.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159368161.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163330898.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166625137.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170120023.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173834541.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177793042.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182020851.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185948556.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190255972.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194893583.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199828520.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205045183.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209695371.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214799165.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220318545.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226210363.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232455717.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238233143.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244507615.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251263739.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258511658.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266258203.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(273892705.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(282109579.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(290817052.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299911728.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309329558.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317977626.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327001658.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336413334.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346235862.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(356478343.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366356365.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(376725148.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(387474910.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(398500580.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(409760041.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(420477608.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(431565664.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443079579.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455098976.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467685611.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480737333.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494409173.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508662273.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523428252.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(538648562.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Least developed countries: UN classification', N'LDC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(241072814.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(246733124.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(252585904.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(258670231.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(265039360.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(271723894.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(278755774.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(286104466.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(293663042.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(301284584.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(308870065.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(316378185.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(323858659.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(331415936.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(339201660.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(347328806.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(355839316.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(364711975.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(373921370.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(383418369.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(393172012.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(403186706.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(413495920.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(424131976.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(435137234.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(446546151.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(458352456.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(470557196.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(483208054.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(496364388.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(510057629.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(524324699.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(539125756.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(554321297.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(569720374.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(585189354.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(600664665.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(616192978.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(631885766.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(647910647.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(664386087.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(681362484.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(698794943.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(716594050.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(734626511.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(752794655.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(771082091.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(789544690.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(808296705.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(827498335.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(847264134.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(867666290.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(888606627.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(910063594.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(931955068.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(954218054.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Least developed countries: UN classification', N'LDC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84487141.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85889995.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87550750.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89411261.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91391695.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93456082.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95313861.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97262589.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99344526.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101638499.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104171167.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106302745.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108747600.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111433731.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114259958.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117175495.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119774662.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122513023.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125368742.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128344634.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131451694.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134170131.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137065847.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140180700.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143567289.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147248933.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150563145.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154307440.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158414914.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162805643.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167441850.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171947619.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176787115.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181910165.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187279798.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192871394.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197857084.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203109003.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208635809.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214464575.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220625081.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226647973.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233096457.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239903605.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246996303.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254345246.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261499325.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268991618.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276852660.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(285137253.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293880524.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(302896574.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(312433825.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322441413.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332854924.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343629235.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Low income', N'LIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(154643623.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(158036089.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(161509904.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(165104405.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(168876308.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(172865168.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(177082193.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(181510268.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(186125837.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(190893116.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(195784159.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(200793533.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(205923794.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(211164322.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(216504309.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(221936253.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(227468025.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(233103356.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(238828284.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(244624718.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(250488773.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(256415591.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(262436928.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(268631460.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(275102794.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(281929614.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(289134456.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(296710433.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(304668356.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(313010644.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(321732573.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(330859667.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(340381945.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(350214780.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(360242918.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(370388264.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(380614813.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(390959022.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(401504632.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(412373685.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(423655372.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(435383252.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(447534597.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(460075083.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(472947363.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(486113306.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(499559269.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(513311068.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(527415958.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(541939703.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(556926383.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(572393050.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(588316015.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(604648276.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(621322015.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(638286288.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Low income', N'LIC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Liechtenstein', N'LIE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(16504.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(16894.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(17298.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(17722.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(18170.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(18647.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(19156.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(19691.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(20235.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(20765.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(21266.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(21726.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(22153.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(22562.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(22984.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(23435.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(23926.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(24444.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(24963.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(25447.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(25869.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(26221.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(26514.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(26768.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(27009.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(27259.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(27523.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(27799.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(28091.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(28405.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(28745.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(29111.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(29503.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(29921.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(30365.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(30833.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(31327.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(31842.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(32357.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(32843.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(33282.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(33663.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(33995.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(34290.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(34569.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(34852.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(35141.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(35431.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(35721.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(36004.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(36276.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(36537.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(36791.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(37040.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(37286.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(37531.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Liechtenstein', N'LIE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5277508.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5425298.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5598578.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5713949.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5928932.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6106219.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6289437.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6457475.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6637923.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6814577.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7011311.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7148034.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7303467.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7506057.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7686852.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7869863.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8052467.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8223370.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8400606.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8602450.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8810061.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8891813.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9075848.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9264325.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9453426.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9641973.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9838510.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10041243.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10246906.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10454252.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10660533.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10873244.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11075109.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11269242.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11459512.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11647905.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11818043.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11989167.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12162544.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12334658.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12502803.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12645847.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12770535.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12881674.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12985854.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13088484.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13172900.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13262921.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13355568.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13445007.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13528227.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13585415.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13638070.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13690349.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13772057.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13863331.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sri Lanka', N'LKA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(9896000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(10168000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(10443000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(10582000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(10903000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(11164000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(11439000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(11703000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(11992000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(12252000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(12514000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(12690000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(12861000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(13091000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(13284000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(13496000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(13717000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(13942000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(14190000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(14472000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(14747000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(14847000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(15096000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(15339000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(15583000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(15831000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(16083000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(16339000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(16593000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(16841000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(17078000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(17306000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(17524000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(17728000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(17912000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18074000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18210000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18323000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18425000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18532000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18655000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18797000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(18939000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19083000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19227000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19373000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19520000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19668000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19817000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(19967000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20118000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20270000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20424000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20579000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20771000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(20966000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sri Lanka', N'LKA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531550981.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(539944525.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(548667381.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(557950788.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(568498313.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(580450253.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591777424.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(604770093.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(619193855.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(634580710.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(650702169.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(665987191.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(682203783.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(699386633.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(717557913.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(736764993.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(754832465.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(774225496.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(794798812.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(816345856.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(838693433.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(859946775.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(882137769.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(905208867.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(929197044.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(954178221.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(977609220.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1002475850.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028473647.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1055249601.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1083473787.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1109625893.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1136622718.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1164408564.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1193270804.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1223362369.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1252815856.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1283577413.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1315463743.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1348088116.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1381162221.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1412102683.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1443563440.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1475591734.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1508150383.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1541155524.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1573302237.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1605845934.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1638706391.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1671780028.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1706323414.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1737315571.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1769518806.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1801924633.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1834471678.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1868260701.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lower middle income', N'LMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(946484445.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(967887109.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(990039377.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1012767666.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1036339571.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1060475807.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1085253011.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1110656509.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1136731635.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1163442863.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1190833082.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1218820931.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1247527713.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1277055585.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1307363461.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1338536946.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1370554174.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1403405869.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1437186461.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1472000213.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1507845249.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1544521899.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1582199139.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1620721765.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1659880097.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1699641522.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1739982872.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1780743196.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1821764134.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1862914881.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1905832740.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1946835397.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(1987933397.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2028791196.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2069485613.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2110085677.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2150734236.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2191409043.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2231891456.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2272160782.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2312488976.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2352812601.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2393060046.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2433405412.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2473856010.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2514348032.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2554924913.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2595645346.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2636521964.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2677558873.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2719003012.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2760562037.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2801879869.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2843404367.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2885248344.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(2927414098.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lower middle income', N'LMC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1282414363.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1292717875.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1309059179.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1332348582.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1358502466.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1389042326.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1417918040.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1451075978.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1488160413.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1527481550.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1567576161.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1605120245.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1643432116.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1682856664.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1723853616.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1766493993.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1808094422.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1851935512.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1898732381.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1948230186.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1999600020.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2051369106.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2105608919.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2161060135.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2217095242.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2274358625.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2327421973.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2382682423.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2438841794.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2495096456.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2552158530.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2601762560.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2654076085.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2708448879.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2764095697.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2820702710.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2880584918.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2939993257.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3000241617.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3063079908.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3128978815.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3191944865.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3257374652.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3325116642.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3393366872.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3461026318.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3523633606.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3586173131.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3648205751.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3709001315.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3769093275.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3824011859.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3878616990.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3932048103.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3984579270.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4037501072.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Low & middle income', N'LMY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2276339100.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2306020875.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2348930217.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2403866384.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2459435934.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2516693764.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2577698886.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2638714413.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2701499529.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2766769391.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2833705952.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2902258252.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(2970140184.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3037952919.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3105316051.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3171437799.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3237021494.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3302089933.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3368262462.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3435930618.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3504520730.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3574775320.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3648412010.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3723177772.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3798059443.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3874692197.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(3953806792.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4035176743.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4117287193.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4198919913.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4281091644.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4360006679.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4437302203.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4513614318.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4589656631.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4665448284.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4741190324.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4817080259.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4892461159.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(4966815693.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5040565572.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5113277261.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5185077870.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5257090524.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5329272591.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5401724600.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5474179013.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5546493627.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5619625334.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5693949714.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5769206886.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5845581661.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(5922876751.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(6001164310.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(6080182833.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(6159443196.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Low & middle income', N'LMY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448485.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(454503.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(461716.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(469894.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478579.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487503.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(495948.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(504845.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(514221.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(524130.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(534603.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(544011.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(553943.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(564688.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(576592.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(589873.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(604371.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(620458.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(637796.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(655934.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(674572.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(689888.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(705670.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721695.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(737753.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(753801.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(768601.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(782883.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(797017.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(811801.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(827981.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(849663.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(872554.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(895842.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(918563.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(940062.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(954882.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(968499.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(981298.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(993958.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007115.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1018444.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1031017.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1044482.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1058392.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1072666.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1090600.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1108479.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1126733.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1146105.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1166839.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1187973.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1210223.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1232933.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1255173.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1276424.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lesotho', N'LSO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(851412.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(866253.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(881910.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(898342.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(915473.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(933251.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(951736.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(970972.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(990869.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1011308.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1032240.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1053524.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1075281.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1098033.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1122484.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1149090.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1177975.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1208836.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1241159.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1274216.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1307403.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1340694.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1374044.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1406818.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1438248.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1467856.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1495101.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1520244.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1544580.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1569936.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1597534.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1627900.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1660360.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1693459.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1725118.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1753824.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1779201.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1801695.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1821632.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1839631.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1856225.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1871489.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1885488.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1898778.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1912042.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1925844.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1940345.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1955656.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1972194.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(1990413.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2010586.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2032950.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2057331.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2083061.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2109197.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(2135022.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lesotho', N'LSO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(627442631.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(626550664.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(631375487.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(642468854.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(654978953.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(669967810.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684341521.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(700832843.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(719434622.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(739071496.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(758575582.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(776841699.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(794923127.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(813039770.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(831473530.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850238145.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(869450588.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(889178661.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910331197.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(932919883.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(956276762.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(981316407.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007541936.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1033671788.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1059029016.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1084278144.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1107235179.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1130497007.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1153058444.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1174529790.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1194909970.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1210100049.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1225222474.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1242351383.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1259469115.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1277248799.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1298260903.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1317426287.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1336142961.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1356316119.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1378245629.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1400179059.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1423503216.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1447953852.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1472251878.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1495552919.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1515276269.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1534618257.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1552822937.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1568907486.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1581777097.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1592377221.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1600443176.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1606338068.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1610763772.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1614114617.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Late-demographic dividend', N'LTE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1099608911.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1101810572.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1116288994.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1141954962.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1167373215.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1193450007.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1222282644.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1250258107.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1279064200.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1309364362.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1340256276.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1371812796.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1401919858.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1431017776.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1458682810.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1484120541.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1508025001.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1530370879.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1552669756.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1575177489.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1597245116.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1619555100.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1644046340.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1668473661.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1691997560.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1716423572.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1742492329.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1770022346.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1797644122.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1824416060.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1849669474.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1873168798.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1892687494.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1913031295.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1994', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1933111068.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1954370502.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1973565502.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(1992617993.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2011082188.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2028428508.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2044297095.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2059525862.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2073941187.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2088053259.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2102015681.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2115935699.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2129490221.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2142553363.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2155686054.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2169131430.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2182060690.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2195191263.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2208629633.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2222181284.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2235786397.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(2249154750.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Late-demographic dividend', N'LTE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1803731.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1827351.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1847366.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1863210.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1878274.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1893124.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1909929.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1926575.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1942678.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1955943.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1972628.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1999441.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2023682.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2046877.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2071741.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2098487.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2123307.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2151617.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2181087.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2206824.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2229670.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2256591.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2284743.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2313508.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2341255.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2368001.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2391204.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2415412.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439233.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2455582.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2461131.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2458208.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2449174.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2432585.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2412758.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2393592.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2375029.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2358662.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2344913.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2334348.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2326696.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2309882.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2294588.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2280550.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2260565.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2229746.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2198964.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2177921.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2160348.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2140213.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2098030.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2046397.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2013469.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1987002.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1962970.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1939279.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lithuania', N'LTU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2778550.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2823550.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2863350.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2898950.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2935200.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2971450.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3008050.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3044400.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3078850.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3107321.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3139689.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3179041.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3213622.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3244438.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3273894.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3301652.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3328664.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3355036.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3379514.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3397842.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3413202.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3432947.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3457179.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3485192.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3514205.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3544543.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3578914.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3616367.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3655049.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3684255.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3697838.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3704134.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3700114.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3682613.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3657144.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3629102.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3601613.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3575137.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3549331.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3524238.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3499536.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3470818.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3443067.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3415213.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3377075.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3322528.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3269909.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3231294.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3198231.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3162916.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3097282.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(3028115.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2987773.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2957689.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2932367.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(2910199.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Lithuania', N'LTU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213482.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214012.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215310.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216345.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217745.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219407.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219809.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219614.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219531.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220260.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221271.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223515.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226759.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(230090.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234116.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(237821.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239790.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240916.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(242131.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(243794.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246170.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248132.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(249956.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251750.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(253466.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254936.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(256512.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258278.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(259908.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261905.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(264422.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266930.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269229.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271448.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(273781.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276460.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279138.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281910.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284961.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288521.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292241.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295377.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298266.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301869.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306366.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311452.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317890.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324349.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331682.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(339205.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346568.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355804.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(365854.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(375757.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(385999.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(396409.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Luxembourg', N'LUX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(313970.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(316845.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(320750.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(324100.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(327750.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(331500.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(333895.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(334995.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(335850.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(337500.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(339171.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(342421.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(346600.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(350450.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(355050.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(358950.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(360731.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(361358.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(362007.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(362856.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(364150.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(365225.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(365525.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(365622.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(365998.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(366706.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(368355.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(370750.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(373450.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(377100.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(381850.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(387000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(392175.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(397475.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(402925.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(408625.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(414225.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(419450.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(424700.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(430475.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(436300.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(441525.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(446175.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(451630.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(458095.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(465158.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(472637.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(479993.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(488650.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(497783.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(506953.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(518347.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(530946.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(543360.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(556319.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(569676.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Luxembourg', N'LUX', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1424940.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1443692.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1461347.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1479695.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1498227.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1513526.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1523012.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1532937.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1545939.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1557188.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1566060.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1574964.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1585424.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1597233.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1611456.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1625923.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1632830.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1642394.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1653617.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1662911.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1671112.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1680556.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1691386.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1703304.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1715376.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1727443.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1737718.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1752650.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1768879.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1777677.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1776851.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1757688.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1725462.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1686326.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1655346.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1631171.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1618309.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1608749.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1600808.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1595679.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1588852.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1574918.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1561759.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1550858.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1537581.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1524125.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1507622.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1493652.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1476302.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1449346.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1415285.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1383107.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1359302.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1337920.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1318112.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1300034.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latvia', N'LVA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2120979.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2152681.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2181586.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2210919.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2240623.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2265919.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2283217.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2301220.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2323619.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2343173.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2359164.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2376389.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2395674.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2415819.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2437186.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2456130.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2470989.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2485073.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2497921.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2505953.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2511701.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2519421.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2531080.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2546011.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2562047.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2578873.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2599892.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2626583.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2653434.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2666955.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2663151.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2650581.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2614338.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2563290.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2520742.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2485056.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2457222.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2432851.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2410019.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2390482.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2367550.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2337170.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2310173.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2287955.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2263122.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2238799.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2218357.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2200325.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2177322.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2141669.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2097555.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2059709.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2034319.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(2012647.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(1993782.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(1978440.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latvia', N'LVA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95294.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95328.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97422.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100780.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104683.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109001.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113275.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118774.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125184.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131833.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138066.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144105.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148442.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151403.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153702.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155946.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156571.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157593.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159167.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161311.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164066.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169311.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175611.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182826.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190995.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200054.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208053.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217191.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226808.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236042.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244385.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(249445.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254085.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258328.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262556.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267213.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272926.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279045.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(285778.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(293278.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301469.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311810.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321879.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331799.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342006.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352960.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366559.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381999.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(398302.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(414068.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428108.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(437226.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(444589.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450229.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(454663.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458320.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Macao SAR, China', N'MAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(171456.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(175135.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(181025.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(188703.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(197523.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(206910.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(216873.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(227258.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(237129.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(245310.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(250997.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(253881.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(254282.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(252845.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(250550.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(248213.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(245915.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(243729.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(242458.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(243073.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(246236.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(252258.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(260921.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(271674.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(283672.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(296222.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(309226.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(322655.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(335952.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(348467.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(359735.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(369484.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(377799.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(385041.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(391783.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(398459.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(405231.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(412031.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(418810.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(425448.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(431907.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(438088.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(444178.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(450754.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(458579.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(468149.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(479728.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(493022.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(507274.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(521405.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(534626.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(546682.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(557763.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(568056.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(577914.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(587606.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Macao SAR, China', N'MAC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Martin (French part)', N'MAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4279.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4453.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4566.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4656.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4748.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4841.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(4936.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5033.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5161.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5303.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5450.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5601.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5756.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(5915.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(6078.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(6291.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(6530.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(6778.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(7035.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(7303.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(7580.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(7868.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(8670.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(10547.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(12790.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(15392.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(18337.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(21628.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(24873.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27676.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(30036.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(31821.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(32892.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(33238.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(33098.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(32712.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(32102.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(31304.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(30358.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(29305.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(28384.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27782.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27450.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27363.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27514.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(27906.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(28414.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(28905.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(29376.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(29820.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(30235.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(30615.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(30959.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(31264.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(31530.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(31754.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Martin (French part)', N'MAF', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6449397.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6553800.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6643708.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6732407.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6841219.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6981350.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7108932.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7264909.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7443926.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7634883.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7834005.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8036007.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8253431.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8489039.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8747341.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9030140.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9332817.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9657114.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9999363.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10353063.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10712619.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11050653.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11395456.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11742821.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12090403.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12437769.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12752369.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13079418.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13413888.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13747918.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14078892.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14429877.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14763215.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15092427.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15437673.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15807472.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16162436.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16548216.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16949981.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17343022.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17715095.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18081566.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18420541.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18743031.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19064767.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19392990.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19740417.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20087147.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20437349.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20793258.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21153759.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21511135.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21881332.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22247091.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22589295.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22898757.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Morocco', N'MAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(12328534.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(12713043.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(13100843.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(13488517.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(13871988.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(14248426.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(14617077.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(14978905.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(15335173.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(15687996.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(16039600.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(16389949.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(16740525.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(17097003.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(17466606.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(17854614.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(18262366.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(18688782.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(19133462.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(19595092.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(20071902.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(20564359.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(21070647.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(21583746.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(22094516.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(22596133.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(23084731.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(23560825.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(24027330.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(24489354.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(24950128.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(25410178.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(25866445.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(26314339.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(26747660.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(27161889.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(27556892.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(27934014.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(28292299.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(28630973.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(28950553.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(29250983.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(29535591.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(29812685.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(30093109.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(30385479.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(30691434.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(31011322.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(31350544.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(31714958.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(32107739.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(32531964.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(32984190.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(33452686.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(33921203.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(34377511.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Morocco', N'MAR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Monaco', N'MCO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(22454.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(22812.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23042.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23169.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23237.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23283.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23304.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23297.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23296.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23348.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23484.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(23722.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(24052.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(24440.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(24835.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(25201.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(25521.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(25809.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(26086.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(26391.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(26746.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(27165.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(27629.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(28098.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(28514.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(28836.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29048.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29169.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29238.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29313.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29438.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29626.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(29864.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(30138.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(30423.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(30700.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(30971.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(31242.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(31517.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(31795.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(32081.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(32364.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(32648.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(32960.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(33339.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(33808.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(34384.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(35046.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(35731.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(36351.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(36845.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(37189.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(37404.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(37528.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(37623.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(37731.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Monaco', N'MCO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1578158.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1602317.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1623132.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1643030.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1664654.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1691451.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1720712.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1754108.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1791218.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1831680.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1873697.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1923198.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1969116.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2012255.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2053170.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2091290.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2118094.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2145459.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2174051.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2200752.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2225220.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2249563.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2271590.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2291836.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2311405.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2329376.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2338099.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2345077.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2350447.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2354379.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2357770.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2356747.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2357792.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2359812.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2363057.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2366324.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2376754.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2384478.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2402261.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2421014.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2442979.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2466259.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2492830.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2520090.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2547536.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2572631.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2582672.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2591583.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2598950.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2606036.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2612291.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2620324.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2630066.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2638882.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2643149.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2641041.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Moldova', N'MDA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2544000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2605000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2664000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2721000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2774000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2825000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2873000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2918000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(2960000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3002000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3044000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3088000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3131000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3174000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3215000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3251000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3284000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3312000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3339000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3366000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3396000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3429000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3464000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3500000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3536000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3570000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3602000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3633000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3660000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3681000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3696000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3704000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3706000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3701000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3691000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3675099.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3667748.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3654208.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3652732.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3647001.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3639592.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3631462.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3623062.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3612874.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3603945.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3595187.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3585209.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3576910.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3570108.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3565604.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3562045.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3559986.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3559519.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3558566.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3556397.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(3554150.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Moldova', N'MDA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2756144.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2793543.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2831984.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2874478.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2925899.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2988310.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3042657.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3110032.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3188183.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3272713.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3360895.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3437808.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3520804.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3610611.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3708764.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3815741.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3912963.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4020945.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4138320.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4264445.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4399204.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4519870.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4656307.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4805279.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4960893.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5119899.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5285613.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5445924.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5608923.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5786676.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5983817.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6154863.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6356499.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6577608.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6800816.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7017749.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7226565.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7431678.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7639849.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7864633.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8113210.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8358890.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8631715.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8927330.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9237751.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9558935.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9885828.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10223239.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10573809.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10941954.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11329178.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11722889.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12134648.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12561224.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12997261.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13439214.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Madagascar', N'MDG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5099371.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5223621.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5352674.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5486593.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1964', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5625401.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5769219.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(5918060.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6072270.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6232704.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6400454.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6576301.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6760352.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(6952383.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(7152391.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(7360271.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(7575757.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(7799642.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(8031589.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(8268902.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(8507958.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(8746516.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(8983494.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(9220693.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(9462343.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(9714342.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(9981113.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(10264368.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(10563491.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(10877757.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(11205548.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(11545782.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(11898267.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(12263899.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(12643864.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(13039754.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(13452526.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(13882646.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(14329239.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(14790245.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(15262817.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(15744811.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(16235767.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(16736029.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(17245275.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(17763367.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(18290394.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(18826129.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(19371031.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(19926798.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(20495706.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(21079532.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(21678867.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(22293720.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(22924557.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(23571713.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(24235390.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Madagascar', N'MDG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53019.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53743.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54556.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55387.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56176.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56918.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57232.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57495.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57843.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58461.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59454.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61051.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63111.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65514.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68085.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70708.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72797.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74998.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77325.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79793.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82402.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85154.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87926.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90758.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93732.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96861.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99228.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101953.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104900.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107900.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108335.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112690.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(116166.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120375.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122529.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128747.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134287.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137726.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144233.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(152238.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158956.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166188.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172966.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181005.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189716.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199052.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(210061.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223641.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235235.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236733.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(243686.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252117.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258894.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265311.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271446.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277495.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Maldives', N'MDV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(89875.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(92327.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(94909.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(97556.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(100177.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(102723.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(105145.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(107488.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(109901.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(112591.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(115703.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(119315.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(123372.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(127717.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(132122.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(136434.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(140582.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(144645.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(148797.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(153285.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(158282.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(163834.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(169861.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(176258.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(182864.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(189551.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(196283.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(203059.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(209832.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(216553.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(218000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(227000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(234000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(242000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(245000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(255000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(262000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(264000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(271000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(280000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(286000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(292000.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(297000.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(304000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(312000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(321000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(333000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(349000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(362000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(360000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(367000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(377000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(385000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(393000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(401000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(409163.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Maldives', N'MDV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56426820.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57511442.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58689262.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59957673.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61389920.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63002598.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64524387.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66307428.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68232375.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70267667.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72383040.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74353553.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76432576.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78672308.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81041407.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83556566.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86115038.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88821189.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91686044.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94736013.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97956521.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101173049.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104595570.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108175612.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111829081.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115627126.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119234308.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122968841.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126805382.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130696615.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(135763638.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139934233.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142881490.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147247184.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151908147.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157901151.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163244416.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168778176.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174442646.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180280884.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186276559.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192436841.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198787302.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205337695.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212062621.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218893411.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225601100.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232386389.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239091961.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245568933.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251647607.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(257012740.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262015998.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266729585.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271282875.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275794135.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa', N'MEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(105557277.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(108429044.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(111438644.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(114526186.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(117724637.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(121014965.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(124390821.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(127924126.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(131489251.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(135136426.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(138863307.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(142629493.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(146461363.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(150475905.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(154655451.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(159062409.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(163721499.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(168635082.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(173827674.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(179347175.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(185183207.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(191326246.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(197762395.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(204428624.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(211185701.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(218133868.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(225163130.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(232203177.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(239177696.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(245912541.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(254531443.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(261076814.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(265336498.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(271312554.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(277344152.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(284973163.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(290950450.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(296986652.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(303006934.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(309069358.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(315122478.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(321163368.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(327207928.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(333373436.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(339823622.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(346657300.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(353917337.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(361549578.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(369452647.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(377485338.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(385417024.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(393274154.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(401032763.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(408731939.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(416401841.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(424065257.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa', N'MEA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19356736.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19875002.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20382247.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20900668.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21468184.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22104079.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22753254.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23466631.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24238643.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25048974.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25884060.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26729455.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27585365.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28456444.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29361710.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30312047.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31187804.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32159701.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33193857.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34241775.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35286599.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36460107.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37583261.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38704919.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39896955.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41190782.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42579157.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44043979.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45565085.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47094608.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48602414.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50078172.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51558193.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53026806.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54471753.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55885897.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57241398.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58567395.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59865854.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61140954.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62392691.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63584614.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64735115.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65877847.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67054796.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68299217.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69751859.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71279169.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72864790.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74479359.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76092193.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77677247.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79246218.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80787201.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82287262.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83739375.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mexico', N'MEX', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(38174114.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(39394125.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(40649590.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(41939880.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(43264267.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(44623041.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(46010959.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(47429553.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(48893607.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(50423127.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(52029859.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(53719547.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(55480125.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(57283361.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(59090495.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(60872399.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(62620087.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(64337694.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(66025613.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(67688533.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(69330974.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(70950741.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(72547995.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(74133377.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(75721210.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(77322643.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(78939441.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(80571067.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(82223153.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(83901643.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(85609404.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(87347208.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(89110043.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(90887097.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(92663664.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(94426946.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(96181710.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(97925825.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(99632299.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(101266570.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(102808590.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(104239563.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(105578297.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(106888418.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(108257822.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(109747906.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(111382857.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(113139374.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(114972821.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(116815612.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(118617542.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(120365271.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(122070963.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(123740109.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(125385833.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(127017224.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mexico', N'MEX', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Marshall Islands', N'MHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(14665.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(15052.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(15545.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(16111.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(16702.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(17283.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(17840.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(18388.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(18965.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(19622.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(20397.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(21310.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(22340.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(23440.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(24536.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(25580.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(26549.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(27470.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(28399.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(29416.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(30581.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(31895.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(33334.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(34895.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(36567.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(38334.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(40203.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(42148.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(44063.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(45813.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(47300.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(48481.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(49382.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(50052.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(50577.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(51020.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(51397.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(51697.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(51922.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52076.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52161.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52184.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52161.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52115.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52074.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52058.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52080.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52136.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52221.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52321.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52428.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52541.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52663.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52786.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52898.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(52993.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Marshall Islands', N'MHL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1197927222.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1206827880.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1221508429.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1242937321.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1267110771.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1295586244.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1322604179.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1353813389.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1388815887.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1425843051.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1463404994.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1498817500.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1534684516.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1571422933.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1609593658.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1649318498.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1688319760.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1729422489.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1773363639.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1819885552.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1868148326.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1917198975.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1968543072.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2020879435.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2073527953.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2127109692.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2176858828.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2228374983.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2280426880.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2332290813.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2384716680.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2429814941.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2477288970.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2526538714.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2576815899.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2627831316.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2682727834.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2736884254.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2791605808.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2848615333.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2908353734.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2965296892.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3024278195.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3085213037.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3146370569.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3206681072.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3262134281.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3317181513.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3371353091.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3423864062.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3475212751.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3521115285.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3566183165.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3609606690.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3651724346.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3693871837.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle income', N'MIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2121695477.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2147984786.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2187420313.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2238761979.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2290559626.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2343828596.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2400616693.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2457204145.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2515373692.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2575876275.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2637921793.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2701464719.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2764216390.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2826788597.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2888811742.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(2949501546.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3009553469.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3068986577.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3129434178.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3191305900.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3254031957.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3318359729.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3385975082.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3454546312.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3522956649.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3592762583.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3664672336.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3738466310.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3812618837.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3885909269.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(3959359071.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4029147012.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4096920258.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4163399538.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4229413713.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4295060020.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4360575511.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4426121237.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4490956527.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4554442008.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4616910200.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4677894009.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4737543273.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4797015441.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4856325228.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4915611294.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(4974619744.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5033182559.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5092209376.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5152010011.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5212280503.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5273188611.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5334560736.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5396516034.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5458860818.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(5521156908.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle income', N'MIC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(853174.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(867444.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(880828.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(894888.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(911716.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(932128.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(953686.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(978525.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1005124.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1030969.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1054465.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1072617.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1089216.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1104325.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1118654.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1133139.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1152344.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1170905.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1189339.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1208495.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1228399.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1247468.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1266527.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1284736.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1300697.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1313716.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1321545.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1327562.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1331181.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1331867.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1329582.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1324666.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1317273.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1310175.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1306836.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1309185.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1315257.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1327588.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1343585.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1359524.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1373058.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1384593.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1393208.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1399911.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1406616.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1414462.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1422074.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1430853.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1440131.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1448701.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455794.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1461896.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1466297.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1469000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1470187.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1469967.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Macedonia, FYR', N'MKD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1488664.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1507653.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1527105.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1547445.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1569143.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1592434.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1617797.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1644944.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1672401.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1698140.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1720798.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1739525.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1754954.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1768996.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1784395.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1803009.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1825554.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1851068.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1877687.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1902718.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1924194.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1941445.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1954990.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1965488.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1974069.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1981532.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1988401.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1994368.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1998471.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1999338.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1996227.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1988458.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1977033.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1964924.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1956165.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1953544.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1958303.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1969345.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1984242.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(1999362.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2012051.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2021585.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2028706.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2033974.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2038444.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2042894.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2047330.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2051427.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2055266.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2058920.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2062443.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2065888.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2069270.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2072543.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2075625.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(2078453.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Macedonia, FYR', N'MKD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2995285.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3011188.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3028569.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3049428.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3078013.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3116348.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3131209.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3158562.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3196396.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3241519.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3292111.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3321283.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3360359.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3406894.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3458961.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3515529.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3544194.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3580579.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3624430.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3675995.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3735554.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3777035.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3829550.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3889385.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3952504.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4016783.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4037697.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4062228.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4094411.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4139320.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4200749.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4289389.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4397888.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4522286.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4657830.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4801168.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4928446.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5067602.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5217601.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5377762.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5548352.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5713594.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5892070.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6083303.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6286993.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6502414.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6699859.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6912446.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7136983.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7370754.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7612451.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7820187.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8041779.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8277089.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8526494.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8791779.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mali', N'MLI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5263730.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5322267.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5381369.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5441611.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5503748.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5568485.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5635859.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5706198.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5780834.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5861411.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(5949043.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6044532.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6147459.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6256192.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6368351.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6482276.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6596817.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6712545.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6831530.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(6956779.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7090125.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7233877.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7386669.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7542377.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7692537.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7831891.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(7957390.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8073178.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8189984.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8322726.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8482075.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8672581.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(8891141.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(9131449.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(9383608.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(9640643.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(9901045.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(10168000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(10444822.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(10736542.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(11046926.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(11376094.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(11723017.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(12088867.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(12474857.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(12881384.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(13309942.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(13759226.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(14223403.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(14694565.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(15167286.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(15639115.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(16112333.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(16592097.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(17086022.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(17599694.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mali', N'MLI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172187.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172493.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174375.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177364.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180517.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182596.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184375.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185698.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186580.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187085.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188386.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191151.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192995.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194408.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195773.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198760.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200565.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202415.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205625.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208493.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211021.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212437.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216877.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219711.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219430.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222904.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226631.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227723.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229023.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231022.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233560.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235723.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238598.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(241857.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244953.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247285.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(249644.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(251913.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(253809.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(255452.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(257367.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265513.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(267748.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269756.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271814.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(273718.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275937.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277619.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279446.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280698.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280369.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280729.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281748.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283099.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284523.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286059.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malta', N'MLT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(326550.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(325250.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(323900.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(322550.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(321250.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(318800.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(315200.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(311550.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(307900.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(304300.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(302650.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(302700.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(302450.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(302200.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(301996.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(304222.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(305774.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(306970.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(310182.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(313342.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(316645.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(318982.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(325898.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(330524.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(330593.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(336452.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(342121.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(344485.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(347325.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(350722.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(354170.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(357727.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(361260.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(364704.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(367941.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(370433.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(372687.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(375236.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(377516.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(379360.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(381363.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(393028.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(395969.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(398582.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(401268.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(403834.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(405308.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(406724.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(409379.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(412477.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(414508.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(416268.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(419455.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(423374.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(427364.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(431333.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malta', N'MLT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12060232.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12212485.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12351705.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12500576.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12693867.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12947484.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13201209.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13513976.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13872881.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14256043.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14650922.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15009289.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15394107.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15799920.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16223157.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16662732.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17088711.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17529009.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17986817.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18467750.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18973682.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19453908.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19959577.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20487496.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21036174.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21605110.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22126576.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22687705.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23271703.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23855905.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24429453.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1991', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24970214.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25480527.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25985794.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26520526.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27100784.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27692141.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28321627.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28968183.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29597490.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30186403.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30651267.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31079766.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31472589.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31839273.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32190821.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32470588.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32754327.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33051172.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33369690.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33717502.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34165411.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34637838.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35132537.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35643031.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36159453.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Myanmar', N'MMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(21486424.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(21961594.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(22446690.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(22947286.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(23471163.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(24023640.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(24606863.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(25218375.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(25853248.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(26504247.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(27166045.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(27836648.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(28517289.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(29209686.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(29916827.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(30640635.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(31379308.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(32130696.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(32895739.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(33675835.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(34470694.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(35279907.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(36098908.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(36917980.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(37724581.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(38508821.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(39269143.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(40005369.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(40711172.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(41379635.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(42007309.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(42588029.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(43126260.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(43642311.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(44164109.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(44710931.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(45290888.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(45895991.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(46509586.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(47106923.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(47669791.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(48195684.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(48689952.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(49151958.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(49582751.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(49984704.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(50355559.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(50698814.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(51030006.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(51369725.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(51733013.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(52125411.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(52543841.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(52983829.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(53437159.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(53897154.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Myanmar', N'MMR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52211976.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53158516.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54157482.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55245744.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56483262.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57900742.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59245565.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60811458.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62542915.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64362615.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66232214.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67920583.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69706512.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71598259.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73609498.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75748776.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77892103.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80147685.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82537687.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85083904.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87785134.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90408776.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93218933.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96173454.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99200578.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102345002.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105357597.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108484180.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111727530.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115060468.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119564756.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123107535.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126792658.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130593145.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134666709.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138930631.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143541184.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148320319.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153234865.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158310005.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163509512.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168742317.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174098637.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179554644.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185043665.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(190473689.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195405667.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200264338.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204990809.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209522845.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213828716.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217663391.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221275490.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(224745277.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(228188348.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231692950.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(97914047.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(100520117.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(103203361.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(105967893.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(108822242.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(111771141.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(114822829.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(117971134.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(121190432.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(124446136.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(127718364.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(130989602.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(134301647.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(137699619.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(141243084.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(144978967.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(148914870.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(153052528.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(157418847.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(162041884.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(166936522.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(172106111.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(177527881.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(183159784.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(188904386.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(194828467.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(200858385.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(206917503.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(212943121.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(218780126.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(226500949.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(232072119.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(237442371.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(242574382.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(247781649.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(252960224.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(258137333.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(263330664.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(268464614.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(273564675.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(278580533.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(283534356.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(288454626.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(293390641.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(298427213.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(303621727.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(308994950.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(314531268.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(320229174.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(326041106.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(331928764.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(337908291.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(343940245.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(350056720.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(356262920.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(362560941.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa (excluding high income)', N'MNA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283550.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(289650.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295819.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301582.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306494.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(310288.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(310065.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308666.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(307034.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306165.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306698.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311221.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317238.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324296.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331818.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(339300.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(345130.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351043.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(357092.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(363290.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(369682.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(377196.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384582.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(391510.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(397636.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(402639.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403763.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403995.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403600.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(402863.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(402125.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403982.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405555.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(406858.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407879.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(408494.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407821.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407013.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(406252.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405642.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405240.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(406567.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407730.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(408820.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(409259.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410069.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410937.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(412199.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413911.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(415868.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(417641.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(418665.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(419825.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(420937.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(421519.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(421357.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Montenegro', N'MNE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(480579.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(491140.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(502558.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(513409.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(521753.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(526327.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(526419.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(522796.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(517481.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(513340.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(512407.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(515449.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(521785.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(530220.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(538902.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(546487.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(552562.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(557576.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(562065.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(566888.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(572608.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(579445.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(587001.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(594506.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(600884.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(605398.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(607711.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(608144.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(607413.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(606571.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(606372.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(607105.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(608516.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(610170.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(611389.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(611712.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(611003.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(609520.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(607662.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(606001.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(604950.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(607389.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(609828.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(612267.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(613353.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(614261.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(615025.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(615875.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(616969.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(618294.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(619428.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(620079.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(620601.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(621207.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(621810.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(622388.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Montenegro', N'MNE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(555877.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(562062.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(567267.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(572478.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(579487.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(589153.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(596242.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607627.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(621892.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(636858.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(651547.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(666888.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(681446.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(696632.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(714797.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(737020.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(758611.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(784923.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(814569.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(845181.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(875491.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(904619.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(933225.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(962415.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(993970.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028645.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1062757.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1099706.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1137839.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1175121.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1210180.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1232987.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1255929.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1278573.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1300714.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1323120.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1352495.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1379734.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1407234.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1438548.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1475319.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1514583.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1559571.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1608241.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1656435.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1701441.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1742433.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1779343.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1813025.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1845588.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1878074.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1904196.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1931264.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1957735.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1982136.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2004171.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mongolia', N'MNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(955514.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(982180.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1011328.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1042383.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1074517.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1107125.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1139960.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1173186.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1207108.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1242213.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1278825.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1317049.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1356669.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1397305.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1438423.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1479650.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1520865.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1562212.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1603908.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1646291.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1689622.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1733479.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1777727.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1823215.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1871087.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1921885.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(1976311.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2033345.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2089716.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2141006.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2184145.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2217920.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2243506.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2263204.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2280495.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2298038.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2316571.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2335694.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2355588.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2376165.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2397438.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2419729.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2443503.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2469045.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2496621.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2526447.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2558484.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2592776.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2629666.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2669572.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2712657.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2759074.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2808339.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2859174.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2909871.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(2959134.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mongolia', N'MNG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Northern Mariana Islands', N'MNP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(10070.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(10340.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(10541.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(10709.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(10901.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(11157.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(11489.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(11882.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(12318.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(12766.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(13203.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(13658.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(14142.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(14605.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(14978.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(15232.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(15316.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(15293.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(15390.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(15906.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(17048.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(18906.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(21393.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(24308.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(27363.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(30341.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(33173.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(35904.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(38570.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(41243.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(43972.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(46719.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(49429.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(52120.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(54817.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(57518.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(60248.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(62939.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(65374.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(67271.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(68434.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(68817.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(68499.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(67562.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(66143.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(64372.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(62235.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(59791.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(57343.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(55276.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(53860.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(53234.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(53314.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(53869.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(54541.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(55070.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Northern Mariana Islands', N'MNP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4118558.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4177802.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4247772.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4326633.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4412871.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4505825.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4578413.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4661883.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4754924.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4856656.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4966699.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5055042.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5155231.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5268152.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5394927.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5535805.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5673440.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5825873.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5987968.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6154658.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6321982.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6423571.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6532177.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6637367.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6726477.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6794389.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6733432.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6655024.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6588720.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6568526.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6614119.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6884497.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7214382.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7578384.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7944079.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8289828.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8525348.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8756157.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8988365.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9229744.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9485981.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9721430.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9975860.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10246020.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10530074.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10827199.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11095725.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11382684.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11688833.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12015452.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12363871.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12716924.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13094710.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13496254.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13920413.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14366015.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mozambique', N'MOZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(7493278.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(7643290.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(7799396.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(7961458.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(8129268.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(8302736.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(8482373.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(8668529.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(8860823.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(9058691.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(9262078.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(9468836.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(9679753.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(9901052.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(10141147.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(10405000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(10693688.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(11001909.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(11320103.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(11635174.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(11936379.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(12228508.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(12511864.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(12766859.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(12968335.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13102982.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13155271.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13142516.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13124285.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13181941.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13371971.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(13719853.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(14203987.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(14775877.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(15363065.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(15913101.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(16410777.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(16872896.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(17317376.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(17774066.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(18264536.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(18792357.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(19348715.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(19928496.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(20523159.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(21126676.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(21737860.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(22359637.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(22994867.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(23647815.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(24321457.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(25016921.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(25732928.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(26467180.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(27216276.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(27977863.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mozambique', N'MOZ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458647.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(468466.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(479489.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(491511.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(504340.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(517923.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(530533.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(544125.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(558763.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(574602.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591702.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607574.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(624953.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(643691.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(663574.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684483.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(703952.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(724804.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(746916.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(770184.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(794548.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(817389.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(841667.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(867150.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893570.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(920781.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(945882.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(971925.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(999155.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1027932.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1058499.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1089742.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1123301.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1159007.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1196608.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1235981.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1276935.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1319985.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1365198.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1412780.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1462801.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1514277.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1568501.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1624683.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1681855.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1739365.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1790564.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1842287.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1895004.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1949416.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2006018.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2062155.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2120866.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2181853.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2244740.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2309304.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mauritania', N'MRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(858170.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(883223.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(909172.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(936014.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(963746.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(992368.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1021880.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1052285.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1083586.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1115790.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1148908.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1182945.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1217912.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1253839.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1290755.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1328687.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1367640.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1407621.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1448664.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1490811.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1534085.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1578585.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1624310.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1671080.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1718641.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1766855.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1815692.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1865356.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1916240.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(1968870.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2023665.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2080782.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2140250.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2202201.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2266745.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2333966.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2403779.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2476188.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2551429.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2629806.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2711421.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2796502.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2884672.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(2974686.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3064882.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3154087.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3241762.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3328285.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3414552.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3501927.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3591400.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3683221.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3777067.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3872684.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(3969625.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(4067564.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mauritania', N'MRT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(335733.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346181.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355408.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(364263.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373630.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384071.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(393745.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405218.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(417804.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(430541.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443129.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458114.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(471582.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(484405.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(498128.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(513486.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531040.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(548333.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(562001.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(575461.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(586821.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(601256.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(614725.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(626868.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(640179.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(652106.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(662491.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(673101.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(683276.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(693344.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(702020.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(713739.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(725371.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(735055.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(746728.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(755580.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(762614.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(774221.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(785811.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(798788.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(808288.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(817845.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(824116.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(829606.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(835583.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(843624.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850054.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(858879.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(868071.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(875470.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(880634.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(885806.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(890311.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893169.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(895578.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(897899.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mauritius', N'MUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(659351.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(680757.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(700349.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(718861.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(736381.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(753000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(768813.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(783917.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(798413.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(812405.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(826000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(839230.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(852053.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(864819.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(878042.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(892000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(906507.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(921379.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(933499.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(949888.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(966039.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(980462.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(992521.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1001691.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1012221.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1020528.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1028360.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1036082.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1043239.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1051260.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1058775.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1070266.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1084441.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1097374.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1112846.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1122457.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1133996.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1148284.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1160421.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1175267.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1186873.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1196287.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1204621.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1213370.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1221003.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1228254.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1233996.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1239630.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1244121.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1247429.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1250400.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1252404.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1255882.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1258653.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1260934.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(1262605.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Mauritius', N'MUS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1902414.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1940947.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1989267.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2043785.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2099138.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2152862.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2194577.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2237142.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2281786.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2331398.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2387682.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2436377.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2493336.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2557406.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2626991.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2701387.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2769902.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2847130.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2930295.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3016354.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3104182.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3171924.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3242648.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3328120.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3443428.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3596975.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3816928.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4080721.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4361524.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4625235.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4849312.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4916027.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4937202.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4935480.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4939931.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4970813.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5049564.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5163310.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5302032.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5454336.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5612340.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5753168.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5904437.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6065808.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6236322.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6416032.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6609217.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6810127.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7019492.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7240364.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7474601.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7719638.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7983755.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8262951.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8551968.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8848909.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malawi', N'MWI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(3618604.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(3700032.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(3784444.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(3872124.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(3963424.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4058680.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4158132.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4262013.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4370664.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4484456.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4603739.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4728693.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4859569.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(4996861.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5141138.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5292816.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5454839.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5627788.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5807170.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(5986639.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(6163225.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(6327344.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(6483571.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(6659453.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(6892527.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(7205635.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(7617137.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(8108484.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(8620942.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9073088.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9408998.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9604199.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9682918.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9697635.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9725612.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(9822812.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(10006767.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(10260421.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(10563554.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(10882543.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(11193230.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(11491824.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(11788731.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(12090476.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(12407618.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(12747846.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(13112383.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(13498377.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(13904671.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(14329056.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(14769824.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(15226813.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(15700436.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(16190126.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(16695253.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(17215232.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malawi', N'MWI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4167871.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1961', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4282193.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4402264.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4530586.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4670013.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4821135.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4970970.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5138362.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5316506.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5494215.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5666095.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5872908.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6063263.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6247695.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6443476.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6659678.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6885265.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7135866.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7406176.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7679940.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7944044.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8198456.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8438857.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8668471.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8900919.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9147948.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9441872.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9758386.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10097255.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10447455.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10797803.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11146523.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11486927.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11827081.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12180925.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12557020.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12957101.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13381837.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13823967.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14271715.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14514049.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14911120.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15331909.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15771033.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16215413.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16675000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17144048.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17622597.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18103298.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18572278.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19024231.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19446078.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19833560.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20265519.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20618970.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20955860.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malaysia', N'MYS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(8160975.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(8429369.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(8710678.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(8999247.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(9287442.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(9569784.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(9844116.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(10111920.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(10375877.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(10640347.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(10908634.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(11182078.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(11460080.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(11741849.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(12025930.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(12311782.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(12599655.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(12891715.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(13191699.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(13504433.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(13833739.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(14180093.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(14543585.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(14926976.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(15333369.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(15764340.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(16221767.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(16703500.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(17202032.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(17707064.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(18211097.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(18709835.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(19204700.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(19700762.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(20205992.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(20725374.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(21260881.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(21808125.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(22358128.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(22898579.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(23420751.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(23920963.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(24401977.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(24869423.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(25332026.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(25796124.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(26263048.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(26730607.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(27197419.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(27661017.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(28119500.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(28572970.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(29021940.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(29465372.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(29901997.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(30331007.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Malaysia', N'MYS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118988763.00000 AS Numeric(28, 5)))
   ,(N'1961', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(120637022.00000 AS Numeric(28, 5)))
   ,(N'1962', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122492012.00000 AS Numeric(28, 5)))
   ,(N'1963', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124527955.00000 AS Numeric(28, 5)))
   ,(N'1964', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(126712346.00000 AS Numeric(28, 5)))
   ,(N'1965', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128890366.00000 AS Numeric(28, 5)))
   ,(N'1966', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131070474.00000 AS Numeric(28, 5)))
   ,(N'1967', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133323066.00000 AS Numeric(28, 5)))
   ,(N'1968', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(135569297.00000 AS Numeric(28, 5)))
   ,(N'1969', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137850001.00000 AS Numeric(28, 5)))
   ,(N'1970', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140450918.00000 AS Numeric(28, 5)))
   ,(N'1971', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143468483.00000 AS Numeric(28, 5)))
   ,(N'1972', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146228849.00000 AS Numeric(28, 5)))
   ,(N'1973', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148865105.00000 AS Numeric(28, 5)))
   ,(N'1974', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151532834.00000 AS Numeric(28, 5)))
   ,(N'1975', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154404563.00000 AS Numeric(28, 5)))
   ,(N'1976', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156695807.00000 AS Numeric(28, 5)))
   ,(N'1977', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159164169.00000 AS Numeric(28, 5)))
   ,(N'1978', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161719258.00000 AS Numeric(28, 5)))
   ,(N'1979', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164264000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166515778.00000 AS Numeric(28, 5)))
   ,(N'1981', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168683459.00000 AS Numeric(28, 5)))
   ,(N'1982', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170707450.00000 AS Numeric(28, 5)))
   ,(N'1983', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172518225.00000 AS Numeric(28, 5)))
   ,(N'1984', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174143817.00000 AS Numeric(28, 5)))
   ,(N'1985', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(175716345.00000 AS Numeric(28, 5)))
   ,(N'1986', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177092608.00000 AS Numeric(28, 5)))
   ,(N'1987', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178473489.00000 AS Numeric(28, 5)))
   ,(N'1988', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179882243.00000 AS Numeric(28, 5)))
   ,(N'1989', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181471120.00000 AS Numeric(28, 5)))
   ,(N'1990', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183364689.00000 AS Numeric(28, 5)))
   ,(N'1991', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185449300.00000 AS Numeric(28, 5)))
   ,(N'1992', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187692475.00000 AS Numeric(28, 5)))
   ,(N'1993', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189954559.00000 AS Numeric(28, 5)))
   ,(N'1994', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192254155.00000 AS Numeric(28, 5)))
   ,(N'1995', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194701878.00000 AS Numeric(28, 5)))
   ,(N'1996', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197104904.00000 AS Numeric(28, 5)))
   ,(N'1997', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199865369.00000 AS Numeric(28, 5)))
   ,(N'1998', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202715439.00000 AS Numeric(28, 5)))
   ,(N'1999', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205595518.00000 AS Numeric(28, 5)))
   ,(N'2000', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208432247.00000 AS Numeric(28, 5)))
   ,(N'2001', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211138598.00000 AS Numeric(28, 5)))
   ,(N'2002', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213599922.00000 AS Numeric(28, 5)))
   ,(N'2003', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215925997.00000 AS Numeric(28, 5)))
   ,(N'2004', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218466213.00000 AS Numeric(28, 5)))
   ,(N'2005', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(221103516.00000 AS Numeric(28, 5)))
   ,(N'2006', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223222615.00000 AS Numeric(28, 5)))
   ,(N'2007', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225485516.00000 AS Numeric(28, 5)))
   ,(N'2008', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227785012.00000 AS Numeric(28, 5)))
   ,(N'2009', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229825759.00000 AS Numeric(28, 5)))
   ,(N'2010', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(231577732.00000 AS Numeric(28, 5)))
   ,(N'2011', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233078715.00000 AS Numeric(28, 5)))
   ,(N'2012', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234451541.00000 AS Numeric(28, 5)))
   ,(N'2013', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235535940.00000 AS Numeric(28, 5)))
   ,(N'2014', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236508578.00000 AS Numeric(28, 5)))
   ,(N'2015', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(237324179.00000 AS Numeric(28, 5)))
   ,(N'2016', N'North America', N'NAC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(198624409.00000 AS Numeric(28, 5)))
   ,(N'1961', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(202007500.00000 AS Numeric(28, 5)))
   ,(N'1962', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(205198600.00000 AS Numeric(28, 5)))
   ,(N'1963', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(208253700.00000 AS Numeric(28, 5)))
   ,(N'1964', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(211262900.00000 AS Numeric(28, 5)))
   ,(N'1965', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(214031100.00000 AS Numeric(28, 5)))
   ,(N'1966', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(216659000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(219176000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(221503000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(223759000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(226431000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(229361135.00000 AS Numeric(28, 5)))
   ,(N'1972', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(231943831.00000 AS Numeric(28, 5)))
   ,(N'1973', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(234332208.00000 AS Numeric(28, 5)))
   ,(N'1974', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(236681487.00000 AS Numeric(28, 5)))
   ,(N'1975', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(239235000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(241606200.00000 AS Numeric(28, 5)))
   ,(N'1977', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(244088400.00000 AS Numeric(28, 5)))
   ,(N'1978', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(246674600.00000 AS Numeric(28, 5)))
   ,(N'1979', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(249385800.00000 AS Numeric(28, 5)))
   ,(N'1980', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(251872670.00000 AS Numeric(28, 5)))
   ,(N'1981', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(254421050.00000 AS Numeric(28, 5)))
   ,(N'1982', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(256921449.00000 AS Numeric(28, 5)))
   ,(N'1983', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(259303930.00000 AS Numeric(28, 5)))
   ,(N'1984', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(261583423.00000 AS Numeric(28, 5)))
   ,(N'1985', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(263922898.00000 AS Numeric(28, 5)))
   ,(N'1986', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(266394382.00000 AS Numeric(28, 5)))
   ,(N'1987', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(268896849.00000 AS Numeric(28, 5)))
   ,(N'1988', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(271452347.00000 AS Numeric(28, 5)))
   ,(N'1989', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(274256841.00000 AS Numeric(28, 5)))
   ,(N'1990', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(277473326.00000 AS Numeric(28, 5)))
   ,(N'1991', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(281211703.00000 AS Numeric(28, 5)))
   ,(N'1992', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(285092192.00000 AS Numeric(28, 5)))
   ,(N'1993', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(288811320.00000 AS Numeric(28, 5)))
   ,(N'1994', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(292297226.00000 AS Numeric(28, 5)))
   ,(N'1995', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(295691746.00000 AS Numeric(28, 5)))
   ,(N'1996', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(299126029.00000 AS Numeric(28, 5)))
   ,(N'1997', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(302704697.00000 AS Numeric(28, 5)))
   ,(N'1998', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(306162843.00000 AS Numeric(28, 5)))
   ,(N'1999', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(309600485.00000 AS Numeric(28, 5)))
   ,(N'2000', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(312993944.00000 AS Numeric(28, 5)))
   ,(N'2001', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(316113359.00000 AS Numeric(28, 5)))
   ,(N'2002', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(319050105.00000 AS Numeric(28, 5)))
   ,(N'2003', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(321847258.00000 AS Numeric(28, 5)))
   ,(N'2004', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(324864038.00000 AS Numeric(28, 5)))
   ,(N'2005', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(327892753.00000 AS Numeric(28, 5)))
   ,(N'2006', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(331014940.00000 AS Numeric(28, 5)))
   ,(N'2007', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(334184023.00000 AS Numeric(28, 5)))
   ,(N'2008', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(337405012.00000 AS Numeric(28, 5)))
   ,(N'2009', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(340465736.00000 AS Numeric(28, 5)))
   ,(N'2010', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(343417261.00000 AS Numeric(28, 5)))
   ,(N'2011', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(346126201.00000 AS Numeric(28, 5)))
   ,(N'2012', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(348918897.00000 AS Numeric(28, 5)))
   ,(N'2013', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(351647895.00000 AS Numeric(28, 5)))
   ,(N'2014', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(354516198.00000 AS Numeric(28, 5)))
   ,(N'2015', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(357335829.00000 AS Numeric(28, 5)))
   ,(N'2016', N'North America', N'NAC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329403.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336047.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(343190.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(350847.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(359092.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(367970.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(376130.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(385011.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(394639.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(404983.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(416010.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426940.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(438471.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450249.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(461907.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(473189.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(479271.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(485407.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(491726.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(498390.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(505726.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(514313.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523898.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(535508.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(550388.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569270.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(600297.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(635461.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(673362.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(712086.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(750148.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(780963.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(810973.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(840736.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(871248.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(903242.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(935298.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(969304.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1003756.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1036790.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1067254.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1086560.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1102950.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1118106.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1134158.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1152550.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1174361.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1198205.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1224355.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1252644.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1282784.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1317991.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1354990.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1393076.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1431589.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1470005.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Namibia', N'NAM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(602545.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(617282.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(632658.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(648668.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(665297.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(682553.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(700316.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(718622.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(737802.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(758305.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(780386.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(804309.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(829806.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(855965.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(881530.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(905647.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(928228.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(949734.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(970569.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(991365.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1012761.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1034446.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1056758.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1081740.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1112044.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1149389.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1194769.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1247186.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1303879.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1360921.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1415447.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1466152.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1513689.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1559480.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1605828.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1654214.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1705349.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1758097.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1809920.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1857320.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1897953.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1931005.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1957749.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(1980531.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2002745.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2027026.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2053915.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2083174.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2115703.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2152357.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2193643.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2240161.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2291645.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2346592.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2402858.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(2458830.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Namibia', N'NAM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46605.00000 AS Numeric(28, 5)))
   ,(N'1961', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47848.00000 AS Numeric(28, 5)))
   ,(N'1962', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49059.00000 AS Numeric(28, 5)))
   ,(N'1963', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50305.00000 AS Numeric(28, 5)))
   ,(N'1964', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51625.00000 AS Numeric(28, 5)))
   ,(N'1965', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52997.00000 AS Numeric(28, 5)))
   ,(N'1966', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54727.00000 AS Numeric(28, 5)))
   ,(N'1967', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56522.00000 AS Numeric(28, 5)))
   ,(N'1968', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58364.00000 AS Numeric(28, 5)))
   ,(N'1969', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61085.00000 AS Numeric(28, 5)))
   ,(N'1970', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65826.00000 AS Numeric(28, 5)))
   ,(N'1971', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70251.00000 AS Numeric(28, 5)))
   ,(N'1972', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73219.00000 AS Numeric(28, 5)))
   ,(N'1973', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74852.00000 AS Numeric(28, 5)))
   ,(N'1974', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76466.00000 AS Numeric(28, 5)))
   ,(N'1975', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77826.00000 AS Numeric(28, 5)))
   ,(N'1976', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78286.00000 AS Numeric(28, 5)))
   ,(N'1977', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79541.00000 AS Numeric(28, 5)))
   ,(N'1978', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80818.00000 AS Numeric(28, 5)))
   ,(N'1979', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81852.00000 AS Numeric(28, 5)))
   ,(N'1980', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83140.00000 AS Numeric(28, 5)))
   ,(N'1981', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84969.00000 AS Numeric(28, 5)))
   ,(N'1982', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86887.00000 AS Numeric(28, 5)))
   ,(N'1983', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88755.00000 AS Numeric(28, 5)))
   ,(N'1984', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90811.00000 AS Numeric(28, 5)))
   ,(N'1985', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93097.00000 AS Numeric(28, 5)))
   ,(N'1986', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95494.00000 AS Numeric(28, 5)))
   ,(N'1987', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98355.00000 AS Numeric(28, 5)))
   ,(N'1988', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101408.00000 AS Numeric(28, 5)))
   ,(N'1989', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104495.00000 AS Numeric(28, 5)))
   ,(N'1990', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107897.00000 AS Numeric(28, 5)))
   ,(N'1991', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111537.00000 AS Numeric(28, 5)))
   ,(N'1992', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114978.00000 AS Numeric(28, 5)))
   ,(N'1993', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118472.00000 AS Numeric(28, 5)))
   ,(N'1994', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122179.00000 AS Numeric(28, 5)))
   ,(N'1995', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125550.00000 AS Numeric(28, 5)))
   ,(N'1996', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128052.00000 AS Numeric(28, 5)))
   ,(N'1997', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130829.00000 AS Numeric(28, 5)))
   ,(N'1998', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133704.00000 AS Numeric(28, 5)))
   ,(N'1999', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136591.00000 AS Numeric(28, 5)))
   ,(N'2000', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139470.00000 AS Numeric(28, 5)))
   ,(N'2001', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142508.00000 AS Numeric(28, 5)))
   ,(N'2002', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145529.00000 AS Numeric(28, 5)))
   ,(N'2003', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148133.00000 AS Numeric(28, 5)))
   ,(N'2004', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150504.00000 AS Numeric(28, 5)))
   ,(N'2005', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153007.00000 AS Numeric(28, 5)))
   ,(N'2006', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156102.00000 AS Numeric(28, 5)))
   ,(N'2007', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158514.00000 AS Numeric(28, 5)))
   ,(N'2008', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161580.00000 AS Numeric(28, 5)))
   ,(N'2009', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163904.00000 AS Numeric(28, 5)))
   ,(N'2010', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167423.00000 AS Numeric(28, 5)))
   ,(N'2011', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170549.00000 AS Numeric(28, 5)))
   ,(N'2012', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174312.00000 AS Numeric(28, 5)))
   ,(N'2013', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177336.00000 AS Numeric(28, 5)))
   ,(N'2014', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180973.00000 AS Numeric(28, 5)))
   ,(N'2015', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184559.00000 AS Numeric(28, 5)))
   ,(N'2016', N'New Caledonia', N'NCL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(79000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(81200.00000 AS Numeric(28, 5)))
   ,(N'1962', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(83400.00000 AS Numeric(28, 5)))
   ,(N'1963', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(85700.00000 AS Numeric(28, 5)))
   ,(N'1964', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(88100.00000 AS Numeric(28, 5)))
   ,(N'1965', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(90500.00000 AS Numeric(28, 5)))
   ,(N'1966', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(93500.00000 AS Numeric(28, 5)))
   ,(N'1967', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(96500.00000 AS Numeric(28, 5)))
   ,(N'1968', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(99500.00000 AS Numeric(28, 5)))
   ,(N'1969', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(104000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(112000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(120000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(125500.00000 AS Numeric(28, 5)))
   ,(N'1973', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(128500.00000 AS Numeric(28, 5)))
   ,(N'1974', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(131000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(132500.00000 AS Numeric(28, 5)))
   ,(N'1976', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(134000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(136000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(137500.00000 AS Numeric(28, 5)))
   ,(N'1979', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(138500.00000 AS Numeric(28, 5)))
   ,(N'1980', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(140050.00000 AS Numeric(28, 5)))
   ,(N'1981', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(142650.00000 AS Numeric(28, 5)))
   ,(N'1982', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(145700.00000 AS Numeric(28, 5)))
   ,(N'1983', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(148700.00000 AS Numeric(28, 5)))
   ,(N'1984', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(151650.00000 AS Numeric(28, 5)))
   ,(N'1985', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(154450.00000 AS Numeric(28, 5)))
   ,(N'1986', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(157350.00000 AS Numeric(28, 5)))
   ,(N'1987', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(160500.00000 AS Numeric(28, 5)))
   ,(N'1988', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(163650.00000 AS Numeric(28, 5)))
   ,(N'1989', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(166898.00000 AS Numeric(28, 5)))
   ,(N'1990', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(170899.00000 AS Numeric(28, 5)))
   ,(N'1991', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(175362.00000 AS Numeric(28, 5)))
   ,(N'1992', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(179799.00000 AS Numeric(28, 5)))
   ,(N'1993', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(184496.00000 AS Numeric(28, 5)))
   ,(N'1994', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(189482.00000 AS Numeric(28, 5)))
   ,(N'1995', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(193816.00000 AS Numeric(28, 5)))
   ,(N'1996', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(197564.00000 AS Numeric(28, 5)))
   ,(N'1997', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(201418.00000 AS Numeric(28, 5)))
   ,(N'1998', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(205279.00000 AS Numeric(28, 5)))
   ,(N'1999', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(209214.00000 AS Numeric(28, 5)))
   ,(N'2000', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(213230.00000 AS Numeric(28, 5)))
   ,(N'2001', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(217324.00000 AS Numeric(28, 5)))
   ,(N'2002', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(221490.00000 AS Numeric(28, 5)))
   ,(N'2003', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(225000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(228000.00000 AS Numeric(28, 5)))
   ,(N'2005', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(231000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(235000.00000 AS Numeric(28, 5)))
   ,(N'2007', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(238000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(242000.00000 AS Numeric(28, 5)))
   ,(N'2009', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(245000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(250000.00000 AS Numeric(28, 5)))
   ,(N'2011', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(254000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(259000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(263000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(268000.00000 AS Numeric(28, 5)))
   ,(N'2015', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(273000.00000 AS Numeric(28, 5)))
   ,(N'2016', N'New Caledonia', N'NCL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1721646.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1764066.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1809035.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1856816.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1908664.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1965339.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2011123.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2064464.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2124110.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2188198.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2255903.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2316500.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2379960.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2447360.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2520528.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2600654.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2676322.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2756962.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2841312.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2927758.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3016373.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3080922.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3156569.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3240907.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3331875.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3429266.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3525226.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3623372.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3725597.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3835231.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3955473.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4071866.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4208553.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4360953.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4523544.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4693638.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4855172.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5023831.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5198115.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5378417.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5566506.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5733991.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5917218.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6112959.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6318430.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6533888.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743336.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6967477.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7207280.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7464771.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7741544.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8021493.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8324443.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8647214.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8986960.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9343503.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Niger', N'NER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3395212.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3493636.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3596613.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3703159.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3811813.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(3921581.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4032210.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4144238.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4258415.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4375837.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4497355.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4623121.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4753054.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(4887484.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5026744.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5171029.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5320869.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5476206.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5635954.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5798584.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(5963159.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(6129762.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(6299343.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(6472971.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(6652110.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(6838170.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(7031675.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(7233482.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(7445788.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(7671233.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(7911884.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(8168834.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(8442330.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(8732500.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(9039088.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(9361912.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(9701730.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(10058960.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(10432657.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(10821434.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(11224523.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(11642308.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(12075991.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(12526725.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(12996012.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(13485436.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(13995530.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(14527631.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(15085130.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(15672194.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(16291990.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(16946485.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(17635782.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(18358863.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(19113728.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(19899120.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Niger', N'NER', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25120448.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25539466.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26024496.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26560679.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27131543.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27729534.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28218238.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28757822.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29344497.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29975744.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30650317.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31235521.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31869124.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32565817.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33345263.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34215773.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35059809.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36028689.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37080071.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38161320.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39242067.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40070974.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40916761.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41799244.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42751983.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43799272.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44818593.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45959221.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47208337.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48547437.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49964733.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51281325.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52693456.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54198440.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55792150.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57468562.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58996293.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60626748.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62345978.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64134164.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65976551.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67609094.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69327894.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71127799.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73007477.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74966203.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76753193.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78664764.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80690264.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82817927.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85042478.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87193796.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89458063.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91846459.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94379786.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97066480.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nigeria', N'NGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(45211614.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(46144154.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(47117859.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(48128460.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(49169819.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(50238569.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(51336375.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(52468593.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(53640547.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(54859201.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(56131844.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(57453734.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(58829319.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(60285453.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(61857023.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(63565598.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(65426976.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(67425435.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(69512233.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(71619216.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(73698096.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(75729572.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(77729802.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(79729311.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(81775215.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(83901570.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(86118043.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(88412917.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(90773613.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(93179755.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(95617345.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(98085436.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(100592458.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(103145093.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(105753088.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(108424822.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(111164651.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(113975055.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(116860691.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(119826231.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(122876723.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(126014935.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(129246283.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(132581484.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(136033321.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(139611303.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(143318011.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(147152502.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(151115683.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(155207145.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(159424742.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(163770669.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(168240403.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(172816517.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(177475986.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(182201962.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nigeria', N'NGA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(889343.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(909552.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(928239.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(947235.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(969696.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(997316.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028013.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1062601.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1100940.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1142185.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1185598.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1226893.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1270665.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1316184.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1362620.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1409560.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1453179.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1498023.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1543541.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1589373.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1635497.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1679492.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1723211.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1767154.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1812282.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1859274.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1905832.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1954713.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2005981.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2059630.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2115952.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2179735.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2246266.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2315281.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2386622.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2459987.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2535173.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2611436.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2688359.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2765269.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2841749.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2918378.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2994041.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3068734.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3142370.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3215007.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3291689.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3366078.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3438937.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3511631.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3584737.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3658741.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3734098.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3808816.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3879940.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3946044.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nicaragua', N'NIC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(1774696.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(1830400.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(1886560.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(1943591.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2002119.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2062633.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2125233.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2189880.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2256779.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2326136.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2398095.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2472656.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2549779.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2629503.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2711847.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2796748.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2884156.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(2973805.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3065118.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3157356.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3249910.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3342666.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3435527.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3527935.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3619252.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3709091.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3796914.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3882940.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(3968453.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4055262.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4144564.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4236805.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4331273.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4426577.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4520727.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4612229.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4700777.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4786641.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4869627.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(4949661.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5026792.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5100750.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5171736.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5240876.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5309703.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5379327.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5450217.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5522119.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5594524.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5666595.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5737722.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5807787.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5877034.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(5945646.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(6013913.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(6082032.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nicaragua', N'NIC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7008047.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7100061.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7227653.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7367389.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7505421.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7635493.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7748079.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7843538.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7929210.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8028651.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8143206.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8256863.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8365876.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8468308.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8574343.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8696952.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8823951.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8937562.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9058997.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9195651.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9349560.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9492795.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9617659.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9733302.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9842429.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9945784.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10033223.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10121314.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10202162.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10270265.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10340579.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10412942.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10477161.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10530734.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10572422.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10603011.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10627347.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10659398.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10705458.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10760077.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10823029.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10893439.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10950651.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10990299.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11019796.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11041801.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11042387.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11056875.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11090496.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11126611.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11144924.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11153126.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11132008.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11092019.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11062349.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11050446.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Netherlands', N'NLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(11486631.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(11638712.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(11805689.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(11965966.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12127120.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12294732.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12456251.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12598201.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12729721.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(12877984.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13038526.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13194497.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13328593.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13439322.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13545056.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13666335.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13774037.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13856185.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(13941700.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14038270.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14149800.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14247208.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14312690.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14367070.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14424211.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14491632.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14572278.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14665037.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14760094.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14848907.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(14951510.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15069798.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15184166.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15290368.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15382838.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15459006.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15530498.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15610650.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15707209.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15812088.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(15925513.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16046180.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16148929.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16225302.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16281779.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16319868.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16346101.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16381696.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16445593.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16530388.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16615394.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16693074.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16754962.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16804432.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16865008.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(16936520.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Netherlands', N'NLD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2257343.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2271465.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2291749.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2314404.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2336136.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2355139.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2372556.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2387584.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2400754.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2414223.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2428026.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439564.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2456382.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2474137.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2490764.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2505951.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2520325.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2534269.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2548332.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2563064.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2579045.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2598104.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2617804.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2636729.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2654281.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2671619.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2685757.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2703028.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2721741.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2735944.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2746994.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2758640.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2772757.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2787110.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2801147.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2814820.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2828599.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2844708.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2863762.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2887038.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2911138.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2931944.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2955267.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2981067.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3006962.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3034508.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3068444.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3107679.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3151820.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3194910.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3235969.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3278959.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3320695.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3355624.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3384916.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3413644.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Norway', N'NOR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3581239.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3609800.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3638918.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3666537.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3694339.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3723168.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3753012.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3784539.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3816486.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3847707.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3875763.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3903039.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3933004.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3960612.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(3985258.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4007313.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4026152.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4043205.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4058671.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4072517.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4085620.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4099702.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4114787.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4128432.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4140099.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4152516.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4167354.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4186905.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1988', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4209488.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4226901.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4241473.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4261732.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4286401.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4311991.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4336613.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4359184.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4381336.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4405157.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4431464.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4461913.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4490967.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4513751.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4538159.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4564855.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4591910.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4623291.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4660677.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4709153.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4768212.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4828726.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4889252.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(4953088.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(5018573.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(5079623.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(5137232.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(5195921.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Norway', N'NOR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5751528.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5814368.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5868282.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5923214.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5995943.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6094496.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6184283.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6300817.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6437720.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6584015.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6733647.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6860548.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6997579.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7142557.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7294840.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7454321.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7591918.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7738495.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7894025.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8059570.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8235829.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8389614.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8559136.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8740944.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8930784.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9126782.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9295321.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9472907.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9664960.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9879310.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10121057.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10395183.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10701390.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11030905.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11371663.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11713829.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12001365.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12283610.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12559920.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12832982.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13106123.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13354349.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13589949.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13814020.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14027273.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14233886.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14501369.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14754676.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15002831.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15263221.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15549317.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15931649.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16348942.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16785168.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17213805.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17618261.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nepal', N'NPL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10056945.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10215153.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10377061.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10544586.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10719988.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(10905006.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(11100672.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(11307139.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(11524132.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(11750914.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(11986974.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(12232454.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(12487785.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(12753028.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(13028248.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(13313487.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(13608670.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(13913775.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(14228941.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(14554356.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(14890080.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(15237302.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(15596012.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(15963746.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(16337117.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(16714335.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(17091959.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(17472138.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(17865238.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(18285434.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(18741688.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(19237322.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(19765570.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(20312687.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(20859421.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(21390905.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(21902534.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(22395247.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(22866496.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(23315053.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(23740145.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(24140941.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(24516969.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(24868900.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(25198130.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(25506847.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(25794344.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(26063619.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(26325183.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(26592666.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(26875910.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(27179237.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(27500515.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(27834981.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(28174724.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(28513700.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nepal', N'NPL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nauru', N'NRU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(4433.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(4675.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(4947.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(5231.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(5500.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(5738.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(5936.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6102.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6241.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6368.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6493.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6619.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6743.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6862.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(6972.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7070.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7156.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7235.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7311.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7393.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7488.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7597.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7719.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(7855.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8007.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8174.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8356.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8550.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8752.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(8956.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9157.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9354.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9544.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9719.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9863.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(9970.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10033.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10056.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10054.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10044.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10042.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10053.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10073.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10096.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10113.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10101.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10075.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10047.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10028.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10025.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10043.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10079.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10125.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10176.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(10222.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Nauru', N'NRU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1386884.00000 AS Numeric(28, 5)))
   ,(N'1961', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1412578.00000 AS Numeric(28, 5)))
   ,(N'1962', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1451805.00000 AS Numeric(28, 5)))
   ,(N'1963', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1487159.00000 AS Numeric(28, 5)))
   ,(N'1964', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1525530.00000 AS Numeric(28, 5)))
   ,(N'1965', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1557235.00000 AS Numeric(28, 5)))
   ,(N'1966', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1587483.00000 AS Numeric(28, 5)))
   ,(N'1967', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1617909.00000 AS Numeric(28, 5)))
   ,(N'1968', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1634427.00000 AS Numeric(28, 5)))
   ,(N'1969', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1652556.00000 AS Numeric(28, 5)))
   ,(N'1970', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1679735.00000 AS Numeric(28, 5)))
   ,(N'1971', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1712343.00000 AS Numeric(28, 5)))
   ,(N'1972', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1749960.00000 AS Numeric(28, 5)))
   ,(N'1973', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1792482.00000 AS Numeric(28, 5)))
   ,(N'1974', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1840546.00000 AS Numeric(28, 5)))
   ,(N'1975', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1890339.00000 AS Numeric(28, 5)))
   ,(N'1976', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1912093.00000 AS Numeric(28, 5)))
   ,(N'1977', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1927842.00000 AS Numeric(28, 5)))
   ,(N'1978', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1941869.00000 AS Numeric(28, 5)))
   ,(N'1979', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1948223.00000 AS Numeric(28, 5)))
   ,(N'1980', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1963020.00000 AS Numeric(28, 5)))
   ,(N'1981', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1987401.00000 AS Numeric(28, 5)))
   ,(N'1982', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2020412.00000 AS Numeric(28, 5)))
   ,(N'1983', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2059108.00000 AS Numeric(28, 5)))
   ,(N'1984', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2087984.00000 AS Numeric(28, 5)))
   ,(N'1985', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2112347.00000 AS Numeric(28, 5)))
   ,(N'1986', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2117476.00000 AS Numeric(28, 5)))
   ,(N'1987', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2141470.00000 AS Numeric(28, 5)))
   ,(N'1988', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2152572.00000 AS Numeric(28, 5)))
   ,(N'1989', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2166213.00000 AS Numeric(28, 5)))
   ,(N'1990', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2186757.00000 AS Numeric(28, 5)))
   ,(N'1991', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2294539.00000 AS Numeric(28, 5)))
   ,(N'1992', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2316713.00000 AS Numeric(28, 5)))
   ,(N'1993', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2340845.00000 AS Numeric(28, 5)))
   ,(N'1994', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2370106.00000 AS Numeric(28, 5)))
   ,(N'1995', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2404115.00000 AS Numeric(28, 5)))
   ,(N'1996', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439482.00000 AS Numeric(28, 5)))
   ,(N'1997', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2470153.00000 AS Numeric(28, 5)))
   ,(N'1998', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2492781.00000 AS Numeric(28, 5)))
   ,(N'1999', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2508331.00000 AS Numeric(28, 5)))
   ,(N'2000', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2526404.00000 AS Numeric(28, 5)))
   ,(N'2001', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2549480.00000 AS Numeric(28, 5)))
   ,(N'2002', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2601424.00000 AS Numeric(28, 5)))
   ,(N'2003', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2660279.00000 AS Numeric(28, 5)))
   ,(N'2004', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2707420.00000 AS Numeric(28, 5)))
   ,(N'2005', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2745745.00000 AS Numeric(28, 5)))
   ,(N'2006', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2782786.00000 AS Numeric(28, 5)))
   ,(N'2007', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2811347.00000 AS Numeric(28, 5)))
   ,(N'2008', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2836405.00000 AS Numeric(28, 5)))
   ,(N'2009', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2863943.00000 AS Numeric(28, 5)))
   ,(N'2010', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2892680.00000 AS Numeric(28, 5)))
   ,(N'2011', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2902432.00000 AS Numeric(28, 5)))
   ,(N'2012', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2905280.00000 AS Numeric(28, 5)))
   ,(N'2013', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2913707.00000 AS Numeric(28, 5)))
   ,(N'2014', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2943231.00000 AS Numeric(28, 5)))
   ,(N'2015', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2984061.00000 AS Numeric(28, 5)))
   ,(N'2016', N'New Zealand', N'NZL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2371800.00000 AS Numeric(28, 5)))
   ,(N'1961', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2419700.00000 AS Numeric(28, 5)))
   ,(N'1962', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2482000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2531800.00000 AS Numeric(28, 5)))
   ,(N'1964', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2585400.00000 AS Numeric(28, 5)))
   ,(N'1965', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2628400.00000 AS Numeric(28, 5)))
   ,(N'1966', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2675900.00000 AS Numeric(28, 5)))
   ,(N'1967', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2724100.00000 AS Numeric(28, 5)))
   ,(N'1968', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2748100.00000 AS Numeric(28, 5)))
   ,(N'1969', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2772800.00000 AS Numeric(28, 5)))
   ,(N'1970', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2810700.00000 AS Numeric(28, 5)))
   ,(N'1971', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2853000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2903900.00000 AS Numeric(28, 5)))
   ,(N'1973', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(2961300.00000 AS Numeric(28, 5)))
   ,(N'1974', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3023700.00000 AS Numeric(28, 5)))
   ,(N'1975', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3083100.00000 AS Numeric(28, 5)))
   ,(N'1976', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3110500.00000 AS Numeric(28, 5)))
   ,(N'1977', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3120200.00000 AS Numeric(28, 5)))
   ,(N'1978', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3121200.00000 AS Numeric(28, 5)))
   ,(N'1979', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3109000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3112900.00000 AS Numeric(28, 5)))
   ,(N'1981', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3124900.00000 AS Numeric(28, 5)))
   ,(N'1982', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3156100.00000 AS Numeric(28, 5)))
   ,(N'1983', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3199300.00000 AS Numeric(28, 5)))
   ,(N'1984', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3227100.00000 AS Numeric(28, 5)))
   ,(N'1985', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3247100.00000 AS Numeric(28, 5)))
   ,(N'1986', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3246300.00000 AS Numeric(28, 5)))
   ,(N'1987', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3274400.00000 AS Numeric(28, 5)))
   ,(N'1988', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3283400.00000 AS Numeric(28, 5)))
   ,(N'1989', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3299200.00000 AS Numeric(28, 5)))
   ,(N'1990', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3329800.00000 AS Numeric(28, 5)))
   ,(N'1991', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3495100.00000 AS Numeric(28, 5)))
   ,(N'1992', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3531700.00000 AS Numeric(28, 5)))
   ,(N'1993', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3572200.00000 AS Numeric(28, 5)))
   ,(N'1994', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3620000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3673400.00000 AS Numeric(28, 5)))
   ,(N'1996', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3732000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3781300.00000 AS Numeric(28, 5)))
   ,(N'1998', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3815000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3835100.00000 AS Numeric(28, 5)))
   ,(N'2000', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3857700.00000 AS Numeric(28, 5)))
   ,(N'2001', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3880500.00000 AS Numeric(28, 5)))
   ,(N'2002', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(3948500.00000 AS Numeric(28, 5)))
   ,(N'2003', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4027200.00000 AS Numeric(28, 5)))
   ,(N'2004', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4087500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4133900.00000 AS Numeric(28, 5)))
   ,(N'2006', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4184600.00000 AS Numeric(28, 5)))
   ,(N'2007', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4223800.00000 AS Numeric(28, 5)))
   ,(N'2008', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4259800.00000 AS Numeric(28, 5)))
   ,(N'2009', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4302600.00000 AS Numeric(28, 5)))
   ,(N'2010', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4350700.00000 AS Numeric(28, 5)))
   ,(N'2011', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4384000.00000 AS Numeric(28, 5)))
   ,(N'2012', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4408100.00000 AS Numeric(28, 5)))
   ,(N'2013', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4442100.00000 AS Numeric(28, 5)))
   ,(N'2014', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4509700.00000 AS Numeric(28, 5)))
   ,(N'2015', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(4595700.00000 AS Numeric(28, 5)))
   ,(N'2016', N'New Zealand', N'NZL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487574867.00000 AS Numeric(28, 5)))
   ,(N'1961', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494368037.00000 AS Numeric(28, 5)))
   ,(N'1962', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500925784.00000 AS Numeric(28, 5)))
   ,(N'1963', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(507945637.00000 AS Numeric(28, 5)))
   ,(N'1964', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(515124762.00000 AS Numeric(28, 5)))
   ,(N'1965', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(522136213.00000 AS Numeric(28, 5)))
   ,(N'1966', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(528482660.00000 AS Numeric(28, 5)))
   ,(N'1967', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(534776889.00000 AS Numeric(28, 5)))
   ,(N'1968', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540614527.00000 AS Numeric(28, 5)))
   ,(N'1969', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(547799680.00000 AS Numeric(28, 5)))
   ,(N'1970', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(554433373.00000 AS Numeric(28, 5)))
   ,(N'1971', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(561779561.00000 AS Numeric(28, 5)))
   ,(N'1972', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569284182.00000 AS Numeric(28, 5)))
   ,(N'1973', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(576337368.00000 AS Numeric(28, 5)))
   ,(N'1974', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(584439272.00000 AS Numeric(28, 5)))
   ,(N'1975', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(592628209.00000 AS Numeric(28, 5)))
   ,(N'1976', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(599011258.00000 AS Numeric(28, 5)))
   ,(N'1977', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(606133927.00000 AS Numeric(28, 5)))
   ,(N'1978', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(613804485.00000 AS Numeric(28, 5)))
   ,(N'1979', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(621823950.00000 AS Numeric(28, 5)))
   ,(N'1980', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(630015295.00000 AS Numeric(28, 5)))
   ,(N'1981', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(638668161.00000 AS Numeric(28, 5)))
   ,(N'1982', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(647117491.00000 AS Numeric(28, 5)))
   ,(N'1983', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(655303279.00000 AS Numeric(28, 5)))
   ,(N'1984', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(663103741.00000 AS Numeric(28, 5)))
   ,(N'1985', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(670689566.00000 AS Numeric(28, 5)))
   ,(N'1986', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(677329173.00000 AS Numeric(28, 5)))
   ,(N'1987', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(683919157.00000 AS Numeric(28, 5)))
   ,(N'1988', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(690548285.00000 AS Numeric(28, 5)))
   ,(N'1989', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(697378427.00000 AS Numeric(28, 5)))
   ,(N'1990', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(704397614.00000 AS Numeric(28, 5)))
   ,(N'1991', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(711315265.00000 AS Numeric(28, 5)))
   ,(N'1992', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(718135354.00000 AS Numeric(28, 5)))
   ,(N'1993', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(724625011.00000 AS Numeric(28, 5)))
   ,(N'1994', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(731010531.00000 AS Numeric(28, 5)))
   ,(N'1995', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(737610637.00000 AS Numeric(28, 5)))
   ,(N'1996', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(743626180.00000 AS Numeric(28, 5)))
   ,(N'1997', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(750035865.00000 AS Numeric(28, 5)))
   ,(N'1998', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(756501774.00000 AS Numeric(28, 5)))
   ,(N'1999', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(762994895.00000 AS Numeric(28, 5)))
   ,(N'2000', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(769280735.00000 AS Numeric(28, 5)))
   ,(N'2001', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(775734010.00000 AS Numeric(28, 5)))
   ,(N'2002', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(781929614.00000 AS Numeric(28, 5)))
   ,(N'2003', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(787981265.00000 AS Numeric(28, 5)))
   ,(N'2004', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(794154728.00000 AS Numeric(28, 5)))
   ,(N'2005', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(800452815.00000 AS Numeric(28, 5)))
   ,(N'2006', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(806143030.00000 AS Numeric(28, 5)))
   ,(N'2007', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(812068775.00000 AS Numeric(28, 5)))
   ,(N'2008', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(818259141.00000 AS Numeric(28, 5)))
   ,(N'2009', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(823640516.00000 AS Numeric(28, 5)))
   ,(N'2010', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(828163815.00000 AS Numeric(28, 5)))
   ,(N'2011', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(831808665.00000 AS Numeric(28, 5)))
   ,(N'2012', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(834040711.00000 AS Numeric(28, 5)))
   ,(N'2013', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(838001657.00000 AS Numeric(28, 5)))
   ,(N'2014', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(839841132.00000 AS Numeric(28, 5)))
   ,(N'2015', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(842037691.00000 AS Numeric(28, 5)))
   ,(N'2016', N'OECD members', N'OED', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(788769132.00000 AS Numeric(28, 5)))
   ,(N'1961', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(801090187.00000 AS Numeric(28, 5)))
   ,(N'1962', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(812036978.00000 AS Numeric(28, 5)))
   ,(N'1963', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(822947943.00000 AS Numeric(28, 5)))
   ,(N'1964', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(833822590.00000 AS Numeric(28, 5)))
   ,(N'1965', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(844353927.00000 AS Numeric(28, 5)))
   ,(N'1966', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(854361513.00000 AS Numeric(28, 5)))
   ,(N'1967', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(863967355.00000 AS Numeric(28, 5)))
   ,(N'1968', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(872669960.00000 AS Numeric(28, 5)))
   ,(N'1969', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(883173471.00000 AS Numeric(28, 5)))
   ,(N'1970', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(892733697.00000 AS Numeric(28, 5)))
   ,(N'1971', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(902969602.00000 AS Numeric(28, 5)))
   ,(N'1972', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(913403656.00000 AS Numeric(28, 5)))
   ,(N'1973', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(922970157.00000 AS Numeric(28, 5)))
   ,(N'1974', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(933599688.00000 AS Numeric(28, 5)))
   ,(N'1975', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(943730729.00000 AS Numeric(28, 5)))
   ,(N'1976', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(952373274.00000 AS Numeric(28, 5)))
   ,(N'1977', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(961212179.00000 AS Numeric(28, 5)))
   ,(N'1978', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(970130430.00000 AS Numeric(28, 5)))
   ,(N'1979', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(979028644.00000 AS Numeric(28, 5)))
   ,(N'1980', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(987744287.00000 AS Numeric(28, 5)))
   ,(N'1981', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(996444161.00000 AS Numeric(28, 5)))
   ,(N'1982', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1004665082.00000 AS Numeric(28, 5)))
   ,(N'1983', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1012545345.00000 AS Numeric(28, 5)))
   ,(N'1984', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1020094013.00000 AS Numeric(28, 5)))
   ,(N'1985', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1027722831.00000 AS Numeric(28, 5)))
   ,(N'1986', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1035667260.00000 AS Numeric(28, 5)))
   ,(N'1987', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1043569333.00000 AS Numeric(28, 5)))
   ,(N'1988', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1051621117.00000 AS Numeric(28, 5)))
   ,(N'1989', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1060182358.00000 AS Numeric(28, 5)))
   ,(N'1990', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1069301886.00000 AS Numeric(28, 5)))
   ,(N'1991', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1078982212.00000 AS Numeric(28, 5)))
   ,(N'1992', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1088746944.00000 AS Numeric(28, 5)))
   ,(N'1993', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1098049603.00000 AS Numeric(28, 5)))
   ,(N'1994', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1106887160.00000 AS Numeric(28, 5)))
   ,(N'1995', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1115578052.00000 AS Numeric(28, 5)))
   ,(N'1996', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1124092178.00000 AS Numeric(28, 5)))
   ,(N'1997', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1132598216.00000 AS Numeric(28, 5)))
   ,(N'1998', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1140821718.00000 AS Numeric(28, 5)))
   ,(N'1999', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1149093535.00000 AS Numeric(28, 5)))
   ,(N'2000', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1157260608.00000 AS Numeric(28, 5)))
   ,(N'2001', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1165754980.00000 AS Numeric(28, 5)))
   ,(N'2002', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1174149916.00000 AS Numeric(28, 5)))
   ,(N'2003', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1182447832.00000 AS Numeric(28, 5)))
   ,(N'2004', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1190808908.00000 AS Numeric(28, 5)))
   ,(N'2005', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1199201044.00000 AS Numeric(28, 5)))
   ,(N'2006', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1207946461.00000 AS Numeric(28, 5)))
   ,(N'2007', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1216989289.00000 AS Numeric(28, 5)))
   ,(N'2008', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1226520017.00000 AS Numeric(28, 5)))
   ,(N'2009', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1235310457.00000 AS Numeric(28, 5)))
   ,(N'2010', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1243550244.00000 AS Numeric(28, 5)))
   ,(N'2011', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1251605332.00000 AS Numeric(28, 5)))
   ,(N'2012', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1258042183.00000 AS Numeric(28, 5)))
   ,(N'2013', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1267816127.00000 AS Numeric(28, 5)))
   ,(N'2014', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1274981875.00000 AS Numeric(28, 5)))
   ,(N'2015', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(1282975040.00000 AS Numeric(28, 5)))
   ,(N'2016', N'OECD members', N'OED', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294453.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(299133.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304661.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(310810.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317347.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324199.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330792.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338050.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346116.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355273.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(365748.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379077.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(394155.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(411133.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(430052.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450906.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(477671.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506180.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(536503.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(568709.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(602514.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(635516.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(670944.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(707496.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(743699.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(778992.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(811170.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(841607.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(872603.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(908035.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(950743.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1011546.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1080233.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1151988.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1219043.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1275445.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1300199.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1315062.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1323915.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1334233.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1352216.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1382690.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1426987.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1480378.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1535575.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1588626.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1669331.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1740246.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1817431.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1925917.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2082044.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2332161.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2633711.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2950671.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3234621.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3453143.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Oman', N'OMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(551737.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(564895.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(578825.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(593504.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(608889.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(625007.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(642005.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(660117.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(679593.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(700729.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(723850.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(748971.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(776379.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(806989.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(841947.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(882044.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(927439.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(977806.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1032799.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1091855.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1154375.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1220548.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1290007.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1360921.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1430926.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1498416.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1561493.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1620573.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1679089.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1741965.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1812159.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1892345.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(1979914.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2066264.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2139539.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2191864.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2219768.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2227596.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2224922.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2225481.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2239403.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2272547.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2323203.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2385075.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2448194.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2506891.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2553376.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2593750.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2652281.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2762073.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(2943747.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(3210003.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(3545192.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(3906912.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(4236057.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(4490541.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Oman', N'OMN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5205647.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5274844.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5352374.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5438853.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5536210.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5642972.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5737237.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5841146.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5955375.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6076042.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6201847.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6329755.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6463855.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6602677.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6747579.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6900618.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7040232.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7189740.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7347362.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7515323.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7693936.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7877320.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8073923.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8278054.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8491141.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8717784.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8943611.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9185546.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9435930.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9685632.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9926150.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10140855.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10341052.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10534695.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10739232.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10957260.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11159030.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11381899.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11623410.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11884694.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12167165.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12449969.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12734899.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13037430.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13376074.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13759859.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14250716.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14795784.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15364314.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15904065.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16404914.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16824641.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17195084.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17536861.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17866340.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18197921.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Other small states', N'OSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(9190554.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(9359115.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(9530669.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(9705396.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(9886197.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(10071866.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(10260416.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(10452463.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(10653156.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(10861518.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(11078167.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(11306275.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(11541593.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(11781479.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(12025293.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(12275209.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(12526930.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(12783508.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(13047655.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(13328816.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(13628840.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(13945999.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(14283059.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(14632383.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(14996144.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(15381431.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(15786818.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(16207189.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(16633611.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(17051830.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(17443575.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(17821355.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(18164444.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(18484577.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(18804340.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(19130028.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(19462187.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(19801297.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(20150470.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(20515051.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(20898841.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(21267515.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(21630779.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(22012962.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(22437930.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(22912669.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(23463471.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(24080704.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(24732235.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(25360267.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(25965594.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(26564437.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(27109032.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(27632006.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(28142985.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(28650005.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Other small states', N'OSS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25377854.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25878974.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26453097.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27068280.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27684851.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28287711.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28834393.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29381765.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29946707.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30562623.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31249764.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31936241.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32704835.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33554465.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34476670.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35467709.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36520547.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37656989.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38875760.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40178308.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41562353.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42965240.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44469459.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46049469.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47672362.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49316551.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50826154.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52347929.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53889257.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55475195.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57122962.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58576442.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60142098.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61804972.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63539096.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65340985.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67259703.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69230360.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71278646.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73452581.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75771077.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78044266.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80496233.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83076771.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85688758.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88274981.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90863785.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93356766.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95817272.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98350033.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100999594.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103474128.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106127705.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108880010.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111618980.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114295357.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pakistan', N'PAK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(44911810.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(45988447.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(47122931.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(48312888.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(49555472.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(50848775.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(52194629.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(53594445.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(55045897.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(56545924.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(58094239.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(59690467.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(61341255.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(63062204.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(64873705.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(66791496.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(68818471.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(70953777.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(73204087.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(75575981.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(78071984.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(80691701.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(83427522.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(86264621.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(89183159.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(92165065.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(95207133.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(98301647.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(101420791.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(104530689.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(107607639.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(110634399.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(113616165.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(116579605.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(119564925.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(122599749.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(125697651.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(128845692.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(132013680.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(135158132.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(138250487.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(141282077.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(144271586.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(147251530.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(150267989.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(153356383.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(156524189.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(159767672.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(163096985.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(166520983.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(170043918.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(173669648.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(177392252.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(181192646.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(185044286.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(188924874.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pakistan', N'PAK', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(595054.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(610849.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(627596.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(645254.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(663819.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(683323.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(702770.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(723372.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(745133.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(768053.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(792154.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(816870.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(842768.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(869844.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(898149.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(927690.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(957150.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(988138.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1020385.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1053537.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1087423.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1122078.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1157322.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1193280.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1230178.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1268058.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1306442.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1345599.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1385468.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1425962.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1467018.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1507882.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1549836.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1592534.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1635423.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1678178.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1721663.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1764393.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1806813.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1849835.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1893879.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1935837.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1980004.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2025402.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2070430.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2114357.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2159587.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2202782.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2245120.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2288472.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2333596.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2377476.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2423481.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2470560.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2517013.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2561924.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Panama', N'PAN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1132924.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1167041.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1202372.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1238824.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1276274.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1314627.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1353805.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1393800.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1434660.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1476478.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1519293.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1563113.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1607835.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1653257.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1699114.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1745207.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1791459.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1837887.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1884512.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1931393.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(1978575.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2026057.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2073826.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2121921.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2170390.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2219276.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2268619.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2318444.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2368772.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2419618.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2471010.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2522901.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2575330.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2628511.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2682720.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2738125.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2794845.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2852739.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2911383.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(2970193.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3028751.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3086887.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3144728.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3202511.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3260611.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3319301.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3378600.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3438398.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3498679.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3559401.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3620506.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3681979.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3743761.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3805683.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3867535.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(3929141.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Panama', N'PAN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5323601.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5445444.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5575311.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5714756.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5867007.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6033492.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6188369.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6362271.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6551206.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6750023.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6956395.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7153325.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7361184.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7580486.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7812461.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8057549.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8297507.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8548576.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8811771.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9089709.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9383337.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9660035.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9961415.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10279852.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10603716.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10927028.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11250346.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11566037.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11881023.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12207630.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12551053.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12873578.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13216709.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13570774.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13920657.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14258307.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14568270.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14867367.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15159093.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15450431.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15746117.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16050955.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16354947.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16662596.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16976621.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17296053.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17612653.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17938389.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18270106.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18601616.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18928390.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19248267.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19562565.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19871522.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20177917.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2015', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20482451.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Peru', N'PER', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(10061519.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(10350239.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(10650672.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(10961539.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(11281015.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(11607684.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(11941327.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(12282081.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(12629333.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(12982444.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(13341071.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(13704333.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(14072476.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(14447649.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(14832839.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(15229951.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(15639898.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(16061327.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(16491087.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(16924758.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(17359118.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(17792551.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(18225727.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(18660443.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(19099575.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(19544950.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(19996250.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(20451712.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(20909897.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(21368856.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(21826658.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(22283130.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(22737056.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(23184222.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(23619358.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(24038761.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(24441076.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(24827409.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(25199744.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(25561297.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(25914875.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(26261363.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(26601463.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(26937737.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(27273188.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(27610406.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(27949958.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(28292768.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(28642048.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(29001563.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(29373644.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(29759891.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(30158768.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(30565461.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(30973148.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(31376670.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Peru', N'PER', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13107635.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13528226.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13930861.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14339702.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14793610.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15310193.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15812391.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16376546.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16989294.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17623653.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18265289.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18905020.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19559730.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20230618.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20923320.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21640531.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22351904.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23083184.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23838597.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24623485.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25440727.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26260267.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27121486.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28016265.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28932250.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29862323.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30780153.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31707375.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32651317.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33626424.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34640239.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35628357.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36664717.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37736483.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38822708.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39913348.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40992982.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42065644.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43148424.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44262659.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45414280.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46549893.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47715438.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48889867.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50058927.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51235111.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52466236.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53719403.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55050075.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56461696.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57903647.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59094349.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60317209.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61536249.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62734852.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63915738.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Philippines', N'PHL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(26273023.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(27164618.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(28081234.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(29016770.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(29962877.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(30913931.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(31867565.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(32826602.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(33797041.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(34787588.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(35804731.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(36851055.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(37925400.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(39026082.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(40149959.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(41295129.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(42461189.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(43650333.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(44866279.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(46113992.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(47396966.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(48715592.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(50068493.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(51455037.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(52873979.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(54323651.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(55803915.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(57312794.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(58844392.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(60391168.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(61947340.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(63509940.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(65078901.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(66654954.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(68240134.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(69835713.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(71437381.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(73042605.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(74656228.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(76285225.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(77932247.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(79604541.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(81294378.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(82971734.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(84596249.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(86141373.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(87592899.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(88965508.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(90297115.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(91641881.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(93038902.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(94501233.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(96017322.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(97571676.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(99138690.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(100699395.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Philippines', N'PHL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Palau', N'PLW', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(9638.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(9901.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(10150.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(10381.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(10593.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(10782.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(10945.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11081.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11206.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11335.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11481.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11656.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(11853.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12045.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12195.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12280.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12284.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12225.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12151.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12127.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12197.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12383.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(12667.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(13015.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(13371.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(13698.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(13982.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(14237.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(14485.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(14762.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(15089.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(15471.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(15894.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(16345.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(16805.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(17255.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(17695.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(18123.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(18524.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(18878.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19174.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19404.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19575.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19700.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19805.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(19907.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20012.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20118.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20227.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20344.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20470.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20606.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20756.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(20919.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(21097.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(21291.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Palau', N'PLW', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1087485.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1102374.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1118243.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1135816.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1156243.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1180058.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1202639.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1229021.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1258540.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1289856.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1322130.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1353240.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1384477.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1416494.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1450852.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1488416.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1520016.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1558199.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1600981.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1645432.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1690441.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1739990.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1788324.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1837855.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1892549.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1954177.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2014183.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2081890.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2155285.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2230459.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2305265.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2378997.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2451809.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2524848.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2600298.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2679082.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2754169.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2832785.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2913981.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2996523.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3079945.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3158121.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3239596.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3323933.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3410838.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3500467.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3592212.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3685518.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3781723.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3882810.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3989557.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4094443.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4205773.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4322066.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4440651.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4560020.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Papua New Guinea', N'PNG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(1966957.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2001048.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2037165.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2075630.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2116832.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2161103.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2208422.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2258877.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2313017.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2371515.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2434755.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2503074.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2576093.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2652586.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2730859.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2809692.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2888509.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(2967620.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3047769.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3130125.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3215483.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3304188.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3395798.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3489402.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3583707.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3677854.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3771578.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3865402.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(3960243.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4057406.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4157903.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4261933.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4369407.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4480689.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4596131.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4715929.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4840311.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(4969116.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5101633.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5236863.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5374051.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5512835.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5653284.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5795571.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(5940048.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6086905.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6236158.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6387470.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6540267.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6693799.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(6847517.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(7001172.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(7154870.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(7308864.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(7463577.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(7619321.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Papua New Guinea', N'PNG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17963128.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18094472.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18319571.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18647769.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19022048.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19331564.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19668954.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20030808.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20391093.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20736654.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21015148.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21243607.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21591753.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21959703.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22308389.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22616008.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22843769.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23030368.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23150775.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23267687.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23422876.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23589650.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23768434.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23954190.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24129527.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24279249.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24356422.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24428914.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24492521.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24567474.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24671304.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24806744.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24930311.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25056061.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25209962.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25394914.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25537940.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25736576.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25966958.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26190575.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26125592.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26314690.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26471860.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26604130.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26738186.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26882230.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26998158.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27105617.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27208939.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27287401.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27219097.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27132410.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27013527.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26850269.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26645616.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26417399.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Poland', N'POL', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(29637450.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(29964000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(30308500.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(30712000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(31139450.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(31444950.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(31681000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(31987155.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(32294655.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(32548300.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(32664300.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(32783500.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(33055650.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(33357200.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(33678899.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(34015199.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(34356300.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(34689050.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(34965600.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(35247217.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(35574150.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(35898587.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(36230481.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(36571808.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(36904134.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37201885.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37456119.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37668045.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37824487.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37961529.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38110782.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38246193.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38363667.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38461408.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38542652.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38594998.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38624370.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38649660.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38663481.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38660271.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38258629.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38248076.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38230364.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38204570.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38182222.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38165445.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38141267.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38120560.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38125759.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38151603.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38042794.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38063255.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38063164.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38040196.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(38011735.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(37999494.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Poland', N'POL', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102391021.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104199782.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106209018.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108416651.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110837561.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113476388.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115722791.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118275777.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121085649.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124093155.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127266866.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129974483.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132923263.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136132085.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139636486.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143452960.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147045205.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151034289.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155312441.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159760256.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164311129.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168064362.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172010386.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176180933.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180623836.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(185382667.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189788717.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194607980.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199880256.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(205657015.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211954068.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(218263482.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225234076.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232693403.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240428485.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(248315241.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(255358396.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262609711.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(270158776.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(278126256.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286577442.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294703540.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(303439010.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(312689658.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322345372.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332339195.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341803410.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351758184.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362211864.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373198390.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384747753.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(396397380.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(408721286.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(421686765.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435245192.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(449364076.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pre-demographic dividend', N'PRE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(188373482.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(192672273.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(197156196.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(201836017.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(206723945.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(211829507.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(217167605.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(222741879.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(228537586.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(234532020.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(240714208.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(247059252.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(253585295.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(260374328.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(267537392.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(275143854.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(283246998.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(291797523.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(300637943.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(309548454.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(318378349.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(327083338.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(335735167.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(344444016.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(353373959.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(362656276.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(372296266.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(382288800.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(392740587.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(403778747.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(415481032.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(427933883.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(441088911.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(454723399.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(468524311.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(482278474.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(495900493.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(509493025.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(523261490.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(537505596.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(552445596.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(568156237.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(584583809.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(601666093.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(619292053.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(637375179.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(655915560.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(674958034.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(694563093.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(714815271.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(735769429.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(757484446.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(779862983.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(802855752.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(826352062.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(850271023.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pre-demographic dividend', N'PRE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1229645.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1274108.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1321373.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1367402.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1408482.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1444093.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1462546.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1481065.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1499980.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1521813.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1548478.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1593149.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1644698.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1699101.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1751644.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1799781.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1833867.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1862549.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1888679.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1914581.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1940995.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1968658.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1995841.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2023976.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2053661.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2084849.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2115133.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2145493.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2175510.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2204408.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2231850.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2257435.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2280771.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2307812.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2337002.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2366735.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2398167.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2427002.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2448754.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2468554.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2481506.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2490794.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2497458.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2502481.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2507396.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2509339.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2503894.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2494977.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2487337.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2481478.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2476055.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2449112.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2420369.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2393317.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2355331.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2315747.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Puerto Rico', N'PRI', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2358000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2399722.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2450322.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2504530.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2554066.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2594000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2624995.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2645674.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2662064.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2684150.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2718000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2762190.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2817256.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2878786.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2939299.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(2994000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3043854.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3088690.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3129421.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3168088.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3206000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3242552.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3277453.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3311138.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3344190.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3377000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3409554.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3441850.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3473898.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3505650.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3537000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3562110.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3585176.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3615497.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3649237.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3683103.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3724655.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3759430.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3781101.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3800081.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3810605.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3818774.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3823701.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3826095.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3826878.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3821362.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3805214.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3782995.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3760866.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3740410.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3721526.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3678736.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3634487.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3593079.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3534888.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(3474182.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Puerto Rico', N'PRI', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6746979.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6816068.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6998574.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7235407.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7429374.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7535736.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7729538.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7776896.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7759395.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7802602.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7959442.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8082592.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8343643.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8685033.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9012583.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9280551.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9538226.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9757794.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9960633.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10184650.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10448183.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10811148.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11146530.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11478570.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11837629.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12231504.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12512933.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12879410.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13279477.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13634390.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13907749.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14186248.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14368624.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14487624.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14607157.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14758094.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14882043.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15040734.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15222075.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15395237.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15545308.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15683378.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15803779.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15914025.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16029141.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16155588.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16265509.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16391664.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16529148.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16666258.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16796653.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16923142.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17032807.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17140602.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17270138.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17430908.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Korea, Dem. People''s Rep.', N'PRK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(11424179.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(11665593.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(11871720.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(12065470.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(12282421.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(12547524.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(12864683.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(13221826.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(13608611.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(14009168.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(14410400.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(14812363.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(15214615.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(15603001.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(15960127.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(16274740.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(16539029.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(16758826.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(16953621.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(17151321.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(17372167.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(17623335.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(17899236.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(18191881.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(18487997.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(18778101.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(19058988.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(19334550.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(19610512.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(19895390.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(20194354.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(20510208.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(20838082.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(21166230.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(21478544.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(21763670.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(22016510.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(22240826.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(22444986.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(22641747.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(22840218.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23043441.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23248053.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23449173.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23639296.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23813324.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(23969897.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24111945.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24243829.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24371806.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24500506.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24631359.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24763353.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(24895705.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(25026772.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(25155317.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Korea, Dem. People''s Rep.', N'PRK', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5563450.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5602994.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5636712.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5650311.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5642188.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5608348.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5539660.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5488841.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5458156.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5404384.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5348483.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5340311.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5340493.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5346144.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5426442.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5646810.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5809921.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5881047.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5960702.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6043851.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6130392.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6212004.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6278763.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6336640.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6390588.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6439453.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6472070.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6500521.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6527874.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6554281.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6574674.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6593182.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6619018.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6654580.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6696868.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6741842.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6779003.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6821880.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6868068.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6914928.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6966083.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7014579.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7047147.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7063620.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7070521.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7077124.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7058330.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7046388.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7035947.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7024098.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7007782.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6976841.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6926501.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6864564.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6802401.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6742683.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Portugal', N'PRT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8857716.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8929316.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8993985.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9030355.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9035365.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8998595.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8930990.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8874520.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8836650.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8757705.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8680431.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8643756.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8630430.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8633100.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(8754365.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9093470.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9355810.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9455675.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9558250.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9661265.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9766312.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9851362.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9911771.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9957865.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9996232.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10023613.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10032734.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10030031.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10019610.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10005000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9983218.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9960235.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9952494.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9964675.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(9991525.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10026176.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10063945.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10108977.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10160196.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10217828.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10289898.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10362722.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10419631.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10458821.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10483861.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10503330.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10522288.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10542964.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10558177.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10568247.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10573100.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10557560.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10514844.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10457295.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10401062.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(10348648.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Portugal', N'PRT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(930414.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(957044.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(983065.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1009165.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1036479.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1065711.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1099425.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1135027.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1171837.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1209094.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1246648.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1287113.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1328995.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1371823.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1414946.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1458252.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1508325.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1556571.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1604528.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1654450.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1707382.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1761767.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1820429.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1881651.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1942905.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1985', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2003016.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2061462.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2120358.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2179800.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2240492.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2303032.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2365579.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2429568.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2495887.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2565511.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2638874.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2713728.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2791513.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2872028.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2955075.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3040400.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3123312.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3210262.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3299159.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3386682.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3470883.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3552809.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3627753.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3698943.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3771425.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3847700.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3922739.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4003290.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4086046.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4165516.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4238795.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Paraguay', N'PRY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(1902871.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(1953331.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2005337.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2058916.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2114095.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2170853.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2229373.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2289579.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2350900.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2412565.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2474102.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2535355.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2596741.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2659084.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2723523.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2790964.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2861582.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(2935375.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3012833.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3094479.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3180628.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3271454.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3366726.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3465796.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3567750.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3671826.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3777764.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3885433.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(3994328.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4103909.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4213740.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4323402.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4432738.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4541902.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4651222.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4760853.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4870695.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(4980346.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5089306.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5196935.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5302703.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5406625.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5508615.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5607948.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5703742.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5795493.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5882797.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(5966160.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6047131.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6127847.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6209877.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6293763.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6379162.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6465669.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6552518.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(6639123.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Paraguay', N'PRY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(420027.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(432980.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(446906.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(461570.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(476873.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(492847.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508114.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(524110.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540903.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(558402.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(576434.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(591780.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607199.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(622970.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(639396.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(656605.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(672935.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(689838.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(707419.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(725689.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(744580.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(763057.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(782426.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(801481.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(819123.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(835048.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(849215.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(861662.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(873582.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(886441.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(901122.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(918112.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(936782.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(957006.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(978235.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(999681.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1017305.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1035441.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1053513.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1070912.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1087637.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1109425.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1129632.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1149189.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1169203.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1190096.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1208086.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1227034.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1246772.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1267172.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1288073.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1304700.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1323098.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1342256.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1361041.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1379115.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pacific island small states', N'PSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(865811.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(894211.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(924223.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(955109.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(985870.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1015764.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1044558.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1072397.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1099414.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1125883.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1152035.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1177886.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1203422.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1228877.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1254520.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1280578.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1306944.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1333634.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1361129.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1390041.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1420689.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1453544.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1488194.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1523013.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1555790.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1585032.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1609921.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1631177.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1650666.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1671112.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1694417.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1721249.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1750857.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1781989.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1812753.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1841772.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1868807.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1894309.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1918419.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1941464.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1963761.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(1985179.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2005803.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2026433.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2048118.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2071588.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2097182.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2124650.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2153399.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2182547.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2211421.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2239849.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2267982.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2295834.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2323513.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(2351091.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Pacific island small states', N'PSS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(475396884.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(481636907.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(487596723.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493898482.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500234703.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506393962.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(511743072.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(516985652.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(521737369.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(527733390.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(533155054.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(539470472.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(545661369.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(551265459.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(557895181.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(564656983.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569655515.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(575418304.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(581771217.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(588524155.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(595269057.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(602387825.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(609147172.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(615510162.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(621411409.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(626968278.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(631536521.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(636068841.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(640591353.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(645176801.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(649645463.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(653673251.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(657790056.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(661680989.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(665279673.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(669113001.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(672508845.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(676400335.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(680347279.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684338067.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(688228308.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(692027979.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(695489543.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(698844386.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(702479851.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(706268142.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(709323754.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(712595623.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(716215803.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(718890963.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(720775101.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721579133.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721170000.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(722479485.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721694637.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(721282154.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Post-demographic dividend', N'PST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(754697140.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(765509490.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(774963142.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(784266930.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(793397728.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(802226258.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(810468063.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(818152203.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(824870118.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(833295508.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(840831632.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(848920841.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(856920648.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(863925539.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(871925569.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(879414142.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(885318037.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(891425425.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(897666639.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(904016300.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(910028235.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(916137223.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(921626766.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(926705289.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(931491066.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(936326850.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(941590822.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(946943601.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(952502232.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(958485541.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(964659603.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(970950461.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(977709589.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(984175293.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(989788286.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(995113407.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1000255943.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1005399457.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1010195262.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1015143403.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1020294075.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1025559136.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1030738658.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1035926661.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1041323104.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1046651906.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1052284984.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1058116566.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1064539739.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1070040846.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1075073808.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1079590396.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1082692198.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1089081466.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1092938826.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(1097737383.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Post-demographic dividend', N'PST', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42194.00000 AS Numeric(28, 5)))
   ,(N'1961', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43482.00000 AS Numeric(28, 5)))
   ,(N'1962', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44552.00000 AS Numeric(28, 5)))
   ,(N'1963', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45505.00000 AS Numeric(28, 5)))
   ,(N'1964', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46580.00000 AS Numeric(28, 5)))
   ,(N'1965', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47924.00000 AS Numeric(28, 5)))
   ,(N'1966', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49599.00000 AS Numeric(28, 5)))
   ,(N'1967', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51389.00000 AS Numeric(28, 5)))
   ,(N'1968', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53215.00000 AS Numeric(28, 5)))
   ,(N'1969', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55057.00000 AS Numeric(28, 5)))
   ,(N'1970', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56985.00000 AS Numeric(28, 5)))
   ,(N'1971', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59214.00000 AS Numeric(28, 5)))
   ,(N'1972', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61879.00000 AS Numeric(28, 5)))
   ,(N'1973', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64802.00000 AS Numeric(28, 5)))
   ,(N'1974', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67771.00000 AS Numeric(28, 5)))
   ,(N'1975', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70677.00000 AS Numeric(28, 5)))
   ,(N'1976', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73764.00000 AS Numeric(28, 5)))
   ,(N'1977', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76651.00000 AS Numeric(28, 5)))
   ,(N'1978', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79508.00000 AS Numeric(28, 5)))
   ,(N'1979', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82618.00000 AS Numeric(28, 5)))
   ,(N'1980', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86140.00000 AS Numeric(28, 5)))
   ,(N'1981', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89573.00000 AS Numeric(28, 5)))
   ,(N'1982', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93496.00000 AS Numeric(28, 5)))
   ,(N'1983', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97819.00000 AS Numeric(28, 5)))
   ,(N'1984', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102216.00000 AS Numeric(28, 5)))
   ,(N'1985', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106399.00000 AS Numeric(28, 5)))
   ,(N'1986', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109906.00000 AS Numeric(28, 5)))
   ,(N'1987', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113056.00000 AS Numeric(28, 5)))
   ,(N'1988', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115855.00000 AS Numeric(28, 5)))
   ,(N'1989', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118475.00000 AS Numeric(28, 5)))
   ,(N'1990', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121085.00000 AS Numeric(28, 5)))
   ,(N'1991', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123262.00000 AS Numeric(28, 5)))
   ,(N'1992', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125643.00000 AS Numeric(28, 5)))
   ,(N'1993', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128205.00000 AS Numeric(28, 5)))
   ,(N'1994', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130865.00000 AS Numeric(28, 5)))
   ,(N'1995', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133652.00000 AS Numeric(28, 5)))
   ,(N'1996', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137156.00000 AS Numeric(28, 5)))
   ,(N'1997', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140535.00000 AS Numeric(28, 5)))
   ,(N'1998', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143980.00000 AS Numeric(28, 5)))
   ,(N'1999', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147709.00000 AS Numeric(28, 5)))
   ,(N'2000', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151739.00000 AS Numeric(28, 5)))
   ,(N'2001', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155553.00000 AS Numeric(28, 5)))
   ,(N'2002', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159647.00000 AS Numeric(28, 5)))
   ,(N'2003', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(163803.00000 AS Numeric(28, 5)))
   ,(N'2004', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167729.00000 AS Numeric(28, 5)))
   ,(N'2005', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(171344.00000 AS Numeric(28, 5)))
   ,(N'2006', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174371.00000 AS Numeric(28, 5)))
   ,(N'2007', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177460.00000 AS Numeric(28, 5)))
   ,(N'2008', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180599.00000 AS Numeric(28, 5)))
   ,(N'2009', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183604.00000 AS Numeric(28, 5)))
   ,(N'2010', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186282.00000 AS Numeric(28, 5)))
   ,(N'2011', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189877.00000 AS Numeric(28, 5)))
   ,(N'2012', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192414.00000 AS Numeric(28, 5)))
   ,(N'2013', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194352.00000 AS Numeric(28, 5)))
   ,(N'2014', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(196386.00000 AS Numeric(28, 5)))
   ,(N'2015', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198808.00000 AS Numeric(28, 5)))
   ,(N'2016', N'French Polynesia', N'PYF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(78083.00000 AS Numeric(28, 5)))
   ,(N'1961', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(80706.00000 AS Numeric(28, 5)))
   ,(N'1962', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(83654.00000 AS Numeric(28, 5)))
   ,(N'1963', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(86839.00000 AS Numeric(28, 5)))
   ,(N'1964', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(90132.00000 AS Numeric(28, 5)))
   ,(N'1965', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(93440.00000 AS Numeric(28, 5)))
   ,(N'1966', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(96730.00000 AS Numeric(28, 5)))
   ,(N'1967', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(100031.00000 AS Numeric(28, 5)))
   ,(N'1968', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(103385.00000 AS Numeric(28, 5)))
   ,(N'1969', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(106858.00000 AS Numeric(28, 5)))
   ,(N'1970', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(110496.00000 AS Numeric(28, 5)))
   ,(N'1971', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(114311.00000 AS Numeric(28, 5)))
   ,(N'1972', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(118279.00000 AS Numeric(28, 5)))
   ,(N'1973', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(122355.00000 AS Numeric(28, 5)))
   ,(N'1974', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(126483.00000 AS Numeric(28, 5)))
   ,(N'1975', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(130619.00000 AS Numeric(28, 5)))
   ,(N'1976', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(134743.00000 AS Numeric(28, 5)))
   ,(N'1977', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(138867.00000 AS Numeric(28, 5)))
   ,(N'1978', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(143033.00000 AS Numeric(28, 5)))
   ,(N'1979', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(147299.00000 AS Numeric(28, 5)))
   ,(N'1980', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(151702.00000 AS Numeric(28, 5)))
   ,(N'1981', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(156240.00000 AS Numeric(28, 5)))
   ,(N'1982', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(160883.00000 AS Numeric(28, 5)))
   ,(N'1983', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(165611.00000 AS Numeric(28, 5)))
   ,(N'1984', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(170397.00000 AS Numeric(28, 5)))
   ,(N'1985', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(175208.00000 AS Numeric(28, 5)))
   ,(N'1986', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(180069.00000 AS Numeric(28, 5)))
   ,(N'1987', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(184958.00000 AS Numeric(28, 5)))
   ,(N'1988', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(189742.00000 AS Numeric(28, 5)))
   ,(N'1989', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(194249.00000 AS Numeric(28, 5)))
   ,(N'1990', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(198370.00000 AS Numeric(28, 5)))
   ,(N'1991', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(202020.00000 AS Numeric(28, 5)))
   ,(N'1992', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(205269.00000 AS Numeric(28, 5)))
   ,(N'1993', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(208349.00000 AS Numeric(28, 5)))
   ,(N'1994', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(211584.00000 AS Numeric(28, 5)))
   ,(N'1995', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(215200.00000 AS Numeric(28, 5)))
   ,(N'1996', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(219282.00000 AS Numeric(28, 5)))
   ,(N'1997', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(223734.00000 AS Numeric(28, 5)))
   ,(N'1998', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(228380.00000 AS Numeric(28, 5)))
   ,(N'1999', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(232956.00000 AS Numeric(28, 5)))
   ,(N'2000', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(237267.00000 AS Numeric(28, 5)))
   ,(N'2001', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(241276.00000 AS Numeric(28, 5)))
   ,(N'2002', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(245032.00000 AS Numeric(28, 5)))
   ,(N'2003', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(248536.00000 AS Numeric(28, 5)))
   ,(N'2004', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(251811.00000 AS Numeric(28, 5)))
   ,(N'2005', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(254884.00000 AS Numeric(28, 5)))
   ,(N'2006', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(257731.00000 AS Numeric(28, 5)))
   ,(N'2007', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(260361.00000 AS Numeric(28, 5)))
   ,(N'2008', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(262877.00000 AS Numeric(28, 5)))
   ,(N'2009', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(265412.00000 AS Numeric(28, 5)))
   ,(N'2010', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(268065.00000 AS Numeric(28, 5)))
   ,(N'2011', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(270862.00000 AS Numeric(28, 5)))
   ,(N'2012', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(273775.00000 AS Numeric(28, 5)))
   ,(N'2013', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(276766.00000 AS Numeric(28, 5)))
   ,(N'2014', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(279781.00000 AS Numeric(28, 5)))
   ,(N'2015', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(282764.00000 AS Numeric(28, 5)))
   ,(N'2016', N'French Polynesia', N'PYF', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26389.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28874.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31894.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35366.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39163.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43178.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47342.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51770.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56526.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61783.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67672.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74255.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81985.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90370.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98663.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106323.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112559.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118171.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124374.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132900.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144850.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164271.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186858.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211290.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(235800.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(259008.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277141.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294834.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311054.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(324723.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(335425.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(344429.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(349828.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352973.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(356196.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361345.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(368093.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(379760.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(395158.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(412154.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(429655.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(450297.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(469990.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(498036.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(548155.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(629699.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(779801.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(962503.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1160141.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1348007.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1508583.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1618304.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1702715.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1765288.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1815511.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1861947.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Qatar', N'QAT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(47309.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(51355.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(56187.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(61647.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(67487.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(73543.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(79735.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(86161.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(93043.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(100697.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(109329.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(119246.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(130377.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(142111.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(153593.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(164333.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(173759.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(182370.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(192018.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(205244.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(223715.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(248053.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(277242.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(309276.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(341286.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(371071.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(398326.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(423327.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(445203.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(463062.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(476478.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(485114.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(489668.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(492120.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(495179.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(501019.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(511864.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(528213.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(548618.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(570643.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(593453.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(613720.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(634388.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(668165.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(732096.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(836924.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(988448.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(1178955.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(1388962.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(1591151.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(1765513.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(1905437.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(2015624.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(2101288.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(2172065.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(2235355.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Qatar', N'QAT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11835086.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11920617.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12024534.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12154818.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12286177.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12394150.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12584862.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12807188.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12964567.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13097689.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13282985.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13347879.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13486980.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13648141.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13781325.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13891039.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14012612.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14008861.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13963657.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13936508.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14015398.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14129175.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14299288.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14513236.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14709281.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14870507.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15015283.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15088211.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15139257.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15205967.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15277393.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15136410.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15057842.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15134654.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15203020.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15231437.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15265140.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15245439.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15211219.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15200700.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15228865.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15022671.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14792897.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14753333.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14732824.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14687917.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14615952.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14389971.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14120559.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13963183.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13836109.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13727039.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13627762.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13538088.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13437506.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13320508.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Romania', N'ROM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(18406905.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(18555250.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(18676550.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(18797850.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(18919126.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19031576.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19215450.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19534242.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19799831.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20009141.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20250398.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20461567.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20657957.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20835681.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21029429.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21293583.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21551634.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21756096.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21951464.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22090488.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22242653.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22415169.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22515389.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22588790.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22655940.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22755427.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22859269.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22949430.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(23057662.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(23161458.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(23201835.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(23001155.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22794284.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22763280.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22730211.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22684270.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22619004.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22553978.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22507344.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22472040.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22442971.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(22131970.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21730496.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21574326.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21451748.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21319685.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(21193760.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20882982.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20537875.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20367487.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20246871.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20147528.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(20058035.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19983693.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19908979.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(19832389.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Romania', N'ROM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76192721.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76591373.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77379936.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(78484477.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79720201.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80985942.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81951116.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82961450.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84008893.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85082659.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86155391.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87337812.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88398020.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89366037.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90286274.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91176222.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91808051.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92551236.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93337954.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94077169.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94738407.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95373152.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95848800.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96206151.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96713951.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97283342.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97637928.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98060510.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98495048.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98874951.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99047673.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98866590.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98635699.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98401455.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98343108.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98644140.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99236719.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99864253.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100551615.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101139124.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101611291.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101613437.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101583571.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101586674.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101698323.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101908867.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101951172.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102249160.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102623924.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102874625.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102883112.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102667489.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102297483.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101812708.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101275056.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100698078.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Russian Federation', N'RUS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(119897000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(121236000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(122591000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(123960000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(125345000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(126745000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(127468000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(128196000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(128928000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(129664000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(130404000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(131155000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(131909000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(132669000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(133432000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(134200000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(135147000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(136100000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(137060000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(138027000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(139010000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(139941000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(140823000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(141668000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142745000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143858000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(144894000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(145908000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(146857000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(147721000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148292000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148624000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148689000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148520000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148336000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148375726.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(148160042.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(147915307.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(147670692.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(147214392.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(146596557.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(145976083.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(145306046.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(144648257.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(144067054.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143518523.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143049528.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142805088.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142742350.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142785342.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142849449.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(142960868.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143201676.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143506911.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(143819569.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(144096812.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Russian Federation', N'RUS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1444879.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1456581.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1470936.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1489531.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1513781.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1545140.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1593762.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1650978.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1715108.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1784068.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1855933.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1916854.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1981067.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2048240.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2117942.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2190129.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2254931.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2323611.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2395977.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2472056.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2551774.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2618103.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2686994.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2762769.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2850396.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2951289.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3073851.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3212489.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3341555.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3435868.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3485938.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3420053.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3310416.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3203966.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3154597.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3193924.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3302774.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3496724.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3727626.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3952382.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4151771.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4341017.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4510956.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4668772.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4816418.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4957485.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5101914.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5235632.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5363568.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5499007.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5649323.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5796059.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5963159.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6145496.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6332692.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6519771.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Rwanda', N'RWA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(2933424.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(2996091.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3050596.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3102968.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3161719.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3232937.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3319077.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3418313.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3527260.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3640591.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3754546.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3868345.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(3983707.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4102336.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4226836.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4359166.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4499720.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4648070.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4804375.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(4968628.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5140786.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5313908.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5486431.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5669251.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5877556.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6117966.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6410594.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6742390.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7048075.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7239097.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7259740.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7071393.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6712924.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6300358.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5995987.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(5912755.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6097688.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(6506118.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7047196.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(7585143.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(8021875.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(8329113.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(8539029.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(8686469.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(8828956.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(9008230.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(9231041.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(9481083.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(9750314.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(10024594.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(10293669.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(10556429.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(10817350.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(11078095.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(11341544.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(11609666.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Rwanda', N'RWA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322950039.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327930080.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333026949.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338416298.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(344683960.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351893888.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(358662704.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366540554.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(375339250.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384697843.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(394457611.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403485871.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413057494.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423226370.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434008402.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445459335.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(456212164.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467830425.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480181009.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493089259.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506414059.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(518730894.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531661685.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(545111485.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(559142349.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(573778091.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(587290498.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(601733189.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(616953043.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(632776104.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(649123950.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(664848310.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(681217808.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(698248295.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715988692.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(734446809.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(752441120.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(771053711.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(790272496.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(810047292.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(830293034.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(849542158.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(869402856.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(889675662.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910098228.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(930516991.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(949874489.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(969200946.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(988589080.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1008257443.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028348229.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1048020904.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1068276622.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1088858960.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1109378713.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1129553683.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Asia', N'SAS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(572036107.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(584143236.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(596701125.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(609571502.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(623073110.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(636963781.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(651325994.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(666134328.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(681405837.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(697060567.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(713115397.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(729469562.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(746222138.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(763491289.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(781254784.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(799620311.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(818590962.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(838141522.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(858266916.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(878939779.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(900085240.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(921521635.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(943562470.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(966023576.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(988878603.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1012099768.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1035659508.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1059536231.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1083705645.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1108148042.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1132833314.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1157752321.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1182862267.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1208123497.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1233480616.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1258903823.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1284343918.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1309774343.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1335193652.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1360594891.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1385959570.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1411288216.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1436527869.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1461601023.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1486402311.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1510864613.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1534949611.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1558685624.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1582147481.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1605443788.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1628688562.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1651888921.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2012', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1675019307.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1698093032.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1721152580.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(1744161298.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Asia', N'SAS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2175411.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2238315.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2310426.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2389348.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2472131.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2557440.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2640963.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2730994.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2828654.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2935881.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3054460.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3191387.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3343839.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3513062.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3699899.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3903314.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4125182.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4366641.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4625811.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4903757.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5204006.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5588103.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5995929.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6421387.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6856720.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7292539.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7673181.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8046786.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8396030.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8716938.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9020819.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9298669.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9570236.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9851632.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10157480.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10493323.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10974593.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11447803.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11901166.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12342090.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12792312.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13313547.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13893491.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14513359.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15143656.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15762839.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16406866.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17020656.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17608094.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18186195.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18767675.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19370559.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19978407.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20569895.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21120397.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21622717.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Saudi Arabia', N'SAU', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4086539.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4218879.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4362863.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4516663.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4677409.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(4843635.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(5015672.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(5196349.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(5389848.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(5601649.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(5836394.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(6096106.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(6382106.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(6697486.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(7045477.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(7428705.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(7845300.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(8295384.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(8785326.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(9323290.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(9912917.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(10556936.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(11247085.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(11962244.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(12674089.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(13361284.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(14016569.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(14642354.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(15239174.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(15810980.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(16361453.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(16890555.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(17398523.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(17890529.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(18373412.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(18853670.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(19331311.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(19809633.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(20302193.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(20825955.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(21392273.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(22007937.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(22668102.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(23357887.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(24055573.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(24745230.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(25419994.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(26083522.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(26742842.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(27409491.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(28090647.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(28788438.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(29496047.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(30201051.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(30886545.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(31540372.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Saudi Arabia', N'SAU', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3905777.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4007419.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4117970.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4236702.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4362847.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4495985.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4620287.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4754510.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4897734.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5049006.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5207936.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5358221.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5519424.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5692131.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5877340.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6075715.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6273960.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6488890.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6719193.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6963824.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7222219.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7476991.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7751295.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8040500.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8339226.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8645593.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8931526.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9225965.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9545193.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9908309.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10324364.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10800878.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11335047.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11897594.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12453709.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12982162.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13407914.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13800838.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14178076.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14560518.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14963007.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15367991.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15793913.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16240103.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16707787.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17196805.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17669726.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18176376.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18707168.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19248214.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19792584.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20322368.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20853962.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21400066.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21978769.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22599407.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sudan', N'SDN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(7527450.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(7749884.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(7981797.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(8223613.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(8475765.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(8738703.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(9013112.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(9299545.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(9598196.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(9909152.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(10232758.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(10568788.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(10918137.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(11283574.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(11668674.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(12075841.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(12506035.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(12958110.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(13429688.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(13917268.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(14418063.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(14935471.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(15470415.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(16015120.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(16559205.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(17097619.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(17618852.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(18130501.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(18669146.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(19284633.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(20008804.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(20861117.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(21820588.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(22829227.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(23805536.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(24691970.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(25466387.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(26149124.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(26777059.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(27406808.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(28079664.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(28805142.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(29569978.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(30365586.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(31176209.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(31990003.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(32809056.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(33637960.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(34470138.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(35297298.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(36114885.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(36918193.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(37712420.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(38515095.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(39350274.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(40234882.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sudan', N'SDN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1714660.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1750135.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1787975.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1828994.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1875191.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1927814.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1974838.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2029802.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2091931.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2159875.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2232671.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2292742.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2359704.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2431182.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2504628.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2578349.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2618589.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2661657.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2708300.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2760130.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2818856.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2876442.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2944141.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3021126.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3106505.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3199710.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3293082.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3394944.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3505028.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3623472.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3750151.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3872614.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4005183.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4144781.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4287573.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4431596.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4555491.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4681444.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4812044.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4950528.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5098833.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5249880.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5411458.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5582220.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5760289.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5944240.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6117513.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6300009.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6491446.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6690994.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6898302.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7116669.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7340892.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7571785.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7812487.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8064565.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Senegal', N'SEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3177560.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3265558.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3356421.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3450418.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3547939.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3649308.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3754268.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3862783.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(3975614.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4093763.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4217754.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4348499.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4485342.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4625377.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4764623.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(4900491.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5031849.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5160313.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5289445.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5424299.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5568651.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5723541.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(5888261.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(6062682.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(6246140.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(6438024.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(6638186.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(6846556.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(7062540.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(7285378.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(7514201.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(7749559.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(7990736.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(8234147.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(8475136.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(8710746.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(8939438.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(9163184.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(9386923.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(9617641.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(9860578.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(10118078.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(10389457.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(10673320.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(10967016.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(11268994.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(11578430.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(11897230.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(12229703.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(12581624.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(12956791.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(13357003.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(13780108.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(14221041.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(14672557.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(15129273.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Senegal', N'SEN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(900764.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(917681.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(935043.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(956218.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(983034.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1012782.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1051550.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1089844.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1125390.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1161347.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1200638.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1244850.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1289475.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1335491.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1381153.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1426732.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1467272.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1513914.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1560581.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1606084.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1646918.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1748236.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1839463.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1870997.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1914162.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1926927.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1937318.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1983836.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2053618.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2129941.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2222719.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2284946.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2344531.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2389140.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2450543.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2516680.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2606710.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2691265.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2787557.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2815283.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2867860.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2962883.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3004354.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2971886.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3019076.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3098200.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3199762.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3341028.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3534511.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3658106.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3738837.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3816753.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3905355.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3958527.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3996609.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4028171.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Singapore', N'SGP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1646400.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1702400.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1750200.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1795000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1841600.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1886900.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1934400.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(1977600.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2012000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2042500.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2074500.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2112900.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2152400.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2193000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2229800.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2262600.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2293300.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2325300.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2353600.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2383500.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2413945.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2532835.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2646466.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2681061.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2732221.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2735957.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2733373.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2774789.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2846108.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(2930901.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3047132.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3135083.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3230698.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3313471.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3419048.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3524506.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3670704.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3796038.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3927213.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(3958723.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4027887.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4138012.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4175950.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4114826.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4166664.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4265762.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4401365.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4588599.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4839396.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(4987573.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5076732.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5183688.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5312437.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5399162.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5469724.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(5535002.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Singapore', N'SGP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64521.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66126.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67679.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69221.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70860.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72691.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74802.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77134.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79708.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82476.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85343.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87347.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89295.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91228.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93261.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95509.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98797.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102445.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106309.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(110208.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(114050.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117794.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121552.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125422.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129583.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134137.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138910.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143985.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149425.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155252.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161439.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167338.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(173701.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(180377.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187183.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194025.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200518.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207118.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213842.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220742.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227844.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234450.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(241108.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247806.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254568.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261442.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268053.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274627.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281178.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(287781.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294564.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301540.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309022.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(316891.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(325016.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333323.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Solomon Islands', N'SLB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(117869.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(121403.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(125068.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(128863.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(132787.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(136847.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(141027.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(145354.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(149926.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(154876.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(160292.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(166214.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(172599.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(179354.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(186338.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(193447.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(200642.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(207942.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(215353.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(222905.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(230614.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(238488.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(246502.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(254602.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(262719.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(270809.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(278846.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(286868.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(294962.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(303258.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(311849.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(320764.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(329984.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(339490.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(349250.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(359236.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(369438.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(379859.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(390489.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(401319.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(412336.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(423535.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(434893.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(446352.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(457841.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(469306.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(480716.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(492075.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(503410.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(514767.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(526177.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(537648.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(549162.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(560685.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(572171.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(583591.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Solomon Islands', N'SLB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1274180.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1286266.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1302357.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1321416.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1342201.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1364120.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1377069.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1392669.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1410837.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1431702.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455221.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1471386.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1491127.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1513867.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1539145.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1566667.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1586839.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1610923.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1638058.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1667332.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1698311.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1721986.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1747595.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1776791.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1811776.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1853304.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1895385.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1945151.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1995696.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2039033.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2071102.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2071024.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2059660.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2043967.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2031924.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2028743.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2025758.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2034497.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2058398.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2101295.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2164162.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2247022.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2355985.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2479400.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2603244.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2718937.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2808479.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2887110.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2960105.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3034817.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3115859.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3191281.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3273303.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3360977.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3452576.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3547159.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sierra Leone', N'SLE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2181701.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2210169.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2239581.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2269890.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2301023.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2332999.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2365801.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2399667.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2435197.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2473165.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2514151.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2558395.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2605837.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2656380.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2709797.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2765914.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2824827.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2886607.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(2951001.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3017670.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3086406.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3155368.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3224346.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3296530.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3376371.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3466044.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3569102.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3681945.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3791078.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3878211.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3931208.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3945899.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3929182.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3893891.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3858559.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3837807.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3833053.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3843472.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3878475.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(3948800.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(4060709.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(4220198.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(4422154.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(4647701.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(4870467.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5071271.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5243214.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5391108.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5521838.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5647194.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5775902.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(5908908.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(6043157.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(6178859.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(6315627.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(6453184.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sierra Leone', N'SLE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1430582.00000 AS Numeric(28, 5)))
   ,(N'1961', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1464743.00000 AS Numeric(28, 5)))
   ,(N'1962', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1500988.00000 AS Numeric(28, 5)))
   ,(N'1963', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1539715.00000 AS Numeric(28, 5)))
   ,(N'1964', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1581948.00000 AS Numeric(28, 5)))
   ,(N'1965', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1628163.00000 AS Numeric(28, 5)))
   ,(N'1966', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1670608.00000 AS Numeric(28, 5)))
   ,(N'1967', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1717722.00000 AS Numeric(28, 5)))
   ,(N'1968', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1768555.00000 AS Numeric(28, 5)))
   ,(N'1969', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1821722.00000 AS Numeric(28, 5)))
   ,(N'1970', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1876564.00000 AS Numeric(28, 5)))
   ,(N'1971', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1930957.00000 AS Numeric(28, 5)))
   ,(N'1972', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1985949.00000 AS Numeric(28, 5)))
   ,(N'1973', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2041409.00000 AS Numeric(28, 5)))
   ,(N'1974', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2097653.00000 AS Numeric(28, 5)))
   ,(N'1975', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2154838.00000 AS Numeric(28, 5)))
   ,(N'1976', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2208369.00000 AS Numeric(28, 5)))
   ,(N'1977', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2261810.00000 AS Numeric(28, 5)))
   ,(N'1978', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2314354.00000 AS Numeric(28, 5)))
   ,(N'1979', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2365389.00000 AS Numeric(28, 5)))
   ,(N'1980', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2415036.00000 AS Numeric(28, 5)))
   ,(N'1981', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2463211.00000 AS Numeric(28, 5)))
   ,(N'1982', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2510114.00000 AS Numeric(28, 5)))
   ,(N'1983', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2555942.00000 AS Numeric(28, 5)))
   ,(N'1984', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2601219.00000 AS Numeric(28, 5)))
   ,(N'1985', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2646757.00000 AS Numeric(28, 5)))
   ,(N'1986', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2703541.00000 AS Numeric(28, 5)))
   ,(N'1987', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2759334.00000 AS Numeric(28, 5)))
   ,(N'1988', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2814838.00000 AS Numeric(28, 5)))
   ,(N'1989', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2870902.00000 AS Numeric(28, 5)))
   ,(N'1990', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2927575.00000 AS Numeric(28, 5)))
   ,(N'1991', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2990326.00000 AS Numeric(28, 5)))
   ,(N'1992', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3052697.00000 AS Numeric(28, 5)))
   ,(N'1993', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3112683.00000 AS Numeric(28, 5)))
   ,(N'1994', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3168046.00000 AS Numeric(28, 5)))
   ,(N'1995', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3217720.00000 AS Numeric(28, 5)))
   ,(N'1996', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3259914.00000 AS Numeric(28, 5)))
   ,(N'1997', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3297912.00000 AS Numeric(28, 5)))
   ,(N'1998', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3332058.00000 AS Numeric(28, 5)))
   ,(N'1999', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3363448.00000 AS Numeric(28, 5)))
   ,(N'2000', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3393409.00000 AS Numeric(28, 5)))
   ,(N'2001', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3424280.00000 AS Numeric(28, 5)))
   ,(N'2002', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3454366.00000 AS Numeric(28, 5)))
   ,(N'2003', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3484547.00000 AS Numeric(28, 5)))
   ,(N'2004', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3515582.00000 AS Numeric(28, 5)))
   ,(N'2005', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3548032.00000 AS Numeric(28, 5)))
   ,(N'2006', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3589359.00000 AS Numeric(28, 5)))
   ,(N'2007', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3629348.00000 AS Numeric(28, 5)))
   ,(N'2008', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3669168.00000 AS Numeric(28, 5)))
   ,(N'2009', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3709964.00000 AS Numeric(28, 5)))
   ,(N'2010', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3752087.00000 AS Numeric(28, 5)))
   ,(N'2011', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3797024.00000 AS Numeric(28, 5)))
   ,(N'2012', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3843900.00000 AS Numeric(28, 5)))
   ,(N'2013', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3890370.00000 AS Numeric(28, 5)))
   ,(N'2014', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3932974.00000 AS Numeric(28, 5)))
   ,(N'2015', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3970001.00000 AS Numeric(28, 5)))
   ,(N'2016', N'El Salvador', N'SLV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(2762897.00000 AS Numeric(28, 5)))
   ,(N'1961', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(2843246.00000 AS Numeric(28, 5)))
   ,(N'1962', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(2927861.00000 AS Numeric(28, 5)))
   ,(N'1963', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3015885.00000 AS Numeric(28, 5)))
   ,(N'1964', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3106186.00000 AS Numeric(28, 5)))
   ,(N'1965', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3197865.00000 AS Numeric(28, 5)))
   ,(N'1966', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3290397.00000 AS Numeric(28, 5)))
   ,(N'1967', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3383674.00000 AS Numeric(28, 5)))
   ,(N'1968', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3477702.00000 AS Numeric(28, 5)))
   ,(N'1969', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3572667.00000 AS Numeric(28, 5)))
   ,(N'1970', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3668592.00000 AS Numeric(28, 5)))
   ,(N'1971', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3765252.00000 AS Numeric(28, 5)))
   ,(N'1972', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3862132.00000 AS Numeric(28, 5)))
   ,(N'1973', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(3958616.00000 AS Numeric(28, 5)))
   ,(N'1974', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4053958.00000 AS Numeric(28, 5)))
   ,(N'1975', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4147525.00000 AS Numeric(28, 5)))
   ,(N'1976', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4239205.00000 AS Numeric(28, 5)))
   ,(N'1977', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4328817.00000 AS Numeric(28, 5)))
   ,(N'1978', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4415625.00000 AS Numeric(28, 5)))
   ,(N'1979', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4498757.00000 AS Numeric(28, 5)))
   ,(N'1980', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4577683.00000 AS Numeric(28, 5)))
   ,(N'1981', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4652058.00000 AS Numeric(28, 5)))
   ,(N'1982', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4722272.00000 AS Numeric(28, 5)))
   ,(N'1983', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4789472.00000 AS Numeric(28, 5)))
   ,(N'1984', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4855280.00000 AS Numeric(28, 5)))
   ,(N'1985', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4920932.00000 AS Numeric(28, 5)))
   ,(N'1986', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(4986528.00000 AS Numeric(28, 5)))
   ,(N'1987', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5051885.00000 AS Numeric(28, 5)))
   ,(N'1988', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5117577.00000 AS Numeric(28, 5)))
   ,(N'1989', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5184221.00000 AS Numeric(28, 5)))
   ,(N'1990', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5252082.00000 AS Numeric(28, 5)))
   ,(N'1991', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5321576.00000 AS Numeric(28, 5)))
   ,(N'1992', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5392142.00000 AS Numeric(28, 5)))
   ,(N'1993', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5461834.00000 AS Numeric(28, 5)))
   ,(N'1994', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5528012.00000 AS Numeric(28, 5)))
   ,(N'1995', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5588743.00000 AS Numeric(28, 5)))
   ,(N'1996', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5643363.00000 AS Numeric(28, 5)))
   ,(N'1997', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5692300.00000 AS Numeric(28, 5)))
   ,(N'1998', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5736075.00000 AS Numeric(28, 5)))
   ,(N'1999', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5775660.00000 AS Numeric(28, 5)))
   ,(N'2000', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5811836.00000 AS Numeric(28, 5)))
   ,(N'2001', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5844738.00000 AS Numeric(28, 5)))
   ,(N'2002', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5874301.00000 AS Numeric(28, 5)))
   ,(N'2003', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5900929.00000 AS Numeric(28, 5)))
   ,(N'2004', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5925089.00000 AS Numeric(28, 5)))
   ,(N'2005', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5947206.00000 AS Numeric(28, 5)))
   ,(N'2006', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5967556.00000 AS Numeric(28, 5)))
   ,(N'2007', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(5986414.00000 AS Numeric(28, 5)))
   ,(N'2008', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6004199.00000 AS Numeric(28, 5)))
   ,(N'2009', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6021368.00000 AS Numeric(28, 5)))
   ,(N'2010', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6038306.00000 AS Numeric(28, 5)))
   ,(N'2011', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6055208.00000 AS Numeric(28, 5)))
   ,(N'2012', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6072233.00000 AS Numeric(28, 5)))
   ,(N'2013', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6089644.00000 AS Numeric(28, 5)))
   ,(N'2014', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6107706.00000 AS Numeric(28, 5)))
   ,(N'2015', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(6126583.00000 AS Numeric(28, 5)))
   ,(N'2016', N'El Salvador', N'SLV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'San Marino', N'SMR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(15393.00000 AS Numeric(28, 5)))
   ,(N'1961', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(15787.00000 AS Numeric(28, 5)))
   ,(N'1962', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(16197.00000 AS Numeric(28, 5)))
   ,(N'1963', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(16616.00000 AS Numeric(28, 5)))
   ,(N'1964', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(17033.00000 AS Numeric(28, 5)))
   ,(N'1965', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(17440.00000 AS Numeric(28, 5)))
   ,(N'1966', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(17839.00000 AS Numeric(28, 5)))
   ,(N'1967', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(18228.00000 AS Numeric(28, 5)))
   ,(N'1968', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(18587.00000 AS Numeric(28, 5)))
   ,(N'1969', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(18895.00000 AS Numeric(28, 5)))
   ,(N'1970', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19136.00000 AS Numeric(28, 5)))
   ,(N'1971', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19299.00000 AS Numeric(28, 5)))
   ,(N'1972', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19396.00000 AS Numeric(28, 5)))
   ,(N'1973', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19467.00000 AS Numeric(28, 5)))
   ,(N'1974', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19565.00000 AS Numeric(28, 5)))
   ,(N'1975', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19732.00000 AS Numeric(28, 5)))
   ,(N'1976', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(19981.00000 AS Numeric(28, 5)))
   ,(N'1977', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(20301.00000 AS Numeric(28, 5)))
   ,(N'1978', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(20663.00000 AS Numeric(28, 5)))
   ,(N'1979', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(21026.00000 AS Numeric(28, 5)))
   ,(N'1980', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(21363.00000 AS Numeric(28, 5)))
   ,(N'1981', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(21666.00000 AS Numeric(28, 5)))
   ,(N'1982', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(21944.00000 AS Numeric(28, 5)))
   ,(N'1983', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(22203.00000 AS Numeric(28, 5)))
   ,(N'1984', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(22455.00000 AS Numeric(28, 5)))
   ,(N'1985', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(22708.00000 AS Numeric(28, 5)))
   ,(N'1986', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(22959.00000 AS Numeric(28, 5)))
   ,(N'1987', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(23208.00000 AS Numeric(28, 5)))
   ,(N'1988', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(23463.00000 AS Numeric(28, 5)))
   ,(N'1989', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(23740.00000 AS Numeric(28, 5)))
   ,(N'1990', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(24045.00000 AS Numeric(28, 5)))
   ,(N'1991', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(24385.00000 AS Numeric(28, 5)))
   ,(N'1992', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(24755.00000 AS Numeric(28, 5)))
   ,(N'1993', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(25141.00000 AS Numeric(28, 5)))
   ,(N'1994', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(25519.00000 AS Numeric(28, 5)))
   ,(N'1995', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(25875.00000 AS Numeric(28, 5)))
   ,(N'1996', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(26201.00000 AS Numeric(28, 5)))
   ,(N'1997', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(26503.00000 AS Numeric(28, 5)))
   ,(N'1998', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(26795.00000 AS Numeric(28, 5)))
   ,(N'1999', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(27097.00000 AS Numeric(28, 5)))
   ,(N'2000', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(27420.00000 AS Numeric(28, 5)))
   ,(N'2001', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(27771.00000 AS Numeric(28, 5)))
   ,(N'2002', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(28142.00000 AS Numeric(28, 5)))
   ,(N'2003', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(28520.00000 AS Numeric(28, 5)))
   ,(N'2004', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(28891.00000 AS Numeric(28, 5)))
   ,(N'2005', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(29242.00000 AS Numeric(28, 5)))
   ,(N'2006', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(29568.00000 AS Numeric(28, 5)))
   ,(N'2007', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(29874.00000 AS Numeric(28, 5)))
   ,(N'2008', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(30160.00000 AS Numeric(28, 5)))
   ,(N'2009', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(30431.00000 AS Numeric(28, 5)))
   ,(N'2010', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(30690.00000 AS Numeric(28, 5)))
   ,(N'2011', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(30938.00000 AS Numeric(28, 5)))
   ,(N'2012', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(31172.00000 AS Numeric(28, 5)))
   ,(N'2013', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(31391.00000 AS Numeric(28, 5)))
   ,(N'2014', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(31595.00000 AS Numeric(28, 5)))
   ,(N'2015', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(31781.00000 AS Numeric(28, 5)))
   ,(N'2016', N'San Marino', N'SMR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1501021.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1524133.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1551586.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1582882.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1617357.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1654602.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1687460.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1727086.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1769107.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1808520.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1843658.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1854813.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1861699.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1884800.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1948982.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2065775.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2262499.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2518779.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2793536.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3038820.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3227205.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3299202.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3299296.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3258867.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3216035.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3194690.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3189310.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3208409.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3239570.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3266843.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3281665.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3263172.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3238919.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3219838.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3218537.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3241340.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3291150.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3370978.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3470096.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3577059.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3684848.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3774153.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3869635.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3970019.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4073742.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4180657.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4285609.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4390429.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4498299.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4614482.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4741453.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4857859.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4989634.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5134228.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5286632.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5444348.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Somalia', N'SOM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(2756380.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(2814683.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(2874944.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(2937360.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3002173.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3069558.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3144244.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3227245.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3311111.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3385414.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3445420.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3477568.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3490295.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3526527.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3644572.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(3880955.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(4259636.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(4754149.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(5289049.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(5758961.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6089707.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6251730.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1982', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6271538.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6199671.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6113252.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6068425.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6082723.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6138907.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6217331.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6285456.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6321615.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6319531.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6294017.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6269244.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6278911.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6346440.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6480888.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6672781.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(6904231.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(7148406.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(7385416.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(7610053.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(7827203.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(8039104.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(8251054.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(8466938.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(8686939.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(8909015.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(9132589.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(9356827.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(9581714.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(9806670.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(10033630.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(10268157.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(10517569.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(10787104.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Somalia', N'SOM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5055410.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5053214.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5083524.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5118610.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5142714.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5070381.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5060248.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5032903.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4995382.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4958784.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4927964.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4917250.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4919793.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4924247.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4932498.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4939845.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4947092.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4953103.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4954156.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4948551.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4932542.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4887971.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4851838.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4811380.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4769935.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4728662.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Serbia', N'SRB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7586000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7595636.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7646424.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7699307.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7734639.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7625357.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7617794.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7596501.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7567745.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7540401.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7516346.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7503433.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7496522.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7480591.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7463157.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7440769.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7411569.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7381579.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7350222.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7320807.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7291436.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7234099.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7199077.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7164132.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7130576.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(7098247.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Serbia', N'SRB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123596535.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125959152.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128563496.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131387627.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134418669.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137654279.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140442039.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143548075.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146937673.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150572627.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154431500.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157825124.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161515759.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165497229.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169776298.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174355077.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178559844.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183149050.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188065181.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193264587.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198728153.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203634982.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208954901.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214675243.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220795794.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227312601.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233380188.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239927984.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246923521.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254347849.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262186811.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269667386.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277739589.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286320958.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295308304.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304631566.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313058671.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321890246.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331132924.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(340838735.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351040644.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360560269.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(370490614.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381016472.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(392029264.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403490445.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(414658047.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426431703.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(438800612.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451782184.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(465380683.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478948112.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493243173.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508224556.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523853468.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540110531.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(228227052.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(233717101.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(239359579.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(245171874.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(251169529.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(257367430.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(263781998.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(270427647.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(277314338.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(284450088.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(291844283.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(299523889.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(307468014.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(315701605.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(324258161.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(333162846.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(342428852.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(352047880.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(362013509.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(372327378.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(382979491.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(393955998.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(405263129.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(416916315.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(428941639.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(441346877.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(454129421.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(467269469.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(480740813.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(494510951.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(508546039.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(522937118.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(537687904.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(552769967.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(568154431.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(583817375.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(599782228.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(616083993.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(632778303.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(649950074.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(667660967.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(685714078.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(703920405.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(722749402.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(742226949.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(762393890.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(783273041.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(804865417.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(827152715.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(850102988.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(873690400.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(897911089.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(922766806.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(948232478.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(974280491.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(1000888081.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa (excluding high income)', N'SSA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1647892.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1672227.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1704726.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1742221.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1780357.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1817159.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1842879.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1869292.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1897594.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1930523.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1969493.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2000008.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2039098.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2085070.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2135512.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2189244.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2236370.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2287416.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2344308.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2409977.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2485474.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2558700.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2642693.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2731636.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2818006.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2897070.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2952642.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2999112.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3033166.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3051993.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3055489.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3009501.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2950296.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2895527.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2865399.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2871237.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2931972.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3041484.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3182737.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3336105.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3489273.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3626019.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3766359.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3914502.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4075819.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4253670.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4442652.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4647386.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4867957.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5104991.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5357739.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5614387.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5887668.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6169133.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6448242.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6718978.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Sudan', N'SSD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(2955044.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3011112.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3069990.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3131686.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3196258.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3263767.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3334254.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3407754.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3484335.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3564079.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3647097.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3733547.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3823605.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(3917450.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4015271.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4117299.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4222056.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4329467.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4442665.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4565912.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4701360.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(4849708.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5007145.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5165623.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5314358.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5444907.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5559804.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5660153.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5735170.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5771305.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5762190.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5698998.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5593347.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5484372.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5425099.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5452771.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5584223.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(5806951.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(6092688.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(6398416.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(6692999.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(6967817.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(7233237.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(7499695.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(7784488.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(8099908.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(8445659.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(8815495.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(9208598.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(9623176.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(10056475.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(10510122.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(10980623.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(11453810.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(11911184.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(12339812.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Sudan', N'SSD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123619564.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125982512.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128587052.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131411353.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134442701.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137678815.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140466881.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143573375.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146963534.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150599071.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154458523.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157853000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161544504.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165526849.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169806817.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174386523.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178592106.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183182146.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188099097.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193299296.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198763631.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203671271.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208991952.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214713004.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220834222.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227351657.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233419439.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239967446.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246963212.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254387785.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262227042.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269708761.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277782142.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286364732.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295353370.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304678020.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313106030.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321938451.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331182426.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(340889573.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351092259.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360612840.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(370545594.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381071521.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(392084722.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403546808.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(414715790.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426490066.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(438860722.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451843000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(465443669.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(479009440.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493305107.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508287559.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523917379.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540175260.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa', N'SSF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(228268752.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(233759990.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(239403621.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(245217050.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(251215851.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(257414930.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(263830697.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(270477558.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(277365472.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(284502453.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(291897883.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(299578724.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(307524082.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(315758889.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(324316627.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(333222446.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(342489556.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(352109622.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(362076216.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(372390972.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(383043891.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(394021126.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(405328909.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(416982682.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(429008541.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(441414277.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(454197298.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(467337821.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(480809661.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(494580339.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(508616039.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(523007873.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(537759561.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(552842678.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(568228356.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(583892679.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(599858645.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(616161312.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(632857149.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(650030484.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(667742098.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(685795280.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(704004105.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(722832202.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(742309449.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(762476790.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(783357641.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(804950450.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(827239671.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(850190286.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(873780170.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(897998530.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(922855109.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(948322378.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(974371891.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(1000980981.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa', N'SSF', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7770995.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7877392.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7994299.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8122012.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8261546.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8410454.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8538396.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8675994.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8825302.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8983553.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9150639.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9342737.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9539695.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9742375.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9955329.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10181854.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10405107.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10641120.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10885420.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11136608.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11394225.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11660016.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11937213.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12219053.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12508753.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12809816.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13092798.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13389899.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13691473.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13997128.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14288660.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14561064.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14818268.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15069766.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15336487.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15621852.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15898670.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16195162.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16508514.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16834585.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17176489.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17535518.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17889267.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18258375.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18663653.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19115370.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19677747.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20295273.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20937602.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21552325.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22128317.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22617511.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23058671.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23470151.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23864892.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24255331.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Small states', N'SST', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(14247175.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(14524254.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(14808300.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(15096335.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(15386499.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(15674526.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(15958314.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(16238627.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(16522722.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(16813107.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(17112785.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(17424684.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(17744988.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(18070691.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(18400040.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(18734727.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(19070972.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(19410932.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(19759114.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(20127911.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(20520549.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(20931142.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(21370353.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(21822949.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(22284023.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(22752740.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(23227893.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(23702110.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(24170869.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(24646585.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(25098360.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(25544342.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(25962570.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(26362582.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(26763596.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(27169420.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(27589152.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(28008288.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(28434112.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(28868201.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(29317318.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(29750155.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(30169143.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(30606605.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(31089066.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(31625173.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(32241884.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(32928941.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(33652912.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(34354027.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(35031584.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(35700983.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(36314122.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(36903594.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(37479355.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(38050062.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Small states', N'SST', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40589.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39475.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38364.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37374.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36695.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36459.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35673.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35305.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35256.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35398.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35634.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36363.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37154.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38034.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39011.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40087.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41014.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41975.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43023.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44221.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45537.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46104.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46942.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47889.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48744.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49440.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50497.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51224.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51867.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52760.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54053.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55366.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57129.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59123.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61012.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62651.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64256.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65556.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66729.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68051.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69669.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71311.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73315.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75520.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77731.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79858.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(81954.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(84060.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86178.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88332.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90551.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93017.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95457.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97938.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100548.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103332.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sao Tome and Principe', N'STP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64255.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64549.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64429.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64181.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64209.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(64797.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(66057.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(67874.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(70040.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(72240.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(74251.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(75989.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(77536.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(79026.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(80670.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(82607.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(84889.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(87436.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(90095.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(92652.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(94953.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(96947.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(98692.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(100285.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(101871.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(103557.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(105364.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(107264.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(109268.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(111373.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(113575.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(115900.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(118346.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(120849.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(123318.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(125694.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(127946.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(130110.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(132284.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(134602.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(137164.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(140003.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(143085.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(146357.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(149732.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(153146.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(156584.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(160064.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(163595.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(167196.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(170880.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(174646.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(178484.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(182386.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(186342.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(190344.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sao Tome and Principe', N'STP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139978.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143082.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146465.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150129.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154117.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(158473.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161985.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166109.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170449.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174459.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177764.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179317.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179393.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178483.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177302.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(176474.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181019.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(186167.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191899.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197779.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203286.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208329.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212323.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215767.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219410.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223665.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227543.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(232944.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239132.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(245101.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(250288.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254886.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258763.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262204.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265784.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269858.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274323.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279072.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(283930.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(288550.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292698.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298277.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(303193.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(307549.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311627.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(315693.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(319485.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323406.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327582.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(332073.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336794.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341334.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(346072.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(350899.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355633.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360168.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Suriname', N'SUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(289972.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(298190.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(306330.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(314530.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(322995.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(331799.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(341137.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(350755.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(359735.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(366845.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(371268.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(372619.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(371318.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(368342.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(365104.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(362651.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(361368.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(361053.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(361463.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(362137.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(362777.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(363309.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(363993.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(365242.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(367611.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(371469.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(376973.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(383916.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(391851.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(400133.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(408276.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(416068.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(423572.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(430901.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(438280.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(445830.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(453653.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(461569.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(469108.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(475637.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(480751.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(484210.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(486271.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(487641.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(489312.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(491999.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(495953.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(500953.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(506657.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(512522.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(518141.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(523439.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(528535.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(533450.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(538248.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(542975.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Suriname', N'SUR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2513940.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2588495.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2610199.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2629579.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2655920.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2690347.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2723386.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2763814.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2808265.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2852190.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2881610.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2907229.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2940153.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2972226.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3004186.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3035709.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3058081.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3080947.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3103901.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3129489.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3154984.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3183027.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3219450.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3257130.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3290763.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3318331.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3340102.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3353624.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3365580.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3382200.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3407040.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3419405.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3439835.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3479076.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3521501.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3560816.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3591973.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3624241.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3656504.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3689481.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3715248.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3739503.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3767427.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3792594.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3817929.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3842378.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3858475.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3872893.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3886449.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3898131.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3904041.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3900391.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3897145.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3888175.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3873255.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3852773.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Slovak Republic', N'SVK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4068095.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4191667.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4238188.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4282017.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4327341.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4370983.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4411666.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4449367.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4483915.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4518607.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4538223.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4557449.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4596622.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4641445.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4689623.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4739105.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4789507.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4840501.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4890125.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4938973.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(4979815.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5016105.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5055099.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5091971.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5127097.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5161768.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5193838.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5222840.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5250596.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5275942.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5299187.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5303294.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5305016.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5325305.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5346331.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5361999.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5373361.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5383291.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5390516.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5396020.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5388720.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5378867.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5376912.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5373374.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5372280.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5372807.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5373054.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5374622.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5379233.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5386406.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5391428.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5398384.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5407579.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5413393.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5418649.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(5424050.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Slovak Republic', N'SVK', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1023099.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1030179.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1037369.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1047404.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1059292.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1073094.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1087967.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1104546.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1119239.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1129376.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1138743.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1147206.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1153635.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1159149.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1161797.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1171004.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1185673.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1198641.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1211501.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1225590.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1240339.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1249205.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1260621.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1279782.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1297702.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1313969.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1336063.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1355351.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1361068.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1364927.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1371323.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1373351.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1374560.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1375830.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1378772.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1382707.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1385443.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1385925.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1384519.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1387347.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1393975.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1397777.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1401992.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1405408.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1407795.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1409973.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1412795.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1416899.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1413847.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2009', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1420967.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1421539.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1415942.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1411334.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1405708.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1398004.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1387826.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Slovenia', N'SVN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1584720.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1594131.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1603649.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1616971.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1632114.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1649160.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1669905.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1689528.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1704546.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1713874.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1724891.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1738335.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1752233.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1766697.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1776132.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1793581.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1820249.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1842377.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1862548.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1882599.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1901315.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1906531.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1910334.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1922321.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1932154.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1941641.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1965964.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1989776.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1995196.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1996351.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1998161.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1999429.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1996498.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1991746.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1989443.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1989872.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1988628.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1985956.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1981629.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1983045.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1988925.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1992060.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1994530.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1995733.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(1997012.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2000474.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2006868.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2018122.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2021316.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2039669.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2048583.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2052843.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2057159.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2059953.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2061980.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(2063768.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Slovenia', N'SVN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4926117.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4955194.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4994858.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5037267.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5084949.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5135501.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5176569.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5204351.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5217398.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5236104.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5267526.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5278736.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5270004.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5256775.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5253101.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5259183.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5268080.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5281807.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5296665.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5311300.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5328313.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5342239.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5354515.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5366893.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5380368.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5394343.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5406336.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5420568.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5438906.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5467419.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5501876.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5523284.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5542074.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5562751.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5594314.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5621434.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5628678.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5640028.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5658421.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5680137.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5705159.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5750782.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5788881.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5823433.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5859386.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5897500.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5928538.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5979198.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6034846.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6086388.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6122939.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6141837.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6142836.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6136923.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6138053.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6151055.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sweden', N'SWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7484656.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7519998.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7561588.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7604328.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7661354.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7733853.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7807797.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7867931.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7912273.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(7968072.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8042801.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8098334.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8122300.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8136312.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8159955.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8192437.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8222286.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8251540.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8275599.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8293678.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8310531.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8320503.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8325263.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8329033.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8336605.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8350386.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8369829.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8397804.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8436489.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8492964.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8558835.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8617375.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8668067.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8718561.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8780745.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8826939.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8840998.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8846062.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8850974.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8857874.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8872109.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8895960.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8924958.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8958229.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(8993531.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9029572.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9080505.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9148092.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9219637.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9298515.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9378126.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9449213.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9519374.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9600379.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9696110.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(9798871.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sweden', N'SWE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(181854.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184899.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188158.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191677.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195476.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(199593.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203491.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207781.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212491.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217622.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223162.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(228624.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234516.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240840.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247565.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254665.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261290.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268520.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276229.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284243.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292510.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(300872.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309331.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(318488.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(329013.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(341184.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(356005.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(372696.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(390338.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(407847.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(424561.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435447.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445466.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455354.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(466012.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(478111.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(492593.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508458.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(525183.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(541913.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(557897.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569130.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(578749.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(587625.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(596936.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(607603.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(621736.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(637771.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(655083.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(672705.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(689862.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(704685.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(719353.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(733568.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(747160.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(760113.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Swaziland', N'SWZ', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(349233.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(357522.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(365719.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(373991.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(382575.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(391659.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(401295.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(411478.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(422266.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(433709.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(445844.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(458717.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(472337.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(486656.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(501596.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(517100.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(533264.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(550135.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(567560.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(585335.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(603373.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(621314.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(639333.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(658496.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(680253.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(705492.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(734790.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(767417.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(801350.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(833787.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(862728.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(887248.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(907947.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(926224.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(944223.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(963428.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(984506.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1006760.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1028694.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1048151.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1063715.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1074765.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1082195.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1087949.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1094775.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1104642.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1118204.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1134853.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1153750.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1173529.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1193148.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1212458.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1231694.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1250641.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1269112.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(1286970.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Swaziland', N'SWZ', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sint Maarten (Dutch part)', N'SXM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(31240.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(31084.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(30519.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(31189.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(32566.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(33790.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(35316.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(36934.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(38270.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(39462.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(40458.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(39133.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(35474.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(33435.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(34640.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(36607.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(37685.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(38817.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sint Maarten (Dutch part)', N'SXM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23029.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23360.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23556.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23726.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24032.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24536.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24842.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25300.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25861.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26444.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27023.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27876.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28745.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29620.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30519.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31446.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32262.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33096.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33916.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34709.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35478.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36289.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37051.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37761.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38428.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39056.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39251.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39462.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39691.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39936.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40231.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41375.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42553.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43774.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45066.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46454.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47359.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48205.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49502.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50838.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51615.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52571.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54980.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55049.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55458.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56363.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57743.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58363.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60110.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60816.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62986.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61328.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61934.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63003.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63911.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64729.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Seychelles', N'SYC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(41700.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(42889.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(44042.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(45176.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(46322.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(47500.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(48699.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(49911.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(51134.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(52365.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(53600.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(54835.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(56068.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(57284.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(58466.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(59600.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(60704.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(61742.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(62707.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(63594.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(64400.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(65128.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(65780.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(66367.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(66902.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(67400.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(67877.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(68352.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(68848.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(69388.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(70000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(70755.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(71657.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(72711.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(73925.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(75304.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(76417.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(77319.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(78846.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(80410.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(81131.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(81202.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(83700.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(82800.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(82500.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(82900.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(84600.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(85033.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(86956.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(87298.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(89770.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(87441.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(88303.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(89900.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(91400.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(92900.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Seychelles', N'SYC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2281839.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2336818.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2389666.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2445443.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2511942.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2592873.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2676487.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2775098.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2885294.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3000689.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3117528.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3227277.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3338817.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3452806.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3571155.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3694819.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3808233.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3927809.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4054184.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4187884.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4329688.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4483947.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4648200.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4821514.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5003112.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5192534.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5380409.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5576832.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5783120.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6001223.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6232682.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6480700.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6743442.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7019576.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7305424.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7598013.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7902715.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8206122.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8509233.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8815007.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9123445.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9365554.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9613288.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9876781.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10168836.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10498640.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10978203.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11495521.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11988070.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12377533.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12610444.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12375752.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11976005.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11516819.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11123803.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10881822.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Syrian Arab Republic', N'SYR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(4592777.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(4742596.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(4897428.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5057825.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5224579.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5398333.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5579283.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5767478.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(5963248.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(6166933.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(6378802.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(6599366.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(6828765.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(7066474.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(7311685.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(7564000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(7822610.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(8088148.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(8363346.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(8651904.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(8956156.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(9277263.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(9613517.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(9960833.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(10313485.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(10667245.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(11020718.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(11374772.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(11730217.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(12088714.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(12451539.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(12817578.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(13186187.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(13559642.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(13941025.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(14331962.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(14736209.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(15151962.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(15568797.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(15972430.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(16354050.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(16694414.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(16997521.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(17304339.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(17671913.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(18132842.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(18728200.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(19425597.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(20097057.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(20566871.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(20720602.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(20501167.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(19978756.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(19322593.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(18772481.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(18502413.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Syrian Arab Republic', N'SYR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turks and Caicos Islands', N'TCA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5724.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5760.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5762.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5741.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5705.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5669.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5629.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5589.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5563.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5573.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5632.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5750.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(5924.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(6132.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(6346.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(6546.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(6723.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(6886.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(7057.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(7262.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(7525.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(7855.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(8245.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(8671.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(9097.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(9502.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(9873.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(10224.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(10588.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(11019.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(11550.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(12205.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(12970.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(13793.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(14597.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(15334.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(15967.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(16527.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(17114.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(17866.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(18876.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(20186.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(21740.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(23412.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(25025.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(26450.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(27642.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(28638.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(29481.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(30247.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(30993.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(31727.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(32430.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(33103.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(33740.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(34339.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turks and Caicos Islands', N'TCA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1658805.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1679770.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1700671.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1722947.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1749430.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1781453.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1805798.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1836238.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1872052.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1911559.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1953679.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1989516.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2029087.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2070687.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2112991.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2155343.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2183866.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2214203.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2246815.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2282281.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2321313.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2354681.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2394036.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2439961.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2493371.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2554598.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2614590.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2685251.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2764309.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2849125.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2938228.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3019181.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3106240.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3199923.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3301075.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3410243.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3512805.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3626073.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3749999.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3884607.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4029855.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4172510.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4329119.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4496842.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4672777.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4855530.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5024876.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5202127.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5389287.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5588945.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5802669.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6012726.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6239494.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6480556.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6732902.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6994721.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Chad', N'TCD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3002596.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3061423.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3122357.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3184775.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3247798.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3310921.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3373563.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3436227.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3500778.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3569778.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3644911.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3727382.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3816299.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(3908729.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4000511.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4088858.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4173070.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4254770.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4336389.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4421448.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4512795.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4610964.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4716073.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4830055.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(4955088.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5092650.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5244158.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5409275.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5585528.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5769273.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(5958022.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(6151213.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(6350174.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(6556628.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(6773104.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(7001634.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(7242018.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(7494143.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(7760157.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(8042713.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(8343321.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(8663599.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(9002102.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(9353516.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(9710498.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(10067932.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(10423616.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(10779504.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(11139740.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(11510535.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(11896380.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(12298512.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(12715465.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(13145788.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(13587053.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(14037472.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Chad', N'TCD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(495582633.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493343818.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(496201673.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(504865472.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(514706975.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(527221797.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(539319215.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(553491877.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(569819763.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(587210316.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(604571860.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(620483555.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(636081114.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(651835818.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(667978142.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684484035.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(701632714.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(719333758.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(738538343.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(759288095.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(780888436.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(804434665.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(829300180.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(854293377.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(878559122.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(902814160.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(925154952.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(947914254.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(970116302.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(991323030.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1011790191.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1027537937.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1044611127.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1062360502.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1079931252.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1096838577.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1117560490.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1136395054.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1154702676.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1174448102.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1196213469.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1217931427.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1241005916.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1264923335.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1288430238.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1310763973.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1330078895.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1348666193.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1365994818.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1381243056.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1394092071.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1405404074.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1414613349.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1422056714.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1428348893.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1433849482.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(885053233.00000 AS Numeric(28, 5)))
   ,(N'1961', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(884103308.00000 AS Numeric(28, 5)))
   ,(N'1962', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(895507467.00000 AS Numeric(28, 5)))
   ,(N'1963', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(918210288.00000 AS Numeric(28, 5)))
   ,(N'1964', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(940539011.00000 AS Numeric(28, 5)))
   ,(N'1965', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(963844335.00000 AS Numeric(28, 5)))
   ,(N'1966', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(990693705.00000 AS Numeric(28, 5)))
   ,(N'1967', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1016635143.00000 AS Numeric(28, 5)))
   ,(N'1968', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1043552396.00000 AS Numeric(28, 5)))
   ,(N'1969', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1072206476.00000 AS Numeric(28, 5)))
   ,(N'1970', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1101819667.00000 AS Numeric(28, 5)))
   ,(N'1971', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1132130567.00000 AS Numeric(28, 5)))
   ,(N'1972', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1160753692.00000 AS Numeric(28, 5)))
   ,(N'1973', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1188474965.00000 AS Numeric(28, 5)))
   ,(N'1974', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1214719944.00000 AS Numeric(28, 5)))
   ,(N'1975', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1238563024.00000 AS Numeric(28, 5)))
   ,(N'1976', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1260573946.00000 AS Numeric(28, 5)))
   ,(N'1977', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1281008032.00000 AS Numeric(28, 5)))
   ,(N'1978', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1301409787.00000 AS Numeric(28, 5)))
   ,(N'1979', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1322089801.00000 AS Numeric(28, 5)))
   ,(N'1980', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1342386406.00000 AS Numeric(28, 5)))
   ,(N'1981', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1363262173.00000 AS Numeric(28, 5)))
   ,(N'1982', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1386395671.00000 AS Numeric(28, 5)))
   ,(N'1983', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1409622082.00000 AS Numeric(28, 5)))
   ,(N'1984', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1431811586.00000 AS Numeric(28, 5)))
   ,(N'1985', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1454823474.00000 AS Numeric(28, 5)))
   ,(N'1986', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1479545928.00000 AS Numeric(28, 5)))
   ,(N'1987', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1505857510.00000 AS Numeric(28, 5)))
   ,(N'1988', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1532465627.00000 AS Numeric(28, 5)))
   ,(N'1989', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1558388099.00000 AS Numeric(28, 5)))
   ,(N'1990', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1583420482.00000 AS Numeric(28, 5)))
   ,(N'1991', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1607332058.00000 AS Numeric(28, 5)))
   ,(N'1992', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1629666457.00000 AS Numeric(28, 5)))
   ,(N'1993', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1651168577.00000 AS Numeric(28, 5)))
   ,(N'1994', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1672562483.00000 AS Numeric(28, 5)))
   ,(N'1995', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1693610863.00000 AS Numeric(28, 5)))
   ,(N'1996', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1714375070.00000 AS Numeric(28, 5)))
   ,(N'1997', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1734987785.00000 AS Numeric(28, 5)))
   ,(N'1998', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1754947036.00000 AS Numeric(28, 5)))
   ,(N'1999', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1773820531.00000 AS Numeric(28, 5)))
   ,(N'2000', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1791655658.00000 AS Numeric(28, 5)))
   ,(N'2001', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1808712336.00000 AS Numeric(28, 5)))
   ,(N'2002', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1825011514.00000 AS Numeric(28, 5)))
   ,(N'2003', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1840686278.00000 AS Numeric(28, 5)))
   ,(N'2004', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1855914203.00000 AS Numeric(28, 5)))
   ,(N'2005', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1870882188.00000 AS Numeric(28, 5)))
   ,(N'2006', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1885233245.00000 AS Numeric(28, 5)))
   ,(N'2007', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1898935255.00000 AS Numeric(28, 5)))
   ,(N'2008', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1912445321.00000 AS Numeric(28, 5)))
   ,(N'2009', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1925862760.00000 AS Numeric(28, 5)))
   ,(N'2010', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1939296199.00000 AS Numeric(28, 5)))
   ,(N'2011', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1952981621.00000 AS Numeric(28, 5)))
   ,(N'2012', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1966974740.00000 AS Numeric(28, 5)))
   ,(N'2013', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1981182565.00000 AS Numeric(28, 5)))
   ,(N'2014', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(1995584007.00000 AS Numeric(28, 5)))
   ,(N'2015', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(2009929013.00000 AS Numeric(28, 5)))
   ,(N'2016', N'East Asia & Pacific (IDA & IBRD)', N'TEA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(191277312.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192948086.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195078998.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(197681504.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200591255.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203620049.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(206467650.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209655925.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(213009085.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(216410832.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219672030.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223119205.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(226628660.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229924073.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233156314.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(236341360.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(238950090.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(241634010.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(244345270.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1979', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(247059328.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(249872494.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252805689.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(255589825.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(258297572.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(261123759.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(263909657.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(266169308.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(268481428.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(270760895.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(272952282.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(274596242.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(275284045.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(276122162.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277164094.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(278087985.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(279311479.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(280957319.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(282992525.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(285132626.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(287332383.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(289118893.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(290292231.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291413790.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292901491.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(294651235.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(296596297.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298269634.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(300012826.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(301942952.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304023192.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306922415.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(306943548.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(307958704.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(308823103.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309405371.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(310849191.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(308998195.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(313624599.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(318286940.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(323018416.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(327746440.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(332271277.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(336043053.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(339936898.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(343746230.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(347456619.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(350929974.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(354605064.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(358622285.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(362514898.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(366434741.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(370357735.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(374400766.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(378331627.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(382172768.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(385994516.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(389981317.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(394058227.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(397990103.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(401922589.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(406091720.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(410237947.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(414308796.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(418318260.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(422146358.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(425769906.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(428458829.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(430290396.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(431966368.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(433465126.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(434183214.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(434695993.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(434935182.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435428807.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435652084.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435716325.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435333173.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435103609.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(434792812.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(434933277.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435275699.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(435684965.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(436218371.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(436773705.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(437826163.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(439618582.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(441582321.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(443792065.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(446161259.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(448720643.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(451234370.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(453562136.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Europe & Central Asia (IDA & IBRD)', N'TEC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(850754.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(856479.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(862690.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(871915.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887200.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910024.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(940220.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(979602.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1023814.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1067801.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1108635.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1138580.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1164964.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1189315.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1213680.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1239568.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1260564.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1283501.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1309866.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1341325.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1378739.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1420307.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1469785.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1524823.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1582751.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1641938.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1695292.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1750138.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1806423.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1864271.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1923813.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1973158.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2024733.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2079114.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2136929.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2198771.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2265566.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2336759.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2412216.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2491591.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2574349.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2655507.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2740279.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2828313.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2919066.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3012028.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3098894.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3189479.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3283294.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3380074.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3479954.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3578137.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3680813.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3788090.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3900197.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4017233.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Togo', N'TGO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1580513.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1597528.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1612758.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1631763.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1662072.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1708632.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1774029.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1855445.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(1945781.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2034909.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2115521.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2185661.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2247575.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2303345.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2356623.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2410446.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2464457.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2518566.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2576468.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2642845.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2720838.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2812071.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(2915148.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3026378.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3140355.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3252995.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3363448.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3472459.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3579489.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3684309.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3786942.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3886858.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(3984356.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4081398.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4180689.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4284286.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4392941.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4506465.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4624826.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4747665.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(4874735.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5006223.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5142419.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5283246.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5428552.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5578219.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5732175.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(5890414.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6052937.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6219761.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6390851.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6566179.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6745581.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(6928719.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(7115163.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(7304578.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Togo', N'TGO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14780858.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15138285.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15526921.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15943468.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16380839.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16835592.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17282842.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17751469.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18248181.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18784805.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19367659.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19959366.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20622171.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21338808.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22086747.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22853803.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23628105.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24408830.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25206504.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26041084.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26923189.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27852922.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28812382.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29802224.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30816238.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31847721.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32911992.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33987124.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35042545.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36034781.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36932608.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37633502.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38240058.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38790052.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39338439.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39923769.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40621369.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41347990.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42097364.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42839993.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43545812.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44175141.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44771324.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45313188.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45786976.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46191091.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46703884.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47098713.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47415062.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47693722.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47955461.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48168403.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48383947.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48579781.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48726559.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48806616.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Thailand', N'THA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(27397178.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(28224208.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(29081037.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(29967043.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(30881332.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(31822798.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(32789097.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(33778500.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(34790945.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(35826803.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(36884914.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(37964925.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(39061999.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(40164969.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(41259539.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(42334954.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(43386846.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(44416007.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(45423442.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(46412310.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(47385325.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(48336894.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(49265597.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(50183106.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(51105438.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(52041468.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(53002775.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(53979503.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(54933561.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(55812794.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(56582824.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(57225972.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(57761574.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(58237672.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(58722767.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(59266089.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(59878955.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(60544937.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(61250974.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(61973957.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(62693322.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(63415174.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(64136669.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(64817254.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(65404522.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(65863973.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66174486.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66353572.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66453255.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66548197.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66692024.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(66902958.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(67164130.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(67451422.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(67725979.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(67959359.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Thailand', N'THA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1157945.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1171190.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1185500.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1201475.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1220703.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1244326.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1265749.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1294904.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1330724.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1370769.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1413602.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1469533.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1524517.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1579359.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1637328.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1700630.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1760778.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1828601.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1902692.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1979073.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2055018.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2130027.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2201696.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2271800.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2343995.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2420063.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2492554.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2569147.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2645778.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2717704.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2782872.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2825302.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2867272.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2909355.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2952471.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2998365.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3049872.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3101106.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3157789.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3227401.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3313576.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3414936.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3533881.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3666129.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3803547.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3940816.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4083709.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4223046.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4360001.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4497413.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4636047.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4759858.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4886283.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5015400.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5144928.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5271996.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tajikistan', N'TJK', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2064035.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2140413.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2223956.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2312193.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2401598.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2489648.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2575335.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2659452.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2743461.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2829641.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(2919586.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3013956.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3112041.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3212446.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3313144.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3412819.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3511050.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3608761.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3707624.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3809991.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(3917642.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4030104.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4146923.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4269775.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4400743.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4540688.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4690913.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(4849253.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5008827.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5160375.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5297286.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5417554.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5523207.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5616797.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5702611.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5784330.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5862224.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(5936780.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6012308.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6094126.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6186152.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6290413.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6406518.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6532871.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6666628.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6805655.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(6949566.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7099021.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7254072.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7414960.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7581696.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7753925.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(7930929.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(8111894.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(8295840.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(8481855.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tajikistan', N'TJK', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(880935.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(893661.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(907834.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(923747.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(941945.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(962943.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(982856.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1007426.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1036173.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1067884.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1101795.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1141427.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1181373.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1222185.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1265519.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1312243.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1356726.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1404925.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1455425.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1506160.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1556290.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1604961.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1652682.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1699613.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1746869.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1795319.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1842046.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1889657.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1938671.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1990020.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2044498.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2099574.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2161161.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2226468.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2292763.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2358876.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2420463.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2483352.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2547291.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2611056.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2673813.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2738335.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2795002.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2849390.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2909556.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2979193.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3044100.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3122944.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3208553.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3289650.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3360373.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3427945.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3484479.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3533471.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3582006.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3633611.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turkmenistan', N'TKM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1593501.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1649914.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1708711.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1769008.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1829697.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1890000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(1949425.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2008148.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2066889.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2126749.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2188499.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2252386.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2318070.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2385039.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2452528.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2520002.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2587417.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2655036.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2723006.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2791575.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2861000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(2931343.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3002785.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3075867.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3151262.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3229499.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3310059.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3392823.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3479088.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3570558.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3668000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3772350.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3881973.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(3991917.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4095512.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4188010.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4267690.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4335991.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4395293.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4449427.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4501419.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4551762.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4600172.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4648036.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4696876.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4747839.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4801594.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4858235.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4917541.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(4978960.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5041995.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5106672.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5172941.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5240088.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5307188.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(5373502.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turkmenistan', N'TKM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112855623.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115544696.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118317651.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121229572.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124376416.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127805118.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131092710.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134747661.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(138692569.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142803008.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147018988.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151275441.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155617683.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160086378.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164756663.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169654960.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174441883.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179443045.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184627048.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189944841.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(195370466.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200675799.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(206147219.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211741491.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(217427249.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(223192764.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(228933736.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(234760635.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(240683339.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246730865.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(252903549.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(259081735.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(265379569.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(271799270.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(278328600.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(284946283.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(291463283.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298013757.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304585885.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(311156356.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(317701924.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(323974705.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(330236284.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(336481107.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342715827.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(348961824.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(355287089.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361680905.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(368104182.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(374493613.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(380797516.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(387144267.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(393267096.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(399219594.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(405078130.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410857259.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(210495731.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(216494111.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(222689403.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(229042493.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(235498668.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(242018410.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(248586687.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(255211837.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(261910770.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(268711935.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(275635159.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(282681487.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(289841667.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(297108880.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(304472396.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(311923848.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(319457184.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(327069797.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(334765619.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(342552013.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(350430521.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(358395133.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(366442099.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(374541998.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(382659818.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(390765564.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(398848998.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(406905621.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(414936302.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(422967105.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(430984322.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(438984479.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(446960668.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(454917331.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(462861799.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(470796413.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(478735248.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(486652062.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(494519111.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(502290053.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(509938616.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(517452800.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(524836888.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(532128984.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(539376205.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(546612100.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(553844614.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(561061674.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(568252282.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(575398084.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(582484107.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(589506204.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(596463472.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(603347698.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(610149938.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(616862604.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Latin America & Caribbean (IDA & IBRD)', N'TLA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52211976.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53158516.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54157482.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55245744.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56483262.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57900742.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59245565.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60811458.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62542915.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64362615.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66232214.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67920583.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69706512.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71598259.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73609498.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75748776.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77892103.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80147685.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82537687.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85083904.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87785134.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90408776.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93218933.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96173454.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99200578.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102345002.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105357597.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108484180.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111727530.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115060468.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(118589237.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(122087932.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125726742.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129478616.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133501059.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137711054.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(142266679.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146985775.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151862169.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156896418.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162051428.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(167236831.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172544080.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177947953.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183380712.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188750597.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193618127.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198409186.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203059234.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207512668.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211738537.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(215491971.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(219020029.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(222404415.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(225761637.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(229180396.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(97914047.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(100520117.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(103203361.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(105967893.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(108822242.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(111771141.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(114822829.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(117971134.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(121190432.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(124446136.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(127718364.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(130989602.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(134301647.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(137699619.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(141243084.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(144978967.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(148914870.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(153052528.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(157418847.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(162041884.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(166936522.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(172106111.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(177527881.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(183159784.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(188904386.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(194828467.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(200858385.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(206917503.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(212943121.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(218780126.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(224522701.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(230003274.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(235278780.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(240311706.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(245415351.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(250485558.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(255549336.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(260624146.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(265688046.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(270716244.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(275658380.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(280536572.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(285379253.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(290235672.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(295190587.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(300301331.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(305588616.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(311036772.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(316632486.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(322338888.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(328117662.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(333981240.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(339893344.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(345887214.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(351968238.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(358138798.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Middle East & North Africa (IDA & IBRD)', N'TMN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277335.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(281659.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286785.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(292515.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(298530.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304673.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(309597.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(314671.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(320224.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(326766.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(334499.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342759.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(352359.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(361523.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(368234.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(371423.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(365580.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(357198.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(348622.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(342462.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(340349.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(345840.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(353520.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(362724.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(373039.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(383977.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(389961.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(399181.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(410902.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423332.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(435347.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(447616.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(458018.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(465986.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(471609.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(474740.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(460742.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(443880.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(427042.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413191.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(404182.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413372.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(428818.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(448125.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(468079.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(481418.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(503866.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(526149.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(547530.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(566328.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(580697.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(608085.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(616126.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(623241.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(632970.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(647518.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Timor-Leste', N'TMP', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(499525.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(508311.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(517446.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(526936.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(536798.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(547035.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(557252.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(567330.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(577824.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(589519.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(602737.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(618508.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(636100.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(652017.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(661528.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(661634.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(650490.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(630151.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(606295.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(586886.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(577580.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(580556.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(593937.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(614379.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(636670.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(657018.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(674128.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(689170.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(703696.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(720198.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(740231.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(764884.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(792846.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(820471.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(842752.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(856439.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(859496.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(853867.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(845106.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(841063.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(847185.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(865848.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(894837.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(929431.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(962634.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(979201.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(996052.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1013194.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1030630.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1048367.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1066409.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1120392.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1148958.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1180069.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1212107.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(1245015.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Timor-Leste', N'TMP', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31525.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32498.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33698.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35024.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36363.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37649.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38359.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39077.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39807.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40561.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41357.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42161.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42891.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43622.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44438.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45385.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46681.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47927.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49096.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50173.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51155.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51303.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51496.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51704.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51886.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52036.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52372.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52768.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53125.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53346.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53406.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53388.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53139.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52850.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52734.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52860.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52988.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53415.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53978.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54466.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54774.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55378.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55718.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55902.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56095.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56393.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56778.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57261.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57826.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58403.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58945.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59245.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59551.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59894.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60334.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60902.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tonga', N'TON', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(61600.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(63740.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(66255.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(69000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(71757.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(74363.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(76787.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(79048.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(81096.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(82879.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(84370.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(85520.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(86349.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(86985.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(87609.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(88347.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(89258.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(90296.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(91360.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(92299.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93007.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93452.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93683.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93775.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93838.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(93953.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(94147.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(94399.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(94680.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(94943.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95152.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95304.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95421.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95532.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95678.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(95889.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(96174.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(96526.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(96937.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(97398.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(97898.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(98434.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(99005.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(99606.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(100226.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(100858.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2006', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(101507.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(102169.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(102816.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(103416.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(103947.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(104392.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(104769.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(105139.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(105586.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(106170.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tonga', N'TON', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(322950039.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(327930080.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(333026949.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(338416298.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(344683960.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351893888.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(358662704.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(366540554.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(375339250.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(384697843.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(394457611.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403485871.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(413057494.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(423226370.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(434008402.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(445459335.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(456212164.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(467830425.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480181009.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493089259.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(506414059.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(518730894.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(531661685.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(545111485.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(559142349.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(573778091.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(587290498.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(601733189.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(616953043.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(632776104.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(649123950.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(664848310.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(681217808.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(698248295.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715988692.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(734446809.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(752441120.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(771053711.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(790272496.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(810047292.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(830293034.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(849542158.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(869402856.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(889675662.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910098228.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(930516991.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(949874489.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(969200946.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(988589080.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1008257443.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1028348229.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1048020904.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1068276622.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1088858960.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1109378713.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1129553683.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Asia (IDA & IBRD)', N'TSA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(572036107.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(584143236.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(596701125.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(609571502.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(623073110.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(636963781.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(651325994.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(666134328.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(681405837.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(697060567.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(713115397.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(729469562.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(746222138.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(763491289.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(781254784.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(799620311.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(818590962.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(838141522.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(858266916.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(878939779.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(900085240.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(921521635.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(943562470.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(966023576.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(988878603.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1012099768.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1035659508.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1059536231.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1083705645.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1108148042.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1132833314.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1157752321.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1182862267.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1208123497.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1233480616.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1258903823.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1284343918.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1309774343.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1335193652.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1360594891.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1385959570.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1411288216.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1436527869.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1461601023.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1486402311.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1510864613.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1534949611.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1558685624.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1582147481.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1605443788.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1628688562.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1651888921.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1675019307.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1698093032.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1721152580.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(1744161298.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Asia (IDA & IBRD)', N'TSA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123619564.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(125982512.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(128587052.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(131411353.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134442701.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(137678815.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140466881.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143573375.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(146963534.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(150599071.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(154458523.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157853000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161544504.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(165526849.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(169806817.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174386523.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(178592106.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(183182146.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(188099097.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(193299296.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198763631.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(203671271.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(208991952.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(214713004.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(220834222.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(227351657.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(233419439.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(239967446.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(246963212.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(254387785.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(262227042.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(269708761.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(277782142.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(286364732.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(295353370.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(304678020.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(313106030.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(321938451.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(331182426.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(340889573.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(351092259.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(360612840.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(370545594.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(381071521.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(392084722.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(403546808.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(414715790.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(426490066.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(438860722.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(451843000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(465443669.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(479009440.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(493305107.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(508287559.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(523917379.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540175260.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(228268752.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(233759990.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(239403621.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(245217050.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(251215851.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(257414930.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(263830697.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(270477558.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(277365472.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(284502453.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(291897883.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(299578724.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(307524082.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(315758889.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(324316627.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(333222446.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(342489556.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(352109622.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(362076216.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(372390972.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(383043891.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(394021126.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(405328909.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(416982682.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(429008541.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(441414277.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(454197298.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(467337821.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(480809661.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(494580339.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(508616039.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(523007873.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(537759561.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(552842678.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(568228356.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(583892679.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(599858645.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(616161312.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(632857149.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(650030484.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(667742098.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(685795280.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(704004105.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(722832202.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(742309449.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(762476790.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(783357641.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(804950450.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(827239671.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(850190286.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(873780170.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(897998530.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(922855109.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(948322378.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(974371891.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(1000980981.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Sub-Saharan Africa (IDA & IBRD)', N'TSS', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(455373.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(463483.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(470023.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(475296.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(480194.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(485533.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(489291.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(494472.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(500706.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(507298.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(514125.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(527731.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(540229.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(552608.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(566310.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(581752.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(595469.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(611414.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(628297.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(643937.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(657285.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(669583.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(679508.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(687691.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(695701.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(704405.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(709604.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(716649.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(724922.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(733217.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(741105.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(752088.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(761587.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(770633.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(780805.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(792753.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(805093.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(818617.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(833004.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(847275.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(860840.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(874471.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(887444.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(899461.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(910308.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(919782.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(926662.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(932362.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(936849.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(940245.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(942751.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(944944.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(946680.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(947960.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(948863.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(949454.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Trinidad and Tobago', N'TTO', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(848481.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(865356.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(880019.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(892571.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(903272.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(912419.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(919902.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(925918.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(931466.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(937846.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(945996.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(956364.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(968742.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(982594.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(997052.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1011487.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1025655.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1039757.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1054109.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1069199.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1085308.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1102562.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1120610.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1138673.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1155701.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1170935.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1184053.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1195243.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1204890.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1213625.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1221904.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1229906.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1237486.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1244410.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1250316.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1255001.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1258365.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1260677.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1262544.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1264781.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1267980.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1272383.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1277840.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1284052.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1290535.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1296933.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1303141.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1309260.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1315372.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1321624.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1328095.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1334790.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1341579.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1348240.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1354483.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(1360088.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Trinidad and Tobago', N'TTO', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2228217.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2253850.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2278569.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2297941.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2314532.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2334654.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2370714.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2424158.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2488283.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2553875.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2616054.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2678057.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2739598.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2803739.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2875026.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2955856.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3043523.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3141091.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3246983.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3357602.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3470557.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3588322.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3711396.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3837644.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3941781.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4088786.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4245322.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4377088.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4497503.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4580335.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4724285.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4852947.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4996861.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5095947.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5276540.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5433655.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5569161.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5698940.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5825963.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5961705.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6088226.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6214969.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6347639.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6477854.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6606515.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6731793.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6856265.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6973261.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7087293.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7198047.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7297801.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7399158.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7475710.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7547020.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7611312.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7670066.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tunisia', N'TUN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4220701.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4277371.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4350811.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4436643.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4530835.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4630000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4731395.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4832923.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(4933131.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5031211.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5127000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5208154.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5294325.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5388709.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5493722.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5611000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5742339.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(5889693.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6049539.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6215690.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6384000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6555185.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6729178.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(6905136.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7042550.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7260361.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7492633.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7684751.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7857619.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(7958694.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8154400.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8318200.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8489900.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8572200.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8785700.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(8957500.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9089300.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9214900.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9333300.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9455900.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9552500.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9650600.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9748900.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9839800.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(9932400.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10029000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10127900.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10225100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10328900.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10439600.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10547100.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10673800.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10777500.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10886500.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(10996600.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(11107800.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tunisia', N'TUN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14940251.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15209923.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15457508.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15711448.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16016548.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16393974.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16760649.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17200223.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17697482.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18223087.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18759225.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19267386.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19788272.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20320129.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20862558.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21412822.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21925503.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22459492.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23019337.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23614636.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24252873.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24944866.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25684887.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26460419.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27256693.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28062617.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28811656.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29579499.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30363435.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31159731.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31966112.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32766598.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33571029.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34381921.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35199518.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36020443.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36820035.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37615235.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38409487.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39210757.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40022491.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40795651.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41604701.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42425025.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43225720.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43994177.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44747573.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45458298.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46169661.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46938356.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47789560.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48712657.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49710693.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50724899.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51682605.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52541533.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turkey', N'TUR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(27553280.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(28229291.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(28909985.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(29597047.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(30292969.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(31000167.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(31718266.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(32448404.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(33196289.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(33969201.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(34772031.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(35608079.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(36475356.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(37366922.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(38272701.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(39185637.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(40100696.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(41020211.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(41953105.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(42912350.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(43905790.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(44936836.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(45997940.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(47072603.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(48138191.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(49178079.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(50187091.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(51168841.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(52126497.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(53066569.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(53994605.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(54909508.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(55811134.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(56707454.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(57608769.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(58522320.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(59451488.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(60394104.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(61344874.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(62295617.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(63240157.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(64182694.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(65125766.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(66060121.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(66973561.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(67860617.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(68704721.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(69515492.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(70344357.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(71261307.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(72310416.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(73517002.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(74849187.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(76223639.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(77523788.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(78665830.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Turkey', N'TUR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tuvalu', N'TUV', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6104.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6242.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6391.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6542.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6687.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6819.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(6935.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7037.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7128.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7213.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7296.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7379.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7459.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7538.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7613.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7685.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7752.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7816.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7883.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(7959.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8051.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8160.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8284.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8413.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8537.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8648.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8741.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8821.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8889.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(8949.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9004.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9056.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9103.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9148.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9188.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9227.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9264.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9298.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9334.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9374.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9419.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9471.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9530.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9590.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9646.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9694.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9732.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9764.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9788.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9808.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9827.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9844.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9860.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9876.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9893.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(9916.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tuvalu', N'TUV', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5220218.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5357649.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5513831.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5684095.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5861826.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6043919.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6207618.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6379997.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6562861.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6760022.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6973501.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7174705.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7396547.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7635587.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7887346.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8149272.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8388819.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8642641.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8910777.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9194352.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9494448.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9780045.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10088736.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10417746.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10763699.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11124964.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11463541.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11820755.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12201339.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12611652.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13054430.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13486843.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13960106.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14459691.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14968757.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15477977.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15909137.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16345915.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16794183.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17259224.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17744077.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18219824.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18704304.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19203646.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19731105.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20295747.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20877547.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21518385.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22204964.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22916543.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23641906.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24378585.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25131145.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25906968.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26723120.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27590383.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tanzania', N'TZA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(10074490.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(10373380.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(10683888.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(11005882.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(11339076.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(11683511.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(12038886.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(12406040.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(12787494.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(13186560.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(13605504.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(14045757.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(14506496.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(14984973.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(15477155.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(15980265.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(16493435.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(17018013.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(17556148.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(18110990.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(18684893.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(19279543.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(19894677.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(20528465.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(21178079.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(21842087.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(22516809.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(23204186.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(23914852.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(24663284.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(25458208.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(26307482.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(27203865.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(28122799.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(29030288.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(29903329.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(30733937.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(31533781.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(32323953.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(33135281.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(33991590.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(34899062.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(35855480.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(36866228.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(37935334.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(39065600.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(40260847.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(41522004.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(42844744.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(44222113.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(45648525.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(47122998.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(48645709.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(50213457.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(51822621.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(53470420.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Tanzania', N'TZA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3495377.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3593758.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3700536.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3815760.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3940845.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4075971.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4201347.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4337682.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4481180.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4627208.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4773584.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4896202.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5021332.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5151179.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5288688.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5436012.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5579054.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5734785.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5902099.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6079949.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6267657.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6439843.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6626316.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6828061.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7045924.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7280136.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7501714.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7746030.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8008065.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8282099.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8564620.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8807252.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9061270.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9326512.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9603814.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9894470.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10151712.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10428574.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10727153.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11049549.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11397357.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11759794.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12148663.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12562168.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13000128.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13462491.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13929716.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14428194.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14954464.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15504472.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16077266.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16657460.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17266628.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17906349.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18579985.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19289981.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uganda', N'UGA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(6788211.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(7006629.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(7240155.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(7487411.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(7746181.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(8014376.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(8292747.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(8580632.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(8872866.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(9162773.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(9446024.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(9720365.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(9988321.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(10256342.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(10533627.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(10827071.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(11139772.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(11470741.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(11817951.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(12177677.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(12547754.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(12927007.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(13318149.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(13727427.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(14163214.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(14631089.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(15133740.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(15668278.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(16227778.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(16802258.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(17384369.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(17973428.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(18571527.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(19177660.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(19791266.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(20412967.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(21041468.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(21679497.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(22336812.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(23026357.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(23757636.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(24534668.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(25355794.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(26217760.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(27114742.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(28042413.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(29000925.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(29991958.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(31014427.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(32067125.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(33149417.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(34260342.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(35400620.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(36573387.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(37782971.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(39032383.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uganda', N'UGA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27993292.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28302892.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28572868.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28833980.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29132295.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29484682.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29781240.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30146916.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30548969.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30923450.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31237688.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31603891.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31892418.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32122138.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32335088.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32552244.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32665946.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32811363.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32978397.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33149768.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33317569.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33523204.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33664267.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33809121.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33961663.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34100850.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34192696.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34326111.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34496575.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34667625.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34719544.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34735106.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34745147.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34687698.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34521967.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34373358.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34220798.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34176212.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34196697.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34169252.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34036117.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33773168.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33438492.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33132129.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32878036.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32703883.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32543720.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32424330.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32318858.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32237288.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32174115.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32028605.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31984034.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31946443.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31810370.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31533063.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ukraine', N'UKR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(42662150.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(43203635.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(43749469.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(44285897.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(44794325.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45261939.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45682314.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46060456.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46409007.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46746668.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47086758.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47433807.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47783013.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(48127170.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(48455120.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(48758986.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1976', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49036202.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49290087.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49525597.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49750150.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49968811.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50221000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50384000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50564000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50754000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50917000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51097000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51293000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51521000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51773000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51892000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(52000470.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(52150266.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(52179210.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51921041.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51512299.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(51057189.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50594105.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(50143939.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49673350.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(49175848.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(48683865.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(48202500.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47812950.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47451600.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(47105150.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46787750.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46509350.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46258200.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(46053300.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45870700.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45706100.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45593300.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45489600.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45362900.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(45198200.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Ukraine', N'UKR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(666376241.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(666883355.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(672841048.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(684986533.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(698612458.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(715135991.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(730826755.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(749043296.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(769622032.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(791262341.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(812702825.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(832830309.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(852480733.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(872036300.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(892035745.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(912553505.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(933487295.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(955196993.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(978564827.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1003539696.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1029454893.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1057252200.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1086405303.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1115670568.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1144330909.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1172931471.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1199249608.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1225899133.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1251953233.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1277041212.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1301242893.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1320189048.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1340666252.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1362130150.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1383545095.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1404468947.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1429911978.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1453306841.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1476142065.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1500527217.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1527191513.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1553194209.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1580714755.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1609621303.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1638220186.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1665525548.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1688832044.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1711335579.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1732646700.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1752084034.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1768889337.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1783799714.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1796664359.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1807682057.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1817252668.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1825611136.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Upper middle income', N'UMC', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1175211032.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1180097677.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1197380936.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1225994313.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1254220055.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1283352789.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1315363682.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1346547636.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1378642057.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1412433412.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1447088711.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1482643788.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1516688677.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1549733012.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1581448281.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1610964600.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1638999295.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1665580708.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1692247717.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1719305687.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1746186708.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1773837830.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1803775943.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1833824547.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1863076552.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1893121061.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1924689464.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1957723114.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(1990854703.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2022994388.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2053526331.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2082311615.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2108986861.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2134608342.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2159928100.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2184974343.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2209841275.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2234712194.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2259065071.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2282281226.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2304421224.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2325081408.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2344483227.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2363610029.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2382469218.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2401263262.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2419694831.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2437537213.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2455687412.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2474451138.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2493277491.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2512626574.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2532680867.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2553111667.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2573612474.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(2593742810.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Upper middle income', N'UMC', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1624224.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1641338.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1659125.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1677161.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1694891.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1712098.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1726725.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1741505.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1755380.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1766976.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1775634.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1778788.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1776918.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1773116.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1771139.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1772960.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1776794.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1786138.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1798850.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1811935.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1823738.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1834066.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1844316.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1854274.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1864054.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1873819.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1887407.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1899031.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1910470.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1923610.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1939030.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1951524.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1967156.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1984467.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2001363.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2016820.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2029605.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2041804.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2052851.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2062560.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2070862.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2075032.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2076572.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2077360.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2079632.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2084742.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2092790.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2103915.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2117225.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2131125.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2144435.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2156242.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2167849.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2179172.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2190320.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2201360.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uruguay', N'URY', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2538651.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2571691.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2603887.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2635128.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2665387.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2694535.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2722874.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2750093.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2774771.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2795044.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2809799.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2818269.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2821437.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2822084.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2824069.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2830172.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2841436.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2857107.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2875970.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2896021.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2915775.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2935036.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2954281.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2973461.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(2992648.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3011907.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3031032.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3049962.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3069094.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3088985.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3109987.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3132048.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3154853.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3178156.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3201604.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3224807.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3248039.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3271014.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3292134.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3309318.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3321242.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3327105.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3327770.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3325637.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3324096.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3325608.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3331041.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3339750.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3350832.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3362761.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3374414.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3385610.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3396753.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3407969.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3419516.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(3431555.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uruguay', N'URY', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108494922.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109954012.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111609334.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(113421603.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115359141.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(117278501.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119156506.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(121082687.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123001156.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(124973084.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127254166.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(129907236.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(132297706.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(134550089.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136806631.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(139234995.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(141208207.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(143361676.00000 AS Numeric(28, 5)))
   ,(N'1978', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(145622579.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(147886786.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(149830981.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(151720752.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153490321.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(155099797.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156544452.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(157951947.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(159159673.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(160321485.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(161517936.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(162804495.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(164447763.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(166308325.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(168351353.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(170430590.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(172556600.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(174836940.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(177024504.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(179544234.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(182170287.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(184824467.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(187421416.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(189845349.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(192053377.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(194107100.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(196371737.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(198737636.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(200635780.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(202645940.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(204680593.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(206462514.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(207986631.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(209330613.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(210506729.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(211414948.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212242158.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(212983634.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United States', N'USA', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(180671000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(183691000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(186538000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(189242000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(191889000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(194303000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(196560000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(198712000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(200706000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(202677000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(205052000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(207661000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(209896000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(211909000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(213854000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(215973000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(218035000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(220239000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(222585000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(225055000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(227225000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(229466000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(231664000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(233792000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(235825000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(237924000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(240133000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(242289000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(244499000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(246819000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(249623000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(252981000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(256514000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(259919000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(263126000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(266278000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(269394000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(272657000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(275854000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(279040000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(282162411.00000 AS Numeric(28, 5)))
   ,(N'2001', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(284968955.00000 AS Numeric(28, 5)))
   ,(N'2002', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(287625193.00000 AS Numeric(28, 5)))
   ,(N'2003', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(290107933.00000 AS Numeric(28, 5)))
   ,(N'2004', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(292805298.00000 AS Numeric(28, 5)))
   ,(N'2005', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(295516599.00000 AS Numeric(28, 5)))
   ,(N'2006', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(298379912.00000 AS Numeric(28, 5)))
   ,(N'2007', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(301231207.00000 AS Numeric(28, 5)))
   ,(N'2008', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(304093966.00000 AS Numeric(28, 5)))
   ,(N'2009', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(306771529.00000 AS Numeric(28, 5)))
   ,(N'2010', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(309346863.00000 AS Numeric(28, 5)))
   ,(N'2011', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(311718857.00000 AS Numeric(28, 5)))
   ,(N'2012', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(314102623.00000 AS Numeric(28, 5)))
   ,(N'2013', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(316427395.00000 AS Numeric(28, 5)))
   ,(N'2014', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(318907401.00000 AS Numeric(28, 5)))
   ,(N'2015', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(321418820.00000 AS Numeric(28, 5)))
   ,(N'2016', N'United States', N'USA', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5232920.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5223484.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5203121.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5171324.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5139393.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5125045.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5216169.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5335338.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5485640.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5662361.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5859033.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6094100.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6338662.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6592489.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6860757.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7146428.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7413207.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7701323.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8004846.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8311356.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8613519.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8910474.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9193477.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9466061.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9737869.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10014175.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10258862.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10512804.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10773550.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11036450.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11297300.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11515955.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11784578.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12070008.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12344039.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12627806.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12980001.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13351651.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13713295.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14030988.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14419850.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14802447.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15197722.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15601784.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16014955.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16431943.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16859479.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17312379.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17783615.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18252855.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18915358.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19502825.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19851348.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20202585.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20560286.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20915060.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uzbekistan', N'UZB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(8789492.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(9044671.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(9319510.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(9611601.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(9917202.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(10233502.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(10559050.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(10894306.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(11240523.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(11599763.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(11972994.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(12361237.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(12762439.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(13170848.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(13578783.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(13980997.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(14374729.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(14762133.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(15148932.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(15543520.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(15951899.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(16375135.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(16810937.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(17257774.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(17712992.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(18174143.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(18640558.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(19111312.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(19583186.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(20052259.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(20510000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(20952000.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(21449000.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(21942000.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(22377000.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(22785000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(23225000.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(23667000.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(24051000.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(24311650.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(24650400.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(24964450.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(25271850.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(25567650.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(25864350.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(26167000.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(26488250.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(26868000.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(27302800.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(27767400.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(28562400.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(29339400.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(29774500.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(30243200.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(30757700.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(31299500.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Uzbekistan', N'UZB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37534.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37887.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38175.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38427.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38668.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38920.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39331.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39768.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40223.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40686.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41146.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41839.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42556.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43321.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44159.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45070.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46085.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47202.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48397.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49610.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50796.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52067.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53264.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54432.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55628.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56846.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57737.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58538.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59205.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59701.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60049.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60956.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61732.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62419.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63069.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63696.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64301.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64897.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65471.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66000.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66491.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67186.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67873.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68556.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69242.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69922.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70565.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71181.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71784.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72384.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72975.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73332.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73695.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74046.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74347.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74586.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Vincent and the Grenadines', N'VCT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(80948.00000 AS Numeric(28, 5)))
   ,(N'1961', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(82144.00000 AS Numeric(28, 5)))
   ,(N'1962', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(83206.00000 AS Numeric(28, 5)))
   ,(N'1963', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(84167.00000 AS Numeric(28, 5)))
   ,(N'1964', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(85076.00000 AS Numeric(28, 5)))
   ,(N'1965', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(85972.00000 AS Numeric(28, 5)))
   ,(N'1966', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(86860.00000 AS Numeric(28, 5)))
   ,(N'1967', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(87736.00000 AS Numeric(28, 5)))
   ,(N'1968', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(88615.00000 AS Numeric(28, 5)))
   ,(N'1969', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(89518.00000 AS Numeric(28, 5)))
   ,(N'1970', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(90457.00000 AS Numeric(28, 5)))
   ,(N'1971', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(91440.00000 AS Numeric(28, 5)))
   ,(N'1972', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(92465.00000 AS Numeric(28, 5)))
   ,(N'1973', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(93516.00000 AS Numeric(28, 5)))
   ,(N'1974', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(94572.00000 AS Numeric(28, 5)))
   ,(N'1975', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(95614.00000 AS Numeric(28, 5)))
   ,(N'1976', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(96639.00000 AS Numeric(28, 5)))
   ,(N'1977', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(97649.00000 AS Numeric(28, 5)))
   ,(N'1978', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(98634.00000 AS Numeric(28, 5)))
   ,(N'1979', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(99589.00000 AS Numeric(28, 5)))
   ,(N'1980', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(100506.00000 AS Numeric(28, 5)))
   ,(N'1981', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(101378.00000 AS Numeric(28, 5)))
   ,(N'1982', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(102202.00000 AS Numeric(28, 5)))
   ,(N'1983', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(102985.00000 AS Numeric(28, 5)))
   ,(N'1984', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(103742.00000 AS Numeric(28, 5)))
   ,(N'1985', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(104477.00000 AS Numeric(28, 5)))
   ,(N'1986', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(105197.00000 AS Numeric(28, 5)))
   ,(N'1987', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(105892.00000 AS Numeric(28, 5)))
   ,(N'1988', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(106533.00000 AS Numeric(28, 5)))
   ,(N'1989', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107081.00000 AS Numeric(28, 5)))
   ,(N'1990', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107509.00000 AS Numeric(28, 5)))
   ,(N'1991', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107811.00000 AS Numeric(28, 5)))
   ,(N'1992', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108001.00000 AS Numeric(28, 5)))
   ,(N'1993', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108097.00000 AS Numeric(28, 5)))
   ,(N'1994', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108129.00000 AS Numeric(28, 5)))
   ,(N'1995', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108122.00000 AS Numeric(28, 5)))
   ,(N'1996', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108078.00000 AS Numeric(28, 5)))
   ,(N'1997', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108001.00000 AS Numeric(28, 5)))
   ,(N'1998', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107923.00000 AS Numeric(28, 5)))
   ,(N'1999', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107879.00000 AS Numeric(28, 5)))
   ,(N'2000', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107897.00000 AS Numeric(28, 5)))
   ,(N'2001', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(107989.00000 AS Numeric(28, 5)))
   ,(N'2002', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108150.00000 AS Numeric(28, 5)))
   ,(N'2003', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108354.00000 AS Numeric(28, 5)))
   ,(N'2004', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108563.00000 AS Numeric(28, 5)))
   ,(N'2005', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108749.00000 AS Numeric(28, 5)))
   ,(N'2006', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(108908.00000 AS Numeric(28, 5)))
   ,(N'2007', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109049.00000 AS Numeric(28, 5)))
   ,(N'2008', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109165.00000 AS Numeric(28, 5)))
   ,(N'2009', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109255.00000 AS Numeric(28, 5)))
   ,(N'2010', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109316.00000 AS Numeric(28, 5)))
   ,(N'2011', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109341.00000 AS Numeric(28, 5)))
   ,(N'2012', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109334.00000 AS Numeric(28, 5)))
   ,(N'2013', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109327.00000 AS Numeric(28, 5)))
   ,(N'2014', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109360.00000 AS Numeric(28, 5)))
   ,(N'2015', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(109462.00000 AS Numeric(28, 5)))
   ,(N'2016', N'St. Vincent and the Grenadines', N'VCT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4227820.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4368609.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4515369.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4668403.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4829157.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4998718.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5157819.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5334178.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5523404.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5720142.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5922927.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6137643.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6356702.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6584892.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6828330.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7089172.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7364920.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7650574.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7946113.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8250425.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8561449.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8854508.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9162595.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9478148.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9790804.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10095895.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10400847.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10695636.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10986466.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11285620.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11599713.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11905361.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12231708.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12573081.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12919539.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13266615.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13620483.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13970749.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14322831.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14685126.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15060764.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15435355.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15820093.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16211089.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16601395.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16986495.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17357950.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17726793.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18090480.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18447221.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18796239.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19133812.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19462436.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19783734.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20100827.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20415486.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Venezuela, RB', N'VEN', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(8146845.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(8461684.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(8790590.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(9130346.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(9476255.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(9824694.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(10175143.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(10528054.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(10881995.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(11235492.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(11587758.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(11937803.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(12286434.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(12636971.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(12994025.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(13360988.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(13739142.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(14127790.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(14525929.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(14931741.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(15343917.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(15761800.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(16185895.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(16617343.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(17057786.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(17508059.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(17968530.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(18437737.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(18912431.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(19388262.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(19861959.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(20332247.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(20799471.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(21263994.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(21726808.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(22188671.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(22649212.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(23108003.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(23565734.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(24023355.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(24481477.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(24940223.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(25399143.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(25857553.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(26314483.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(26769115.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(27221228.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(27670659.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(28116716.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(28558607.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(28995745.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(29427631.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(29854238.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(30276045.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(30693827.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(31108083.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Venezuela, RB', N'VEN', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1991', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1992', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1993', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1994', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1995', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1996', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1997', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1998', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1999', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2000', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2001', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2002', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2003', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2004', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2005', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2006', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2007', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2008', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2009', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2010', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2011', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2012', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2013', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2014', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2015', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'2016', N'British Virgin Islands', N'VGB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8036.00000 AS Numeric(28, 5)))
   ,(N'1961', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8157.00000 AS Numeric(28, 5)))
   ,(N'1962', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8298.00000 AS Numeric(28, 5)))
   ,(N'1963', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8455.00000 AS Numeric(28, 5)))
   ,(N'1964', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8628.00000 AS Numeric(28, 5)))
   ,(N'1965', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(8813.00000 AS Numeric(28, 5)))
   ,(N'1966', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9009.00000 AS Numeric(28, 5)))
   ,(N'1967', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9214.00000 AS Numeric(28, 5)))
   ,(N'1968', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9422.00000 AS Numeric(28, 5)))
   ,(N'1969', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9620.00000 AS Numeric(28, 5)))
   ,(N'1970', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9802.00000 AS Numeric(28, 5)))
   ,(N'1971', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(9969.00000 AS Numeric(28, 5)))
   ,(N'1972', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10125.00000 AS Numeric(28, 5)))
   ,(N'1973', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10263.00000 AS Numeric(28, 5)))
   ,(N'1974', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10380.00000 AS Numeric(28, 5)))
   ,(N'1975', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10476.00000 AS Numeric(28, 5)))
   ,(N'1976', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10544.00000 AS Numeric(28, 5)))
   ,(N'1977', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10596.00000 AS Numeric(28, 5)))
   ,(N'1978', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10663.00000 AS Numeric(28, 5)))
   ,(N'1979', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(10788.00000 AS Numeric(28, 5)))
   ,(N'1980', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(11003.00000 AS Numeric(28, 5)))
   ,(N'1981', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(11316.00000 AS Numeric(28, 5)))
   ,(N'1982', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(11715.00000 AS Numeric(28, 5)))
   ,(N'1983', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(12192.00000 AS Numeric(28, 5)))
   ,(N'1984', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(12729.00000 AS Numeric(28, 5)))
   ,(N'1985', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(13308.00000 AS Numeric(28, 5)))
   ,(N'1986', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(13932.00000 AS Numeric(28, 5)))
   ,(N'1987', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(14595.00000 AS Numeric(28, 5)))
   ,(N'1988', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(15265.00000 AS Numeric(28, 5)))
   ,(N'1989', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(15896.00000 AS Numeric(28, 5)))
   ,(N'1990', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(16459.00000 AS Numeric(28, 5)))
   ,(N'1991', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(16937.00000 AS Numeric(28, 5)))
   ,(N'1992', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(17343.00000 AS Numeric(28, 5)))
   ,(N'1993', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(17700.00000 AS Numeric(28, 5)))
   ,(N'1994', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(18051.00000 AS Numeric(28, 5)))
   ,(N'1995', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(18425.00000 AS Numeric(28, 5)))
   ,(N'1996', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(18834.00000 AS Numeric(28, 5)))
   ,(N'1997', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(19270.00000 AS Numeric(28, 5)))
   ,(N'1998', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(19726.00000 AS Numeric(28, 5)))
   ,(N'1999', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(20186.00000 AS Numeric(28, 5)))
   ,(N'2000', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(20643.00000 AS Numeric(28, 5)))
   ,(N'2001', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(21087.00000 AS Numeric(28, 5)))
   ,(N'2002', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(21530.00000 AS Numeric(28, 5)))
   ,(N'2003', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(22000.00000 AS Numeric(28, 5)))
   ,(N'2004', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(22538.00000 AS Numeric(28, 5)))
   ,(N'2005', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(23169.00000 AS Numeric(28, 5)))
   ,(N'2006', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(23908.00000 AS Numeric(28, 5)))
   ,(N'2007', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(24735.00000 AS Numeric(28, 5)))
   ,(N'2008', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(25604.00000 AS Numeric(28, 5)))
   ,(N'2009', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(26450.00000 AS Numeric(28, 5)))
   ,(N'2010', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(27223.00000 AS Numeric(28, 5)))
   ,(N'2011', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(27906.00000 AS Numeric(28, 5)))
   ,(N'2012', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(28511.00000 AS Numeric(28, 5)))
   ,(N'2013', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(29058.00000 AS Numeric(28, 5)))
   ,(N'2014', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(29585.00000 AS Numeric(28, 5)))
   ,(N'2015', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(30117.00000 AS Numeric(28, 5)))
   ,(N'2016', N'British Virgin Islands', N'VGB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17169.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18492.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19782.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21085.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22512.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24138.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26384.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28929.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31815.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34846.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37950.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42130.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44118.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47486.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49711.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51298.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52068.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50923.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53817.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55455.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57674.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59190.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62157.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63478.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65883.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65473.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65174.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65513.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65755.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66078.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67707.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68906.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69617.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69853.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69966.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70212.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69866.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70029.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70503.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70926.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71170.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71763.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72160.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72328.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72329.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72300.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72038.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71657.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71176.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70546.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69737.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68711.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(67620.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66484.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65351.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64252.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Virgin Islands (U.S.)', N'VIR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(32000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(34100.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(36300.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(38700.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(41300.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(44000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(47300.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(50800.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(54600.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(58600.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(63000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(71000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(76000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(84000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(90000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(94000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(96000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(93000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(96000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(96000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(97000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(98000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(102000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(104000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(106500.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(106000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(104500.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(103000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(103963.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(104807.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(105711.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(106577.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107317.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107817.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108093.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108355.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108535.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108596.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108639.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108386.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108208.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(108085.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107950.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107863.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107700.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107423.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(107091.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(106707.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(106267.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(105784.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(105275.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(104737.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(104170.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(103574.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Virgin Islands (U.S.)', N'VIR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19158382.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19200860.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19250202.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19327869.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19464708.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19676748.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19939148.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20277032.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20690897.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21175021.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21721091.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22310789.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22961070.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23664638.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24412698.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25197831.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25887939.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26617638.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27374159.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28137868.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28894431.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29641936.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30345451.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31044479.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31790080.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32627496.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33551475.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34569399.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35613794.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36663090.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(37560462.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38429598.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39296289.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40178437.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41109312.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42117628.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(43137227.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44285672.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45538516.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(46831416.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48068444.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(49454247.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50704770.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'2003', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(51928977.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53228562.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54594783.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55808366.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57093062.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58387854.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59596904.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60660551.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61578666.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62401069.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63113000.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63756789.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(64348378.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Vietnam', N'VNM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(34743000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(35428000.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(36123000.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(36836000.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(37574000.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(38341000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(39142000.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(39980000.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(40856000.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(41773000.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(42729000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(43725000.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(44758000.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(45825000.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(46918000.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(48030000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(49158000.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(50295000.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(51436000.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(52574000.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(53700000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(54722000.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(55687000.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(56655000.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(57692000.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(58868000.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(60249000.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(61750000.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(63263000.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(64774000.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(66016700.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(67242400.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(68450100.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(69644500.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(70824500.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(71995500.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(73156700.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(74306900.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(75456300.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(76596700.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(77630900.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(78620500.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(79537700.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(80467400.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(81436400.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(82392100.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(83311200.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(84218500.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(85118700.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(86025000.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(86932500.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(87860300.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(88809200.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(89759500.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(90728900.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(91703800.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Vietnam', N'VNM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32704.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33675.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34729.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35844.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36999.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38197.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39285.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(40394.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(41561.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(42818.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(44175.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(45576.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(47083.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(48663.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(50308.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52016.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(53705.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55473.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57260.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(59007.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60696.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(62360.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63896.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65324.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66705.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68101.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69884.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(71644.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73390.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(75185.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77087.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79684.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82412.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85183.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87893.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90486.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92802.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95032.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97247.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99570.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102112.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105163.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108557.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(112168.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(115818.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(119402.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(123516.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(127100.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(130247.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(133337.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(136703.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(140199.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(144378.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(148820.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(153034.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(156859.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Vanuatu', N'VUT', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(63701.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(65708.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(67806.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(69962.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(72131.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(74287.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(76410.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(78518.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(80669.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(82941.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(85388.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(88023.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(90824.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(93761.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(96793.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(99879.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(103024.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(106223.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(109429.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(112579.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(115634.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(118578.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(121433.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(124248.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(127094.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(130028.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(133040.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(136129.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(139369.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(142852.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(146633.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(150779.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(155242.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(159814.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(164209.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(168236.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(171802.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(175004.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(178074.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(181346.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(185058.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(189288.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(193957.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(198963.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(204144.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(209375.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(214635.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(219956.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(225335.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(230782.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(236299.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(241876.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(247498.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(253165.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(258883.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(264652.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Vanuatu', N'VUT', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(975519.00000 AS Numeric(28, 5)))
   ,(N'1991', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1019603.00000 AS Numeric(28, 5)))
   ,(N'1992', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1065916.00000 AS Numeric(28, 5)))
   ,(N'1993', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1114529.00000 AS Numeric(28, 5)))
   ,(N'1994', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1165650.00000 AS Numeric(28, 5)))
   ,(N'1995', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1219577.00000 AS Numeric(28, 5)))
   ,(N'1996', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1274505.00000 AS Numeric(28, 5)))
   ,(N'1997', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1334544.00000 AS Numeric(28, 5)))
   ,(N'1998', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1372696.00000 AS Numeric(28, 5)))
   ,(N'1999', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1413587.00000 AS Numeric(28, 5)))
   ,(N'2000', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1458084.00000 AS Numeric(28, 5)))
   ,(N'2001', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1505486.00000 AS Numeric(28, 5)))
   ,(N'2002', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1554557.00000 AS Numeric(28, 5)))
   ,(N'2003', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1606691.00000 AS Numeric(28, 5)))
   ,(N'2004', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1662953.00000 AS Numeric(28, 5)))
   ,(N'2005', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1723092.00000 AS Numeric(28, 5)))
   ,(N'2006', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1787540.00000 AS Numeric(28, 5)))
   ,(N'2007', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1855152.00000 AS Numeric(28, 5)))
   ,(N'2008', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1931575.00000 AS Numeric(28, 5)))
   ,(N'2009', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2010177.00000 AS Numeric(28, 5)))
   ,(N'2010', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2090179.00000 AS Numeric(28, 5)))
   ,(N'2011', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2171420.00000 AS Numeric(28, 5)))
   ,(N'2012', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2255461.00000 AS Numeric(28, 5)))
   ,(N'2013', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2340862.00000 AS Numeric(28, 5)))
   ,(N'2014', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2426711.00000 AS Numeric(28, 5)))
   ,(N'2015', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2512554.00000 AS Numeric(28, 5)))
   ,(N'2016', N'West Bank and Gaza', N'WBG', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1961', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1962', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1963', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1964', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1965', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1966', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1967', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1968', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1969', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1970', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1971', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1972', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1973', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1974', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1975', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1976', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1977', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1978', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1979', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1980', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1981', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1982', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1983', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1984', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1985', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1986', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1987', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1988', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1989', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1990', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(1978248.00000 AS Numeric(28, 5)))
   ,(N'1991', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2068845.00000 AS Numeric(28, 5)))
   ,(N'1992', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2163591.00000 AS Numeric(28, 5)))
   ,(N'1993', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2262676.00000 AS Numeric(28, 5)))
   ,(N'1994', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2366298.00000 AS Numeric(28, 5)))
   ,(N'1995', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2474666.00000 AS Numeric(28, 5)))
   ,(N'1996', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2587997.00000 AS Numeric(28, 5)))
   ,(N'1997', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2706518.00000 AS Numeric(28, 5)))
   ,(N'1998', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2776568.00000 AS Numeric(28, 5)))
   ,(N'1999', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2848431.00000 AS Numeric(28, 5)))
   ,(N'2000', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2922153.00000 AS Numeric(28, 5)))
   ,(N'2001', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(2997784.00000 AS Numeric(28, 5)))
   ,(N'2002', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3075373.00000 AS Numeric(28, 5)))
   ,(N'2003', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3154969.00000 AS Numeric(28, 5)))
   ,(N'2004', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3236626.00000 AS Numeric(28, 5)))
   ,(N'2005', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3320396.00000 AS Numeric(28, 5)))
   ,(N'2006', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3406334.00000 AS Numeric(28, 5)))
   ,(N'2007', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3494496.00000 AS Numeric(28, 5)))
   ,(N'2008', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3596688.00000 AS Numeric(28, 5)))
   ,(N'2009', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3702218.00000 AS Numeric(28, 5)))
   ,(N'2010', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3811102.00000 AS Numeric(28, 5)))
   ,(N'2011', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(3927051.00000 AS Numeric(28, 5)))
   ,(N'2012', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(4046901.00000 AS Numeric(28, 5)))
   ,(N'2013', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(4169506.00000 AS Numeric(28, 5)))
   ,(N'2014', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(4294682.00000 AS Numeric(28, 5)))
   ,(N'2015', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(4422143.00000 AS Numeric(28, 5)))
   ,(N'2016', N'West Bank and Gaza', N'WBG', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1750139799.00000 AS Numeric(28, 5)))
   ,(N'1961', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1766733920.00000 AS Numeric(28, 5)))
   ,(N'1962', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1789223631.00000 AS Numeric(28, 5)))
   ,(N'1963', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1819117208.00000 AS Numeric(28, 5)))
   ,(N'1964', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1851928463.00000 AS Numeric(28, 5)))
   ,(N'1965', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1888828159.00000 AS Numeric(28, 5)))
   ,(N'1966', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1923325685.00000 AS Numeric(28, 5)))
   ,(N'1967', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1961974363.00000 AS Numeric(28, 5)))
   ,(N'1968', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2003985680.00000 AS Numeric(28, 5)))
   ,(N'1969', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2049519442.00000 AS Numeric(28, 5)))
   ,(N'1970', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2095291023.00000 AS Numeric(28, 5)))
   ,(N'1971', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2139337073.00000 AS Numeric(28, 5)))
   ,(N'1972', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2184289852.00000 AS Numeric(28, 5)))
   ,(N'1973', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2229923774.00000 AS Numeric(28, 5)))
   ,(N'1974', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2278152045.00000 AS Numeric(28, 5)))
   ,(N'1975', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2328116886.00000 AS Numeric(28, 5)))
   ,(N'1976', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2375327528.00000 AS Numeric(28, 5)))
   ,(N'1977', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2425456952.00000 AS Numeric(28, 5)))
   ,(N'1978', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2479066184.00000 AS Numeric(28, 5)))
   ,(N'1979', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2535796376.00000 AS Numeric(28, 5)))
   ,(N'1980', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2594445036.00000 AS Numeric(28, 5)))
   ,(N'1981', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2653888275.00000 AS Numeric(28, 5)))
   ,(N'1982', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2715575295.00000 AS Numeric(28, 5)))
   ,(N'1983', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2778114731.00000 AS Numeric(28, 5)))
   ,(N'1984', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2840763748.00000 AS Numeric(28, 5)))
   ,(N'1985', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2904305340.00000 AS Numeric(28, 5)))
   ,(N'1986', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2962596562.00000 AS Numeric(28, 5)))
   ,(N'1987', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3022994289.00000 AS Numeric(28, 5)))
   ,(N'1988', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3084246420.00000 AS Numeric(28, 5)))
   ,(N'1989', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3145742368.00000 AS Numeric(28, 5)))
   ,(N'1990', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3208186993.00000 AS Numeric(28, 5)))
   ,(N'1991', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3262883296.00000 AS Numeric(28, 5)))
   ,(N'1992', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3319025244.00000 AS Numeric(28, 5)))
   ,(N'1993', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3378383049.00000 AS Numeric(28, 5)))
   ,(N'1994', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3438884806.00000 AS Numeric(28, 5)))
   ,(N'1995', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3501736783.00000 AS Numeric(28, 5)))
   ,(N'1996', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3566351919.00000 AS Numeric(28, 5)))
   ,(N'1997', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3630963654.00000 AS Numeric(28, 5)))
   ,(N'1998', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3696415677.00000 AS Numeric(28, 5)))
   ,(N'1999', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3764526995.00000 AS Numeric(28, 5)))
   ,(N'2000', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3835429501.00000 AS Numeric(28, 5)))
   ,(N'2001', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3903928588.00000 AS Numeric(28, 5)))
   ,(N'2002', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3974646173.00000 AS Numeric(28, 5)))
   ,(N'2003', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4047531596.00000 AS Numeric(28, 5)))
   ,(N'2004', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4121300764.00000 AS Numeric(28, 5)))
   ,(N'2005', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4194744909.00000 AS Numeric(28, 5)))
   ,(N'2006', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4262730562.00000 AS Numeric(28, 5)))
   ,(N'2007', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4331054869.00000 AS Numeric(28, 5)))
   ,(N'2008', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4399167265.00000 AS Numeric(28, 5)))
   ,(N'2009', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4464971943.00000 AS Numeric(28, 5)))
   ,(N'2010', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4528931223.00000 AS Numeric(28, 5)))
   ,(N'2011', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4586428334.00000 AS Numeric(28, 5)))
   ,(N'2012', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4642125265.00000 AS Numeric(28, 5)))
   ,(N'2013', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4698161985.00000 AS Numeric(28, 5)))
   ,(N'2014', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4751114059.00000 AS Numeric(28, 5)))
   ,(N'2015', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4804840745.00000 AS Numeric(28, 5)))
   ,(N'2016', N'World', N'WLD', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3035055570.00000 AS Numeric(28, 5)))
   ,(N'1961', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3076120548.00000 AS Numeric(28, 5)))
   ,(N'1962', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3129063789.00000 AS Numeric(28, 5)))
   ,(N'1963', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3193947306.00000 AS Numeric(28, 5)))
   ,(N'1964', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3259354557.00000 AS Numeric(28, 5)))
   ,(N'1965', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3326054230.00000 AS Numeric(28, 5)))
   ,(N'1966', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3395866317.00000 AS Numeric(28, 5)))
   ,(N'1967', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3465297420.00000 AS Numeric(28, 5)))
   ,(N'1968', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3535511844.00000 AS Numeric(28, 5)))
   ,(N'1969', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3609910116.00000 AS Numeric(28, 5)))
   ,(N'1970', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3684996710.00000 AS Numeric(28, 5)))
   ,(N'1971', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3762289912.00000 AS Numeric(28, 5)))
   ,(N'1972', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3839015704.00000 AS Numeric(28, 5)))
   ,(N'1973', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3914800478.00000 AS Numeric(28, 5)))
   ,(N'1974', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(3991194334.00000 AS Numeric(28, 5)))
   ,(N'1975', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4065954672.00000 AS Numeric(28, 5)))
   ,(N'1976', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4138731185.00000 AS Numeric(28, 5)))
   ,(N'1977', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4211259460.00000 AS Numeric(28, 5)))
   ,(N'1978', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4285061775.00000 AS Numeric(28, 5)))
   ,(N'1979', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4360572310.00000 AS Numeric(28, 5)))
   ,(N'1980', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4436734568.00000 AS Numeric(28, 5)))
   ,(N'1981', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4514655817.00000 AS Numeric(28, 5)))
   ,(N'1982', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4595487517.00000 AS Numeric(28, 5)))
   ,(N'1983', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4677020244.00000 AS Numeric(28, 5)))
   ,(N'1984', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4758310418.00000 AS Numeric(28, 5)))
   ,(N'1985', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4841376791.00000 AS Numeric(28, 5)))
   ,(N'1986', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(4927207009.00000 AS Numeric(28, 5)))
   ,(N'1987', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5015267869.00000 AS Numeric(28, 5)))
   ,(N'1988', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5104205218.00000 AS Numeric(28, 5)))
   ,(N'1989', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5193123373.00000 AS Numeric(28, 5)))
   ,(N'1990', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5283057867.00000 AS Numeric(28, 5)))
   ,(N'1991', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5369889993.00000 AS Numeric(28, 5)))
   ,(N'1992', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5453473436.00000 AS Numeric(28, 5)))
   ,(N'1993', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5537776461.00000 AS Numeric(28, 5)))
   ,(N'1994', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5621146521.00000 AS Numeric(28, 5)))
   ,(N'1995', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5705843054.00000 AS Numeric(28, 5)))
   ,(N'1996', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5788596142.00000 AS Numeric(28, 5)))
   ,(N'1997', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5871549366.00000 AS Numeric(28, 5)))
   ,(N'1998', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(5953672500.00000 AS Numeric(28, 5)))
   ,(N'1999', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6034911639.00000 AS Numeric(28, 5)))
   ,(N'2000', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6115444311.00000 AS Numeric(28, 5)))
   ,(N'2001', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6195589560.00000 AS Numeric(28, 5)))
   ,(N'2002', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6274734084.00000 AS Numeric(28, 5)))
   ,(N'2003', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6353976427.00000 AS Numeric(28, 5)))
   ,(N'2004', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6433748714.00000 AS Numeric(28, 5)))
   ,(N'2005', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6513959904.00000 AS Numeric(28, 5)))
   ,(N'2006', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6594722462.00000 AS Numeric(28, 5)))
   ,(N'2007', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6675832678.00000 AS Numeric(28, 5)))
   ,(N'2008', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6758302523.00000 AS Numeric(28, 5)))
   ,(N'2009', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6840955706.00000 AS Numeric(28, 5)))
   ,(N'2010', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(6923684085.00000 AS Numeric(28, 5)))
   ,(N'2011', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(7006907989.00000 AS Numeric(28, 5)))
   ,(N'2012', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(7089451551.00000 AS Numeric(28, 5)))
   ,(N'2013', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(7176092192.00000 AS Numeric(28, 5)))
   ,(N'2014', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(7260780278.00000 AS Numeric(28, 5)))
   ,(N'2015', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(7346633037.00000 AS Numeric(28, 5)))
   ,(N'2016', N'World', N'WLD', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(52621.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(54091.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(55315.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(56397.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(57548.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(58886.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(60280.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(61881.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(63646.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(65389.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(66973.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(68232.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(69208.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70071.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(70991.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(72040.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(73426.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(74834.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(76313.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(77832.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(79331.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(80769.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(82234.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(83749.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(85236.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(86597.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(87546.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(88300.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89048.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(89904.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(90847.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(91622.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92316.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(92931.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93442.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(93817.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(94535.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95052.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95391.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95584.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(95697.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(96737.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(97594.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(98367.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(99165.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(100030.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(101087.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(102143.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(103206.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(104294.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(105429.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(106283.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(107432.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(108729.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(109967.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(111059.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Samoa', N'WSM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(108645.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(112121.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(115786.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(119564.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(123354.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(127068.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(130687.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(134194.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(137503.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(140520.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(143175.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(145437.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(147323.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(148889.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(150219.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(151383.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(152390.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(153244.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(154010.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(154763.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(155554.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(156435.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(157401.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(158383.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(159281.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(160030.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(160591.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(161014.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(161424.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(162001.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(162865.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(164073.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(165568.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(167206.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(168786.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(170158.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(171276.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(172191.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(172979.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(173758.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(174614.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(175567.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(176592.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(177677.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(178794.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(179928.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(181072.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(182238.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(183440.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(184700.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(186029.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(187434.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(188901.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(190390.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(191845.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(193228.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Samoa', N'WSM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2795065.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2835782.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2888437.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2948888.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3010212.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3068486.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3104414.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3137737.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3168647.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3199838.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3233480.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3243856.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3261434.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3287147.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3321476.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3365839.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3438172.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3522287.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3618402.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3727493.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3849110.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3966745.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4101815.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4249714.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4404010.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4562003.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4712177.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4867779.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5037932.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5235285.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5467188.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5758957.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6082224.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6426898.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6777758.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7123612.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7409545.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7701872.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8003322.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8317559.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8649551.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9012182.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9380079.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9761963.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10169864.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10607395.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11045711.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11516289.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12007930.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12502677.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12990178.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13449364.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13908569.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14365942.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14822828.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15280727.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Yemen, Rep.', N'YEM', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5166311.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5251663.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5339285.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5429501.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5522690.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5619170.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5720538.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5827223.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(5937125.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6047230.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6156234.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6262934.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6370599.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6487853.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6626208.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6793979.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(6994840.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(7226885.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(7485921.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(7765087.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(8059381.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(8369708.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(8698304.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(9043210.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(9402070.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(9774242.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(10153613.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(10542601.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(10958983.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(11426912.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(11961099.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(12571240.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(13245003.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(13948118.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(14633091.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(15266147.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(15834747.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(16349809.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(16829935.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(17304422.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(17795219.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(18306287.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(18832097.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(19374012.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(19931617.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(20504385.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(21093973.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(21701105.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(22322699.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(22954226.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(23591972.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(24234940.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(24882792.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(25533217.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(26183676.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(26832215.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Yemen, Rep.', N'YEM', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9601167.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9857087.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10093808.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10317658.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10537167.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10760041.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10986231.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11224510.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11477745.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11747637.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12034615.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12312626.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12609798.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12921369.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13243426.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13575290.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13873085.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14182879.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14511180.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14869009.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15263250.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15680444.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16125493.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16601511.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17112987.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17659285.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18175735.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18719347.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19276952.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19832002.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20370744.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20976566.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21618795.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22293276.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22991993.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23706388.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24319299.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24924340.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25538479.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26191591.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26907239.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27533434.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28009750.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28567629.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29144824.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29712616.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30282169.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30808829.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31321266.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31875203.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32498823.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33106749.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33821440.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34601402.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35379128.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36121760.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Africa', N'ZAF', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(17396000.00000 AS Numeric(28, 5)))
   ,(N'1961', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(17949962.00000 AS Numeric(28, 5)))
   ,(N'1962', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(18459442.00000 AS Numeric(28, 5)))
   ,(N'1963', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(18936138.00000 AS Numeric(28, 5)))
   ,(N'1964', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(19390554.00000 AS Numeric(28, 5)))
   ,(N'1965', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(19832000.00000 AS Numeric(28, 5)))
   ,(N'1966', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(20268594.00000 AS Numeric(28, 5)))
   ,(N'1967', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(20707258.00000 AS Numeric(28, 5)))
   ,(N'1968', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(21153722.00000 AS Numeric(28, 5)))
   ,(N'1969', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(21612522.00000 AS Numeric(28, 5)))
   ,(N'1970', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(22087000.00000 AS Numeric(28, 5)))
   ,(N'1971', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(22602373.00000 AS Numeric(28, 5)))
   ,(N'1972', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(23126276.00000 AS Numeric(28, 5)))
   ,(N'1973', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(23655908.00000 AS Numeric(28, 5)))
   ,(N'1974', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(24189837.00000 AS Numeric(28, 5)))
   ,(N'1975', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(24728000.00000 AS Numeric(28, 5)))
   ,(N'1976', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(25268094.00000 AS Numeric(28, 5)))
   ,(N'1977', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(25805575.00000 AS Numeric(28, 5)))
   ,(N'1978', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(26355319.00000 AS Numeric(28, 5)))
   ,(N'1979', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(26940793.00000 AS Numeric(28, 5)))
   ,(N'1980', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(27576000.00000 AS Numeric(28, 5)))
   ,(N'1981', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(28254655.00000 AS Numeric(28, 5)))
   ,(N'1982', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(28971839.00000 AS Numeric(28, 5)))
   ,(N'1983', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(29724004.00000 AS Numeric(28, 5)))
   ,(N'1984', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(30505361.00000 AS Numeric(28, 5)))
   ,(N'1985', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(31307880.00000 AS Numeric(28, 5)))
   ,(N'1986', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(32121290.00000 AS Numeric(28, 5)))
   ,(N'1987', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(32933081.00000 AS Numeric(28, 5)))
   ,(N'1988', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(33728498.00000 AS Numeric(28, 5)))
   ,(N'1989', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(34490549.00000 AS Numeric(28, 5)))
   ,(N'1990', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(35200000.00000 AS Numeric(28, 5)))
   ,(N'1991', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(35933108.00000 AS Numeric(28, 5)))
   ,(N'1992', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(36690739.00000 AS Numeric(28, 5)))
   ,(N'1993', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(37473796.00000 AS Numeric(28, 5)))
   ,(N'1994', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(38283223.00000 AS Numeric(28, 5)))
   ,(N'1995', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(39120000.00000 AS Numeric(28, 5)))
   ,(N'1996', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(40000247.00000 AS Numeric(28, 5)))
   ,(N'1997', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(40926063.00000 AS Numeric(28, 5)))
   ,(N'1998', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(41899683.00000 AS Numeric(28, 5)))
   ,(N'1999', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(42923485.00000 AS Numeric(28, 5)))
   ,(N'2000', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(44000000.00000 AS Numeric(28, 5)))
   ,(N'2001', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(44909738.00000 AS Numeric(28, 5)))
   ,(N'2002', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(45448096.00000 AS Numeric(28, 5)))
   ,(N'2003', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(46034026.00000 AS Numeric(28, 5)))
   ,(N'2004', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(46641103.00000 AS Numeric(28, 5)))
   ,(N'2005', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(47270063.00000 AS Numeric(28, 5)))
   ,(N'2006', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(47921682.00000 AS Numeric(28, 5)))
   ,(N'2007', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(48596781.00000 AS Numeric(28, 5)))
   ,(N'2008', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(49296223.00000 AS Numeric(28, 5)))
   ,(N'2009', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(50020918.00000 AS Numeric(28, 5)))
   ,(N'2010', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(50771826.00000 AS Numeric(28, 5)))
   ,(N'2011', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(51549958.00000 AS Numeric(28, 5)))
   ,(N'2012', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(52356381.00000 AS Numeric(28, 5)))
   ,(N'2013', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(53192216.00000 AS Numeric(28, 5)))
   ,(N'2014', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(54058647.00000 AS Numeric(28, 5)))
   ,(N'2015', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(54956920.00000 AS Numeric(28, 5)))
   ,(N'2016', N'South Africa', N'ZAF', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8188493.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8379555.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8594696.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8829668.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9078748.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9339135.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9570244.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(9820341.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10085928.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10365076.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10656890.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(10906584.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11173385.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11458900.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(11765532.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12094853.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12399541.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(12735760.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13094259.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13463953.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(13838986.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14156299.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14484152.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(14829326.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15200976.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15605148.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(15977981.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16396606.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(16866329.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17392703.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(17976423.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(18585628.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19267825.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(19986514.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(20703087.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21398582.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(21950807.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(22482592.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23025665.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(23615740.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24274433.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(24938270.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(25683970.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(26501073.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(27378210.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(28306809.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(29191212.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(30153258.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(31179588.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(32255012.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(33372869.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(34466249.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(35613566.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(36819175.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(38092678.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(39439399.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Congo, Dem. Rep.', N'ZAR', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(15248246.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(15637715.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(16041247.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(16461914.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(16903899.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(17369859.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(17861860.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(18378189.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(18913177.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(19458874.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(20009902.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(20563111.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(21120996.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(21690604.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(22282079.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(22902275.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(23556784.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(24242643.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(24948113.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(25656486.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(26357407.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(27049145.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(27741104.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(28448122.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(29190679.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(29985665.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(30829103.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(31721541.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(32688708.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(33763056.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(34962676.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(36309209.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(37783835.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(39314955.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(40804011.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(42183620.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(43424997.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(44558347.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(45647949.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(46788238.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(48048664.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(49449015.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(50971407.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(52602208.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(54314855.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(56089536.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(57926840.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(59834875.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(61809278.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(63845097.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(65938712.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(68087376.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(70291160.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(72552861.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(74877030.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(77266814.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Congo, Dem. Rep.', N'ZAR', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1585503.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1626851.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1672546.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1721758.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1773373.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1826854.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1874389.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1925120.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1979410.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2038032.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2101504.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2163797.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2232775.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2307451.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2386578.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2469489.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2548174.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2631245.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2719410.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2814145.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2916328.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3016376.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3126514.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3244257.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3365944.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3489440.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3598530.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3708284.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3820312.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3937624.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4061716.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4161943.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4273014.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4393328.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4519908.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4651603.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4783424.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4921499.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5065232.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5214886.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5369807.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5500033.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5635899.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5777891.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5926646.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6083367.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6249343.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6426435.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6614263.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6813172.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7023748.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7249542.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7491208.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7747337.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8016097.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8296609.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Zambia', N'ZMB', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3049586.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3142848.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3240664.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3342894.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3449266.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3559687.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3674088.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3792864.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(3916928.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4047479.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4185378.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4331002.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4484141.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4644329.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4810810.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(4983017.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(5160570.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(5343550.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(5532350.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(5727577.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(5929497.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(6138069.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(6352561.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(6571673.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(6793708.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(7017292.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(7242496.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(7469270.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(7696070.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(7921028.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(8143142.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(8361381.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(8576987.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(8794061.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(9018229.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(9253527.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(9502346.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(9763742.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(10034412.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(10309310.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(10585220.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(10861238.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(11139978.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(11426006.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(11725635.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(12043591.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(12381509.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(12738676.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(13114579.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(13507849.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(13917439.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(14343526.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(14786581.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(15246086.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(15721343.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(16211767.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Zambia', N'ZMB', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1927740.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(1975363.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2017341.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2058304.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2106184.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2164928.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2221576.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2289768.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2367322.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2449764.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2534707.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2618783.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2706861.00000 AS Numeric(28, 5)))
GO

INSERT [dbo].[WorldGenderStatisticsDataByYear] ([Year], [Country Name], [Country Code], [Indicator Name], [Indicator Code], [Value]) 
 VALUES
    (N'1973', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2798634.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2894364.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(2994040.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3082576.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3175631.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3275580.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3385155.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3506253.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3650580.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3809037.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(3979527.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4160176.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4349530.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4534737.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4730469.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(4932759.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5136805.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5339423.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5498422.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5652616.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5805038.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(5959878.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6119229.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6246449.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6378636.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6512234.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6641026.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6761224.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6841389.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6910713.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(6975670.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7044198.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7121556.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7224979.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7335819.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7455067.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7583386.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7720995.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(7887326.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8065950.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8253799.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8448496.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(8649405.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Zimbabwe', N'ZWE', N'Population ages 15-64, total', N'SP.POP.1564.TO', CAST(0.00000 AS Numeric(28, 5)))
   ,(N'1960', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(3752390.00000 AS Numeric(28, 5)))
   ,(N'1961', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(3876638.00000 AS Numeric(28, 5)))
   ,(N'1962', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4006262.00000 AS Numeric(28, 5)))
   ,(N'1963', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4140804.00000 AS Numeric(28, 5)))
   ,(N'1964', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4279561.00000 AS Numeric(28, 5)))
   ,(N'1965', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4422132.00000 AS Numeric(28, 5)))
   ,(N'1966', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4568320.00000 AS Numeric(28, 5)))
   ,(N'1967', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4718612.00000 AS Numeric(28, 5)))
   ,(N'1968', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(4874113.00000 AS Numeric(28, 5)))
   ,(N'1969', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5036321.00000 AS Numeric(28, 5)))
   ,(N'1970', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5206311.00000 AS Numeric(28, 5)))
   ,(N'1971', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5385342.00000 AS Numeric(28, 5)))
   ,(N'1972', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5573312.00000 AS Numeric(28, 5)))
   ,(N'1973', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5768382.00000 AS Numeric(28, 5)))
   ,(N'1974', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(5967861.00000 AS Numeric(28, 5)))
   ,(N'1975', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(6170284.00000 AS Numeric(28, 5)))
   ,(N'1976', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(6373956.00000 AS Numeric(28, 5)))
   ,(N'1977', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(6580739.00000 AS Numeric(28, 5)))
   ,(N'1978', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(6796946.00000 AS Numeric(28, 5)))
   ,(N'1979', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(7031159.00000 AS Numeric(28, 5)))
   ,(N'1980', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(7289083.00000 AS Numeric(28, 5)))
   ,(N'1981', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(7571965.00000 AS Numeric(28, 5)))
   ,(N'1982', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(7876414.00000 AS Numeric(28, 5)))
   ,(N'1983', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(8197564.00000 AS Numeric(28, 5)))
   ,(N'1984', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(8528328.00000 AS Numeric(28, 5)))
   ,(N'1985', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(8862601.00000 AS Numeric(28, 5)))
   ,(N'1986', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(9198874.00000 AS Numeric(28, 5)))
   ,(N'1987', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(9535657.00000 AS Numeric(28, 5)))
   ,(N'1988', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(9866776.00000 AS Numeric(28, 5)))
   ,(N'1989', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(10184966.00000 AS Numeric(28, 5)))
   ,(N'1990', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(10484771.00000 AS Numeric(28, 5)))
   ,(N'1991', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(10763036.00000 AS Numeric(28, 5)))
   ,(N'1992', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(11019717.00000 AS Numeric(28, 5)))
   ,(N'1993', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(11256512.00000 AS Numeric(28, 5)))
   ,(N'1994', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(11476807.00000 AS Numeric(28, 5)))
   ,(N'1995', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(11683136.00000 AS Numeric(28, 5)))
   ,(N'1996', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(11877664.00000 AS Numeric(28, 5)))
   ,(N'1997', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12059858.00000 AS Numeric(28, 5)))
   ,(N'1998', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12226742.00000 AS Numeric(28, 5)))
   ,(N'1999', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12374019.00000 AS Numeric(28, 5)))
   ,(N'2000', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12499981.00000 AS Numeric(28, 5)))
   ,(N'2001', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12603988.00000 AS Numeric(28, 5)))
   ,(N'2002', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12691431.00000 AS Numeric(28, 5)))
   ,(N'2003', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12774162.00000 AS Numeric(28, 5)))
   ,(N'2004', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12867828.00000 AS Numeric(28, 5)))
   ,(N'2005', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(12984418.00000 AS Numeric(28, 5)))
   ,(N'2006', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(13127942.00000 AS Numeric(28, 5)))
   ,(N'2007', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(13297798.00000 AS Numeric(28, 5)))
   ,(N'2008', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(13495462.00000 AS Numeric(28, 5)))
   ,(N'2009', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(13720997.00000 AS Numeric(28, 5)))
   ,(N'2010', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(13973897.00000 AS Numeric(28, 5)))
   ,(N'2011', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(14255592.00000 AS Numeric(28, 5)))
   ,(N'2012', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(14565482.00000 AS Numeric(28, 5)))
   ,(N'2013', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(14898092.00000 AS Numeric(28, 5)))
   ,(N'2014', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(15245855.00000 AS Numeric(28, 5)))
   ,(N'2015', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(15602751.00000 AS Numeric(28, 5)))
   ,(N'2016', N'Zimbabwe', N'ZWE', N'Population, total', N'SP.POP.TOTL', CAST(0.00000 AS Numeric(28, 5)))
GO
